# Copyright (c) 2018, NVIDIA CORPORATION.  All rights reserved.
#
# NVIDIA CORPORATION and its licensors retain all intellectual property
# and proprietary rights in and to this software, related documentation
# and any modifications thereto.  Any use, reproduction, disclosure or
# distribution of this software and related documentation without an express
# license agreement from NVIDIA CORPORATION is strictly prohibited.



__all__ = [
    "color",
    "repl"
]

import os
import sys

sys.path.append(os.path.dirname(__file__))

from . import color
from . import completer
from . import context
from . import interpreter
from . import log
from . import progress
from . import repl
from . import targetAddress

# SMASH verbs
from nvsm.command import cd
from nvsm.command import exit
from nvsm.command import set
from nvsm.command import show
from nvsm.command import start
from nvsm.command import encrypt 

# Command aliases
from nvsm.command import dumpHealth
from nvsm.command import powermode
from nvsm.command import showAlerts
from nvsm.command import showFans
from nvsm.command import showGPU
from nvsm.command import showHealth
from nvsm.command import showMemory
from nvsm.command import showPolicy
from nvsm.command import showPower
from nvsm.command import showProcessors
from nvsm.command import showStorage
from nvsm.command import showTemperatures
from nvsm.command import updateFirmware
from nvsm.command import showVersions
from nvsm.command import showNetworkAdapters
from nvsm.command import showNetworkPorts
from nvsm.command import showNetworkInterfaces
from nvsm.command import showNetworkDevicesFunctions
from nvsm.command import showNVSwitch
from nvsm.command import stress
from nvsm.command import queryNGC
from nvsm.command import showLed
from nvsm.command import enableDashboard
from nvsm.command import exporters

def nvsm_main():
    """ nvsm_main"""
    from nvsm.__main__ import main
    main()

