# Copyright (c) 2018-2019, NVIDIA CORPORATION.  All rights reserved.
#
# NVIDIA CORPORATION and its licensors retain all intellectual property
# and proprietary rights in and to this software, related documentation
# and any modifications thereto.  Any use, reproduction, disclosure or
# distribution of this software and related documentation without an express
# license agreement from NVIDIA CORPORATION is strictly prohibited.

def line_buffered_stream(stream):
    line = ''
    for y in stream:
        x = y.decode('utf-8')
        i = x.find('\n')
        while i != -1:
            # Concatenate up to newline and return line buffer
            line = line + x[:i]
            yield line
            line = ''
            # Continue looking for newlines
            x = x[i+1:]
            i = x.find('\n')
        # No more newlines; concatenate and continue looking in input
        line = line + x
        continue
    # Return remaining line buffer (in case of missing newline at end of stream)
    if line:
        yield line
