# Copyright (c) 2020, NVIDIA CORPORATION.  All rights reserved.
#
# NVIDIA CORPORATION and its licensors retain all intellectual property
# and proprietary rights in and to this software, related documentation
# and any modifications thereto.  Any use, reproduction, disclosure or
# distribution of this software and related documentation without an express
# license agreement from NVIDIA CORPORATION is strictly prohibited.

from nvsm.backend.context import Target, Property, dict_to_properties

import nvsm.log
import json
import sys

from nvsm.backend import line_buffered_stream

def run_exporters (enable=True, out_file=None, log_level=None):
        if enable:
                cmd = 'env LC_ALL=POSIX  echo "Enabling NVSM Exporters"; systemctl enable nvsm-exporter.service; systemctl start nvsm-exporter.service'
        else:
                cmd = 'env LC_ALL=POSIX  echo "Disabling NVSM Exporters"; systemctl disable nvsm-exporter.service; systemctl stop nvsm-exporter.service'

        import os
        rc = os.system(cmd)
        # on unix systems, higher 8bits are exit codes
        return rc >> 8

