# Copyright (c) 2018, NVIDIA CORPORATION.  All rights reserved.
#
# NVIDIA CORPORATION and its licensors retain all intellectual property
# and proprietary rights in and to this software, related documentation
# and any modifications thereto.  Any use, reproduction, disclosure or
# distribution of this software and related documentation without an express
# license agreement from NVIDIA CORPORATION is strictly prohibited.



class BackendError(Exception):
    def __init__(self, msg, status_code=-1):
        super(BackendError, self).__init__(msg)
        self.__statusCode = status_code

    @property
    def statusCode(self):
        return self.__statusCode

class CommandError(Exception):
    pass

class InvalidArguments(Exception):
    pass

class MissingProperty(Exception):
    pass

class MissingTarget(Exception):
    pass

class SchemaError(Exception):
    pass

class UnknownCommand(Exception):
    pass
