# Copyright (c) 2018, NVIDIA CORPORATION.  All rights reserved.
#
# NVIDIA CORPORATION and its licensors retain all intellectual property
# and proprietary rights in and to this software, related documentation
# and any modifications thereto.  Any use, reproduction, disclosure or
# distribution of this software and related documentation without an express
# license agreement from NVIDIA CORPORATION is strictly prohibited.



class ParseNode(object):
    def __init__(self):
        pass

class ProgramNode(ParseNode):
    def __init__(self):
        super(ProgramNode, self).__init__()
        self.commands = []

    # def __str__(self):
    #     return str(self)

    def __unicode__(self):
        s = 'ProgramNode('
        for c in self.commands:
            s += '\n    {0}'.format(str(c))
        s += '\n)'
        return s

    def appendCommand(self, command):
        self.commands.append(command)

class CommandNode(ParseNode):
    def __init__(self, name):
        super(CommandNode, self).__init__()
        self.name = name
        self.argv = [ name ]

    # def __str__(self):
    #     return str(self)

    def __unicode__(self):
        return 'CommandNode({0})'.format(', '.join(self.argv))

    def appendArgument(self, argument):
        self.argv.append(argument)
