from threading import Thread
import logging
import queue

logger = logging.getLogger(__name__)


class NotifierTask(Thread):

    queue_size = 300
    name = 'Base'

    def __init__(self):
        super(NotifierTask, self).__init__()
        self.queue = queue.Queue(self.queue_size)
        self.daemon = True
        logger.debug("{} initialized".format(self.name))

    def put(self, alert):
        if not self.queue.full():
            self.queue.put(alert)
        else:
            logger.info(
                "{} queue is full, unable to process the notification".format(self.name))
