#!/usr/bin/python
# Copyright (c) 2018, NVIDIA CORPORATION.  All rights reserved.
#
# NVIDIA CORPORATION and its licensors retain all intellectual property
# and proprietary rights in and to this software, related documentation
# and any modifications thereto.  Any use, reproduction, disclosure or
# distribution of this software and related documentation without an express
# license agreement from NVIDIA CORPORATION is strictly prohibited.


class Topic(object):

    TOPIC_CHASSIS = "/redfish/v1/Chassis/#"
    TOPIC_THERMAL = "/redfish/v1/Chassis/+/Thermal"
    TOPIC_THERMAL_REGEX = "\/redfish\/v1\/Chassis\/([^\s^\/]+)\/Thermal$"
    TOPIC_POWER = "/redfish/v1/Chassis/+/Power"
    TOPIC_POWER_REGEX = "\/redfish\/v1\/Chassis\/([^\s^\/]+)\/Power$"
    TOPIC_MANAGER = "/redfish/v1/Managers/+"
    TOPIC_MANAGER_REGEX = "\/redfish\/v1\/Managers\/([^\s^\/]+)$"
    TOPIC_BLADE_REGEX = "/redfish/v1/Chassis/.*_Blade([^\s^\/]+)$"
    TOPIC_POWER_MODE = "/redfish/v1/Chassis/+"
    TOPIC_POWER_MODE_REGEX = "\/redfish\/v1\/Chassis\/([^\s^\/]+)$"
    TOPIC_NETWORK_ADAPTER_ROOT = "/redfish/v1/Chassis/+/NetworkAdapters"
    TOPIC_NETWORK_ADAPTER_ROOT_REGEX = "\/redfish\/v1\/Chassis\/([^\s^\/]+)\/NetworkAdapters$"
    TOPIC_NETWORK_ADAPTER = "/redfish/v1/Chassis/+/NetworkAdapters/+"
    TOPIC_NETWORK_ADAPTER_REGEX = "\/redfish\/v1\/Chassis\/([^\s^\/]+)\/NetworkAdapters\/([^\s^\/]+)$"
    TOPIC_NETWORK_PORT = "/redfish/v1/Chassis/+/NetworkAdapters/+/NetworkPorts/+"
    TOPIC_NETWORK_PORT_REGEX = "\/redfish\/v1\/Chassis\/([^\s^\/]+)\/NetworkAdapters\/([^\s^\/]+)\/NetworkPorts\/([^\s^\/]+)$"
    TOPIC_NETWORK_DEVICE_FUNC = "/redfish/v1/Chassis/+/NetworkAdapters/+/NetworkDeviceFunctions/+"
    TOPIC_NETWORK_DEVICE_FUNC_REGEX = "\/redfish\/v1\/Chassis\/([^\s^\/]+)\/NetworkAdapters\/([^\s^\/]+)\/NetworkDeviceFunctions\/([^\s^\/]+)$"

    TOPIC_SYSTEM = "/redfish/v1/Systems/#"

    # STORAGE RELATED TOPICS
    TOPIC_STORAGE = "/redfish/v1/Systems/1/Storage/1"
    TOPIC_STORAGE_CONTROLLER = "/nvsm//v1/Systems/1/Storage/1/Controller"
    TOPIC_STORAGE_VOLUME = "/redfish/v1/Systems/1/Storage/Volumes/#"
    TOPIC_STORAGE_VOLUME_REGEX = "\/redfish\/v1\/Systems\/1\/Storage\/Volumes\/([^\s^\/]+)$"

    TOPIC_STORAGE_DRIVE = "/redfish/v1/Systems/1/Storage/Drives"
    TOPIC_STORAGE_VOLUME_COLLECTION = "/redfish/v1/Systems/Storage/Volumes"
    TOPIC_STORAGE_VOLUME_COLLECTION_REGEX = "\/redfish\/v1\/Systems\/Storage\/Volumes\/([^\s^\/]+)$"
    TOPIC_STORAGE_DRIVE_COLLECTION = "/redfish/v1/Systems/1/Storage/Drives/#"
    TOPIC_STORAGE_VOULMES_REBUILD_PROGRESS = "/redfish/v1/Systems/1/Storage/Volumes.Rebuild.Progress"

    ALERT_TOPICS = {'/nvsm/v1/Alerts/#'}

    # MEMORY RELATED TOPICS
    TOPIC_DIMM = "/redfish/v1/Systems/1/Memory/#"
    TOPIC_MEMORY = "/redfish/v1/Systems/1/Memory"

    # CPU RELATED TOPICS
    TOPIC_CPU = "/redfish/v1/Systems/1/Processors/#"

    # PCIE TOPICS
    TOPIC_PCIE = "/nvsm/v1/Systems/1/PCIeDevices/#"

    # GPU TOPICS
    TOPIC_GPU_HEALTH = "/nvsm/v1/Systems/1/GPUs/Health"

    # GPU Limits
    TOPIC_GPU_LIMITS = "/nvsm/v1/Systems/1/GPUs/Limits"

    TOPIC_CALLHOME_STATUS = "/nvsm/v1/CallHome/Status"
    TOPIC_CALLHOME = "/nvsm/v1/CallHome"
    TOPIC_CALLHOME_ENABLED = "/nvsm/v1/CallHome/Enabled"

    TOPIC_CHASSIS_PLUGIN_INIT = "/nvsm/chassis_init"

    TOPIC_PAGERDUTY_STATUS = "/nvsm/v1/PagerDuty/Status"
    TOPIC_PAGERDUTY = "/nvsm/v1/PagerDuty"

    # GPU NVLinks Health
    TOPIC_GPU_NVLINK_HEALTH = "/nvsm/v1/Systems/1/GPUs/NVLinks/Health"

    # NVSwitch Health
    TOPIC_NVSWITCH_HEALTH = "/nvsm/v1/Systems/1/NVSwitches/Health"

