# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Actions(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'computer_system_add_resource_block': 'AddResourceBlock',
        'computer_system_remove_resource_block': 'RemoveResourceBlock',
        'computer_system_reset': 'Reset',
        'computer_system_set_default_boot_order': 'SetDefaultBootOrder',
        'oem': 'dict(str, object)'
    }

    attribute_map = {
        'computer_system_add_resource_block': '#ComputerSystem.AddResourceBlock',
        'computer_system_remove_resource_block': '#ComputerSystem.RemoveResourceBlock',
        'computer_system_reset': '#ComputerSystem.Reset',
        'computer_system_set_default_boot_order': '#ComputerSystem.SetDefaultBootOrder',
        'oem': 'Oem'
    }

    def __init__(self, computer_system_add_resource_block=None, computer_system_remove_resource_block=None, computer_system_reset=None, computer_system_set_default_boot_order=None, oem=None):  # noqa: E501
        """Actions - a model defined in OpenAPI"""  # noqa: E501

        self._computer_system_add_resource_block = None
        self._computer_system_remove_resource_block = None
        self._computer_system_reset = None
        self._computer_system_set_default_boot_order = None
        self._oem = None
        self.discriminator = None

        if computer_system_add_resource_block is not None:
            self.computer_system_add_resource_block = computer_system_add_resource_block
        if computer_system_remove_resource_block is not None:
            self.computer_system_remove_resource_block = computer_system_remove_resource_block
        if computer_system_reset is not None:
            self.computer_system_reset = computer_system_reset
        if computer_system_set_default_boot_order is not None:
            self.computer_system_set_default_boot_order = computer_system_set_default_boot_order
        if oem is not None:
            self.oem = oem

    @property
    def computer_system_add_resource_block(self):
        """Gets the computer_system_add_resource_block of this Actions.  # noqa: E501


        :return: The computer_system_add_resource_block of this Actions.  # noqa: E501
        :rtype: AddResourceBlock
        """
        return self._computer_system_add_resource_block

    @computer_system_add_resource_block.setter
    def computer_system_add_resource_block(self, computer_system_add_resource_block):
        """Sets the computer_system_add_resource_block of this Actions.


        :param computer_system_add_resource_block: The computer_system_add_resource_block of this Actions.  # noqa: E501
        :type: AddResourceBlock
        """

        self._computer_system_add_resource_block = computer_system_add_resource_block

    @property
    def computer_system_remove_resource_block(self):
        """Gets the computer_system_remove_resource_block of this Actions.  # noqa: E501


        :return: The computer_system_remove_resource_block of this Actions.  # noqa: E501
        :rtype: RemoveResourceBlock
        """
        return self._computer_system_remove_resource_block

    @computer_system_remove_resource_block.setter
    def computer_system_remove_resource_block(self, computer_system_remove_resource_block):
        """Sets the computer_system_remove_resource_block of this Actions.


        :param computer_system_remove_resource_block: The computer_system_remove_resource_block of this Actions.  # noqa: E501
        :type: RemoveResourceBlock
        """

        self._computer_system_remove_resource_block = computer_system_remove_resource_block

    @property
    def computer_system_reset(self):
        """Gets the computer_system_reset of this Actions.  # noqa: E501


        :return: The computer_system_reset of this Actions.  # noqa: E501
        :rtype: Reset
        """
        return self._computer_system_reset

    @computer_system_reset.setter
    def computer_system_reset(self, computer_system_reset):
        """Sets the computer_system_reset of this Actions.


        :param computer_system_reset: The computer_system_reset of this Actions.  # noqa: E501
        :type: Reset
        """

        self._computer_system_reset = computer_system_reset

    @property
    def computer_system_set_default_boot_order(self):
        """Gets the computer_system_set_default_boot_order of this Actions.  # noqa: E501


        :return: The computer_system_set_default_boot_order of this Actions.  # noqa: E501
        :rtype: SetDefaultBootOrder
        """
        return self._computer_system_set_default_boot_order

    @computer_system_set_default_boot_order.setter
    def computer_system_set_default_boot_order(self, computer_system_set_default_boot_order):
        """Sets the computer_system_set_default_boot_order of this Actions.


        :param computer_system_set_default_boot_order: The computer_system_set_default_boot_order of this Actions.  # noqa: E501
        :type: SetDefaultBootOrder
        """

        self._computer_system_set_default_boot_order = computer_system_set_default_boot_order

    @property
    def oem(self):
        """Gets the oem of this Actions.  # noqa: E501

        The available OEM specific actions for this resource.  # noqa: E501

        :return: The oem of this Actions.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this Actions.

        The available OEM specific actions for this resource.  # noqa: E501

        :param oem: The oem of this Actions.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Actions):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
