# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class BomCheck(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'sub_system': 'str',
        'check_name': 'str',
        'specific_check_name': 'str',
        'messages': 'list[str]',
        'result': 'dict(str, Int)',
        'formatted_result': 'str',
        'predicate': 'str'
    }

    attribute_map = {
        'sub_system': 'SubSystem',
        'check_name': 'CheckName',
        'specific_check_name': 'SpecificCheckName',
        'messages': 'Messages',
        'result': 'Result',
        'formatted_result': 'FormattedResult',
        'predicate': 'predicate'
    }

    def __init__(self, sub_system=None, check_name=None, specific_check_name=None, messages=None, result=None, formatted_result=None, predicate=None):  # noqa: E501
        """BomCheck - a model defined in OpenAPI"""  # noqa: E501

        self._sub_system = None
        self._check_name = None
        self._specific_check_name = None
        self._messages = None
        self._result = None
        self._formatted_result = None
        self._predicate = None
        self.discriminator = None

        self.sub_system = sub_system
        self.check_name = check_name
        self.specific_check_name = specific_check_name
        self.messages = messages
        self.result = result
        self.formatted_result = formatted_result
        if predicate is not None:
            self.predicate = predicate

    @property
    def sub_system(self):
        """Gets the sub_system of this BomCheck.  # noqa: E501


        :return: The sub_system of this BomCheck.  # noqa: E501
        :rtype: str
        """
        return self._sub_system

    @sub_system.setter
    def sub_system(self, sub_system):
        """Sets the sub_system of this BomCheck.


        :param sub_system: The sub_system of this BomCheck.  # noqa: E501
        :type: str
        """
        if sub_system is None:
            raise ValueError("Invalid value for `sub_system`, must not be `None`")  # noqa: E501

        self._sub_system = sub_system

    @property
    def check_name(self):
        """Gets the check_name of this BomCheck.  # noqa: E501


        :return: The check_name of this BomCheck.  # noqa: E501
        :rtype: str
        """
        return self._check_name

    @check_name.setter
    def check_name(self, check_name):
        """Sets the check_name of this BomCheck.


        :param check_name: The check_name of this BomCheck.  # noqa: E501
        :type: str
        """
        if check_name is None:
            raise ValueError("Invalid value for `check_name`, must not be `None`")  # noqa: E501

        self._check_name = check_name

    @property
    def specific_check_name(self):
        """Gets the specific_check_name of this BomCheck.  # noqa: E501


        :return: The specific_check_name of this BomCheck.  # noqa: E501
        :rtype: str
        """
        return self._specific_check_name

    @specific_check_name.setter
    def specific_check_name(self, specific_check_name):
        """Sets the specific_check_name of this BomCheck.


        :param specific_check_name: The specific_check_name of this BomCheck.  # noqa: E501
        :type: str
        """
        if specific_check_name is None:
            raise ValueError("Invalid value for `specific_check_name`, must not be `None`")  # noqa: E501

        self._specific_check_name = specific_check_name

    @property
    def messages(self):
        """Gets the messages of this BomCheck.  # noqa: E501


        :return: The messages of this BomCheck.  # noqa: E501
        :rtype: list[str]
        """
        return self._messages

    @messages.setter
    def messages(self, messages):
        """Sets the messages of this BomCheck.


        :param messages: The messages of this BomCheck.  # noqa: E501
        :type: list[str]
        """
        if messages is None:
            raise ValueError("Invalid value for `messages`, must not be `None`")  # noqa: E501

        self._messages = messages

    @property
    def result(self):
        """Gets the result of this BomCheck.  # noqa: E501

        A map set with healthy:1 or unhealthy:1 or unknown:1 or informational:1 or disabled:1 or skipped:1  # noqa: E501

        :return: The result of this BomCheck.  # noqa: E501
        :rtype: dict(str, Int)
        """
        return self._result

    @result.setter
    def result(self, result):
        """Sets the result of this BomCheck.

        A map set with healthy:1 or unhealthy:1 or unknown:1 or informational:1 or disabled:1 or skipped:1  # noqa: E501

        :param result: The result of this BomCheck.  # noqa: E501
        :type: dict(str, Int)
        """
        if result is None:
            raise ValueError("Invalid value for `result`, must not be `None`")  # noqa: E501

        self._result = result

    @property
    def formatted_result(self):
        """Gets the formatted_result of this BomCheck.  # noqa: E501


        :return: The formatted_result of this BomCheck.  # noqa: E501
        :rtype: str
        """
        return self._formatted_result

    @formatted_result.setter
    def formatted_result(self, formatted_result):
        """Sets the formatted_result of this BomCheck.


        :param formatted_result: The formatted_result of this BomCheck.  # noqa: E501
        :type: str
        """
        if formatted_result is None:
            raise ValueError("Invalid value for `formatted_result`, must not be `None`")  # noqa: E501

        self._formatted_result = formatted_result

    @property
    def predicate(self):
        """Gets the predicate of this BomCheck.  # noqa: E501

        A condition to be checked before executing the check.  # noqa: E501

        :return: The predicate of this BomCheck.  # noqa: E501
        :rtype: str
        """
        return self._predicate

    @predicate.setter
    def predicate(self, predicate):
        """Sets the predicate of this BomCheck.

        A condition to be checked before executing the check.  # noqa: E501

        :param predicate: The predicate of this BomCheck.  # noqa: E501
        :type: str
        """

        self._predicate = predicate

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BomCheck):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
