# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class BomCheckCollection(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_id': 'str',
        'odata_type': 'str',
        'name': 'str',
        'run_info': 'RunInfo',
        'bom_checks': 'dict(str, list[BomCheck])',
        'system_details': 'SystemInfo',
        'bom_check_collection_summary': 'BomCheckCollectionSummary',
        'general_summary': 'str',
        'aux_info': 'str',
        'disabled_checks': 'list[str]',
        'sample_bom_check': 'BomCheck'
    }

    attribute_map = {
        'odata_id': '@odata.id',
        'odata_type': '@odata.type',
        'name': 'Name',
        'run_info': 'RunInfo',
        'bom_checks': 'BomChecks',
        'system_details': 'SystemDetails',
        'bom_check_collection_summary': 'BomCheckCollectionSummary',
        'general_summary': 'GeneralSummary',
        'aux_info': 'AuxInfo',
        'disabled_checks': 'DisabledChecks',
        'sample_bom_check': 'sampleBomCheck'
    }

    def __init__(self, odata_id=None, odata_type=None, name=None, run_info=None, bom_checks=None, system_details=None, bom_check_collection_summary=None, general_summary=None, aux_info=None, disabled_checks=None, sample_bom_check=None):  # noqa: E501
        """BomCheckCollection - a model defined in OpenAPI"""  # noqa: E501

        self._odata_id = None
        self._odata_type = None
        self._name = None
        self._run_info = None
        self._bom_checks = None
        self._system_details = None
        self._bom_check_collection_summary = None
        self._general_summary = None
        self._aux_info = None
        self._disabled_checks = None
        self._sample_bom_check = None
        self.discriminator = None

        self.odata_id = odata_id
        self.odata_type = odata_type
        self.name = name
        self.run_info = run_info
        self.bom_checks = bom_checks
        self.system_details = system_details
        self.bom_check_collection_summary = bom_check_collection_summary
        self.general_summary = general_summary
        if aux_info is not None:
            self.aux_info = aux_info
        self.disabled_checks = disabled_checks
        if sample_bom_check is not None:
            self.sample_bom_check = sample_bom_check

    @property
    def odata_id(self):
        """Gets the odata_id of this BomCheckCollection.  # noqa: E501


        :return: The odata_id of this BomCheckCollection.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this BomCheckCollection.


        :param odata_id: The odata_id of this BomCheckCollection.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def odata_type(self):
        """Gets the odata_type of this BomCheckCollection.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this BomCheckCollection.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this BomCheckCollection.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this BomCheckCollection.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def name(self):
        """Gets the name of this BomCheckCollection.  # noqa: E501


        :return: The name of this BomCheckCollection.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this BomCheckCollection.


        :param name: The name of this BomCheckCollection.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def run_info(self):
        """Gets the run_info of this BomCheckCollection.  # noqa: E501


        :return: The run_info of this BomCheckCollection.  # noqa: E501
        :rtype: RunInfo
        """
        return self._run_info

    @run_info.setter
    def run_info(self, run_info):
        """Sets the run_info of this BomCheckCollection.


        :param run_info: The run_info of this BomCheckCollection.  # noqa: E501
        :type: RunInfo
        """
        if run_info is None:
            raise ValueError("Invalid value for `run_info`, must not be `None`")  # noqa: E501

        self._run_info = run_info

    @property
    def bom_checks(self):
        """Gets the bom_checks of this BomCheckCollection.  # noqa: E501

        A map with system check name as key and array of system checks  # noqa: E501

        :return: The bom_checks of this BomCheckCollection.  # noqa: E501
        :rtype: dict(str, list[BomCheck])
        """
        return self._bom_checks

    @bom_checks.setter
    def bom_checks(self, bom_checks):
        """Sets the bom_checks of this BomCheckCollection.

        A map with system check name as key and array of system checks  # noqa: E501

        :param bom_checks: The bom_checks of this BomCheckCollection.  # noqa: E501
        :type: dict(str, list[BomCheck])
        """
        if bom_checks is None:
            raise ValueError("Invalid value for `bom_checks`, must not be `None`")  # noqa: E501

        self._bom_checks = bom_checks

    @property
    def system_details(self):
        """Gets the system_details of this BomCheckCollection.  # noqa: E501


        :return: The system_details of this BomCheckCollection.  # noqa: E501
        :rtype: SystemInfo
        """
        return self._system_details

    @system_details.setter
    def system_details(self, system_details):
        """Sets the system_details of this BomCheckCollection.


        :param system_details: The system_details of this BomCheckCollection.  # noqa: E501
        :type: SystemInfo
        """
        if system_details is None:
            raise ValueError("Invalid value for `system_details`, must not be `None`")  # noqa: E501

        self._system_details = system_details

    @property
    def bom_check_collection_summary(self):
        """Gets the bom_check_collection_summary of this BomCheckCollection.  # noqa: E501


        :return: The bom_check_collection_summary of this BomCheckCollection.  # noqa: E501
        :rtype: BomCheckCollectionSummary
        """
        return self._bom_check_collection_summary

    @bom_check_collection_summary.setter
    def bom_check_collection_summary(self, bom_check_collection_summary):
        """Sets the bom_check_collection_summary of this BomCheckCollection.


        :param bom_check_collection_summary: The bom_check_collection_summary of this BomCheckCollection.  # noqa: E501
        :type: BomCheckCollectionSummary
        """
        if bom_check_collection_summary is None:
            raise ValueError("Invalid value for `bom_check_collection_summary`, must not be `None`")  # noqa: E501

        self._bom_check_collection_summary = bom_check_collection_summary

    @property
    def general_summary(self):
        """Gets the general_summary of this BomCheckCollection.  # noqa: E501

        Details about dump health and opening a case.  # noqa: E501

        :return: The general_summary of this BomCheckCollection.  # noqa: E501
        :rtype: str
        """
        return self._general_summary

    @general_summary.setter
    def general_summary(self, general_summary):
        """Sets the general_summary of this BomCheckCollection.

        Details about dump health and opening a case.  # noqa: E501

        :param general_summary: The general_summary of this BomCheckCollection.  # noqa: E501
        :type: str
        """
        if general_summary is None:
            raise ValueError("Invalid value for `general_summary`, must not be `None`")  # noqa: E501

        self._general_summary = general_summary

    @property
    def aux_info(self):
        """Gets the aux_info of this BomCheckCollection.  # noqa: E501

        Additional info on the platform.  # noqa: E501

        :return: The aux_info of this BomCheckCollection.  # noqa: E501
        :rtype: str
        """
        return self._aux_info

    @aux_info.setter
    def aux_info(self, aux_info):
        """Sets the aux_info of this BomCheckCollection.

        Additional info on the platform.  # noqa: E501

        :param aux_info: The aux_info of this BomCheckCollection.  # noqa: E501
        :type: str
        """

        self._aux_info = aux_info

    @property
    def disabled_checks(self):
        """Gets the disabled_checks of this BomCheckCollection.  # noqa: E501

        List of subsystems and systems checks which got disabled.  # noqa: E501

        :return: The disabled_checks of this BomCheckCollection.  # noqa: E501
        :rtype: list[str]
        """
        return self._disabled_checks

    @disabled_checks.setter
    def disabled_checks(self, disabled_checks):
        """Sets the disabled_checks of this BomCheckCollection.

        List of subsystems and systems checks which got disabled.  # noqa: E501

        :param disabled_checks: The disabled_checks of this BomCheckCollection.  # noqa: E501
        :type: list[str]
        """
        if disabled_checks is None:
            raise ValueError("Invalid value for `disabled_checks`, must not be `None`")  # noqa: E501

        self._disabled_checks = disabled_checks

    @property
    def sample_bom_check(self):
        """Gets the sample_bom_check of this BomCheckCollection.  # noqa: E501


        :return: The sample_bom_check of this BomCheckCollection.  # noqa: E501
        :rtype: BomCheck
        """
        return self._sample_bom_check

    @sample_bom_check.setter
    def sample_bom_check(self, sample_bom_check):
        """Sets the sample_bom_check of this BomCheckCollection.


        :param sample_bom_check: The sample_bom_check of this BomCheckCollection.  # noqa: E501
        :type: BomCheck
        """

        self._sample_bom_check = sample_bom_check

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BomCheckCollection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
