# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Boot(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'alias_boot_order': 'list[BootSource]',
        'boot_next': 'str',
        'boot_options': 'IdRef',
        'boot_order': 'list[str]',
        'boot_order_property_selection': 'BootOrderTypes',
        'boot_source_override_enabled': 'BootSourceOverrideEnabled',
        'boot_source_override_mode': 'BootSourceOverrideMode',
        'boot_source_override_target': 'BootSource',
        'uefi_target_boot_source_override': 'str'
    }

    attribute_map = {
        'alias_boot_order': 'AliasBootOrder',
        'boot_next': 'BootNext',
        'boot_options': 'BootOptions',
        'boot_order': 'BootOrder',
        'boot_order_property_selection': 'BootOrderPropertySelection',
        'boot_source_override_enabled': 'BootSourceOverrideEnabled',
        'boot_source_override_mode': 'BootSourceOverrideMode',
        'boot_source_override_target': 'BootSourceOverrideTarget',
        'uefi_target_boot_source_override': 'UefiTargetBootSourceOverride'
    }

    def __init__(self, alias_boot_order=None, boot_next=None, boot_options=None, boot_order=None, boot_order_property_selection=None, boot_source_override_enabled=None, boot_source_override_mode=None, boot_source_override_target=None, uefi_target_boot_source_override=None):  # noqa: E501
        """Boot - a model defined in OpenAPI"""  # noqa: E501

        self._alias_boot_order = None
        self._boot_next = None
        self._boot_options = None
        self._boot_order = None
        self._boot_order_property_selection = None
        self._boot_source_override_enabled = None
        self._boot_source_override_mode = None
        self._boot_source_override_target = None
        self._uefi_target_boot_source_override = None
        self.discriminator = None

        if alias_boot_order is not None:
            self.alias_boot_order = alias_boot_order
        self.boot_next = boot_next
        if boot_options is not None:
            self.boot_options = boot_options
        if boot_order is not None:
            self.boot_order = boot_order
        if boot_order_property_selection is not None:
            self.boot_order_property_selection = boot_order_property_selection
        if boot_source_override_enabled is not None:
            self.boot_source_override_enabled = boot_source_override_enabled
        if boot_source_override_mode is not None:
            self.boot_source_override_mode = boot_source_override_mode
        if boot_source_override_target is not None:
            self.boot_source_override_target = boot_source_override_target
        self.uefi_target_boot_source_override = uefi_target_boot_source_override

    @property
    def alias_boot_order(self):
        """Gets the alias_boot_order of this Boot.  # noqa: E501

        Ordered array of boot source aliases representing the persistent Boot Order associated with this computer system.  # noqa: E501

        :return: The alias_boot_order of this Boot.  # noqa: E501
        :rtype: list[BootSource]
        """
        return self._alias_boot_order

    @alias_boot_order.setter
    def alias_boot_order(self, alias_boot_order):
        """Sets the alias_boot_order of this Boot.

        Ordered array of boot source aliases representing the persistent Boot Order associated with this computer system.  # noqa: E501

        :param alias_boot_order: The alias_boot_order of this Boot.  # noqa: E501
        :type: list[BootSource]
        """

        self._alias_boot_order = alias_boot_order

    @property
    def boot_next(self):
        """Gets the boot_next of this Boot.  # noqa: E501

        This property is the BootOptionReference of the Boot Option to perform a one time boot from when BootSourceOverrideTarget is UefiBootNext.  # noqa: E501

        :return: The boot_next of this Boot.  # noqa: E501
        :rtype: str
        """
        return self._boot_next

    @boot_next.setter
    def boot_next(self, boot_next):
        """Sets the boot_next of this Boot.

        This property is the BootOptionReference of the Boot Option to perform a one time boot from when BootSourceOverrideTarget is UefiBootNext.  # noqa: E501

        :param boot_next: The boot_next of this Boot.  # noqa: E501
        :type: str
        """

        self._boot_next = boot_next

    @property
    def boot_options(self):
        """Gets the boot_options of this Boot.  # noqa: E501


        :return: The boot_options of this Boot.  # noqa: E501
        :rtype: IdRef
        """
        return self._boot_options

    @boot_options.setter
    def boot_options(self, boot_options):
        """Sets the boot_options of this Boot.


        :param boot_options: The boot_options of this Boot.  # noqa: E501
        :type: IdRef
        """

        self._boot_options = boot_options

    @property
    def boot_order(self):
        """Gets the boot_order of this Boot.  # noqa: E501

        Ordered array of BootOptionReference strings representing the persistent Boot Order associated with this computer system.  # noqa: E501

        :return: The boot_order of this Boot.  # noqa: E501
        :rtype: list[str]
        """
        return self._boot_order

    @boot_order.setter
    def boot_order(self, boot_order):
        """Sets the boot_order of this Boot.

        Ordered array of BootOptionReference strings representing the persistent Boot Order associated with this computer system.  # noqa: E501

        :param boot_order: The boot_order of this Boot.  # noqa: E501
        :type: list[str]
        """

        self._boot_order = boot_order

    @property
    def boot_order_property_selection(self):
        """Gets the boot_order_property_selection of this Boot.  # noqa: E501


        :return: The boot_order_property_selection of this Boot.  # noqa: E501
        :rtype: BootOrderTypes
        """
        return self._boot_order_property_selection

    @boot_order_property_selection.setter
    def boot_order_property_selection(self, boot_order_property_selection):
        """Sets the boot_order_property_selection of this Boot.


        :param boot_order_property_selection: The boot_order_property_selection of this Boot.  # noqa: E501
        :type: BootOrderTypes
        """

        self._boot_order_property_selection = boot_order_property_selection

    @property
    def boot_source_override_enabled(self):
        """Gets the boot_source_override_enabled of this Boot.  # noqa: E501


        :return: The boot_source_override_enabled of this Boot.  # noqa: E501
        :rtype: BootSourceOverrideEnabled
        """
        return self._boot_source_override_enabled

    @boot_source_override_enabled.setter
    def boot_source_override_enabled(self, boot_source_override_enabled):
        """Sets the boot_source_override_enabled of this Boot.


        :param boot_source_override_enabled: The boot_source_override_enabled of this Boot.  # noqa: E501
        :type: BootSourceOverrideEnabled
        """

        self._boot_source_override_enabled = boot_source_override_enabled

    @property
    def boot_source_override_mode(self):
        """Gets the boot_source_override_mode of this Boot.  # noqa: E501


        :return: The boot_source_override_mode of this Boot.  # noqa: E501
        :rtype: BootSourceOverrideMode
        """
        return self._boot_source_override_mode

    @boot_source_override_mode.setter
    def boot_source_override_mode(self, boot_source_override_mode):
        """Sets the boot_source_override_mode of this Boot.


        :param boot_source_override_mode: The boot_source_override_mode of this Boot.  # noqa: E501
        :type: BootSourceOverrideMode
        """

        self._boot_source_override_mode = boot_source_override_mode

    @property
    def boot_source_override_target(self):
        """Gets the boot_source_override_target of this Boot.  # noqa: E501


        :return: The boot_source_override_target of this Boot.  # noqa: E501
        :rtype: BootSource
        """
        return self._boot_source_override_target

    @boot_source_override_target.setter
    def boot_source_override_target(self, boot_source_override_target):
        """Sets the boot_source_override_target of this Boot.


        :param boot_source_override_target: The boot_source_override_target of this Boot.  # noqa: E501
        :type: BootSource
        """

        self._boot_source_override_target = boot_source_override_target

    @property
    def uefi_target_boot_source_override(self):
        """Gets the uefi_target_boot_source_override of this Boot.  # noqa: E501

        This property is the UEFI Device Path of the device to boot from when BootSourceOverrideTarget is UefiTarget.  # noqa: E501

        :return: The uefi_target_boot_source_override of this Boot.  # noqa: E501
        :rtype: str
        """
        return self._uefi_target_boot_source_override

    @uefi_target_boot_source_override.setter
    def uefi_target_boot_source_override(self, uefi_target_boot_source_override):
        """Sets the uefi_target_boot_source_override of this Boot.

        This property is the UEFI Device Path of the device to boot from when BootSourceOverrideTarget is UefiTarget.  # noqa: E501

        :param uefi_target_boot_source_override: The uefi_target_boot_source_override of this Boot.  # noqa: E501
        :type: str
        """

        self._uefi_target_boot_source_override = uefi_target_boot_source_override

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Boot):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
