# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class BootTargets(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'boot_priority': 'int',
        'lunid': 'str',
        'wwpn': 'str'
    }

    attribute_map = {
        'boot_priority': 'BootPriority',
        'lunid': 'LUNID',
        'wwpn': 'WWPN'
    }

    def __init__(self, boot_priority=None, lunid=None, wwpn=None):  # noqa: E501
        """BootTargets - a model defined in OpenAPI"""  # noqa: E501

        self._boot_priority = None
        self._lunid = None
        self._wwpn = None
        self.discriminator = None

        self.boot_priority = boot_priority
        self.lunid = lunid
        self.wwpn = wwpn

    @property
    def boot_priority(self):
        """Gets the boot_priority of this BootTargets.  # noqa: E501

        The relative priority for this entry in the boot targets array.  # noqa: E501

        :return: The boot_priority of this BootTargets.  # noqa: E501
        :rtype: int
        """
        return self._boot_priority

    @boot_priority.setter
    def boot_priority(self, boot_priority):
        """Sets the boot_priority of this BootTargets.

        The relative priority for this entry in the boot targets array.  # noqa: E501

        :param boot_priority: The boot_priority of this BootTargets.  # noqa: E501
        :type: int
        """

        self._boot_priority = boot_priority

    @property
    def lunid(self):
        """Gets the lunid of this BootTargets.  # noqa: E501

        The Logical Unit Number (LUN) ID to boot from on the device referred to by the corresponding WWPN.  # noqa: E501

        :return: The lunid of this BootTargets.  # noqa: E501
        :rtype: str
        """
        return self._lunid

    @lunid.setter
    def lunid(self, lunid):
        """Sets the lunid of this BootTargets.

        The Logical Unit Number (LUN) ID to boot from on the device referred to by the corresponding WWPN.  # noqa: E501

        :param lunid: The lunid of this BootTargets.  # noqa: E501
        :type: str
        """

        self._lunid = lunid

    @property
    def wwpn(self):
        """Gets the wwpn of this BootTargets.  # noqa: E501

        The World-Wide Port Name to boot from.  # noqa: E501

        :return: The wwpn of this BootTargets.  # noqa: E501
        :rtype: str
        """
        return self._wwpn

    @wwpn.setter
    def wwpn(self, wwpn):
        """Sets the wwpn of this BootTargets.

        The World-Wide Port Name to boot from.  # noqa: E501

        :param wwpn: The wwpn of this BootTargets.  # noqa: E501
        :type: str
        """

        self._wwpn = wwpn

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BootTargets):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
