# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class CallHomeRequestBody(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'trigger': 'bool',
        'description': 'str',
        'email': 'str',
        'diag_test': 'bool'
    }

    attribute_map = {
        'trigger': 'Trigger',
        'description': 'Description',
        'email': 'Email',
        'diag_test': 'DiagTest'
    }

    def __init__(self, trigger=None, description=None, email=None, diag_test=None):  # noqa: E501
        """CallHomeRequestBody - a model defined in OpenAPI"""  # noqa: E501

        self._trigger = None
        self._description = None
        self._email = None
        self._diag_test = None
        self.discriminator = None

        self.trigger = trigger
        self.description = description
        self.email = email
        self.diag_test = diag_test

    @property
    def trigger(self):
        """Gets the trigger of this CallHomeRequestBody.  # noqa: E501

        Property used to trigger or cancel callhome.  # noqa: E501

        :return: The trigger of this CallHomeRequestBody.  # noqa: E501
        :rtype: bool
        """
        return self._trigger

    @trigger.setter
    def trigger(self, trigger):
        """Sets the trigger of this CallHomeRequestBody.

        Property used to trigger or cancel callhome.  # noqa: E501

        :param trigger: The trigger of this CallHomeRequestBody.  # noqa: E501
        :type: bool
        """

        self._trigger = trigger

    @property
    def description(self):
        """Gets the description of this CallHomeRequestBody.  # noqa: E501

        Property sets the user provided comments for which the callhome is triggered.  # noqa: E501

        :return: The description of this CallHomeRequestBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CallHomeRequestBody.

        Property sets the user provided comments for which the callhome is triggered.  # noqa: E501

        :param description: The description of this CallHomeRequestBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def email(self):
        """Gets the email of this CallHomeRequestBody.  # noqa: E501

        Property sets the user provided Email id when the callhome is triggered.  # noqa: E501

        :return: The email of this CallHomeRequestBody.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this CallHomeRequestBody.

        Property sets the user provided Email id when the callhome is triggered.  # noqa: E501

        :param email: The email of this CallHomeRequestBody.  # noqa: E501
        :type: str
        """

        self._email = email

    @property
    def diag_test(self):
        """Gets the diag_test of this CallHomeRequestBody.  # noqa: E501

        Setting this property true,call-home diagnostic test will be carried out.  # noqa: E501

        :return: The diag_test of this CallHomeRequestBody.  # noqa: E501
        :rtype: bool
        """
        return self._diag_test

    @diag_test.setter
    def diag_test(self, diag_test):
        """Sets the diag_test of this CallHomeRequestBody.

        Setting this property true,call-home diagnostic test will be carried out.  # noqa: E501

        :param diag_test: The diag_test of this CallHomeRequestBody.  # noqa: E501
        :type: bool
        """

        self._diag_test = diag_test

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CallHomeRequestBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
