# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class ClockPolicy(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'auto_boost': 'str',
        'auto_boost_by_default': 'str'
    }

    attribute_map = {
        'auto_boost': 'AutoBoost',
        'auto_boost_by_default': 'AutoBoostByDefault'
    }

    def __init__(self, auto_boost=None, auto_boost_by_default=None):  # noqa: E501
        """ClockPolicy - a model defined in OpenAPI"""  # noqa: E501

        self._auto_boost = None
        self._auto_boost_by_default = None
        self.discriminator = None

        self.auto_boost = auto_boost
        self.auto_boost_by_default = auto_boost_by_default

    @property
    def auto_boost(self):
        """Gets the auto_boost of this ClockPolicy.  # noqa: E501

        Indicates whether auto boost mode is currently enabled for this GPU (On) or disabled for this GPU (Off).  # noqa: E501

        :return: The auto_boost of this ClockPolicy.  # noqa: E501
        :rtype: str
        """
        return self._auto_boost

    @auto_boost.setter
    def auto_boost(self, auto_boost):
        """Sets the auto_boost of this ClockPolicy.

        Indicates whether auto boost mode is currently enabled for this GPU (On) or disabled for this GPU (Off).  # noqa: E501

        :param auto_boost: The auto_boost of this ClockPolicy.  # noqa: E501
        :type: str
        """
        if auto_boost is None:
            raise ValueError("Invalid value for `auto_boost`, must not be `None`")  # noqa: E501

        self._auto_boost = auto_boost

    @property
    def auto_boost_by_default(self):
        """Gets the auto_boost_by_default of this ClockPolicy.  # noqa: E501

        Indicates the default setting for auto boost mode, either enabled (On) or disabled (Off).  # noqa: E501

        :return: The auto_boost_by_default of this ClockPolicy.  # noqa: E501
        :rtype: str
        """
        return self._auto_boost_by_default

    @auto_boost_by_default.setter
    def auto_boost_by_default(self, auto_boost_by_default):
        """Sets the auto_boost_by_default of this ClockPolicy.

        Indicates the default setting for auto boost mode, either enabled (On) or disabled (Off).  # noqa: E501

        :param auto_boost_by_default: The auto_boost_by_default of this ClockPolicy.  # noqa: E501
        :type: str
        """
        if auto_boost_by_default is None:
            raise ValueError("Invalid value for `auto_boost_by_default`, must not be `None`")  # noqa: E501

        self._auto_boost_by_default = auto_boost_by_default

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ClockPolicy):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
