# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class ClocksConfig(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'graphics_clock': 'str',
        'mem_clock': 'str'
    }

    attribute_map = {
        'graphics_clock': 'GraphicsClock',
        'mem_clock': 'MemClock'
    }

    def __init__(self, graphics_clock=None, mem_clock=None):  # noqa: E501
        """ClocksConfig - a model defined in OpenAPI"""  # noqa: E501

        self._graphics_clock = None
        self._mem_clock = None
        self.discriminator = None

        self.graphics_clock = graphics_clock
        self.mem_clock = mem_clock

    @property
    def graphics_clock(self):
        """Gets the graphics_clock of this ClocksConfig.  # noqa: E501

        Configured frequency of graphics (shader) clock.  # noqa: E501

        :return: The graphics_clock of this ClocksConfig.  # noqa: E501
        :rtype: str
        """
        return self._graphics_clock

    @graphics_clock.setter
    def graphics_clock(self, graphics_clock):
        """Sets the graphics_clock of this ClocksConfig.

        Configured frequency of graphics (shader) clock.  # noqa: E501

        :param graphics_clock: The graphics_clock of this ClocksConfig.  # noqa: E501
        :type: str
        """
        if graphics_clock is None:
            raise ValueError("Invalid value for `graphics_clock`, must not be `None`")  # noqa: E501

        self._graphics_clock = graphics_clock

    @property
    def mem_clock(self):
        """Gets the mem_clock of this ClocksConfig.  # noqa: E501

        Configured frequency of memory clock.  # noqa: E501

        :return: The mem_clock of this ClocksConfig.  # noqa: E501
        :rtype: str
        """
        return self._mem_clock

    @mem_clock.setter
    def mem_clock(self, mem_clock):
        """Sets the mem_clock of this ClocksConfig.

        Configured frequency of memory clock.  # noqa: E501

        :param mem_clock: The mem_clock of this ClocksConfig.  # noqa: E501
        :type: str
        """
        if mem_clock is None:
            raise ValueError("Invalid value for `mem_clock`, must not be `None`")  # noqa: E501

        self._mem_clock = mem_clock

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ClocksConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
