# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Connections(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'cpu_affinity_bit_map': 'CPUAffinityBitMap',
        'device_minor_number': 'int',
        'display_attached': 'str',
        'driver_assigned_board_id': 'int',
        'multi_gpu_board': 'bool',
        'pc_ie_gen': 'str',
        'pc_ie_link_width': 'str',
        'pc_ie_location': 'str'
    }

    attribute_map = {
        'cpu_affinity_bit_map': 'CPUAffinityBitMap',
        'device_minor_number': 'DeviceMinorNumber',
        'display_attached': 'DisplayAttached',
        'driver_assigned_board_id': 'DriverAssignedBoardID',
        'multi_gpu_board': 'MultiGPUBoard',
        'pc_ie_gen': 'PCIeGen',
        'pc_ie_link_width': 'PCIeLinkWidth',
        'pc_ie_location': 'PCIeLocation'
    }

    def __init__(self, cpu_affinity_bit_map=None, device_minor_number=None, display_attached=None, driver_assigned_board_id=None, multi_gpu_board=None, pc_ie_gen=None, pc_ie_link_width=None, pc_ie_location=None):  # noqa: E501
        """Connections - a model defined in OpenAPI"""  # noqa: E501

        self._cpu_affinity_bit_map = None
        self._device_minor_number = None
        self._display_attached = None
        self._driver_assigned_board_id = None
        self._multi_gpu_board = None
        self._pc_ie_gen = None
        self._pc_ie_link_width = None
        self._pc_ie_location = None
        self.discriminator = None

        self.cpu_affinity_bit_map = cpu_affinity_bit_map
        self.device_minor_number = device_minor_number
        self.display_attached = display_attached
        self.driver_assigned_board_id = driver_assigned_board_id
        self.multi_gpu_board = multi_gpu_board
        self.pc_ie_gen = pc_ie_gen
        self.pc_ie_link_width = pc_ie_link_width
        self.pc_ie_location = pc_ie_location

    @property
    def cpu_affinity_bit_map(self):
        """Gets the cpu_affinity_bit_map of this Connections.  # noqa: E501


        :return: The cpu_affinity_bit_map of this Connections.  # noqa: E501
        :rtype: CPUAffinityBitMap
        """
        return self._cpu_affinity_bit_map

    @cpu_affinity_bit_map.setter
    def cpu_affinity_bit_map(self, cpu_affinity_bit_map):
        """Sets the cpu_affinity_bit_map of this Connections.


        :param cpu_affinity_bit_map: The cpu_affinity_bit_map of this Connections.  # noqa: E501
        :type: CPUAffinityBitMap
        """
        if cpu_affinity_bit_map is None:
            raise ValueError("Invalid value for `cpu_affinity_bit_map`, must not be `None`")  # noqa: E501

        self._cpu_affinity_bit_map = cpu_affinity_bit_map

    @property
    def device_minor_number(self):
        """Gets the device_minor_number of this Connections.  # noqa: E501

        The minor number for the device is such that the Nvidia device node file for each GPU will have the form /dev/nvidia[minor number]. Available only on Linux platform.  # noqa: E501

        :return: The device_minor_number of this Connections.  # noqa: E501
        :rtype: int
        """
        return self._device_minor_number

    @device_minor_number.setter
    def device_minor_number(self, device_minor_number):
        """Sets the device_minor_number of this Connections.

        The minor number for the device is such that the Nvidia device node file for each GPU will have the form /dev/nvidia[minor number]. Available only on Linux platform.  # noqa: E501

        :param device_minor_number: The device_minor_number of this Connections.  # noqa: E501
        :type: int
        """
        if device_minor_number is None:
            raise ValueError("Invalid value for `device_minor_number`, must not be `None`")  # noqa: E501

        self._device_minor_number = device_minor_number

    @property
    def display_attached(self):
        """Gets the display_attached of this Connections.  # noqa: E501

        A flag that indicates whether a physical display (e.g. monitor) is currently connected to any of the GPU connectors. \"Enabled\" indicates an attached display. \"Disabled\" indicates otherwise.  # noqa: E501

        :return: The display_attached of this Connections.  # noqa: E501
        :rtype: str
        """
        return self._display_attached

    @display_attached.setter
    def display_attached(self, display_attached):
        """Sets the display_attached of this Connections.

        A flag that indicates whether a physical display (e.g. monitor) is currently connected to any of the GPU connectors. \"Enabled\" indicates an attached display. \"Disabled\" indicates otherwise.  # noqa: E501

        :param display_attached: The display_attached of this Connections.  # noqa: E501
        :type: str
        """
        if display_attached is None:
            raise ValueError("Invalid value for `display_attached`, must not be `None`")  # noqa: E501

        self._display_attached = display_attached

    @property
    def driver_assigned_board_id(self):
        """Gets the driver_assigned_board_id of this Connections.  # noqa: E501

        The unique board ID assigned by the driver. If two or more GPUs have the same board ID and the above \"MultiGPU\" field is true then the GPUs are on the same board.  # noqa: E501

        :return: The driver_assigned_board_id of this Connections.  # noqa: E501
        :rtype: int
        """
        return self._driver_assigned_board_id

    @driver_assigned_board_id.setter
    def driver_assigned_board_id(self, driver_assigned_board_id):
        """Sets the driver_assigned_board_id of this Connections.

        The unique board ID assigned by the driver. If two or more GPUs have the same board ID and the above \"MultiGPU\" field is true then the GPUs are on the same board.  # noqa: E501

        :param driver_assigned_board_id: The driver_assigned_board_id of this Connections.  # noqa: E501
        :type: int
        """
        if driver_assigned_board_id is None:
            raise ValueError("Invalid value for `driver_assigned_board_id`, must not be `None`")  # noqa: E501

        self._driver_assigned_board_id = driver_assigned_board_id

    @property
    def multi_gpu_board(self):
        """Gets the multi_gpu_board of this Connections.  # noqa: E501

        Whether or not this GPU is part of a multiGPU board.  # noqa: E501

        :return: The multi_gpu_board of this Connections.  # noqa: E501
        :rtype: bool
        """
        return self._multi_gpu_board

    @multi_gpu_board.setter
    def multi_gpu_board(self, multi_gpu_board):
        """Sets the multi_gpu_board of this Connections.

        Whether or not this GPU is part of a multiGPU board.  # noqa: E501

        :param multi_gpu_board: The multi_gpu_board of this Connections.  # noqa: E501
        :type: bool
        """
        if multi_gpu_board is None:
            raise ValueError("Invalid value for `multi_gpu_board`, must not be `None`")  # noqa: E501

        self._multi_gpu_board = multi_gpu_board

    @property
    def pc_ie_gen(self):
        """Gets the pc_ie_gen of this Connections.  # noqa: E501

        The current link generation. This may be reduced when the GPU is not in use.  # noqa: E501

        :return: The pc_ie_gen of this Connections.  # noqa: E501
        :rtype: str
        """
        return self._pc_ie_gen

    @pc_ie_gen.setter
    def pc_ie_gen(self, pc_ie_gen):
        """Sets the pc_ie_gen of this Connections.

        The current link generation. This may be reduced when the GPU is not in use.  # noqa: E501

        :param pc_ie_gen: The pc_ie_gen of this Connections.  # noqa: E501
        :type: str
        """
        if pc_ie_gen is None:
            raise ValueError("Invalid value for `pc_ie_gen`, must not be `None`")  # noqa: E501

        self._pc_ie_gen = pc_ie_gen

    @property
    def pc_ie_link_width(self):
        """Gets the pc_ie_link_width of this Connections.  # noqa: E501

        The current link width. This may be reduced when the GPU is not in use.  # noqa: E501

        :return: The pc_ie_link_width of this Connections.  # noqa: E501
        :rtype: str
        """
        return self._pc_ie_link_width

    @pc_ie_link_width.setter
    def pc_ie_link_width(self, pc_ie_link_width):
        """Sets the pc_ie_link_width of this Connections.

        The current link width. This may be reduced when the GPU is not in use.  # noqa: E501

        :param pc_ie_link_width: The pc_ie_link_width of this Connections.  # noqa: E501
        :type: str
        """
        if pc_ie_link_width is None:
            raise ValueError("Invalid value for `pc_ie_link_width`, must not be `None`")  # noqa: E501

        self._pc_ie_link_width = pc_ie_link_width

    @property
    def pc_ie_location(self):
        """Gets the pc_ie_location of this Connections.  # noqa: E501

        The PCIe Bus Device Function this GPU is enumerated as. Format is \"domain:bus:device.function\", in hex.  # noqa: E501

        :return: The pc_ie_location of this Connections.  # noqa: E501
        :rtype: str
        """
        return self._pc_ie_location

    @pc_ie_location.setter
    def pc_ie_location(self, pc_ie_location):
        """Sets the pc_ie_location of this Connections.

        The PCIe Bus Device Function this GPU is enumerated as. Format is \"domain:bus:device.function\", in hex.  # noqa: E501

        :param pc_ie_location: The pc_ie_location of this Connections.  # noqa: E501
        :type: str
        """
        if pc_ie_location is None:
            raise ValueError("Invalid value for `pc_ie_location`, must not be `None`")  # noqa: E501

        self._pc_ie_location = pc_ie_location

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Connections):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
