# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class ControllerCapabilities(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'data_center_bridging': 'DataCenterBridging',
        'npar': 'NicPartitioning',
        'npiv': 'NPIV',
        'network_device_function_count': 'int',
        'network_port_count': 'int',
        'virtualization_offload': 'VirtualizationOffload'
    }

    attribute_map = {
        'data_center_bridging': 'DataCenterBridging',
        'npar': 'NPAR',
        'npiv': 'NPIV',
        'network_device_function_count': 'NetworkDeviceFunctionCount',
        'network_port_count': 'NetworkPortCount',
        'virtualization_offload': 'VirtualizationOffload'
    }

    def __init__(self, data_center_bridging=None, npar=None, npiv=None, network_device_function_count=None, network_port_count=None, virtualization_offload=None):  # noqa: E501
        """ControllerCapabilities - a model defined in OpenAPI"""  # noqa: E501

        self._data_center_bridging = None
        self._npar = None
        self._npiv = None
        self._network_device_function_count = None
        self._network_port_count = None
        self._virtualization_offload = None
        self.discriminator = None

        if data_center_bridging is not None:
            self.data_center_bridging = data_center_bridging
        if npar is not None:
            self.npar = npar
        if npiv is not None:
            self.npiv = npiv
        self.network_device_function_count = network_device_function_count
        self.network_port_count = network_port_count
        if virtualization_offload is not None:
            self.virtualization_offload = virtualization_offload

    @property
    def data_center_bridging(self):
        """Gets the data_center_bridging of this ControllerCapabilities.  # noqa: E501


        :return: The data_center_bridging of this ControllerCapabilities.  # noqa: E501
        :rtype: DataCenterBridging
        """
        return self._data_center_bridging

    @data_center_bridging.setter
    def data_center_bridging(self, data_center_bridging):
        """Sets the data_center_bridging of this ControllerCapabilities.


        :param data_center_bridging: The data_center_bridging of this ControllerCapabilities.  # noqa: E501
        :type: DataCenterBridging
        """

        self._data_center_bridging = data_center_bridging

    @property
    def npar(self):
        """Gets the npar of this ControllerCapabilities.  # noqa: E501


        :return: The npar of this ControllerCapabilities.  # noqa: E501
        :rtype: NicPartitioning
        """
        return self._npar

    @npar.setter
    def npar(self, npar):
        """Sets the npar of this ControllerCapabilities.


        :param npar: The npar of this ControllerCapabilities.  # noqa: E501
        :type: NicPartitioning
        """

        self._npar = npar

    @property
    def npiv(self):
        """Gets the npiv of this ControllerCapabilities.  # noqa: E501


        :return: The npiv of this ControllerCapabilities.  # noqa: E501
        :rtype: NPIV
        """
        return self._npiv

    @npiv.setter
    def npiv(self, npiv):
        """Sets the npiv of this ControllerCapabilities.


        :param npiv: The npiv of this ControllerCapabilities.  # noqa: E501
        :type: NPIV
        """

        self._npiv = npiv

    @property
    def network_device_function_count(self):
        """Gets the network_device_function_count of this ControllerCapabilities.  # noqa: E501

        The maximum number of physical functions available on this controller.  # noqa: E501

        :return: The network_device_function_count of this ControllerCapabilities.  # noqa: E501
        :rtype: int
        """
        return self._network_device_function_count

    @network_device_function_count.setter
    def network_device_function_count(self, network_device_function_count):
        """Sets the network_device_function_count of this ControllerCapabilities.

        The maximum number of physical functions available on this controller.  # noqa: E501

        :param network_device_function_count: The network_device_function_count of this ControllerCapabilities.  # noqa: E501
        :type: int
        """

        self._network_device_function_count = network_device_function_count

    @property
    def network_port_count(self):
        """Gets the network_port_count of this ControllerCapabilities.  # noqa: E501

        The number of physical ports on this controller.  # noqa: E501

        :return: The network_port_count of this ControllerCapabilities.  # noqa: E501
        :rtype: int
        """
        return self._network_port_count

    @network_port_count.setter
    def network_port_count(self, network_port_count):
        """Sets the network_port_count of this ControllerCapabilities.

        The number of physical ports on this controller.  # noqa: E501

        :param network_port_count: The network_port_count of this ControllerCapabilities.  # noqa: E501
        :type: int
        """

        self._network_port_count = network_port_count

    @property
    def virtualization_offload(self):
        """Gets the virtualization_offload of this ControllerCapabilities.  # noqa: E501


        :return: The virtualization_offload of this ControllerCapabilities.  # noqa: E501
        :rtype: VirtualizationOffload
        """
        return self._virtualization_offload

    @virtualization_offload.setter
    def virtualization_offload(self, virtualization_offload):
        """Sets the virtualization_offload of this ControllerCapabilities.


        :param virtualization_offload: The virtualization_offload of this ControllerCapabilities.  # noqa: E501
        :type: VirtualizationOffload
        """

        self._virtualization_offload = virtualization_offload

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ControllerCapabilities):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
