# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class ControllerLinks(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'network_device_functions': 'list[IdRef]',
        'network_device_functionsodata_count': 'int',
        'network_ports': 'list[IdRef]',
        'network_portsodata_count': 'int',
        'oem': 'dict(str, object)',
        'pc_ie_devices': 'list[IdRef]',
        'pc_ie_devicesodata_count': 'int'
    }

    attribute_map = {
        'network_device_functions': 'NetworkDeviceFunctions',
        'network_device_functionsodata_count': 'NetworkDeviceFunctions@odata.count',
        'network_ports': 'NetworkPorts',
        'network_portsodata_count': 'NetworkPorts@odata.count',
        'oem': 'Oem',
        'pc_ie_devices': 'PCIeDevices',
        'pc_ie_devicesodata_count': 'PCIeDevices@odata.count'
    }

    def __init__(self, network_device_functions=None, network_device_functionsodata_count=None, network_ports=None, network_portsodata_count=None, oem=None, pc_ie_devices=None, pc_ie_devicesodata_count=None):  # noqa: E501
        """ControllerLinks - a model defined in OpenAPI"""  # noqa: E501

        self._network_device_functions = None
        self._network_device_functionsodata_count = None
        self._network_ports = None
        self._network_portsodata_count = None
        self._oem = None
        self._pc_ie_devices = None
        self._pc_ie_devicesodata_count = None
        self.discriminator = None

        if network_device_functions is not None:
            self.network_device_functions = network_device_functions
        if network_device_functionsodata_count is not None:
            self.network_device_functionsodata_count = network_device_functionsodata_count
        if network_ports is not None:
            self.network_ports = network_ports
        if network_portsodata_count is not None:
            self.network_portsodata_count = network_portsodata_count
        if oem is not None:
            self.oem = oem
        if pc_ie_devices is not None:
            self.pc_ie_devices = pc_ie_devices
        if pc_ie_devicesodata_count is not None:
            self.pc_ie_devicesodata_count = pc_ie_devicesodata_count

    @property
    def network_device_functions(self):
        """Gets the network_device_functions of this ControllerLinks.  # noqa: E501

        An array of references to the NetworkDeviceFunctions associated with this Network Controller.  # noqa: E501

        :return: The network_device_functions of this ControllerLinks.  # noqa: E501
        :rtype: list[IdRef]
        """
        return self._network_device_functions

    @network_device_functions.setter
    def network_device_functions(self, network_device_functions):
        """Sets the network_device_functions of this ControllerLinks.

        An array of references to the NetworkDeviceFunctions associated with this Network Controller.  # noqa: E501

        :param network_device_functions: The network_device_functions of this ControllerLinks.  # noqa: E501
        :type: list[IdRef]
        """

        self._network_device_functions = network_device_functions

    @property
    def network_device_functionsodata_count(self):
        """Gets the network_device_functionsodata_count of this ControllerLinks.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The network_device_functionsodata_count of this ControllerLinks.  # noqa: E501
        :rtype: int
        """
        return self._network_device_functionsodata_count

    @network_device_functionsodata_count.setter
    def network_device_functionsodata_count(self, network_device_functionsodata_count):
        """Sets the network_device_functionsodata_count of this ControllerLinks.

        The number of items in a collection.  # noqa: E501

        :param network_device_functionsodata_count: The network_device_functionsodata_count of this ControllerLinks.  # noqa: E501
        :type: int
        """

        self._network_device_functionsodata_count = network_device_functionsodata_count

    @property
    def network_ports(self):
        """Gets the network_ports of this ControllerLinks.  # noqa: E501

        An array of references to the NetworkPorts associated with this Network Controller.  # noqa: E501

        :return: The network_ports of this ControllerLinks.  # noqa: E501
        :rtype: list[IdRef]
        """
        return self._network_ports

    @network_ports.setter
    def network_ports(self, network_ports):
        """Sets the network_ports of this ControllerLinks.

        An array of references to the NetworkPorts associated with this Network Controller.  # noqa: E501

        :param network_ports: The network_ports of this ControllerLinks.  # noqa: E501
        :type: list[IdRef]
        """

        self._network_ports = network_ports

    @property
    def network_portsodata_count(self):
        """Gets the network_portsodata_count of this ControllerLinks.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The network_portsodata_count of this ControllerLinks.  # noqa: E501
        :rtype: int
        """
        return self._network_portsodata_count

    @network_portsodata_count.setter
    def network_portsodata_count(self, network_portsodata_count):
        """Sets the network_portsodata_count of this ControllerLinks.

        The number of items in a collection.  # noqa: E501

        :param network_portsodata_count: The network_portsodata_count of this ControllerLinks.  # noqa: E501
        :type: int
        """

        self._network_portsodata_count = network_portsodata_count

    @property
    def oem(self):
        """Gets the oem of this ControllerLinks.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this ControllerLinks.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this ControllerLinks.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this ControllerLinks.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def pc_ie_devices(self):
        """Gets the pc_ie_devices of this ControllerLinks.  # noqa: E501

        An array of references to the PCIeDevices associated with this Network Controller.  # noqa: E501

        :return: The pc_ie_devices of this ControllerLinks.  # noqa: E501
        :rtype: list[IdRef]
        """
        return self._pc_ie_devices

    @pc_ie_devices.setter
    def pc_ie_devices(self, pc_ie_devices):
        """Sets the pc_ie_devices of this ControllerLinks.

        An array of references to the PCIeDevices associated with this Network Controller.  # noqa: E501

        :param pc_ie_devices: The pc_ie_devices of this ControllerLinks.  # noqa: E501
        :type: list[IdRef]
        """

        self._pc_ie_devices = pc_ie_devices

    @property
    def pc_ie_devicesodata_count(self):
        """Gets the pc_ie_devicesodata_count of this ControllerLinks.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The pc_ie_devicesodata_count of this ControllerLinks.  # noqa: E501
        :rtype: int
        """
        return self._pc_ie_devicesodata_count

    @pc_ie_devicesodata_count.setter
    def pc_ie_devicesodata_count(self, pc_ie_devicesodata_count):
        """Sets the pc_ie_devicesodata_count of this ControllerLinks.

        The number of items in a collection.  # noqa: E501

        :param pc_ie_devicesodata_count: The pc_ie_devicesodata_count of this ControllerLinks.  # noqa: E501
        :type: int
        """

        self._pc_ie_devicesodata_count = pc_ie_devicesodata_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ControllerLinks):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
