# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Controllers(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'controller_capabilities': 'ControllerCapabilities',
        'firmware_package_version': 'str',
        'links': 'ControllerLinks',
        'location': 'Location',
        'pc_ie_interface': 'PCIeInterface'
    }

    attribute_map = {
        'controller_capabilities': 'ControllerCapabilities',
        'firmware_package_version': 'FirmwarePackageVersion',
        'links': 'Links',
        'location': 'Location',
        'pc_ie_interface': 'PCIeInterface'
    }

    def __init__(self, controller_capabilities=None, firmware_package_version=None, links=None, location=None, pc_ie_interface=None):  # noqa: E501
        """Controllers - a model defined in OpenAPI"""  # noqa: E501

        self._controller_capabilities = None
        self._firmware_package_version = None
        self._links = None
        self._location = None
        self._pc_ie_interface = None
        self.discriminator = None

        if controller_capabilities is not None:
            self.controller_capabilities = controller_capabilities
        self.firmware_package_version = firmware_package_version
        if links is not None:
            self.links = links
        if location is not None:
            self.location = location
        if pc_ie_interface is not None:
            self.pc_ie_interface = pc_ie_interface

    @property
    def controller_capabilities(self):
        """Gets the controller_capabilities of this Controllers.  # noqa: E501


        :return: The controller_capabilities of this Controllers.  # noqa: E501
        :rtype: ControllerCapabilities
        """
        return self._controller_capabilities

    @controller_capabilities.setter
    def controller_capabilities(self, controller_capabilities):
        """Sets the controller_capabilities of this Controllers.


        :param controller_capabilities: The controller_capabilities of this Controllers.  # noqa: E501
        :type: ControllerCapabilities
        """

        self._controller_capabilities = controller_capabilities

    @property
    def firmware_package_version(self):
        """Gets the firmware_package_version of this Controllers.  # noqa: E501

        The version of the user-facing firmware package.  # noqa: E501

        :return: The firmware_package_version of this Controllers.  # noqa: E501
        :rtype: str
        """
        return self._firmware_package_version

    @firmware_package_version.setter
    def firmware_package_version(self, firmware_package_version):
        """Sets the firmware_package_version of this Controllers.

        The version of the user-facing firmware package.  # noqa: E501

        :param firmware_package_version: The firmware_package_version of this Controllers.  # noqa: E501
        :type: str
        """

        self._firmware_package_version = firmware_package_version

    @property
    def links(self):
        """Gets the links of this Controllers.  # noqa: E501


        :return: The links of this Controllers.  # noqa: E501
        :rtype: ControllerLinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this Controllers.


        :param links: The links of this Controllers.  # noqa: E501
        :type: ControllerLinks
        """

        self._links = links

    @property
    def location(self):
        """Gets the location of this Controllers.  # noqa: E501


        :return: The location of this Controllers.  # noqa: E501
        :rtype: Location
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this Controllers.


        :param location: The location of this Controllers.  # noqa: E501
        :type: Location
        """

        self._location = location

    @property
    def pc_ie_interface(self):
        """Gets the pc_ie_interface of this Controllers.  # noqa: E501


        :return: The pc_ie_interface of this Controllers.  # noqa: E501
        :rtype: PCIeInterface
        """
        return self._pc_ie_interface

    @pc_ie_interface.setter
    def pc_ie_interface(self, pc_ie_interface):
        """Sets the pc_ie_interface of this Controllers.


        :param pc_ie_interface: The pc_ie_interface of this Controllers.  # noqa: E501
        :type: PCIeInterface
        """

        self._pc_ie_interface = pc_ie_interface

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Controllers):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
