# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class CPUAffinityBitMap(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'cp_us_0_63': 'str',
        'cp_us_128_191': 'str',
        'cp_us_192_255': 'str',
        'cp_us_64_127': 'str'
    }

    attribute_map = {
        'cp_us_0_63': 'CPUs_0_63',
        'cp_us_128_191': 'CPUs_128_191',
        'cp_us_192_255': 'CPUs_192_255',
        'cp_us_64_127': 'CPUs_64_127'
    }

    def __init__(self, cp_us_0_63=None, cp_us_128_191=None, cp_us_192_255=None, cp_us_64_127=None):  # noqa: E501
        """CPUAffinityBitMap - a model defined in OpenAPI"""  # noqa: E501

        self._cp_us_0_63 = None
        self._cp_us_128_191 = None
        self._cp_us_192_255 = None
        self._cp_us_64_127 = None
        self.discriminator = None

        self.cp_us_0_63 = cp_us_0_63
        self.cp_us_128_191 = cp_us_128_191
        self.cp_us_192_255 = cp_us_192_255
        self.cp_us_64_127 = cp_us_64_127

    @property
    def cp_us_0_63(self):
        """Gets the cp_us_0_63 of this CPUAffinityBitMap.  # noqa: E501

        Affinity of this GPU to CPU number 0 to 63.  # noqa: E501

        :return: The cp_us_0_63 of this CPUAffinityBitMap.  # noqa: E501
        :rtype: str
        """
        return self._cp_us_0_63

    @cp_us_0_63.setter
    def cp_us_0_63(self, cp_us_0_63):
        """Sets the cp_us_0_63 of this CPUAffinityBitMap.

        Affinity of this GPU to CPU number 0 to 63.  # noqa: E501

        :param cp_us_0_63: The cp_us_0_63 of this CPUAffinityBitMap.  # noqa: E501
        :type: str
        """
        if cp_us_0_63 is None:
            raise ValueError("Invalid value for `cp_us_0_63`, must not be `None`")  # noqa: E501

        self._cp_us_0_63 = cp_us_0_63

    @property
    def cp_us_128_191(self):
        """Gets the cp_us_128_191 of this CPUAffinityBitMap.  # noqa: E501

        Affinity of this GPU to CPU number 128 to 191.  # noqa: E501

        :return: The cp_us_128_191 of this CPUAffinityBitMap.  # noqa: E501
        :rtype: str
        """
        return self._cp_us_128_191

    @cp_us_128_191.setter
    def cp_us_128_191(self, cp_us_128_191):
        """Sets the cp_us_128_191 of this CPUAffinityBitMap.

        Affinity of this GPU to CPU number 128 to 191.  # noqa: E501

        :param cp_us_128_191: The cp_us_128_191 of this CPUAffinityBitMap.  # noqa: E501
        :type: str
        """
        if cp_us_128_191 is None:
            raise ValueError("Invalid value for `cp_us_128_191`, must not be `None`")  # noqa: E501

        self._cp_us_128_191 = cp_us_128_191

    @property
    def cp_us_192_255(self):
        """Gets the cp_us_192_255 of this CPUAffinityBitMap.  # noqa: E501

        Affinity of this GPU to CPU number 192 to 255.  # noqa: E501

        :return: The cp_us_192_255 of this CPUAffinityBitMap.  # noqa: E501
        :rtype: str
        """
        return self._cp_us_192_255

    @cp_us_192_255.setter
    def cp_us_192_255(self, cp_us_192_255):
        """Sets the cp_us_192_255 of this CPUAffinityBitMap.

        Affinity of this GPU to CPU number 192 to 255.  # noqa: E501

        :param cp_us_192_255: The cp_us_192_255 of this CPUAffinityBitMap.  # noqa: E501
        :type: str
        """
        if cp_us_192_255 is None:
            raise ValueError("Invalid value for `cp_us_192_255`, must not be `None`")  # noqa: E501

        self._cp_us_192_255 = cp_us_192_255

    @property
    def cp_us_64_127(self):
        """Gets the cp_us_64_127 of this CPUAffinityBitMap.  # noqa: E501

        Affinity of this GPU to CPU number 64 to 127.  # noqa: E501

        :return: The cp_us_64_127 of this CPUAffinityBitMap.  # noqa: E501
        :rtype: str
        """
        return self._cp_us_64_127

    @cp_us_64_127.setter
    def cp_us_64_127(self, cp_us_64_127):
        """Sets the cp_us_64_127 of this CPUAffinityBitMap.

        Affinity of this GPU to CPU number 64 to 127.  # noqa: E501

        :param cp_us_64_127: The cp_us_64_127 of this CPUAffinityBitMap.  # noqa: E501
        :type: str
        """
        if cp_us_64_127 is None:
            raise ValueError("Invalid value for `cp_us_64_127`, must not be `None`")  # noqa: E501

        self._cp_us_64_127 = cp_us_64_127

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CPUAffinityBitMap):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
