# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class DHCPv4Configuration(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'dhcp_enabled': 'bool',
        'fallback_address': 'DHCPFallback',
        'use_dns_servers': 'bool',
        'use_domain_name': 'bool',
        'use_gateway': 'bool',
        'use_ntp_servers': 'bool',
        'use_static_routes': 'bool'
    }

    attribute_map = {
        'dhcp_enabled': 'DHCPEnabled',
        'fallback_address': 'FallbackAddress',
        'use_dns_servers': 'UseDNSServers',
        'use_domain_name': 'UseDomainName',
        'use_gateway': 'UseGateway',
        'use_ntp_servers': 'UseNTPServers',
        'use_static_routes': 'UseStaticRoutes'
    }

    def __init__(self, dhcp_enabled=None, fallback_address=None, use_dns_servers=None, use_domain_name=None, use_gateway=None, use_ntp_servers=None, use_static_routes=None):  # noqa: E501
        """DHCPv4Configuration - a model defined in OpenAPI"""  # noqa: E501

        self._dhcp_enabled = None
        self._fallback_address = None
        self._use_dns_servers = None
        self._use_domain_name = None
        self._use_gateway = None
        self._use_ntp_servers = None
        self._use_static_routes = None
        self.discriminator = None

        self.dhcp_enabled = dhcp_enabled
        if fallback_address is not None:
            self.fallback_address = fallback_address
        self.use_dns_servers = use_dns_servers
        self.use_domain_name = use_domain_name
        self.use_gateway = use_gateway
        self.use_ntp_servers = use_ntp_servers
        self.use_static_routes = use_static_routes

    @property
    def dhcp_enabled(self):
        """Gets the dhcp_enabled of this DHCPv4Configuration.  # noqa: E501

        Determines whether DHCPv4 is enabled on this interface.  # noqa: E501

        :return: The dhcp_enabled of this DHCPv4Configuration.  # noqa: E501
        :rtype: bool
        """
        return self._dhcp_enabled

    @dhcp_enabled.setter
    def dhcp_enabled(self, dhcp_enabled):
        """Sets the dhcp_enabled of this DHCPv4Configuration.

        Determines whether DHCPv4 is enabled on this interface.  # noqa: E501

        :param dhcp_enabled: The dhcp_enabled of this DHCPv4Configuration.  # noqa: E501
        :type: bool
        """

        self._dhcp_enabled = dhcp_enabled

    @property
    def fallback_address(self):
        """Gets the fallback_address of this DHCPv4Configuration.  # noqa: E501


        :return: The fallback_address of this DHCPv4Configuration.  # noqa: E501
        :rtype: DHCPFallback
        """
        return self._fallback_address

    @fallback_address.setter
    def fallback_address(self, fallback_address):
        """Sets the fallback_address of this DHCPv4Configuration.


        :param fallback_address: The fallback_address of this DHCPv4Configuration.  # noqa: E501
        :type: DHCPFallback
        """

        self._fallback_address = fallback_address

    @property
    def use_dns_servers(self):
        """Gets the use_dns_servers of this DHCPv4Configuration.  # noqa: E501

        Determines whether to use DHCPv4-supplied DNS servers.  # noqa: E501

        :return: The use_dns_servers of this DHCPv4Configuration.  # noqa: E501
        :rtype: bool
        """
        return self._use_dns_servers

    @use_dns_servers.setter
    def use_dns_servers(self, use_dns_servers):
        """Sets the use_dns_servers of this DHCPv4Configuration.

        Determines whether to use DHCPv4-supplied DNS servers.  # noqa: E501

        :param use_dns_servers: The use_dns_servers of this DHCPv4Configuration.  # noqa: E501
        :type: bool
        """

        self._use_dns_servers = use_dns_servers

    @property
    def use_domain_name(self):
        """Gets the use_domain_name of this DHCPv4Configuration.  # noqa: E501

        Determines whether to use a DHCPv4-supplied domain name.  # noqa: E501

        :return: The use_domain_name of this DHCPv4Configuration.  # noqa: E501
        :rtype: bool
        """
        return self._use_domain_name

    @use_domain_name.setter
    def use_domain_name(self, use_domain_name):
        """Sets the use_domain_name of this DHCPv4Configuration.

        Determines whether to use a DHCPv4-supplied domain name.  # noqa: E501

        :param use_domain_name: The use_domain_name of this DHCPv4Configuration.  # noqa: E501
        :type: bool
        """

        self._use_domain_name = use_domain_name

    @property
    def use_gateway(self):
        """Gets the use_gateway of this DHCPv4Configuration.  # noqa: E501

        Determines whether to use a DHCPv4-supplied gateway.  # noqa: E501

        :return: The use_gateway of this DHCPv4Configuration.  # noqa: E501
        :rtype: bool
        """
        return self._use_gateway

    @use_gateway.setter
    def use_gateway(self, use_gateway):
        """Sets the use_gateway of this DHCPv4Configuration.

        Determines whether to use a DHCPv4-supplied gateway.  # noqa: E501

        :param use_gateway: The use_gateway of this DHCPv4Configuration.  # noqa: E501
        :type: bool
        """

        self._use_gateway = use_gateway

    @property
    def use_ntp_servers(self):
        """Gets the use_ntp_servers of this DHCPv4Configuration.  # noqa: E501

        Determines whether to use DHCPv4-supplied NTP servers.  # noqa: E501

        :return: The use_ntp_servers of this DHCPv4Configuration.  # noqa: E501
        :rtype: bool
        """
        return self._use_ntp_servers

    @use_ntp_servers.setter
    def use_ntp_servers(self, use_ntp_servers):
        """Sets the use_ntp_servers of this DHCPv4Configuration.

        Determines whether to use DHCPv4-supplied NTP servers.  # noqa: E501

        :param use_ntp_servers: The use_ntp_servers of this DHCPv4Configuration.  # noqa: E501
        :type: bool
        """

        self._use_ntp_servers = use_ntp_servers

    @property
    def use_static_routes(self):
        """Gets the use_static_routes of this DHCPv4Configuration.  # noqa: E501

        Determines whether to use DHCPv4-supplied static routes.  # noqa: E501

        :return: The use_static_routes of this DHCPv4Configuration.  # noqa: E501
        :rtype: bool
        """
        return self._use_static_routes

    @use_static_routes.setter
    def use_static_routes(self, use_static_routes):
        """Sets the use_static_routes of this DHCPv4Configuration.

        Determines whether to use DHCPv4-supplied static routes.  # noqa: E501

        :param use_static_routes: The use_static_routes of this DHCPv4Configuration.  # noqa: E501
        :type: bool
        """

        self._use_static_routes = use_static_routes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DHCPv4Configuration):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
