# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class DHCPv6Configuration(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'operating_mode': 'DHCPv6OperatingMode',
        'use_dns_servers': 'bool',
        'use_domain_name': 'bool',
        'use_ntp_servers': 'bool',
        'use_rapid_commit': 'bool'
    }

    attribute_map = {
        'operating_mode': 'OperatingMode',
        'use_dns_servers': 'UseDNSServers',
        'use_domain_name': 'UseDomainName',
        'use_ntp_servers': 'UseNTPServers',
        'use_rapid_commit': 'UseRapidCommit'
    }

    def __init__(self, operating_mode=None, use_dns_servers=None, use_domain_name=None, use_ntp_servers=None, use_rapid_commit=None):  # noqa: E501
        """DHCPv6Configuration - a model defined in OpenAPI"""  # noqa: E501

        self._operating_mode = None
        self._use_dns_servers = None
        self._use_domain_name = None
        self._use_ntp_servers = None
        self._use_rapid_commit = None
        self.discriminator = None

        if operating_mode is not None:
            self.operating_mode = operating_mode
        self.use_dns_servers = use_dns_servers
        self.use_domain_name = use_domain_name
        self.use_ntp_servers = use_ntp_servers
        self.use_rapid_commit = use_rapid_commit

    @property
    def operating_mode(self):
        """Gets the operating_mode of this DHCPv6Configuration.  # noqa: E501


        :return: The operating_mode of this DHCPv6Configuration.  # noqa: E501
        :rtype: DHCPv6OperatingMode
        """
        return self._operating_mode

    @operating_mode.setter
    def operating_mode(self, operating_mode):
        """Sets the operating_mode of this DHCPv6Configuration.


        :param operating_mode: The operating_mode of this DHCPv6Configuration.  # noqa: E501
        :type: DHCPv6OperatingMode
        """

        self._operating_mode = operating_mode

    @property
    def use_dns_servers(self):
        """Gets the use_dns_servers of this DHCPv6Configuration.  # noqa: E501

        When enabled, DNS server addresses supplied through DHCPv6 stateless mode will be used.  # noqa: E501

        :return: The use_dns_servers of this DHCPv6Configuration.  # noqa: E501
        :rtype: bool
        """
        return self._use_dns_servers

    @use_dns_servers.setter
    def use_dns_servers(self, use_dns_servers):
        """Sets the use_dns_servers of this DHCPv6Configuration.

        When enabled, DNS server addresses supplied through DHCPv6 stateless mode will be used.  # noqa: E501

        :param use_dns_servers: The use_dns_servers of this DHCPv6Configuration.  # noqa: E501
        :type: bool
        """

        self._use_dns_servers = use_dns_servers

    @property
    def use_domain_name(self):
        """Gets the use_domain_name of this DHCPv6Configuration.  # noqa: E501

        When enabled, the domain name supplied through DHCPv6 stateless mode will be used.  # noqa: E501

        :return: The use_domain_name of this DHCPv6Configuration.  # noqa: E501
        :rtype: bool
        """
        return self._use_domain_name

    @use_domain_name.setter
    def use_domain_name(self, use_domain_name):
        """Sets the use_domain_name of this DHCPv6Configuration.

        When enabled, the domain name supplied through DHCPv6 stateless mode will be used.  # noqa: E501

        :param use_domain_name: The use_domain_name of this DHCPv6Configuration.  # noqa: E501
        :type: bool
        """

        self._use_domain_name = use_domain_name

    @property
    def use_ntp_servers(self):
        """Gets the use_ntp_servers of this DHCPv6Configuration.  # noqa: E501

        When enabled, NTP server addresses supplied through DHCPv6 stateless mode will be used.  # noqa: E501

        :return: The use_ntp_servers of this DHCPv6Configuration.  # noqa: E501
        :rtype: bool
        """
        return self._use_ntp_servers

    @use_ntp_servers.setter
    def use_ntp_servers(self, use_ntp_servers):
        """Sets the use_ntp_servers of this DHCPv6Configuration.

        When enabled, NTP server addresses supplied through DHCPv6 stateless mode will be used.  # noqa: E501

        :param use_ntp_servers: The use_ntp_servers of this DHCPv6Configuration.  # noqa: E501
        :type: bool
        """

        self._use_ntp_servers = use_ntp_servers

    @property
    def use_rapid_commit(self):
        """Gets the use_rapid_commit of this DHCPv6Configuration.  # noqa: E501

        Determines whether to use DHCPv6 rapid commit mode for stateful mode address assignments. Do not enable in networks where more than one DHCPv6 server is configured to provide address assignments.  # noqa: E501

        :return: The use_rapid_commit of this DHCPv6Configuration.  # noqa: E501
        :rtype: bool
        """
        return self._use_rapid_commit

    @use_rapid_commit.setter
    def use_rapid_commit(self, use_rapid_commit):
        """Sets the use_rapid_commit of this DHCPv6Configuration.

        Determines whether to use DHCPv6 rapid commit mode for stateful mode address assignments. Do not enable in networks where more than one DHCPv6 server is configured to provide address assignments.  # noqa: E501

        :param use_rapid_commit: The use_rapid_commit of this DHCPv6Configuration.  # noqa: E501
        :type: bool
        """

        self._use_rapid_commit = use_rapid_commit

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DHCPv6Configuration):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
