# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class DriveEncryption(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_type': 'str',
        'description': 'str',
        'auto_locking_drives': 'list[str]',
        'locked_drives': 'list[str]',
        'boot_drives': 'list[str]',
        'sed_capable': 'list[str]',
        'kmip_server': 'str',
        'tpm_enabled': 'Bool',
        'tpm_version': 'str'
    }

    attribute_map = {
        'odata_type': '@odata.type',
        'description': 'Description',
        'auto_locking_drives': 'AutoLocking_Drives',
        'locked_drives': 'Locked_Drives',
        'boot_drives': 'Boot_Drives',
        'sed_capable': 'SED_Capable',
        'kmip_server': 'KMIP_Server',
        'tpm_enabled': 'TPM_Enabled',
        'tpm_version': 'TPM_Version'
    }

    def __init__(self, odata_type=None, description=None, auto_locking_drives=None, locked_drives=None, boot_drives=None, sed_capable=None, kmip_server=None, tpm_enabled=None, tpm_version=None):  # noqa: E501
        """DriveEncryption - a model defined in OpenAPI"""  # noqa: E501

        self._odata_type = None
        self._description = None
        self._auto_locking_drives = None
        self._locked_drives = None
        self._boot_drives = None
        self._sed_capable = None
        self._kmip_server = None
        self._tpm_enabled = None
        self._tpm_version = None
        self.discriminator = None

        self.odata_type = odata_type
        if description is not None:
            self.description = description
        if auto_locking_drives is not None:
            self.auto_locking_drives = auto_locking_drives
        if locked_drives is not None:
            self.locked_drives = locked_drives
        if boot_drives is not None:
            self.boot_drives = boot_drives
        if sed_capable is not None:
            self.sed_capable = sed_capable
        if kmip_server is not None:
            self.kmip_server = kmip_server
        if tpm_enabled is not None:
            self.tpm_enabled = tpm_enabled
        if tpm_version is not None:
            self.tpm_version = tpm_version

    @property
    def odata_type(self):
        """Gets the odata_type of this DriveEncryption.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this DriveEncryption.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this DriveEncryption.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this DriveEncryption.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def description(self):
        """Gets the description of this DriveEncryption.  # noqa: E501


        :return: The description of this DriveEncryption.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this DriveEncryption.


        :param description: The description of this DriveEncryption.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def auto_locking_drives(self):
        """Gets the auto_locking_drives of this DriveEncryption.  # noqa: E501


        :return: The auto_locking_drives of this DriveEncryption.  # noqa: E501
        :rtype: list[str]
        """
        return self._auto_locking_drives

    @auto_locking_drives.setter
    def auto_locking_drives(self, auto_locking_drives):
        """Sets the auto_locking_drives of this DriveEncryption.


        :param auto_locking_drives: The auto_locking_drives of this DriveEncryption.  # noqa: E501
        :type: list[str]
        """

        self._auto_locking_drives = auto_locking_drives

    @property
    def locked_drives(self):
        """Gets the locked_drives of this DriveEncryption.  # noqa: E501


        :return: The locked_drives of this DriveEncryption.  # noqa: E501
        :rtype: list[str]
        """
        return self._locked_drives

    @locked_drives.setter
    def locked_drives(self, locked_drives):
        """Sets the locked_drives of this DriveEncryption.


        :param locked_drives: The locked_drives of this DriveEncryption.  # noqa: E501
        :type: list[str]
        """

        self._locked_drives = locked_drives

    @property
    def boot_drives(self):
        """Gets the boot_drives of this DriveEncryption.  # noqa: E501


        :return: The boot_drives of this DriveEncryption.  # noqa: E501
        :rtype: list[str]
        """
        return self._boot_drives

    @boot_drives.setter
    def boot_drives(self, boot_drives):
        """Sets the boot_drives of this DriveEncryption.


        :param boot_drives: The boot_drives of this DriveEncryption.  # noqa: E501
        :type: list[str]
        """

        self._boot_drives = boot_drives

    @property
    def sed_capable(self):
        """Gets the sed_capable of this DriveEncryption.  # noqa: E501


        :return: The sed_capable of this DriveEncryption.  # noqa: E501
        :rtype: list[str]
        """
        return self._sed_capable

    @sed_capable.setter
    def sed_capable(self, sed_capable):
        """Sets the sed_capable of this DriveEncryption.


        :param sed_capable: The sed_capable of this DriveEncryption.  # noqa: E501
        :type: list[str]
        """

        self._sed_capable = sed_capable

    @property
    def kmip_server(self):
        """Gets the kmip_server of this DriveEncryption.  # noqa: E501


        :return: The kmip_server of this DriveEncryption.  # noqa: E501
        :rtype: str
        """
        return self._kmip_server

    @kmip_server.setter
    def kmip_server(self, kmip_server):
        """Sets the kmip_server of this DriveEncryption.


        :param kmip_server: The kmip_server of this DriveEncryption.  # noqa: E501
        :type: str
        """

        self._kmip_server = kmip_server

    @property
    def tpm_enabled(self):
        """Gets the tpm_enabled of this DriveEncryption.  # noqa: E501


        :return: The tpm_enabled of this DriveEncryption.  # noqa: E501
        :rtype: Bool
        """
        return self._tpm_enabled

    @tpm_enabled.setter
    def tpm_enabled(self, tpm_enabled):
        """Sets the tpm_enabled of this DriveEncryption.


        :param tpm_enabled: The tpm_enabled of this DriveEncryption.  # noqa: E501
        :type: Bool
        """

        self._tpm_enabled = tpm_enabled

    @property
    def tpm_version(self):
        """Gets the tpm_version of this DriveEncryption.  # noqa: E501


        :return: The tpm_version of this DriveEncryption.  # noqa: E501
        :rtype: str
        """
        return self._tpm_version

    @tpm_version.setter
    def tpm_version(self, tpm_version):
        """Sets the tpm_version of this DriveEncryption.


        :param tpm_version: The tpm_version of this DriveEncryption.  # noqa: E501
        :type: str
        """

        self._tpm_version = tpm_version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DriveEncryption):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
