# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class ErrorStat(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'ecc_mode': 'str',
        'ecc_mode_pending': 'str',
        'errors_lifetime': 'ErrorsSince',
        'errors_since_driver_load': 'ErrorsSince',
        'retired_pages': 'RetiredPages'
    }

    attribute_map = {
        'ecc_mode': 'ECCMode',
        'ecc_mode_pending': 'ECCModePending',
        'errors_lifetime': 'ErrorsLifetime',
        'errors_since_driver_load': 'ErrorsSinceDriverLoad',
        'retired_pages': 'RetiredPages'
    }

    def __init__(self, ecc_mode=None, ecc_mode_pending=None, errors_lifetime=None, errors_since_driver_load=None, retired_pages=None):  # noqa: E501
        """ErrorStat - a model defined in OpenAPI"""  # noqa: E501

        self._ecc_mode = None
        self._ecc_mode_pending = None
        self._errors_lifetime = None
        self._errors_since_driver_load = None
        self._retired_pages = None
        self.discriminator = None

        self.ecc_mode = ecc_mode
        self.ecc_mode_pending = ecc_mode_pending
        self.errors_lifetime = errors_lifetime
        self.errors_since_driver_load = errors_since_driver_load
        self.retired_pages = retired_pages

    @property
    def ecc_mode(self):
        """Gets the ecc_mode of this ErrorStat.  # noqa: E501

        The ECC mode that the GPU is currently operating under.  # noqa: E501

        :return: The ecc_mode of this ErrorStat.  # noqa: E501
        :rtype: str
        """
        return self._ecc_mode

    @ecc_mode.setter
    def ecc_mode(self, ecc_mode):
        """Sets the ecc_mode of this ErrorStat.

        The ECC mode that the GPU is currently operating under.  # noqa: E501

        :param ecc_mode: The ecc_mode of this ErrorStat.  # noqa: E501
        :type: str
        """
        if ecc_mode is None:
            raise ValueError("Invalid value for `ecc_mode`, must not be `None`")  # noqa: E501

        self._ecc_mode = ecc_mode

    @property
    def ecc_mode_pending(self):
        """Gets the ecc_mode_pending of this ErrorStat.  # noqa: E501

        The ECC mode that the GPU will operate under after the next reboot.  # noqa: E501

        :return: The ecc_mode_pending of this ErrorStat.  # noqa: E501
        :rtype: str
        """
        return self._ecc_mode_pending

    @ecc_mode_pending.setter
    def ecc_mode_pending(self, ecc_mode_pending):
        """Sets the ecc_mode_pending of this ErrorStat.

        The ECC mode that the GPU will operate under after the next reboot.  # noqa: E501

        :param ecc_mode_pending: The ecc_mode_pending of this ErrorStat.  # noqa: E501
        :type: str
        """
        if ecc_mode_pending is None:
            raise ValueError("Invalid value for `ecc_mode_pending`, must not be `None`")  # noqa: E501

        self._ecc_mode_pending = ecc_mode_pending

    @property
    def errors_lifetime(self):
        """Gets the errors_lifetime of this ErrorStat.  # noqa: E501


        :return: The errors_lifetime of this ErrorStat.  # noqa: E501
        :rtype: ErrorsSince
        """
        return self._errors_lifetime

    @errors_lifetime.setter
    def errors_lifetime(self, errors_lifetime):
        """Sets the errors_lifetime of this ErrorStat.


        :param errors_lifetime: The errors_lifetime of this ErrorStat.  # noqa: E501
        :type: ErrorsSince
        """
        if errors_lifetime is None:
            raise ValueError("Invalid value for `errors_lifetime`, must not be `None`")  # noqa: E501

        self._errors_lifetime = errors_lifetime

    @property
    def errors_since_driver_load(self):
        """Gets the errors_since_driver_load of this ErrorStat.  # noqa: E501


        :return: The errors_since_driver_load of this ErrorStat.  # noqa: E501
        :rtype: ErrorsSince
        """
        return self._errors_since_driver_load

    @errors_since_driver_load.setter
    def errors_since_driver_load(self, errors_since_driver_load):
        """Sets the errors_since_driver_load of this ErrorStat.


        :param errors_since_driver_load: The errors_since_driver_load of this ErrorStat.  # noqa: E501
        :type: ErrorsSince
        """
        if errors_since_driver_load is None:
            raise ValueError("Invalid value for `errors_since_driver_load`, must not be `None`")  # noqa: E501

        self._errors_since_driver_load = errors_since_driver_load

    @property
    def retired_pages(self):
        """Gets the retired_pages of this ErrorStat.  # noqa: E501


        :return: The retired_pages of this ErrorStat.  # noqa: E501
        :rtype: RetiredPages
        """
        return self._retired_pages

    @retired_pages.setter
    def retired_pages(self, retired_pages):
        """Sets the retired_pages of this ErrorStat.


        :param retired_pages: The retired_pages of this ErrorStat.  # noqa: E501
        :type: RetiredPages
        """
        if retired_pages is None:
            raise ValueError("Invalid value for `retired_pages`, must not be `None`")  # noqa: E501

        self._retired_pages = retired_pages

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ErrorStat):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
