# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Ethernet(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'mac_address': 'str',
        'mtu_size': 'int',
        'permanent_mac_address': 'str',
        'vlan': 'VLAN',
        'vla_ns': 'IdRef2'
    }

    attribute_map = {
        'mac_address': 'MACAddress',
        'mtu_size': 'MTUSize',
        'permanent_mac_address': 'PermanentMACAddress',
        'vlan': 'VLAN',
        'vla_ns': 'VLANs'
    }

    def __init__(self, mac_address=None, mtu_size=None, permanent_mac_address=None, vlan=None, vla_ns=None):  # noqa: E501
        """Ethernet - a model defined in OpenAPI"""  # noqa: E501

        self._mac_address = None
        self._mtu_size = None
        self._permanent_mac_address = None
        self._vlan = None
        self._vla_ns = None
        self.discriminator = None

        self.mac_address = mac_address
        self.mtu_size = mtu_size
        self.permanent_mac_address = permanent_mac_address
        if vlan is not None:
            self.vlan = vlan
        if vla_ns is not None:
            self.vla_ns = vla_ns

    @property
    def mac_address(self):
        """Gets the mac_address of this Ethernet.  # noqa: E501

        This is the currently configured MAC address of the (logical port) network device function.  # noqa: E501

        :return: The mac_address of this Ethernet.  # noqa: E501
        :rtype: str
        """
        return self._mac_address

    @mac_address.setter
    def mac_address(self, mac_address):
        """Sets the mac_address of this Ethernet.

        This is the currently configured MAC address of the (logical port) network device function.  # noqa: E501

        :param mac_address: The mac_address of this Ethernet.  # noqa: E501
        :type: str
        """

        self._mac_address = mac_address

    @property
    def mtu_size(self):
        """Gets the mtu_size of this Ethernet.  # noqa: E501

        The Maximum Transmission Unit (MTU) configured for this network device function.  # noqa: E501

        :return: The mtu_size of this Ethernet.  # noqa: E501
        :rtype: int
        """
        return self._mtu_size

    @mtu_size.setter
    def mtu_size(self, mtu_size):
        """Sets the mtu_size of this Ethernet.

        The Maximum Transmission Unit (MTU) configured for this network device function.  # noqa: E501

        :param mtu_size: The mtu_size of this Ethernet.  # noqa: E501
        :type: int
        """

        self._mtu_size = mtu_size

    @property
    def permanent_mac_address(self):
        """Gets the permanent_mac_address of this Ethernet.  # noqa: E501

        This is the permanent MAC address assigned to this network device function (physical function).  # noqa: E501

        :return: The permanent_mac_address of this Ethernet.  # noqa: E501
        :rtype: str
        """
        return self._permanent_mac_address

    @permanent_mac_address.setter
    def permanent_mac_address(self, permanent_mac_address):
        """Sets the permanent_mac_address of this Ethernet.

        This is the permanent MAC address assigned to this network device function (physical function).  # noqa: E501

        :param permanent_mac_address: The permanent_mac_address of this Ethernet.  # noqa: E501
        :type: str
        """

        self._permanent_mac_address = permanent_mac_address

    @property
    def vlan(self):
        """Gets the vlan of this Ethernet.  # noqa: E501


        :return: The vlan of this Ethernet.  # noqa: E501
        :rtype: VLAN
        """
        return self._vlan

    @vlan.setter
    def vlan(self, vlan):
        """Sets the vlan of this Ethernet.


        :param vlan: The vlan of this Ethernet.  # noqa: E501
        :type: VLAN
        """

        self._vlan = vlan

    @property
    def vla_ns(self):
        """Gets the vla_ns of this Ethernet.  # noqa: E501


        :return: The vla_ns of this Ethernet.  # noqa: E501
        :rtype: IdRef2
        """
        return self._vla_ns

    @vla_ns.setter
    def vla_ns(self, vla_ns):
        """Sets the vla_ns of this Ethernet.


        :param vla_ns: The vla_ns of this Ethernet.  # noqa: E501
        :type: IdRef2
        """

        self._vla_ns = vla_ns

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Ethernet):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
