# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class EthernetInterface2(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'max_lanes': 'int',
        'max_speed_mbps': 'int',
        'oem': 'dict(str, object)'
    }

    attribute_map = {
        'max_lanes': 'MaxLanes',
        'max_speed_mbps': 'MaxSpeedMbps',
        'oem': 'Oem'
    }

    def __init__(self, max_lanes=None, max_speed_mbps=None, oem=None):  # noqa: E501
        """EthernetInterface2 - a model defined in OpenAPI"""  # noqa: E501

        self._max_lanes = None
        self._max_speed_mbps = None
        self._oem = None
        self.discriminator = None

        self.max_lanes = max_lanes
        self.max_speed_mbps = max_speed_mbps
        if oem is not None:
            self.oem = oem

    @property
    def max_lanes(self):
        """Gets the max_lanes of this EthernetInterface2.  # noqa: E501

        This is the number of lanes supported by this interface.  # noqa: E501

        :return: The max_lanes of this EthernetInterface2.  # noqa: E501
        :rtype: int
        """
        return self._max_lanes

    @max_lanes.setter
    def max_lanes(self, max_lanes):
        """Sets the max_lanes of this EthernetInterface2.

        This is the number of lanes supported by this interface.  # noqa: E501

        :param max_lanes: The max_lanes of this EthernetInterface2.  # noqa: E501
        :type: int
        """

        self._max_lanes = max_lanes

    @property
    def max_speed_mbps(self):
        """Gets the max_speed_mbps of this EthernetInterface2.  # noqa: E501

        The maximum speed supported by this interface.  # noqa: E501

        :return: The max_speed_mbps of this EthernetInterface2.  # noqa: E501
        :rtype: int
        """
        return self._max_speed_mbps

    @max_speed_mbps.setter
    def max_speed_mbps(self, max_speed_mbps):
        """Sets the max_speed_mbps of this EthernetInterface2.

        The maximum speed supported by this interface.  # noqa: E501

        :param max_speed_mbps: The max_speed_mbps of this EthernetInterface2.  # noqa: E501
        :type: int
        """

        self._max_speed_mbps = max_speed_mbps

    @property
    def oem(self):
        """Gets the oem of this EthernetInterface2.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this EthernetInterface2.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this EthernetInterface2.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this EthernetInterface2.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EthernetInterface2):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
