# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Expand(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'expand_all': 'bool',
        'levels': 'bool',
        'links': 'bool',
        'max_levels': 'int',
        'no_links': 'bool'
    }

    attribute_map = {
        'expand_all': 'ExpandAll',
        'levels': 'Levels',
        'links': 'Links',
        'max_levels': 'MaxLevels',
        'no_links': 'NoLinks'
    }

    def __init__(self, expand_all=None, levels=None, links=None, max_levels=None, no_links=None):  # noqa: E501
        """Expand - a model defined in OpenAPI"""  # noqa: E501

        self._expand_all = None
        self._levels = None
        self._links = None
        self._max_levels = None
        self._no_links = None
        self.discriminator = None

        if expand_all is not None:
            self.expand_all = expand_all
        if levels is not None:
            self.levels = levels
        if links is not None:
            self.links = links
        if max_levels is not None:
            self.max_levels = max_levels
        if no_links is not None:
            self.no_links = no_links

    @property
    def expand_all(self):
        """Gets the expand_all of this Expand.  # noqa: E501

        This indicates whether the $expand support of asterisk (expand all entries) is supported.  # noqa: E501

        :return: The expand_all of this Expand.  # noqa: E501
        :rtype: bool
        """
        return self._expand_all

    @expand_all.setter
    def expand_all(self, expand_all):
        """Sets the expand_all of this Expand.

        This indicates whether the $expand support of asterisk (expand all entries) is supported.  # noqa: E501

        :param expand_all: The expand_all of this Expand.  # noqa: E501
        :type: bool
        """

        self._expand_all = expand_all

    @property
    def levels(self):
        """Gets the levels of this Expand.  # noqa: E501

        This indicates whether the expand support of the $levels qualifier is supported by the service.  # noqa: E501

        :return: The levels of this Expand.  # noqa: E501
        :rtype: bool
        """
        return self._levels

    @levels.setter
    def levels(self, levels):
        """Sets the levels of this Expand.

        This indicates whether the expand support of the $levels qualifier is supported by the service.  # noqa: E501

        :param levels: The levels of this Expand.  # noqa: E501
        :type: bool
        """

        self._levels = levels

    @property
    def links(self):
        """Gets the links of this Expand.  # noqa: E501

        This indicates whether the $expand support of tilde (expand only entries in the Links section) is supported.  # noqa: E501

        :return: The links of this Expand.  # noqa: E501
        :rtype: bool
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this Expand.

        This indicates whether the $expand support of tilde (expand only entries in the Links section) is supported.  # noqa: E501

        :param links: The links of this Expand.  # noqa: E501
        :type: bool
        """

        self._links = links

    @property
    def max_levels(self):
        """Gets the max_levels of this Expand.  # noqa: E501

        This indicates the maximum number value of the $levels qualifier in $expand operations.  # noqa: E501

        :return: The max_levels of this Expand.  # noqa: E501
        :rtype: int
        """
        return self._max_levels

    @max_levels.setter
    def max_levels(self, max_levels):
        """Sets the max_levels of this Expand.

        This indicates the maximum number value of the $levels qualifier in $expand operations.  # noqa: E501

        :param max_levels: The max_levels of this Expand.  # noqa: E501
        :type: int
        """
        if max_levels is not None and max_levels > 6:  # noqa: E501
            raise ValueError("Invalid value for `max_levels`, must be a value less than or equal to `6`")  # noqa: E501
        if max_levels is not None and max_levels < 1:  # noqa: E501
            raise ValueError("Invalid value for `max_levels`, must be a value greater than or equal to `1`")  # noqa: E501

        self._max_levels = max_levels

    @property
    def no_links(self):
        """Gets the no_links of this Expand.  # noqa: E501

        This indicates whether the $expand support of period (expand only entries not in the Links section) is supported.  # noqa: E501

        :return: The no_links of this Expand.  # noqa: E501
        :rtype: bool
        """
        return self._no_links

    @no_links.setter
    def no_links(self, no_links):
        """Sets the no_links of this Expand.

        This indicates whether the $expand support of period (expand only entries not in the Links section) is supported.  # noqa: E501

        :param no_links: The no_links of this Expand.  # noqa: E501
        :type: bool
        """

        self._no_links = no_links

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Expand):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
