# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class FeatureConfigurations(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'accounting_buffer_size': 'int',
        'accounting_mode': 'str',
        'clock_policy': 'ClockPolicy',
        'compute_mode': 'str',
        'display_active': 'str',
        'display_mode': 'str',
        'operation_mode': 'str',
        'operation_mode_on_next_boot': 'str',
        'persistence_mode': 'str',
        'virtualization_mode': 'str'
    }

    attribute_map = {
        'accounting_buffer_size': 'AccountingBufferSize',
        'accounting_mode': 'AccountingMode',
        'clock_policy': 'ClockPolicy',
        'compute_mode': 'ComputeMode',
        'display_active': 'DisplayActive',
        'display_mode': 'DisplayMode',
        'operation_mode': 'OperationMode',
        'operation_mode_on_next_boot': 'OperationModeOnNextBoot',
        'persistence_mode': 'PersistenceMode',
        'virtualization_mode': 'VirtualizationMode'
    }

    def __init__(self, accounting_buffer_size=None, accounting_mode=None, clock_policy=None, compute_mode=None, display_active=None, display_mode=None, operation_mode=None, operation_mode_on_next_boot=None, persistence_mode=None, virtualization_mode=None):  # noqa: E501
        """FeatureConfigurations - a model defined in OpenAPI"""  # noqa: E501

        self._accounting_buffer_size = None
        self._accounting_mode = None
        self._clock_policy = None
        self._compute_mode = None
        self._display_active = None
        self._display_mode = None
        self._operation_mode = None
        self._operation_mode_on_next_boot = None
        self._persistence_mode = None
        self._virtualization_mode = None
        self.discriminator = None

        self.accounting_buffer_size = accounting_buffer_size
        self.accounting_mode = accounting_mode
        self.clock_policy = clock_policy
        self.compute_mode = compute_mode
        self.display_active = display_active
        self.display_mode = display_mode
        self.operation_mode = operation_mode
        self.operation_mode_on_next_boot = operation_mode_on_next_boot
        self.persistence_mode = persistence_mode
        self.virtualization_mode = virtualization_mode

    @property
    def accounting_buffer_size(self):
        """Gets the accounting_buffer_size of this FeatureConfigurations.  # noqa: E501

        The Size of the circular buffer that holds list of processes that can be queried for accounting stats.  # noqa: E501

        :return: The accounting_buffer_size of this FeatureConfigurations.  # noqa: E501
        :rtype: int
        """
        return self._accounting_buffer_size

    @accounting_buffer_size.setter
    def accounting_buffer_size(self, accounting_buffer_size):
        """Sets the accounting_buffer_size of this FeatureConfigurations.

        The Size of the circular buffer that holds list of processes that can be queried for accounting stats.  # noqa: E501

        :param accounting_buffer_size: The accounting_buffer_size of this FeatureConfigurations.  # noqa: E501
        :type: int
        """
        if accounting_buffer_size is None:
            raise ValueError("Invalid value for `accounting_buffer_size`, must not be `None`")  # noqa: E501

        self._accounting_buffer_size = accounting_buffer_size

    @property
    def accounting_mode(self):
        """Gets the accounting_mode of this FeatureConfigurations.  # noqa: E501

        A flag that indicates whether accounting mode is enabled.  # noqa: E501

        :return: The accounting_mode of this FeatureConfigurations.  # noqa: E501
        :rtype: str
        """
        return self._accounting_mode

    @accounting_mode.setter
    def accounting_mode(self, accounting_mode):
        """Sets the accounting_mode of this FeatureConfigurations.

        A flag that indicates whether accounting mode is enabled.  # noqa: E501

        :param accounting_mode: The accounting_mode of this FeatureConfigurations.  # noqa: E501
        :type: str
        """
        if accounting_mode is None:
            raise ValueError("Invalid value for `accounting_mode`, must not be `None`")  # noqa: E501

        self._accounting_mode = accounting_mode

    @property
    def clock_policy(self):
        """Gets the clock_policy of this FeatureConfigurations.  # noqa: E501


        :return: The clock_policy of this FeatureConfigurations.  # noqa: E501
        :rtype: ClockPolicy
        """
        return self._clock_policy

    @clock_policy.setter
    def clock_policy(self, clock_policy):
        """Sets the clock_policy of this FeatureConfigurations.


        :param clock_policy: The clock_policy of this FeatureConfigurations.  # noqa: E501
        :type: ClockPolicy
        """
        if clock_policy is None:
            raise ValueError("Invalid value for `clock_policy`, must not be `None`")  # noqa: E501

        self._clock_policy = clock_policy

    @property
    def compute_mode(self):
        """Gets the compute_mode of this FeatureConfigurations.  # noqa: E501

        The compute mode flag indicates whether individual or multiple compute applications may run on the GPU.  # noqa: E501

        :return: The compute_mode of this FeatureConfigurations.  # noqa: E501
        :rtype: str
        """
        return self._compute_mode

    @compute_mode.setter
    def compute_mode(self, compute_mode):
        """Sets the compute_mode of this FeatureConfigurations.

        The compute mode flag indicates whether individual or multiple compute applications may run on the GPU.  # noqa: E501

        :param compute_mode: The compute_mode of this FeatureConfigurations.  # noqa: E501
        :type: str
        """
        if compute_mode is None:
            raise ValueError("Invalid value for `compute_mode`, must not be `None`")  # noqa: E501

        self._compute_mode = compute_mode

    @property
    def display_active(self):
        """Gets the display_active of this FeatureConfigurations.  # noqa: E501

        A flag that indicates whether the display is in an active state and the GPU has allocated memory for a screen. The display can be active whether or not a physical monitor is attached. \"Enabled\" indicates an active display. \"Disabled\" indicates otherwise.  # noqa: E501

        :return: The display_active of this FeatureConfigurations.  # noqa: E501
        :rtype: str
        """
        return self._display_active

    @display_active.setter
    def display_active(self, display_active):
        """Sets the display_active of this FeatureConfigurations.

        A flag that indicates whether the display is in an active state and the GPU has allocated memory for a screen. The display can be active whether or not a physical monitor is attached. \"Enabled\" indicates an active display. \"Disabled\" indicates otherwise.  # noqa: E501

        :param display_active: The display_active of this FeatureConfigurations.  # noqa: E501
        :type: str
        """
        if display_active is None:
            raise ValueError("Invalid value for `display_active`, must not be `None`")  # noqa: E501

        self._display_active = display_active

    @property
    def display_mode(self):
        """Gets the display_mode of this FeatureConfigurations.  # noqa: E501

        A flag that indicates whether a physical display (e.g. monitor) is currently connected to any of the GPU connectors. \"Enabled\" indicates an attached display. \"Disabled\" indicates otherwise.  # noqa: E501

        :return: The display_mode of this FeatureConfigurations.  # noqa: E501
        :rtype: str
        """
        return self._display_mode

    @display_mode.setter
    def display_mode(self, display_mode):
        """Sets the display_mode of this FeatureConfigurations.

        A flag that indicates whether a physical display (e.g. monitor) is currently connected to any of the GPU connectors. \"Enabled\" indicates an attached display. \"Disabled\" indicates otherwise.  # noqa: E501

        :param display_mode: The display_mode of this FeatureConfigurations.  # noqa: E501
        :type: str
        """
        if display_mode is None:
            raise ValueError("Invalid value for `display_mode`, must not be `None`")  # noqa: E501

        self._display_mode = display_mode

    @property
    def operation_mode(self):
        """Gets the operation_mode of this FeatureConfigurations.  # noqa: E501

        Current mode of Operation for this GPU.  # noqa: E501

        :return: The operation_mode of this FeatureConfigurations.  # noqa: E501
        :rtype: str
        """
        return self._operation_mode

    @operation_mode.setter
    def operation_mode(self, operation_mode):
        """Sets the operation_mode of this FeatureConfigurations.

        Current mode of Operation for this GPU.  # noqa: E501

        :param operation_mode: The operation_mode of this FeatureConfigurations.  # noqa: E501
        :type: str
        """
        if operation_mode is None:
            raise ValueError("Invalid value for `operation_mode`, must not be `None`")  # noqa: E501

        self._operation_mode = operation_mode

    @property
    def operation_mode_on_next_boot(self):
        """Gets the operation_mode_on_next_boot of this FeatureConfigurations.  # noqa: E501

        Mode of Operation for this GPU on next boot.  # noqa: E501

        :return: The operation_mode_on_next_boot of this FeatureConfigurations.  # noqa: E501
        :rtype: str
        """
        return self._operation_mode_on_next_boot

    @operation_mode_on_next_boot.setter
    def operation_mode_on_next_boot(self, operation_mode_on_next_boot):
        """Sets the operation_mode_on_next_boot of this FeatureConfigurations.

        Mode of Operation for this GPU on next boot.  # noqa: E501

        :param operation_mode_on_next_boot: The operation_mode_on_next_boot of this FeatureConfigurations.  # noqa: E501
        :type: str
        """
        if operation_mode_on_next_boot is None:
            raise ValueError("Invalid value for `operation_mode_on_next_boot`, must not be `None`")  # noqa: E501

        self._operation_mode_on_next_boot = operation_mode_on_next_boot

    @property
    def persistence_mode(self):
        """Gets the persistence_mode of this FeatureConfigurations.  # noqa: E501

        A flag that indicates whether persistence mode is enabled for the GPU. Value is either \"Enabled\" or \"Disabled\".  # noqa: E501

        :return: The persistence_mode of this FeatureConfigurations.  # noqa: E501
        :rtype: str
        """
        return self._persistence_mode

    @persistence_mode.setter
    def persistence_mode(self, persistence_mode):
        """Sets the persistence_mode of this FeatureConfigurations.

        A flag that indicates whether persistence mode is enabled for the GPU. Value is either \"Enabled\" or \"Disabled\".  # noqa: E501

        :param persistence_mode: The persistence_mode of this FeatureConfigurations.  # noqa: E501
        :type: str
        """
        if persistence_mode is None:
            raise ValueError("Invalid value for `persistence_mode`, must not be `None`")  # noqa: E501

        self._persistence_mode = persistence_mode

    @property
    def virtualization_mode(self):
        """Gets the virtualization_mode of this FeatureConfigurations.  # noqa: E501


        :return: The virtualization_mode of this FeatureConfigurations.  # noqa: E501
        :rtype: str
        """
        return self._virtualization_mode

    @virtualization_mode.setter
    def virtualization_mode(self, virtualization_mode):
        """Sets the virtualization_mode of this FeatureConfigurations.


        :param virtualization_mode: The virtualization_mode of this FeatureConfigurations.  # noqa: E501
        :type: str
        """
        if virtualization_mode is None:
            raise ValueError("Invalid value for `virtualization_mode`, must not be `None`")  # noqa: E501

        self._virtualization_mode = virtualization_mode

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FeatureConfigurations):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
