# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class FibreChannel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'allow_fipvlan_discovery': 'bool',
        'boot_targets': 'list[BootTargets]',
        'f_co_e_active_vlan_id': 'int',
        'f_co_e_local_vlan_id': 'int',
        'fibre_channel_id': 'str',
        'permanent_wwnn': 'str',
        'permanent_wwpn': 'str',
        'wwnn': 'str',
        'wwn_source': 'WWNSource',
        'wwpn': 'str'
    }

    attribute_map = {
        'allow_fipvlan_discovery': 'AllowFIPVLANDiscovery',
        'boot_targets': 'BootTargets',
        'f_co_e_active_vlan_id': 'FCoEActiveVLANId',
        'f_co_e_local_vlan_id': 'FCoELocalVLANId',
        'fibre_channel_id': 'FibreChannelId',
        'permanent_wwnn': 'PermanentWWNN',
        'permanent_wwpn': 'PermanentWWPN',
        'wwnn': 'WWNN',
        'wwn_source': 'WWNSource',
        'wwpn': 'WWPN'
    }

    def __init__(self, allow_fipvlan_discovery=None, boot_targets=None, f_co_e_active_vlan_id=None, f_co_e_local_vlan_id=None, fibre_channel_id=None, permanent_wwnn=None, permanent_wwpn=None, wwnn=None, wwn_source=None, wwpn=None):  # noqa: E501
        """FibreChannel - a model defined in OpenAPI"""  # noqa: E501

        self._allow_fipvlan_discovery = None
        self._boot_targets = None
        self._f_co_e_active_vlan_id = None
        self._f_co_e_local_vlan_id = None
        self._fibre_channel_id = None
        self._permanent_wwnn = None
        self._permanent_wwpn = None
        self._wwnn = None
        self._wwn_source = None
        self._wwpn = None
        self.discriminator = None

        self.allow_fipvlan_discovery = allow_fipvlan_discovery
        if boot_targets is not None:
            self.boot_targets = boot_targets
        self.f_co_e_active_vlan_id = f_co_e_active_vlan_id
        self.f_co_e_local_vlan_id = f_co_e_local_vlan_id
        self.fibre_channel_id = fibre_channel_id
        self.permanent_wwnn = permanent_wwnn
        self.permanent_wwpn = permanent_wwpn
        self.wwnn = wwnn
        if wwn_source is not None:
            self.wwn_source = wwn_source
        self.wwpn = wwpn

    @property
    def allow_fipvlan_discovery(self):
        """Gets the allow_fipvlan_discovery of this FibreChannel.  # noqa: E501

        Whether the FCoE Initialization Protocol (FIP) is used for populating the FCoE VLAN Id.  # noqa: E501

        :return: The allow_fipvlan_discovery of this FibreChannel.  # noqa: E501
        :rtype: bool
        """
        return self._allow_fipvlan_discovery

    @allow_fipvlan_discovery.setter
    def allow_fipvlan_discovery(self, allow_fipvlan_discovery):
        """Sets the allow_fipvlan_discovery of this FibreChannel.

        Whether the FCoE Initialization Protocol (FIP) is used for populating the FCoE VLAN Id.  # noqa: E501

        :param allow_fipvlan_discovery: The allow_fipvlan_discovery of this FibreChannel.  # noqa: E501
        :type: bool
        """

        self._allow_fipvlan_discovery = allow_fipvlan_discovery

    @property
    def boot_targets(self):
        """Gets the boot_targets of this FibreChannel.  # noqa: E501

        An array of Fibre Channel boot targets configured for this network device function.  # noqa: E501

        :return: The boot_targets of this FibreChannel.  # noqa: E501
        :rtype: list[BootTargets]
        """
        return self._boot_targets

    @boot_targets.setter
    def boot_targets(self, boot_targets):
        """Sets the boot_targets of this FibreChannel.

        An array of Fibre Channel boot targets configured for this network device function.  # noqa: E501

        :param boot_targets: The boot_targets of this FibreChannel.  # noqa: E501
        :type: list[BootTargets]
        """

        self._boot_targets = boot_targets

    @property
    def f_co_e_active_vlan_id(self):
        """Gets the f_co_e_active_vlan_id of this FibreChannel.  # noqa: E501

        The active FCoE VLAN ID.  # noqa: E501

        :return: The f_co_e_active_vlan_id of this FibreChannel.  # noqa: E501
        :rtype: int
        """
        return self._f_co_e_active_vlan_id

    @f_co_e_active_vlan_id.setter
    def f_co_e_active_vlan_id(self, f_co_e_active_vlan_id):
        """Sets the f_co_e_active_vlan_id of this FibreChannel.

        The active FCoE VLAN ID.  # noqa: E501

        :param f_co_e_active_vlan_id: The f_co_e_active_vlan_id of this FibreChannel.  # noqa: E501
        :type: int
        """
        if f_co_e_active_vlan_id is not None and f_co_e_active_vlan_id > 4094:  # noqa: E501
            raise ValueError("Invalid value for `f_co_e_active_vlan_id`, must be a value less than or equal to `4094`")  # noqa: E501
        if f_co_e_active_vlan_id is not None and f_co_e_active_vlan_id < 0:  # noqa: E501
            raise ValueError("Invalid value for `f_co_e_active_vlan_id`, must be a value greater than or equal to `0`")  # noqa: E501

        self._f_co_e_active_vlan_id = f_co_e_active_vlan_id

    @property
    def f_co_e_local_vlan_id(self):
        """Gets the f_co_e_local_vlan_id of this FibreChannel.  # noqa: E501

        The locally configured FCoE VLAN ID.  # noqa: E501

        :return: The f_co_e_local_vlan_id of this FibreChannel.  # noqa: E501
        :rtype: int
        """
        return self._f_co_e_local_vlan_id

    @f_co_e_local_vlan_id.setter
    def f_co_e_local_vlan_id(self, f_co_e_local_vlan_id):
        """Sets the f_co_e_local_vlan_id of this FibreChannel.

        The locally configured FCoE VLAN ID.  # noqa: E501

        :param f_co_e_local_vlan_id: The f_co_e_local_vlan_id of this FibreChannel.  # noqa: E501
        :type: int
        """
        if f_co_e_local_vlan_id is not None and f_co_e_local_vlan_id > 4094:  # noqa: E501
            raise ValueError("Invalid value for `f_co_e_local_vlan_id`, must be a value less than or equal to `4094`")  # noqa: E501
        if f_co_e_local_vlan_id is not None and f_co_e_local_vlan_id < 0:  # noqa: E501
            raise ValueError("Invalid value for `f_co_e_local_vlan_id`, must be a value greater than or equal to `0`")  # noqa: E501

        self._f_co_e_local_vlan_id = f_co_e_local_vlan_id

    @property
    def fibre_channel_id(self):
        """Gets the fibre_channel_id of this FibreChannel.  # noqa: E501

        The Fibre Channel Id assigned by the switch for this interface.  # noqa: E501

        :return: The fibre_channel_id of this FibreChannel.  # noqa: E501
        :rtype: str
        """
        return self._fibre_channel_id

    @fibre_channel_id.setter
    def fibre_channel_id(self, fibre_channel_id):
        """Sets the fibre_channel_id of this FibreChannel.

        The Fibre Channel Id assigned by the switch for this interface.  # noqa: E501

        :param fibre_channel_id: The fibre_channel_id of this FibreChannel.  # noqa: E501
        :type: str
        """

        self._fibre_channel_id = fibre_channel_id

    @property
    def permanent_wwnn(self):
        """Gets the permanent_wwnn of this FibreChannel.  # noqa: E501

        This is the permanent WWNN address assigned to this network device function (physical function).  # noqa: E501

        :return: The permanent_wwnn of this FibreChannel.  # noqa: E501
        :rtype: str
        """
        return self._permanent_wwnn

    @permanent_wwnn.setter
    def permanent_wwnn(self, permanent_wwnn):
        """Sets the permanent_wwnn of this FibreChannel.

        This is the permanent WWNN address assigned to this network device function (physical function).  # noqa: E501

        :param permanent_wwnn: The permanent_wwnn of this FibreChannel.  # noqa: E501
        :type: str
        """

        self._permanent_wwnn = permanent_wwnn

    @property
    def permanent_wwpn(self):
        """Gets the permanent_wwpn of this FibreChannel.  # noqa: E501

        This is the permanent WWPN address assigned to this network device function (physical function).  # noqa: E501

        :return: The permanent_wwpn of this FibreChannel.  # noqa: E501
        :rtype: str
        """
        return self._permanent_wwpn

    @permanent_wwpn.setter
    def permanent_wwpn(self, permanent_wwpn):
        """Sets the permanent_wwpn of this FibreChannel.

        This is the permanent WWPN address assigned to this network device function (physical function).  # noqa: E501

        :param permanent_wwpn: The permanent_wwpn of this FibreChannel.  # noqa: E501
        :type: str
        """

        self._permanent_wwpn = permanent_wwpn

    @property
    def wwnn(self):
        """Gets the wwnn of this FibreChannel.  # noqa: E501

        This is the currently configured WWNN address of the network device function (physical function).  # noqa: E501

        :return: The wwnn of this FibreChannel.  # noqa: E501
        :rtype: str
        """
        return self._wwnn

    @wwnn.setter
    def wwnn(self, wwnn):
        """Sets the wwnn of this FibreChannel.

        This is the currently configured WWNN address of the network device function (physical function).  # noqa: E501

        :param wwnn: The wwnn of this FibreChannel.  # noqa: E501
        :type: str
        """

        self._wwnn = wwnn

    @property
    def wwn_source(self):
        """Gets the wwn_source of this FibreChannel.  # noqa: E501


        :return: The wwn_source of this FibreChannel.  # noqa: E501
        :rtype: WWNSource
        """
        return self._wwn_source

    @wwn_source.setter
    def wwn_source(self, wwn_source):
        """Sets the wwn_source of this FibreChannel.


        :param wwn_source: The wwn_source of this FibreChannel.  # noqa: E501
        :type: WWNSource
        """

        self._wwn_source = wwn_source

    @property
    def wwpn(self):
        """Gets the wwpn of this FibreChannel.  # noqa: E501

        This is the currently configured WWPN address of the network device function (physical function).  # noqa: E501

        :return: The wwpn of this FibreChannel.  # noqa: E501
        :rtype: str
        """
        return self._wwpn

    @wwpn.setter
    def wwpn(self, wwpn):
        """Sets the wwpn of this FibreChannel.

        This is the currently configured WWPN address of the network device function (physical function).  # noqa: E501

        :param wwpn: The wwpn of this FibreChannel.  # noqa: E501
        :type: str
        """

        self._wwpn = wwpn

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FibreChannel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
