# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class FPGA(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'external_interfaces': 'list[FpgaInterface]',
        'firmware_id': 'str',
        'firmware_manufacturer': 'str',
        'firmware_version': 'str',
        'fpga_type': 'FpgaType',
        'host_interface': 'FpgaInterface',
        'model': 'str',
        'oem': 'dict(str, object)',
        'pc_ie_virtual_functions': 'int',
        'programmable_from_host': 'bool',
        'reconfiguration_slots': 'list[FpgaReconfigurationSlot]'
    }

    attribute_map = {
        'external_interfaces': 'ExternalInterfaces',
        'firmware_id': 'FirmwareId',
        'firmware_manufacturer': 'FirmwareManufacturer',
        'firmware_version': 'FirmwareVersion',
        'fpga_type': 'FpgaType',
        'host_interface': 'HostInterface',
        'model': 'Model',
        'oem': 'Oem',
        'pc_ie_virtual_functions': 'PCIeVirtualFunctions',
        'programmable_from_host': 'ProgrammableFromHost',
        'reconfiguration_slots': 'ReconfigurationSlots'
    }

    def __init__(self, external_interfaces=None, firmware_id=None, firmware_manufacturer=None, firmware_version=None, fpga_type=None, host_interface=None, model=None, oem=None, pc_ie_virtual_functions=None, programmable_from_host=None, reconfiguration_slots=None):  # noqa: E501
        """FPGA - a model defined in OpenAPI"""  # noqa: E501

        self._external_interfaces = None
        self._firmware_id = None
        self._firmware_manufacturer = None
        self._firmware_version = None
        self._fpga_type = None
        self._host_interface = None
        self._model = None
        self._oem = None
        self._pc_ie_virtual_functions = None
        self._programmable_from_host = None
        self._reconfiguration_slots = None
        self.discriminator = None

        if external_interfaces is not None:
            self.external_interfaces = external_interfaces
        if firmware_id is not None:
            self.firmware_id = firmware_id
        if firmware_manufacturer is not None:
            self.firmware_manufacturer = firmware_manufacturer
        if firmware_version is not None:
            self.firmware_version = firmware_version
        if fpga_type is not None:
            self.fpga_type = fpga_type
        if host_interface is not None:
            self.host_interface = host_interface
        if model is not None:
            self.model = model
        if oem is not None:
            self.oem = oem
        if pc_ie_virtual_functions is not None:
            self.pc_ie_virtual_functions = pc_ie_virtual_functions
        self.programmable_from_host = programmable_from_host
        if reconfiguration_slots is not None:
            self.reconfiguration_slots = reconfiguration_slots

    @property
    def external_interfaces(self):
        """Gets the external_interfaces of this FPGA.  # noqa: E501

        An array of the FPGA external interfaces.  # noqa: E501

        :return: The external_interfaces of this FPGA.  # noqa: E501
        :rtype: list[FpgaInterface]
        """
        return self._external_interfaces

    @external_interfaces.setter
    def external_interfaces(self, external_interfaces):
        """Sets the external_interfaces of this FPGA.

        An array of the FPGA external interfaces.  # noqa: E501

        :param external_interfaces: The external_interfaces of this FPGA.  # noqa: E501
        :type: list[FpgaInterface]
        """

        self._external_interfaces = external_interfaces

    @property
    def firmware_id(self):
        """Gets the firmware_id of this FPGA.  # noqa: E501

        The FPGA firmware identifier.  # noqa: E501

        :return: The firmware_id of this FPGA.  # noqa: E501
        :rtype: str
        """
        return self._firmware_id

    @firmware_id.setter
    def firmware_id(self, firmware_id):
        """Sets the firmware_id of this FPGA.

        The FPGA firmware identifier.  # noqa: E501

        :param firmware_id: The firmware_id of this FPGA.  # noqa: E501
        :type: str
        """

        self._firmware_id = firmware_id

    @property
    def firmware_manufacturer(self):
        """Gets the firmware_manufacturer of this FPGA.  # noqa: E501

        The FPGA firmware manufacturer.  # noqa: E501

        :return: The firmware_manufacturer of this FPGA.  # noqa: E501
        :rtype: str
        """
        return self._firmware_manufacturer

    @firmware_manufacturer.setter
    def firmware_manufacturer(self, firmware_manufacturer):
        """Sets the firmware_manufacturer of this FPGA.

        The FPGA firmware manufacturer.  # noqa: E501

        :param firmware_manufacturer: The firmware_manufacturer of this FPGA.  # noqa: E501
        :type: str
        """

        self._firmware_manufacturer = firmware_manufacturer

    @property
    def firmware_version(self):
        """Gets the firmware_version of this FPGA.  # noqa: E501

        The FPGA firmware version.  # noqa: E501

        :return: The firmware_version of this FPGA.  # noqa: E501
        :rtype: str
        """
        return self._firmware_version

    @firmware_version.setter
    def firmware_version(self, firmware_version):
        """Sets the firmware_version of this FPGA.

        The FPGA firmware version.  # noqa: E501

        :param firmware_version: The firmware_version of this FPGA.  # noqa: E501
        :type: str
        """

        self._firmware_version = firmware_version

    @property
    def fpga_type(self):
        """Gets the fpga_type of this FPGA.  # noqa: E501


        :return: The fpga_type of this FPGA.  # noqa: E501
        :rtype: FpgaType
        """
        return self._fpga_type

    @fpga_type.setter
    def fpga_type(self, fpga_type):
        """Sets the fpga_type of this FPGA.


        :param fpga_type: The fpga_type of this FPGA.  # noqa: E501
        :type: FpgaType
        """

        self._fpga_type = fpga_type

    @property
    def host_interface(self):
        """Gets the host_interface of this FPGA.  # noqa: E501


        :return: The host_interface of this FPGA.  # noqa: E501
        :rtype: FpgaInterface
        """
        return self._host_interface

    @host_interface.setter
    def host_interface(self, host_interface):
        """Sets the host_interface of this FPGA.


        :param host_interface: The host_interface of this FPGA.  # noqa: E501
        :type: FpgaInterface
        """

        self._host_interface = host_interface

    @property
    def model(self):
        """Gets the model of this FPGA.  # noqa: E501

        The FPGA model.  # noqa: E501

        :return: The model of this FPGA.  # noqa: E501
        :rtype: str
        """
        return self._model

    @model.setter
    def model(self, model):
        """Sets the model of this FPGA.

        The FPGA model.  # noqa: E501

        :param model: The model of this FPGA.  # noqa: E501
        :type: str
        """

        self._model = model

    @property
    def oem(self):
        """Gets the oem of this FPGA.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this FPGA.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this FPGA.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this FPGA.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def pc_ie_virtual_functions(self):
        """Gets the pc_ie_virtual_functions of this FPGA.  # noqa: E501

        The number of the PCIe Virtual Functions.  # noqa: E501

        :return: The pc_ie_virtual_functions of this FPGA.  # noqa: E501
        :rtype: int
        """
        return self._pc_ie_virtual_functions

    @pc_ie_virtual_functions.setter
    def pc_ie_virtual_functions(self, pc_ie_virtual_functions):
        """Sets the pc_ie_virtual_functions of this FPGA.

        The number of the PCIe Virtual Functions.  # noqa: E501

        :param pc_ie_virtual_functions: The pc_ie_virtual_functions of this FPGA.  # noqa: E501
        :type: int
        """

        self._pc_ie_virtual_functions = pc_ie_virtual_functions

    @property
    def programmable_from_host(self):
        """Gets the programmable_from_host of this FPGA.  # noqa: E501

        This flag indicates if the FPGA firmware can be reprogrammed from the host using system software.  # noqa: E501

        :return: The programmable_from_host of this FPGA.  # noqa: E501
        :rtype: bool
        """
        return self._programmable_from_host

    @programmable_from_host.setter
    def programmable_from_host(self, programmable_from_host):
        """Sets the programmable_from_host of this FPGA.

        This flag indicates if the FPGA firmware can be reprogrammed from the host using system software.  # noqa: E501

        :param programmable_from_host: The programmable_from_host of this FPGA.  # noqa: E501
        :type: bool
        """

        self._programmable_from_host = programmable_from_host

    @property
    def reconfiguration_slots(self):
        """Gets the reconfiguration_slots of this FPGA.  # noqa: E501

        An array of the FPGA reconfiguration slots.  A reconfiguration slot is used by an FPGA to contain an acceleration function that can change as the FPGA is being provisioned.  # noqa: E501

        :return: The reconfiguration_slots of this FPGA.  # noqa: E501
        :rtype: list[FpgaReconfigurationSlot]
        """
        return self._reconfiguration_slots

    @reconfiguration_slots.setter
    def reconfiguration_slots(self, reconfiguration_slots):
        """Sets the reconfiguration_slots of this FPGA.

        An array of the FPGA reconfiguration slots.  A reconfiguration slot is used by an FPGA to contain an acceleration function that can change as the FPGA is being provisioned.  # noqa: E501

        :param reconfiguration_slots: The reconfiguration_slots of this FPGA.  # noqa: E501
        :type: list[FpgaReconfigurationSlot]
        """

        self._reconfiguration_slots = reconfiguration_slots

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FPGA):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
