# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class FpgaReconfigurationSlot(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'acceleration_function': 'IdRef',
        'programmable_from_host': 'bool',
        'slot_id': 'str',
        'uuid': 'str'
    }

    attribute_map = {
        'acceleration_function': 'AccelerationFunction',
        'programmable_from_host': 'ProgrammableFromHost',
        'slot_id': 'SlotId',
        'uuid': 'UUID'
    }

    def __init__(self, acceleration_function=None, programmable_from_host=None, slot_id=None, uuid=None):  # noqa: E501
        """FpgaReconfigurationSlot - a model defined in OpenAPI"""  # noqa: E501

        self._acceleration_function = None
        self._programmable_from_host = None
        self._slot_id = None
        self._uuid = None
        self.discriminator = None

        if acceleration_function is not None:
            self.acceleration_function = acceleration_function
        self.programmable_from_host = programmable_from_host
        self.slot_id = slot_id
        if uuid is not None:
            self.uuid = uuid

    @property
    def acceleration_function(self):
        """Gets the acceleration_function of this FpgaReconfigurationSlot.  # noqa: E501


        :return: The acceleration_function of this FpgaReconfigurationSlot.  # noqa: E501
        :rtype: IdRef
        """
        return self._acceleration_function

    @acceleration_function.setter
    def acceleration_function(self, acceleration_function):
        """Sets the acceleration_function of this FpgaReconfigurationSlot.


        :param acceleration_function: The acceleration_function of this FpgaReconfigurationSlot.  # noqa: E501
        :type: IdRef
        """

        self._acceleration_function = acceleration_function

    @property
    def programmable_from_host(self):
        """Gets the programmable_from_host of this FpgaReconfigurationSlot.  # noqa: E501

        This flag indicates if the reconfiguration slot can be reprogrammed from the host using system software.  # noqa: E501

        :return: The programmable_from_host of this FpgaReconfigurationSlot.  # noqa: E501
        :rtype: bool
        """
        return self._programmable_from_host

    @programmable_from_host.setter
    def programmable_from_host(self, programmable_from_host):
        """Sets the programmable_from_host of this FpgaReconfigurationSlot.

        This flag indicates if the reconfiguration slot can be reprogrammed from the host using system software.  # noqa: E501

        :param programmable_from_host: The programmable_from_host of this FpgaReconfigurationSlot.  # noqa: E501
        :type: bool
        """

        self._programmable_from_host = programmable_from_host

    @property
    def slot_id(self):
        """Gets the slot_id of this FpgaReconfigurationSlot.  # noqa: E501

        The FPGA reconfiguration slot identifier.  # noqa: E501

        :return: The slot_id of this FpgaReconfigurationSlot.  # noqa: E501
        :rtype: str
        """
        return self._slot_id

    @slot_id.setter
    def slot_id(self, slot_id):
        """Sets the slot_id of this FpgaReconfigurationSlot.

        The FPGA reconfiguration slot identifier.  # noqa: E501

        :param slot_id: The slot_id of this FpgaReconfigurationSlot.  # noqa: E501
        :type: str
        """

        self._slot_id = slot_id

    @property
    def uuid(self):
        """Gets the uuid of this FpgaReconfigurationSlot.  # noqa: E501


        :return: The uuid of this FpgaReconfigurationSlot.  # noqa: E501
        :rtype: str
        """
        return self._uuid

    @uuid.setter
    def uuid(self, uuid):
        """Sets the uuid of this FpgaReconfigurationSlot.


        :param uuid: The uuid of this FpgaReconfigurationSlot.  # noqa: E501
        :type: str
        """
        if uuid is not None and not re.search(r'([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12})', uuid):  # noqa: E501
            raise ValueError(r"Invalid value for `uuid`, must be a follow pattern or equal to `/([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12})/`")  # noqa: E501

        self._uuid = uuid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FpgaReconfigurationSlot):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
