# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class GPUHealthIncident(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'health': 'str',
        'system': 'str',
        'error': 'GPUError'
    }

    attribute_map = {
        'health': 'Health',
        'system': 'System',
        'error': 'Error'
    }

    def __init__(self, health=None, system=None, error=None):  # noqa: E501
        """GPUHealthIncident - a model defined in OpenAPI"""  # noqa: E501

        self._health = None
        self._system = None
        self._error = None
        self.discriminator = None

        self.health = health
        self.system = system
        self.error = error

    @property
    def health(self):
        """Gets the health of this GPUHealthIncident.  # noqa: E501

        Health diagnosis of this incident  # noqa: E501

        :return: The health of this GPUHealthIncident.  # noqa: E501
        :rtype: str
        """
        return self._health

    @health.setter
    def health(self, health):
        """Sets the health of this GPUHealthIncident.

        Health diagnosis of this incident  # noqa: E501

        :param health: The health of this GPUHealthIncident.  # noqa: E501
        :type: str
        """
        if health is None:
            raise ValueError("Invalid value for `health`, must not be `None`")  # noqa: E501

        self._health = health

    @property
    def system(self):
        """Gets the system of this GPUHealthIncident.  # noqa: E501

        Health watch system of the GPU  # noqa: E501

        :return: The system of this GPUHealthIncident.  # noqa: E501
        :rtype: str
        """
        return self._system

    @system.setter
    def system(self, system):
        """Sets the system of this GPUHealthIncident.

        Health watch system of the GPU  # noqa: E501

        :param system: The system of this GPUHealthIncident.  # noqa: E501
        :type: str
        """
        if system is None:
            raise ValueError("Invalid value for `system`, must not be `None`")  # noqa: E501

        self._system = system

    @property
    def error(self):
        """Gets the error of this GPUHealthIncident.  # noqa: E501


        :return: The error of this GPUHealthIncident.  # noqa: E501
        :rtype: GPUError
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this GPUHealthIncident.


        :param error: The error of this GPUHealthIncident.  # noqa: E501
        :type: GPUError
        """
        if error is None:
            raise ValueError("Invalid value for `error`, must not be `None`")  # noqa: E501

        self._error = error

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GPUHealthIncident):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
