# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class GPUHealthResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_type': 'str',
        'health': 'str',
        'incidents': 'list[GPUHealthIncident]'
    }

    attribute_map = {
        'odata_type': '@odata.type',
        'health': 'Health',
        'incidents': 'Incidents'
    }

    def __init__(self, odata_type=None, health=None, incidents=None):  # noqa: E501
        """GPUHealthResponse - a model defined in OpenAPI"""  # noqa: E501

        self._odata_type = None
        self._health = None
        self._incidents = None
        self.discriminator = None

        self.odata_type = odata_type
        self.health = health
        if incidents is not None:
            self.incidents = incidents

    @property
    def odata_type(self):
        """Gets the odata_type of this GPUHealthResponse.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this GPUHealthResponse.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this GPUHealthResponse.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this GPUHealthResponse.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def health(self):
        """Gets the health of this GPUHealthResponse.  # noqa: E501

        Overall health for the given GPU  # noqa: E501

        :return: The health of this GPUHealthResponse.  # noqa: E501
        :rtype: str
        """
        return self._health

    @health.setter
    def health(self, health):
        """Sets the health of this GPUHealthResponse.

        Overall health for the given GPU  # noqa: E501

        :param health: The health of this GPUHealthResponse.  # noqa: E501
        :type: str
        """
        if health is None:
            raise ValueError("Invalid value for `health`, must not be `None`")  # noqa: E501

        self._health = health

    @property
    def incidents(self):
        """Gets the incidents of this GPUHealthResponse.  # noqa: E501


        :return: The incidents of this GPUHealthResponse.  # noqa: E501
        :rtype: list[GPUHealthIncident]
        """
        return self._incidents

    @incidents.setter
    def incidents(self, incidents):
        """Sets the incidents of this GPUHealthResponse.


        :param incidents: The incidents of this GPUHealthResponse.  # noqa: E501
        :type: list[GPUHealthIncident]
        """

        self._incidents = incidents

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GPUHealthResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
