# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class GPUInfo(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'nvidia_driver_version': 'str',
        'product_name': 'str',
        'vbios_version_s': 'str'
    }

    attribute_map = {
        'nvidia_driver_version': 'NVIDIADriverVersion',
        'product_name': 'ProductName',
        'vbios_version_s': 'VBIOSVersion(s)'
    }

    def __init__(self, nvidia_driver_version=None, product_name=None, vbios_version_s=None):  # noqa: E501
        """GPUInfo - a model defined in OpenAPI"""  # noqa: E501

        self._nvidia_driver_version = None
        self._product_name = None
        self._vbios_version_s = None
        self.discriminator = None

        self.nvidia_driver_version = nvidia_driver_version
        self.product_name = product_name
        self.vbios_version_s = vbios_version_s

    @property
    def nvidia_driver_version(self):
        """Gets the nvidia_driver_version of this GPUInfo.  # noqa: E501


        :return: The nvidia_driver_version of this GPUInfo.  # noqa: E501
        :rtype: str
        """
        return self._nvidia_driver_version

    @nvidia_driver_version.setter
    def nvidia_driver_version(self, nvidia_driver_version):
        """Sets the nvidia_driver_version of this GPUInfo.


        :param nvidia_driver_version: The nvidia_driver_version of this GPUInfo.  # noqa: E501
        :type: str
        """
        if nvidia_driver_version is None:
            raise ValueError("Invalid value for `nvidia_driver_version`, must not be `None`")  # noqa: E501

        self._nvidia_driver_version = nvidia_driver_version

    @property
    def product_name(self):
        """Gets the product_name of this GPUInfo.  # noqa: E501


        :return: The product_name of this GPUInfo.  # noqa: E501
        :rtype: str
        """
        return self._product_name

    @product_name.setter
    def product_name(self, product_name):
        """Sets the product_name of this GPUInfo.


        :param product_name: The product_name of this GPUInfo.  # noqa: E501
        :type: str
        """
        if product_name is None:
            raise ValueError("Invalid value for `product_name`, must not be `None`")  # noqa: E501

        self._product_name = product_name

    @property
    def vbios_version_s(self):
        """Gets the vbios_version_s of this GPUInfo.  # noqa: E501


        :return: The vbios_version_s of this GPUInfo.  # noqa: E501
        :rtype: str
        """
        return self._vbios_version_s

    @vbios_version_s.setter
    def vbios_version_s(self, vbios_version_s):
        """Sets the vbios_version_s of this GPUInfo.


        :param vbios_version_s: The vbios_version_s of this GPUInfo.  # noqa: E501
        :type: str
        """
        if vbios_version_s is None:
            raise ValueError("Invalid value for `vbios_version_s`, must not be `None`")  # noqa: E501

        self._vbios_version_s = vbios_version_s

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GPUInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
