# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class GPUPassThroughCollection(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'member_count': 'int',
        'pass_through_device': 'list[object]'
    }

    attribute_map = {
        'member_count': 'MemberCount',
        'pass_through_device': 'PassThroughDevice'
    }

    def __init__(self, member_count=None, pass_through_device=None):  # noqa: E501
        """GPUPassThroughCollection - a model defined in OpenAPI"""  # noqa: E501

        self._member_count = None
        self._pass_through_device = None
        self.discriminator = None

        self.member_count = member_count
        self.pass_through_device = pass_through_device

    @property
    def member_count(self):
        """Gets the member_count of this GPUPassThroughCollection.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The member_count of this GPUPassThroughCollection.  # noqa: E501
        :rtype: int
        """
        return self._member_count

    @member_count.setter
    def member_count(self, member_count):
        """Sets the member_count of this GPUPassThroughCollection.

        The number of items in a collection.  # noqa: E501

        :param member_count: The member_count of this GPUPassThroughCollection.  # noqa: E501
        :type: int
        """
        if member_count is None:
            raise ValueError("Invalid value for `member_count`, must not be `None`")  # noqa: E501

        self._member_count = member_count

    @property
    def pass_through_device(self):
        """Gets the pass_through_device of this GPUPassThroughCollection.  # noqa: E501


        :return: The pass_through_device of this GPUPassThroughCollection.  # noqa: E501
        :rtype: list[object]
        """
        return self._pass_through_device

    @pass_through_device.setter
    def pass_through_device(self, pass_through_device):
        """Sets the pass_through_device of this GPUPassThroughCollection.


        :param pass_through_device: The pass_through_device of this GPUPassThroughCollection.  # noqa: E501
        :type: list[object]
        """
        if pass_through_device is None:
            raise ValueError("Invalid value for `pass_through_device`, must not be `None`")  # noqa: E501

        self._pass_through_device = pass_through_device

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GPUPassThroughCollection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
