# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class GPUProcess(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'pid': 'int',
        'process_name': 'str',
        'process_type': 'str',
        'used_gpu_memory': 'str'
    }

    attribute_map = {
        'pid': 'PID',
        'process_name': 'ProcessName',
        'process_type': 'ProcessType',
        'used_gpu_memory': 'UsedGPUMemory'
    }

    def __init__(self, pid=None, process_name=None, process_type=None, used_gpu_memory=None):  # noqa: E501
        """GPUProcess - a model defined in OpenAPI"""  # noqa: E501

        self._pid = None
        self._process_name = None
        self._process_type = None
        self._used_gpu_memory = None
        self.discriminator = None

        self.pid = pid
        self.process_name = process_name
        self.process_type = process_type
        self.used_gpu_memory = used_gpu_memory

    @property
    def pid(self):
        """Gets the pid of this GPUProcess.  # noqa: E501

        Process ID number. This identifies the process that is using this GPU.  # noqa: E501

        :return: The pid of this GPUProcess.  # noqa: E501
        :rtype: int
        """
        return self._pid

    @pid.setter
    def pid(self, pid):
        """Sets the pid of this GPUProcess.

        Process ID number. This identifies the process that is using this GPU.  # noqa: E501

        :param pid: The pid of this GPUProcess.  # noqa: E501
        :type: int
        """
        if pid is None:
            raise ValueError("Invalid value for `pid`, must not be `None`")  # noqa: E501

        self._pid = pid

    @property
    def process_name(self):
        """Gets the process_name of this GPUProcess.  # noqa: E501

        Name of process using this GPU.  # noqa: E501

        :return: The process_name of this GPUProcess.  # noqa: E501
        :rtype: str
        """
        return self._process_name

    @process_name.setter
    def process_name(self, process_name):
        """Sets the process_name of this GPUProcess.

        Name of process using this GPU.  # noqa: E501

        :param process_name: The process_name of this GPUProcess.  # noqa: E501
        :type: str
        """
        if process_name is None:
            raise ValueError("Invalid value for `process_name`, must not be `None`")  # noqa: E501

        self._process_name = process_name

    @property
    def process_type(self):
        """Gets the process_type of this GPUProcess.  # noqa: E501

        Type of process which is using this GPU. Possible values are \"Graphics\" or \"Compute\".  # noqa: E501

        :return: The process_type of this GPUProcess.  # noqa: E501
        :rtype: str
        """
        return self._process_type

    @process_type.setter
    def process_type(self, process_type):
        """Sets the process_type of this GPUProcess.

        Type of process which is using this GPU. Possible values are \"Graphics\" or \"Compute\".  # noqa: E501

        :param process_type: The process_type of this GPUProcess.  # noqa: E501
        :type: str
        """
        if process_type is None:
            raise ValueError("Invalid value for `process_type`, must not be `None`")  # noqa: E501

        self._process_type = process_type

    @property
    def used_gpu_memory(self):
        """Gets the used_gpu_memory of this GPUProcess.  # noqa: E501

        Amount of GPU memory (in MiB) used by this process.  # noqa: E501

        :return: The used_gpu_memory of this GPUProcess.  # noqa: E501
        :rtype: str
        """
        return self._used_gpu_memory

    @used_gpu_memory.setter
    def used_gpu_memory(self, used_gpu_memory):
        """Sets the used_gpu_memory of this GPUProcess.

        Amount of GPU memory (in MiB) used by this process.  # noqa: E501

        :param used_gpu_memory: The used_gpu_memory of this GPUProcess.  # noqa: E501
        :type: str
        """
        if used_gpu_memory is None:
            raise ValueError("Invalid value for `used_gpu_memory`, must not be `None`")  # noqa: E501

        self._used_gpu_memory = used_gpu_memory

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GPUProcess):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
