# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class GPUSystemVersions(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'cuda_driver_version': 'str',
        'driver_version': 'str',
        'nvml_version': 'str'
    }

    attribute_map = {
        'cuda_driver_version': 'CUDADriverVersion',
        'driver_version': 'DriverVersion',
        'nvml_version': 'NVMLVersion'
    }

    def __init__(self, cuda_driver_version=None, driver_version=None, nvml_version=None):  # noqa: E501
        """GPUSystemVersions - a model defined in OpenAPI"""  # noqa: E501

        self._cuda_driver_version = None
        self._driver_version = None
        self._nvml_version = None
        self.discriminator = None

        self.cuda_driver_version = cuda_driver_version
        self.driver_version = driver_version
        self.nvml_version = nvml_version

    @property
    def cuda_driver_version(self):
        """Gets the cuda_driver_version of this GPUSystemVersions.  # noqa: E501

        Version of the installed NVIDIA CUDA driver.  # noqa: E501

        :return: The cuda_driver_version of this GPUSystemVersions.  # noqa: E501
        :rtype: str
        """
        return self._cuda_driver_version

    @cuda_driver_version.setter
    def cuda_driver_version(self, cuda_driver_version):
        """Sets the cuda_driver_version of this GPUSystemVersions.

        Version of the installed NVIDIA CUDA driver.  # noqa: E501

        :param cuda_driver_version: The cuda_driver_version of this GPUSystemVersions.  # noqa: E501
        :type: str
        """
        if cuda_driver_version is None:
            raise ValueError("Invalid value for `cuda_driver_version`, must not be `None`")  # noqa: E501

        self._cuda_driver_version = cuda_driver_version

    @property
    def driver_version(self):
        """Gets the driver_version of this GPUSystemVersions.  # noqa: E501

        The version of the installed NVIDIA display driver. This is an alphanumeric string.  # noqa: E501

        :return: The driver_version of this GPUSystemVersions.  # noqa: E501
        :rtype: str
        """
        return self._driver_version

    @driver_version.setter
    def driver_version(self, driver_version):
        """Sets the driver_version of this GPUSystemVersions.

        The version of the installed NVIDIA display driver. This is an alphanumeric string.  # noqa: E501

        :param driver_version: The driver_version of this GPUSystemVersions.  # noqa: E501
        :type: str
        """
        if driver_version is None:
            raise ValueError("Invalid value for `driver_version`, must not be `None`")  # noqa: E501

        self._driver_version = driver_version

    @property
    def nvml_version(self):
        """Gets the nvml_version of this GPUSystemVersions.  # noqa: E501

        Version of NVML library used to find all information in this dataset.  # noqa: E501

        :return: The nvml_version of this GPUSystemVersions.  # noqa: E501
        :rtype: str
        """
        return self._nvml_version

    @nvml_version.setter
    def nvml_version(self, nvml_version):
        """Sets the nvml_version of this GPUSystemVersions.

        Version of NVML library used to find all information in this dataset.  # noqa: E501

        :param nvml_version: The nvml_version of this GPUSystemVersions.  # noqa: E501
        :type: str
        """
        if nvml_version is None:
            raise ValueError("Invalid value for `nvml_version`, must not be `None`")  # noqa: E501

        self._nvml_version = nvml_version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GPUSystemVersions):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
