# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class GPUThrottleReasons(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'applications_clocks_setting': 'str',
        'display_clock_setting': 'str',
        'gpu_idle': 'str',
        'hw_power_brake_slowdown': 'str',
        'hw_slowdown': 'str',
        'hw_thermal_slowdown': 'str',
        'sw_power_cap': 'str',
        'sw_thermal_slowdown': 'str',
        'sync_boost': 'str'
    }

    attribute_map = {
        'applications_clocks_setting': 'ApplicationsClocksSetting',
        'display_clock_setting': 'DisplayClockSetting',
        'gpu_idle': 'GPUIdle',
        'hw_power_brake_slowdown': 'HWPowerBrakeSlowdown',
        'hw_slowdown': 'HWSlowdown',
        'hw_thermal_slowdown': 'HWThermalSlowdown',
        'sw_power_cap': 'SWPowerCap',
        'sw_thermal_slowdown': 'SWThermalSlowdown',
        'sync_boost': 'SyncBoost'
    }

    def __init__(self, applications_clocks_setting=None, display_clock_setting=None, gpu_idle=None, hw_power_brake_slowdown=None, hw_slowdown=None, hw_thermal_slowdown=None, sw_power_cap=None, sw_thermal_slowdown=None, sync_boost=None):  # noqa: E501
        """GPUThrottleReasons - a model defined in OpenAPI"""  # noqa: E501

        self._applications_clocks_setting = None
        self._display_clock_setting = None
        self._gpu_idle = None
        self._hw_power_brake_slowdown = None
        self._hw_slowdown = None
        self._hw_thermal_slowdown = None
        self._sw_power_cap = None
        self._sw_thermal_slowdown = None
        self._sync_boost = None
        self.discriminator = None

        self.applications_clocks_setting = applications_clocks_setting
        self.display_clock_setting = display_clock_setting
        self.gpu_idle = gpu_idle
        self.hw_power_brake_slowdown = hw_power_brake_slowdown
        self.hw_slowdown = hw_slowdown
        self.hw_thermal_slowdown = hw_thermal_slowdown
        self.sw_power_cap = sw_power_cap
        self.sw_thermal_slowdown = sw_thermal_slowdown
        self.sync_boost = sync_boost

    @property
    def applications_clocks_setting(self):
        """Gets the applications_clocks_setting of this GPUThrottleReasons.  # noqa: E501

        GPU clocks are limited by current setting of applications clocks.  # noqa: E501

        :return: The applications_clocks_setting of this GPUThrottleReasons.  # noqa: E501
        :rtype: str
        """
        return self._applications_clocks_setting

    @applications_clocks_setting.setter
    def applications_clocks_setting(self, applications_clocks_setting):
        """Sets the applications_clocks_setting of this GPUThrottleReasons.

        GPU clocks are limited by current setting of applications clocks.  # noqa: E501

        :param applications_clocks_setting: The applications_clocks_setting of this GPUThrottleReasons.  # noqa: E501
        :type: str
        """
        if applications_clocks_setting is None:
            raise ValueError("Invalid value for `applications_clocks_setting`, must not be `None`")  # noqa: E501

        self._applications_clocks_setting = applications_clocks_setting

    @property
    def display_clock_setting(self):
        """Gets the display_clock_setting of this GPUThrottleReasons.  # noqa: E501

        ???  # noqa: E501

        :return: The display_clock_setting of this GPUThrottleReasons.  # noqa: E501
        :rtype: str
        """
        return self._display_clock_setting

    @display_clock_setting.setter
    def display_clock_setting(self, display_clock_setting):
        """Sets the display_clock_setting of this GPUThrottleReasons.

        ???  # noqa: E501

        :param display_clock_setting: The display_clock_setting of this GPUThrottleReasons.  # noqa: E501
        :type: str
        """
        if display_clock_setting is None:
            raise ValueError("Invalid value for `display_clock_setting`, must not be `None`")  # noqa: E501

        self._display_clock_setting = display_clock_setting

    @property
    def gpu_idle(self):
        """Gets the gpu_idle of this GPUThrottleReasons.  # noqa: E501

        Nothing is running on the GPU and the clocks are dropping to Idle state.  # noqa: E501

        :return: The gpu_idle of this GPUThrottleReasons.  # noqa: E501
        :rtype: str
        """
        return self._gpu_idle

    @gpu_idle.setter
    def gpu_idle(self, gpu_idle):
        """Sets the gpu_idle of this GPUThrottleReasons.

        Nothing is running on the GPU and the clocks are dropping to Idle state.  # noqa: E501

        :param gpu_idle: The gpu_idle of this GPUThrottleReasons.  # noqa: E501
        :type: str
        """
        if gpu_idle is None:
            raise ValueError("Invalid value for `gpu_idle`, must not be `None`")  # noqa: E501

        self._gpu_idle = gpu_idle

    @property
    def hw_power_brake_slowdown(self):
        """Gets the hw_power_brake_slowdown of this GPUThrottleReasons.  # noqa: E501

        External Power Brake Assertion is triggered (e.g. by the system power supply)  # noqa: E501

        :return: The hw_power_brake_slowdown of this GPUThrottleReasons.  # noqa: E501
        :rtype: str
        """
        return self._hw_power_brake_slowdown

    @hw_power_brake_slowdown.setter
    def hw_power_brake_slowdown(self, hw_power_brake_slowdown):
        """Sets the hw_power_brake_slowdown of this GPUThrottleReasons.

        External Power Brake Assertion is triggered (e.g. by the system power supply)  # noqa: E501

        :param hw_power_brake_slowdown: The hw_power_brake_slowdown of this GPUThrottleReasons.  # noqa: E501
        :type: str
        """
        if hw_power_brake_slowdown is None:
            raise ValueError("Invalid value for `hw_power_brake_slowdown`, must not be `None`")  # noqa: E501

        self._hw_power_brake_slowdown = hw_power_brake_slowdown

    @property
    def hw_slowdown(self):
        """Gets the hw_slowdown of this GPUThrottleReasons.  # noqa: E501

        HW Slowdown (reducing the core clocks by a factor of 2 or more) is engaged  # noqa: E501

        :return: The hw_slowdown of this GPUThrottleReasons.  # noqa: E501
        :rtype: str
        """
        return self._hw_slowdown

    @hw_slowdown.setter
    def hw_slowdown(self, hw_slowdown):
        """Sets the hw_slowdown of this GPUThrottleReasons.

        HW Slowdown (reducing the core clocks by a factor of 2 or more) is engaged  # noqa: E501

        :param hw_slowdown: The hw_slowdown of this GPUThrottleReasons.  # noqa: E501
        :type: str
        """
        if hw_slowdown is None:
            raise ValueError("Invalid value for `hw_slowdown`, must not be `None`")  # noqa: E501

        self._hw_slowdown = hw_slowdown

    @property
    def hw_thermal_slowdown(self):
        """Gets the hw_thermal_slowdown of this GPUThrottleReasons.  # noqa: E501

        Temperature is too high  # noqa: E501

        :return: The hw_thermal_slowdown of this GPUThrottleReasons.  # noqa: E501
        :rtype: str
        """
        return self._hw_thermal_slowdown

    @hw_thermal_slowdown.setter
    def hw_thermal_slowdown(self, hw_thermal_slowdown):
        """Sets the hw_thermal_slowdown of this GPUThrottleReasons.

        Temperature is too high  # noqa: E501

        :param hw_thermal_slowdown: The hw_thermal_slowdown of this GPUThrottleReasons.  # noqa: E501
        :type: str
        """
        if hw_thermal_slowdown is None:
            raise ValueError("Invalid value for `hw_thermal_slowdown`, must not be `None`")  # noqa: E501

        self._hw_thermal_slowdown = hw_thermal_slowdown

    @property
    def sw_power_cap(self):
        """Gets the sw_power_cap of this GPUThrottleReasons.  # noqa: E501

        SW Power Scaling algorithm is reducing the clocks below requested clocks.  # noqa: E501

        :return: The sw_power_cap of this GPUThrottleReasons.  # noqa: E501
        :rtype: str
        """
        return self._sw_power_cap

    @sw_power_cap.setter
    def sw_power_cap(self, sw_power_cap):
        """Sets the sw_power_cap of this GPUThrottleReasons.

        SW Power Scaling algorithm is reducing the clocks below requested clocks.  # noqa: E501

        :param sw_power_cap: The sw_power_cap of this GPUThrottleReasons.  # noqa: E501
        :type: str
        """
        if sw_power_cap is None:
            raise ValueError("Invalid value for `sw_power_cap`, must not be `None`")  # noqa: E501

        self._sw_power_cap = sw_power_cap

    @property
    def sw_thermal_slowdown(self):
        """Gets the sw_thermal_slowdown of this GPUThrottleReasons.  # noqa: E501

        SW Thermal slowdown  # noqa: E501

        :return: The sw_thermal_slowdown of this GPUThrottleReasons.  # noqa: E501
        :rtype: str
        """
        return self._sw_thermal_slowdown

    @sw_thermal_slowdown.setter
    def sw_thermal_slowdown(self, sw_thermal_slowdown):
        """Sets the sw_thermal_slowdown of this GPUThrottleReasons.

        SW Thermal slowdown  # noqa: E501

        :param sw_thermal_slowdown: The sw_thermal_slowdown of this GPUThrottleReasons.  # noqa: E501
        :type: str
        """
        if sw_thermal_slowdown is None:
            raise ValueError("Invalid value for `sw_thermal_slowdown`, must not be `None`")  # noqa: E501

        self._sw_thermal_slowdown = sw_thermal_slowdown

    @property
    def sync_boost(self):
        """Gets the sync_boost of this GPUThrottleReasons.  # noqa: E501

        This GPU has been added to a Sync boost group with nvidia-smi or DCGM in order to maximize performance per watt.  # noqa: E501

        :return: The sync_boost of this GPUThrottleReasons.  # noqa: E501
        :rtype: str
        """
        return self._sync_boost

    @sync_boost.setter
    def sync_boost(self, sync_boost):
        """Sets the sync_boost of this GPUThrottleReasons.

        This GPU has been added to a Sync boost group with nvidia-smi or DCGM in order to maximize performance per watt.  # noqa: E501

        :param sync_boost: The sync_boost of this GPUThrottleReasons.  # noqa: E501
        :type: str
        """
        if sync_boost is None:
            raise ValueError("Invalid value for `sync_boost`, must not be `None`")  # noqa: E501

        self._sync_boost = sync_boost

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GPUThrottleReasons):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
