# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class GraphicalConsole(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'connect_types_supported': 'list[GraphicalConnectTypesSupported]',
        'max_concurrent_sessions': 'int',
        'service_enabled': 'bool'
    }

    attribute_map = {
        'connect_types_supported': 'ConnectTypesSupported',
        'max_concurrent_sessions': 'MaxConcurrentSessions',
        'service_enabled': 'ServiceEnabled'
    }

    def __init__(self, connect_types_supported=None, max_concurrent_sessions=None, service_enabled=None):  # noqa: E501
        """GraphicalConsole - a model defined in OpenAPI"""  # noqa: E501

        self._connect_types_supported = None
        self._max_concurrent_sessions = None
        self._service_enabled = None
        self.discriminator = None

        if connect_types_supported is not None:
            self.connect_types_supported = connect_types_supported
        if max_concurrent_sessions is not None:
            self.max_concurrent_sessions = max_concurrent_sessions
        if service_enabled is not None:
            self.service_enabled = service_enabled

    @property
    def connect_types_supported(self):
        """Gets the connect_types_supported of this GraphicalConsole.  # noqa: E501

        This object is used to enumerate the Graphical Console connection types allowed by the implementation.  # noqa: E501

        :return: The connect_types_supported of this GraphicalConsole.  # noqa: E501
        :rtype: list[GraphicalConnectTypesSupported]
        """
        return self._connect_types_supported

    @connect_types_supported.setter
    def connect_types_supported(self, connect_types_supported):
        """Sets the connect_types_supported of this GraphicalConsole.

        This object is used to enumerate the Graphical Console connection types allowed by the implementation.  # noqa: E501

        :param connect_types_supported: The connect_types_supported of this GraphicalConsole.  # noqa: E501
        :type: list[GraphicalConnectTypesSupported]
        """

        self._connect_types_supported = connect_types_supported

    @property
    def max_concurrent_sessions(self):
        """Gets the max_concurrent_sessions of this GraphicalConsole.  # noqa: E501

        Indicates the maximum number of service sessions, regardless of protocol, this manager is able to support.  # noqa: E501

        :return: The max_concurrent_sessions of this GraphicalConsole.  # noqa: E501
        :rtype: int
        """
        return self._max_concurrent_sessions

    @max_concurrent_sessions.setter
    def max_concurrent_sessions(self, max_concurrent_sessions):
        """Sets the max_concurrent_sessions of this GraphicalConsole.

        Indicates the maximum number of service sessions, regardless of protocol, this manager is able to support.  # noqa: E501

        :param max_concurrent_sessions: The max_concurrent_sessions of this GraphicalConsole.  # noqa: E501
        :type: int
        """
        if max_concurrent_sessions is not None and max_concurrent_sessions < 0:  # noqa: E501
            raise ValueError("Invalid value for `max_concurrent_sessions`, must be a value greater than or equal to `0`")  # noqa: E501

        self._max_concurrent_sessions = max_concurrent_sessions

    @property
    def service_enabled(self):
        """Gets the service_enabled of this GraphicalConsole.  # noqa: E501

        Indicates if the service is enabled for this manager.  # noqa: E501

        :return: The service_enabled of this GraphicalConsole.  # noqa: E501
        :rtype: bool
        """
        return self._service_enabled

    @service_enabled.setter
    def service_enabled(self, service_enabled):
        """Sets the service_enabled of this GraphicalConsole.

        Indicates if the service is enabled for this manager.  # noqa: E501

        :param service_enabled: The service_enabled of this GraphicalConsole.  # noqa: E501
        :type: bool
        """

        self._service_enabled = service_enabled

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GraphicalConsole):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
