# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class HealthProperties(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_type': 'str',
        'message': 'str',
        'time_stamp': 'str',
        'state': 'str',
        'progress': 'float',
        'result': 'HealthResults'
    }

    attribute_map = {
        'odata_type': '@odata.type',
        'message': 'Message',
        'time_stamp': 'TimeStamp',
        'state': 'State',
        'progress': 'Progress',
        'result': 'Result'
    }

    def __init__(self, odata_type=None, message=None, time_stamp=None, state=None, progress=None, result=None):  # noqa: E501
        """HealthProperties - a model defined in OpenAPI"""  # noqa: E501

        self._odata_type = None
        self._message = None
        self._time_stamp = None
        self._state = None
        self._progress = None
        self._result = None
        self.discriminator = None

        self.odata_type = odata_type
        self.message = message
        if time_stamp is not None:
            self.time_stamp = time_stamp
        self.state = state
        self.progress = progress
        if result is not None:
            self.result = result

    @property
    def odata_type(self):
        """Gets the odata_type of this HealthProperties.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this HealthProperties.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this HealthProperties.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this HealthProperties.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def message(self):
        """Gets the message of this HealthProperties.  # noqa: E501

        Message  # noqa: E501

        :return: The message of this HealthProperties.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this HealthProperties.

        Message  # noqa: E501

        :param message: The message of this HealthProperties.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def time_stamp(self):
        """Gets the time_stamp of this HealthProperties.  # noqa: E501

        Time when last health run executed.  # noqa: E501

        :return: The time_stamp of this HealthProperties.  # noqa: E501
        :rtype: str
        """
        return self._time_stamp

    @time_stamp.setter
    def time_stamp(self, time_stamp):
        """Sets the time_stamp of this HealthProperties.

        Time when last health run executed.  # noqa: E501

        :param time_stamp: The time_stamp of this HealthProperties.  # noqa: E501
        :type: str
        """

        self._time_stamp = time_stamp

    @property
    def state(self):
        """Gets the state of this HealthProperties.  # noqa: E501

        State  # noqa: E501

        :return: The state of this HealthProperties.  # noqa: E501
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this HealthProperties.

        State  # noqa: E501

        :param state: The state of this HealthProperties.  # noqa: E501
        :type: str
        """

        self._state = state

    @property
    def progress(self):
        """Gets the progress of this HealthProperties.  # noqa: E501

        Progress  # noqa: E501

        :return: The progress of this HealthProperties.  # noqa: E501
        :rtype: float
        """
        return self._progress

    @progress.setter
    def progress(self, progress):
        """Sets the progress of this HealthProperties.

        Progress  # noqa: E501

        :param progress: The progress of this HealthProperties.  # noqa: E501
        :type: float
        """

        self._progress = progress

    @property
    def result(self):
        """Gets the result of this HealthProperties.  # noqa: E501


        :return: The result of this HealthProperties.  # noqa: E501
        :rtype: HealthResults
        """
        return self._result

    @result.setter
    def result(self, result):
        """Sets the result of this HealthProperties.


        :param result: The result of this HealthProperties.  # noqa: E501
        :type: HealthResults
        """

        self._result = result

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HealthProperties):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
