# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class IPv4Address2(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'address': 'str',
        'address_origin': 'IPv4AddressOrigin',
        'gateway': 'str',
        'oem': 'dict(str, object)',
        'subnet_mask': 'str'
    }

    attribute_map = {
        'address': 'Address',
        'address_origin': 'AddressOrigin',
        'gateway': 'Gateway',
        'oem': 'Oem',
        'subnet_mask': 'SubnetMask'
    }

    def __init__(self, address=None, address_origin=None, gateway=None, oem=None, subnet_mask=None):  # noqa: E501
        """IPv4Address2 - a model defined in OpenAPI"""  # noqa: E501

        self._address = None
        self._address_origin = None
        self._gateway = None
        self._oem = None
        self._subnet_mask = None
        self.discriminator = None

        self.address = address
        if address_origin is not None:
            self.address_origin = address_origin
        self.gateway = gateway
        if oem is not None:
            self.oem = oem
        if subnet_mask is not None:
            self.subnet_mask = subnet_mask

    @property
    def address(self):
        """Gets the address of this IPv4Address2.  # noqa: E501

        The IPv4 address.  # noqa: E501

        :return: The address of this IPv4Address2.  # noqa: E501
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this IPv4Address2.

        The IPv4 address.  # noqa: E501

        :param address: The address of this IPv4Address2.  # noqa: E501
        :type: str
        """
        if address is not None and not re.search(r'^(?:[0-9]{1,3}\.){3}[0-9]{1,3}$', address):  # noqa: E501
            raise ValueError(r"Invalid value for `address`, must be a follow pattern or equal to `/^(?:[0-9]{1,3}\.){3}[0-9]{1,3}$/`")  # noqa: E501

        self._address = address

    @property
    def address_origin(self):
        """Gets the address_origin of this IPv4Address2.  # noqa: E501


        :return: The address_origin of this IPv4Address2.  # noqa: E501
        :rtype: IPv4AddressOrigin
        """
        return self._address_origin

    @address_origin.setter
    def address_origin(self, address_origin):
        """Sets the address_origin of this IPv4Address2.


        :param address_origin: The address_origin of this IPv4Address2.  # noqa: E501
        :type: IPv4AddressOrigin
        """

        self._address_origin = address_origin

    @property
    def gateway(self):
        """Gets the gateway of this IPv4Address2.  # noqa: E501

        The IPv4 gateway for this address.  # noqa: E501

        :return: The gateway of this IPv4Address2.  # noqa: E501
        :rtype: str
        """
        return self._gateway

    @gateway.setter
    def gateway(self, gateway):
        """Sets the gateway of this IPv4Address2.

        The IPv4 gateway for this address.  # noqa: E501

        :param gateway: The gateway of this IPv4Address2.  # noqa: E501
        :type: str
        """
        if gateway is not None and not re.search(r'^(?:[0-9]{1,3}\.){3}[0-9]{1,3}$', gateway):  # noqa: E501
            raise ValueError(r"Invalid value for `gateway`, must be a follow pattern or equal to `/^(?:[0-9]{1,3}\.){3}[0-9]{1,3}$/`")  # noqa: E501

        self._gateway = gateway

    @property
    def oem(self):
        """Gets the oem of this IPv4Address2.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this IPv4Address2.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this IPv4Address2.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this IPv4Address2.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def subnet_mask(self):
        """Gets the subnet_mask of this IPv4Address2.  # noqa: E501


        :return: The subnet_mask of this IPv4Address2.  # noqa: E501
        :rtype: str
        """
        return self._subnet_mask

    @subnet_mask.setter
    def subnet_mask(self, subnet_mask):
        """Sets the subnet_mask of this IPv4Address2.


        :param subnet_mask: The subnet_mask of this IPv4Address2.  # noqa: E501
        :type: str
        """
        if subnet_mask is not None and not re.search(r'^(?:[0-9]{1,3}\.){3}[0-9]{1,3}$', subnet_mask):  # noqa: E501
            raise ValueError(r"Invalid value for `subnet_mask`, must be a follow pattern or equal to `/^(?:[0-9]{1,3}\.){3}[0-9]{1,3}$/`")  # noqa: E501

        self._subnet_mask = subnet_mask

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IPv4Address2):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
