# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class IPv6Address2(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'address': 'str',
        'address_origin': 'IPv6AddressOrigin',
        'address_state': 'AddressState',
        'oem': 'dict(str, object)',
        'prefix_length': 'int'
    }

    attribute_map = {
        'address': 'Address',
        'address_origin': 'AddressOrigin',
        'address_state': 'AddressState',
        'oem': 'Oem',
        'prefix_length': 'PrefixLength'
    }

    def __init__(self, address=None, address_origin=None, address_state=None, oem=None, prefix_length=None):  # noqa: E501
        """IPv6Address2 - a model defined in OpenAPI"""  # noqa: E501

        self._address = None
        self._address_origin = None
        self._address_state = None
        self._oem = None
        self._prefix_length = None
        self.discriminator = None

        self.address = address
        if address_origin is not None:
            self.address_origin = address_origin
        if address_state is not None:
            self.address_state = address_state
        if oem is not None:
            self.oem = oem
        if prefix_length is not None:
            self.prefix_length = prefix_length

    @property
    def address(self):
        """Gets the address of this IPv6Address2.  # noqa: E501

        The IPv6 address.  # noqa: E501

        :return: The address of this IPv6Address2.  # noqa: E501
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this IPv6Address2.

        The IPv6 address.  # noqa: E501

        :param address: The address of this IPv6Address2.  # noqa: E501
        :type: str
        """

        self._address = address

    @property
    def address_origin(self):
        """Gets the address_origin of this IPv6Address2.  # noqa: E501


        :return: The address_origin of this IPv6Address2.  # noqa: E501
        :rtype: IPv6AddressOrigin
        """
        return self._address_origin

    @address_origin.setter
    def address_origin(self, address_origin):
        """Sets the address_origin of this IPv6Address2.


        :param address_origin: The address_origin of this IPv6Address2.  # noqa: E501
        :type: IPv6AddressOrigin
        """

        self._address_origin = address_origin

    @property
    def address_state(self):
        """Gets the address_state of this IPv6Address2.  # noqa: E501


        :return: The address_state of this IPv6Address2.  # noqa: E501
        :rtype: AddressState
        """
        return self._address_state

    @address_state.setter
    def address_state(self, address_state):
        """Sets the address_state of this IPv6Address2.


        :param address_state: The address_state of this IPv6Address2.  # noqa: E501
        :type: AddressState
        """

        self._address_state = address_state

    @property
    def oem(self):
        """Gets the oem of this IPv6Address2.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this IPv6Address2.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this IPv6Address2.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this IPv6Address2.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def prefix_length(self):
        """Gets the prefix_length of this IPv6Address2.  # noqa: E501


        :return: The prefix_length of this IPv6Address2.  # noqa: E501
        :rtype: int
        """
        return self._prefix_length

    @prefix_length.setter
    def prefix_length(self, prefix_length):
        """Sets the prefix_length of this IPv6Address2.


        :param prefix_length: The prefix_length of this IPv6Address2.  # noqa: E501
        :type: int
        """
        if prefix_length is not None and prefix_length > 128:  # noqa: E501
            raise ValueError("Invalid value for `prefix_length`, must be a value less than or equal to `128`")  # noqa: E501
        if prefix_length is not None and prefix_length < 0:  # noqa: E501
            raise ValueError("Invalid value for `prefix_length`, must be a value greater than or equal to `0`")  # noqa: E501

        self._prefix_length = prefix_length

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IPv6Address2):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
