# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class IPv6AddressPolicyEntry(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'label': 'int',
        'precedence': 'int',
        'prefix': 'str'
    }

    attribute_map = {
        'label': 'Label',
        'precedence': 'Precedence',
        'prefix': 'Prefix'
    }

    def __init__(self, label=None, precedence=None, prefix=None):  # noqa: E501
        """IPv6AddressPolicyEntry - a model defined in OpenAPI"""  # noqa: E501

        self._label = None
        self._precedence = None
        self._prefix = None
        self.discriminator = None

        self.label = label
        self.precedence = precedence
        self.prefix = prefix

    @property
    def label(self):
        """Gets the label of this IPv6AddressPolicyEntry.  # noqa: E501

        The IPv6 Label (as defined in RFC 6724 section 2.1).  # noqa: E501

        :return: The label of this IPv6AddressPolicyEntry.  # noqa: E501
        :rtype: int
        """
        return self._label

    @label.setter
    def label(self, label):
        """Sets the label of this IPv6AddressPolicyEntry.

        The IPv6 Label (as defined in RFC 6724 section 2.1).  # noqa: E501

        :param label: The label of this IPv6AddressPolicyEntry.  # noqa: E501
        :type: int
        """
        if label is not None and label > 100:  # noqa: E501
            raise ValueError("Invalid value for `label`, must be a value less than or equal to `100`")  # noqa: E501
        if label is not None and label < 0:  # noqa: E501
            raise ValueError("Invalid value for `label`, must be a value greater than or equal to `0`")  # noqa: E501

        self._label = label

    @property
    def precedence(self):
        """Gets the precedence of this IPv6AddressPolicyEntry.  # noqa: E501

        The IPv6 Precedence (as defined in RFC 6724 section 2.1.  # noqa: E501

        :return: The precedence of this IPv6AddressPolicyEntry.  # noqa: E501
        :rtype: int
        """
        return self._precedence

    @precedence.setter
    def precedence(self, precedence):
        """Sets the precedence of this IPv6AddressPolicyEntry.

        The IPv6 Precedence (as defined in RFC 6724 section 2.1.  # noqa: E501

        :param precedence: The precedence of this IPv6AddressPolicyEntry.  # noqa: E501
        :type: int
        """
        if precedence is not None and precedence > 100:  # noqa: E501
            raise ValueError("Invalid value for `precedence`, must be a value less than or equal to `100`")  # noqa: E501
        if precedence is not None and precedence < 1:  # noqa: E501
            raise ValueError("Invalid value for `precedence`, must be a value greater than or equal to `1`")  # noqa: E501

        self._precedence = precedence

    @property
    def prefix(self):
        """Gets the prefix of this IPv6AddressPolicyEntry.  # noqa: E501

        The IPv6 Address Prefix (as defined in RFC 6724 section 2.1).  # noqa: E501

        :return: The prefix of this IPv6AddressPolicyEntry.  # noqa: E501
        :rtype: str
        """
        return self._prefix

    @prefix.setter
    def prefix(self, prefix):
        """Sets the prefix of this IPv6AddressPolicyEntry.

        The IPv6 Address Prefix (as defined in RFC 6724 section 2.1).  # noqa: E501

        :param prefix: The prefix of this IPv6AddressPolicyEntry.  # noqa: E501
        :type: str
        """

        self._prefix = prefix

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IPv6AddressPolicyEntry):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
