# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class InputRange(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'input_type': 'InputType',
        'maximum_frequency_hz': 'float',
        'maximum_voltage': 'float',
        'minimum_frequency_hz': 'float',
        'minimum_voltage': 'float',
        'oem': 'dict(str, object)',
        'output_wattage': 'float'
    }

    attribute_map = {
        'input_type': 'InputType',
        'maximum_frequency_hz': 'MaximumFrequencyHz',
        'maximum_voltage': 'MaximumVoltage',
        'minimum_frequency_hz': 'MinimumFrequencyHz',
        'minimum_voltage': 'MinimumVoltage',
        'oem': 'Oem',
        'output_wattage': 'OutputWattage'
    }

    def __init__(self, input_type=None, maximum_frequency_hz=None, maximum_voltage=None, minimum_frequency_hz=None, minimum_voltage=None, oem=None, output_wattage=None):  # noqa: E501
        """InputRange - a model defined in OpenAPI"""  # noqa: E501

        self._input_type = None
        self._maximum_frequency_hz = None
        self._maximum_voltage = None
        self._minimum_frequency_hz = None
        self._minimum_voltage = None
        self._oem = None
        self._output_wattage = None
        self.discriminator = None

        if input_type is not None:
            self.input_type = input_type
        self.maximum_frequency_hz = maximum_frequency_hz
        self.maximum_voltage = maximum_voltage
        self.minimum_frequency_hz = minimum_frequency_hz
        self.minimum_voltage = minimum_voltage
        if oem is not None:
            self.oem = oem
        self.output_wattage = output_wattage

    @property
    def input_type(self):
        """Gets the input_type of this InputRange.  # noqa: E501


        :return: The input_type of this InputRange.  # noqa: E501
        :rtype: InputType
        """
        return self._input_type

    @input_type.setter
    def input_type(self, input_type):
        """Sets the input_type of this InputRange.


        :param input_type: The input_type of this InputRange.  # noqa: E501
        :type: InputType
        """

        self._input_type = input_type

    @property
    def maximum_frequency_hz(self):
        """Gets the maximum_frequency_hz of this InputRange.  # noqa: E501

        The maximum line input frequency at which this power supply input range is effective.  # noqa: E501

        :return: The maximum_frequency_hz of this InputRange.  # noqa: E501
        :rtype: float
        """
        return self._maximum_frequency_hz

    @maximum_frequency_hz.setter
    def maximum_frequency_hz(self, maximum_frequency_hz):
        """Sets the maximum_frequency_hz of this InputRange.

        The maximum line input frequency at which this power supply input range is effective.  # noqa: E501

        :param maximum_frequency_hz: The maximum_frequency_hz of this InputRange.  # noqa: E501
        :type: float
        """
        if maximum_frequency_hz is not None and maximum_frequency_hz < 0:  # noqa: E501
            raise ValueError("Invalid value for `maximum_frequency_hz`, must be a value greater than or equal to `0`")  # noqa: E501

        self._maximum_frequency_hz = maximum_frequency_hz

    @property
    def maximum_voltage(self):
        """Gets the maximum_voltage of this InputRange.  # noqa: E501

        The maximum line input voltage at which this power supply input range is effective.  # noqa: E501

        :return: The maximum_voltage of this InputRange.  # noqa: E501
        :rtype: float
        """
        return self._maximum_voltage

    @maximum_voltage.setter
    def maximum_voltage(self, maximum_voltage):
        """Sets the maximum_voltage of this InputRange.

        The maximum line input voltage at which this power supply input range is effective.  # noqa: E501

        :param maximum_voltage: The maximum_voltage of this InputRange.  # noqa: E501
        :type: float
        """

        self._maximum_voltage = maximum_voltage

    @property
    def minimum_frequency_hz(self):
        """Gets the minimum_frequency_hz of this InputRange.  # noqa: E501

        The minimum line input frequency at which this power supply input range is effective.  # noqa: E501

        :return: The minimum_frequency_hz of this InputRange.  # noqa: E501
        :rtype: float
        """
        return self._minimum_frequency_hz

    @minimum_frequency_hz.setter
    def minimum_frequency_hz(self, minimum_frequency_hz):
        """Sets the minimum_frequency_hz of this InputRange.

        The minimum line input frequency at which this power supply input range is effective.  # noqa: E501

        :param minimum_frequency_hz: The minimum_frequency_hz of this InputRange.  # noqa: E501
        :type: float
        """
        if minimum_frequency_hz is not None and minimum_frequency_hz < 0:  # noqa: E501
            raise ValueError("Invalid value for `minimum_frequency_hz`, must be a value greater than or equal to `0`")  # noqa: E501

        self._minimum_frequency_hz = minimum_frequency_hz

    @property
    def minimum_voltage(self):
        """Gets the minimum_voltage of this InputRange.  # noqa: E501

        The minimum line input voltage at which this power supply input range is effective.  # noqa: E501

        :return: The minimum_voltage of this InputRange.  # noqa: E501
        :rtype: float
        """
        return self._minimum_voltage

    @minimum_voltage.setter
    def minimum_voltage(self, minimum_voltage):
        """Sets the minimum_voltage of this InputRange.

        The minimum line input voltage at which this power supply input range is effective.  # noqa: E501

        :param minimum_voltage: The minimum_voltage of this InputRange.  # noqa: E501
        :type: float
        """

        self._minimum_voltage = minimum_voltage

    @property
    def oem(self):
        """Gets the oem of this InputRange.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this InputRange.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this InputRange.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this InputRange.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def output_wattage(self):
        """Gets the output_wattage of this InputRange.  # noqa: E501

        The maximum capacity of this Power Supply when operating in this input range.  # noqa: E501

        :return: The output_wattage of this InputRange.  # noqa: E501
        :rtype: float
        """
        return self._output_wattage

    @output_wattage.setter
    def output_wattage(self, output_wattage):
        """Sets the output_wattage of this InputRange.

        The maximum capacity of this Power Supply when operating in this input range.  # noqa: E501

        :param output_wattage: The output_wattage of this InputRange.  # noqa: E501
        :type: float
        """
        if output_wattage is not None and output_wattage < 0:  # noqa: E501
            raise ValueError("Invalid value for `output_wattage`, must be a value greater than or equal to `0`")  # noqa: E501

        self._output_wattage = output_wattage

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InputRange):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
