# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Inventory(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'brand_name': 'str',
        'model_name': 'str',
        'pc_ie_device_id': 'str',
        'pc_ie_sub_system_id': 'str',
        'part_number': 'str',
        'serial_number': 'str',
        'uuid': 'str'
    }

    attribute_map = {
        'brand_name': 'BrandName',
        'model_name': 'ModelName',
        'pc_ie_device_id': 'PCIeDeviceId',
        'pc_ie_sub_system_id': 'PCIeSubSystemId',
        'part_number': 'PartNumber',
        'serial_number': 'SerialNumber',
        'uuid': 'UUID'
    }

    def __init__(self, brand_name=None, model_name=None, pc_ie_device_id=None, pc_ie_sub_system_id=None, part_number=None, serial_number=None, uuid=None):  # noqa: E501
        """Inventory - a model defined in OpenAPI"""  # noqa: E501

        self._brand_name = None
        self._model_name = None
        self._pc_ie_device_id = None
        self._pc_ie_sub_system_id = None
        self._part_number = None
        self._serial_number = None
        self._uuid = None
        self.discriminator = None

        self.brand_name = brand_name
        self.model_name = model_name
        self.pc_ie_device_id = pc_ie_device_id
        self.pc_ie_sub_system_id = pc_ie_sub_system_id
        self.part_number = part_number
        self.serial_number = serial_number
        self.uuid = uuid

    @property
    def brand_name(self):
        """Gets the brand_name of this Inventory.  # noqa: E501

        Product family brand this GPU belongs to.  # noqa: E501

        :return: The brand_name of this Inventory.  # noqa: E501
        :rtype: str
        """
        return self._brand_name

    @brand_name.setter
    def brand_name(self, brand_name):
        """Sets the brand_name of this Inventory.

        Product family brand this GPU belongs to.  # noqa: E501

        :param brand_name: The brand_name of this Inventory.  # noqa: E501
        :type: str
        """
        if brand_name is None:
            raise ValueError("Invalid value for `brand_name`, must not be `None`")  # noqa: E501

        self._brand_name = brand_name

    @property
    def model_name(self):
        """Gets the model_name of this Inventory.  # noqa: E501

        The official product name of the GPU.  # noqa: E501

        :return: The model_name of this Inventory.  # noqa: E501
        :rtype: str
        """
        return self._model_name

    @model_name.setter
    def model_name(self, model_name):
        """Sets the model_name of this Inventory.

        The official product name of the GPU.  # noqa: E501

        :param model_name: The model_name of this Inventory.  # noqa: E501
        :type: str
        """
        if model_name is None:
            raise ValueError("Invalid value for `model_name`, must not be `None`")  # noqa: E501

        self._model_name = model_name

    @property
    def pc_ie_device_id(self):
        """Gets the pc_ie_device_id of this Inventory.  # noqa: E501

        PCI vendor device id, in hex.  # noqa: E501

        :return: The pc_ie_device_id of this Inventory.  # noqa: E501
        :rtype: str
        """
        return self._pc_ie_device_id

    @pc_ie_device_id.setter
    def pc_ie_device_id(self, pc_ie_device_id):
        """Sets the pc_ie_device_id of this Inventory.

        PCI vendor device id, in hex.  # noqa: E501

        :param pc_ie_device_id: The pc_ie_device_id of this Inventory.  # noqa: E501
        :type: str
        """
        if pc_ie_device_id is None:
            raise ValueError("Invalid value for `pc_ie_device_id`, must not be `None`")  # noqa: E501

        self._pc_ie_device_id = pc_ie_device_id

    @property
    def pc_ie_sub_system_id(self):
        """Gets the pc_ie_sub_system_id of this Inventory.  # noqa: E501

        PCI Sub System id, in hex.  # noqa: E501

        :return: The pc_ie_sub_system_id of this Inventory.  # noqa: E501
        :rtype: str
        """
        return self._pc_ie_sub_system_id

    @pc_ie_sub_system_id.setter
    def pc_ie_sub_system_id(self, pc_ie_sub_system_id):
        """Sets the pc_ie_sub_system_id of this Inventory.

        PCI Sub System id, in hex.  # noqa: E501

        :param pc_ie_sub_system_id: The pc_ie_sub_system_id of this Inventory.  # noqa: E501
        :type: str
        """
        if pc_ie_sub_system_id is None:
            raise ValueError("Invalid value for `pc_ie_sub_system_id`, must not be `None`")  # noqa: E501

        self._pc_ie_sub_system_id = pc_ie_sub_system_id

    @property
    def part_number(self):
        """Gets the part_number of this Inventory.  # noqa: E501

        Part number of this GPU.  # noqa: E501

        :return: The part_number of this Inventory.  # noqa: E501
        :rtype: str
        """
        return self._part_number

    @part_number.setter
    def part_number(self, part_number):
        """Sets the part_number of this Inventory.

        Part number of this GPU.  # noqa: E501

        :param part_number: The part_number of this Inventory.  # noqa: E501
        :type: str
        """
        if part_number is None:
            raise ValueError("Invalid value for `part_number`, must not be `None`")  # noqa: E501

        self._part_number = part_number

    @property
    def serial_number(self):
        """Gets the serial_number of this Inventory.  # noqa: E501

        Serial number of this GPU.  # noqa: E501

        :return: The serial_number of this Inventory.  # noqa: E501
        :rtype: str
        """
        return self._serial_number

    @serial_number.setter
    def serial_number(self, serial_number):
        """Sets the serial_number of this Inventory.

        Serial number of this GPU.  # noqa: E501

        :param serial_number: The serial_number of this Inventory.  # noqa: E501
        :type: str
        """
        if serial_number is None:
            raise ValueError("Invalid value for `serial_number`, must not be `None`")  # noqa: E501

        self._serial_number = serial_number

    @property
    def uuid(self):
        """Gets the uuid of this Inventory.  # noqa: E501

        This value is the globally unique immutable alphanumeric identifier of the GPU. It does not correspond to any physical label on the board.  # noqa: E501

        :return: The uuid of this Inventory.  # noqa: E501
        :rtype: str
        """
        return self._uuid

    @uuid.setter
    def uuid(self, uuid):
        """Sets the uuid of this Inventory.

        This value is the globally unique immutable alphanumeric identifier of the GPU. It does not correspond to any physical label on the board.  # noqa: E501

        :param uuid: The uuid of this Inventory.  # noqa: E501
        :type: str
        """
        if uuid is None:
            raise ValueError("Invalid value for `uuid`, must not be `None`")  # noqa: E501

        self._uuid = uuid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Inventory):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
