# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class ISCSIBoot(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'authentication_method': 'AuthenticationMethod',
        'chap_secret': 'str',
        'chap_username': 'str',
        'ip_address_type': 'IPAddressType',
        'ip_mask_dns_via_dhcp': 'bool',
        'initiator_default_gateway': 'str',
        'initiator_ip_address': 'str',
        'initiator_name': 'str',
        'initiator_netmask': 'str',
        'mutual_chap_secret': 'str',
        'mutual_chap_username': 'str',
        'primary_dns': 'str',
        'primary_lun': 'int',
        'primary_target_ip_address': 'str',
        'primary_target_name': 'str',
        'primary_target_tcp_port': 'int',
        'primary_vlan_enable': 'bool',
        'primary_vlan_id': 'int',
        'router_advertisement_enabled': 'bool',
        'secondary_dns': 'str',
        'secondary_lun': 'int',
        'secondary_target_ip_address': 'str',
        'secondary_target_name': 'str',
        'secondary_target_tcp_port': 'int',
        'secondary_vlan_enable': 'bool',
        'secondary_vlan_id': 'int',
        'target_info_via_dhcp': 'bool'
    }

    attribute_map = {
        'authentication_method': 'AuthenticationMethod',
        'chap_secret': 'CHAPSecret',
        'chap_username': 'CHAPUsername',
        'ip_address_type': 'IPAddressType',
        'ip_mask_dns_via_dhcp': 'IPMaskDNSViaDHCP',
        'initiator_default_gateway': 'InitiatorDefaultGateway',
        'initiator_ip_address': 'InitiatorIPAddress',
        'initiator_name': 'InitiatorName',
        'initiator_netmask': 'InitiatorNetmask',
        'mutual_chap_secret': 'MutualCHAPSecret',
        'mutual_chap_username': 'MutualCHAPUsername',
        'primary_dns': 'PrimaryDNS',
        'primary_lun': 'PrimaryLUN',
        'primary_target_ip_address': 'PrimaryTargetIPAddress',
        'primary_target_name': 'PrimaryTargetName',
        'primary_target_tcp_port': 'PrimaryTargetTCPPort',
        'primary_vlan_enable': 'PrimaryVLANEnable',
        'primary_vlan_id': 'PrimaryVLANId',
        'router_advertisement_enabled': 'RouterAdvertisementEnabled',
        'secondary_dns': 'SecondaryDNS',
        'secondary_lun': 'SecondaryLUN',
        'secondary_target_ip_address': 'SecondaryTargetIPAddress',
        'secondary_target_name': 'SecondaryTargetName',
        'secondary_target_tcp_port': 'SecondaryTargetTCPPort',
        'secondary_vlan_enable': 'SecondaryVLANEnable',
        'secondary_vlan_id': 'SecondaryVLANId',
        'target_info_via_dhcp': 'TargetInfoViaDHCP'
    }

    def __init__(self, authentication_method=None, chap_secret=None, chap_username=None, ip_address_type=None, ip_mask_dns_via_dhcp=None, initiator_default_gateway=None, initiator_ip_address=None, initiator_name=None, initiator_netmask=None, mutual_chap_secret=None, mutual_chap_username=None, primary_dns=None, primary_lun=None, primary_target_ip_address=None, primary_target_name=None, primary_target_tcp_port=None, primary_vlan_enable=None, primary_vlan_id=None, router_advertisement_enabled=None, secondary_dns=None, secondary_lun=None, secondary_target_ip_address=None, secondary_target_name=None, secondary_target_tcp_port=None, secondary_vlan_enable=None, secondary_vlan_id=None, target_info_via_dhcp=None):  # noqa: E501
        """ISCSIBoot - a model defined in OpenAPI"""  # noqa: E501

        self._authentication_method = None
        self._chap_secret = None
        self._chap_username = None
        self._ip_address_type = None
        self._ip_mask_dns_via_dhcp = None
        self._initiator_default_gateway = None
        self._initiator_ip_address = None
        self._initiator_name = None
        self._initiator_netmask = None
        self._mutual_chap_secret = None
        self._mutual_chap_username = None
        self._primary_dns = None
        self._primary_lun = None
        self._primary_target_ip_address = None
        self._primary_target_name = None
        self._primary_target_tcp_port = None
        self._primary_vlan_enable = None
        self._primary_vlan_id = None
        self._router_advertisement_enabled = None
        self._secondary_dns = None
        self._secondary_lun = None
        self._secondary_target_ip_address = None
        self._secondary_target_name = None
        self._secondary_target_tcp_port = None
        self._secondary_vlan_enable = None
        self._secondary_vlan_id = None
        self._target_info_via_dhcp = None
        self.discriminator = None

        if authentication_method is not None:
            self.authentication_method = authentication_method
        self.chap_secret = chap_secret
        self.chap_username = chap_username
        if ip_address_type is not None:
            self.ip_address_type = ip_address_type
        self.ip_mask_dns_via_dhcp = ip_mask_dns_via_dhcp
        self.initiator_default_gateway = initiator_default_gateway
        self.initiator_ip_address = initiator_ip_address
        self.initiator_name = initiator_name
        self.initiator_netmask = initiator_netmask
        self.mutual_chap_secret = mutual_chap_secret
        self.mutual_chap_username = mutual_chap_username
        self.primary_dns = primary_dns
        self.primary_lun = primary_lun
        self.primary_target_ip_address = primary_target_ip_address
        self.primary_target_name = primary_target_name
        self.primary_target_tcp_port = primary_target_tcp_port
        self.primary_vlan_enable = primary_vlan_enable
        self.primary_vlan_id = primary_vlan_id
        self.router_advertisement_enabled = router_advertisement_enabled
        self.secondary_dns = secondary_dns
        self.secondary_lun = secondary_lun
        self.secondary_target_ip_address = secondary_target_ip_address
        self.secondary_target_name = secondary_target_name
        self.secondary_target_tcp_port = secondary_target_tcp_port
        self.secondary_vlan_enable = secondary_vlan_enable
        self.secondary_vlan_id = secondary_vlan_id
        self.target_info_via_dhcp = target_info_via_dhcp

    @property
    def authentication_method(self):
        """Gets the authentication_method of this ISCSIBoot.  # noqa: E501


        :return: The authentication_method of this ISCSIBoot.  # noqa: E501
        :rtype: AuthenticationMethod
        """
        return self._authentication_method

    @authentication_method.setter
    def authentication_method(self, authentication_method):
        """Sets the authentication_method of this ISCSIBoot.


        :param authentication_method: The authentication_method of this ISCSIBoot.  # noqa: E501
        :type: AuthenticationMethod
        """

        self._authentication_method = authentication_method

    @property
    def chap_secret(self):
        """Gets the chap_secret of this ISCSIBoot.  # noqa: E501

        The shared secret for CHAP authentication.  # noqa: E501

        :return: The chap_secret of this ISCSIBoot.  # noqa: E501
        :rtype: str
        """
        return self._chap_secret

    @chap_secret.setter
    def chap_secret(self, chap_secret):
        """Sets the chap_secret of this ISCSIBoot.

        The shared secret for CHAP authentication.  # noqa: E501

        :param chap_secret: The chap_secret of this ISCSIBoot.  # noqa: E501
        :type: str
        """

        self._chap_secret = chap_secret

    @property
    def chap_username(self):
        """Gets the chap_username of this ISCSIBoot.  # noqa: E501

        The username for CHAP authentication.  # noqa: E501

        :return: The chap_username of this ISCSIBoot.  # noqa: E501
        :rtype: str
        """
        return self._chap_username

    @chap_username.setter
    def chap_username(self, chap_username):
        """Sets the chap_username of this ISCSIBoot.

        The username for CHAP authentication.  # noqa: E501

        :param chap_username: The chap_username of this ISCSIBoot.  # noqa: E501
        :type: str
        """

        self._chap_username = chap_username

    @property
    def ip_address_type(self):
        """Gets the ip_address_type of this ISCSIBoot.  # noqa: E501


        :return: The ip_address_type of this ISCSIBoot.  # noqa: E501
        :rtype: IPAddressType
        """
        return self._ip_address_type

    @ip_address_type.setter
    def ip_address_type(self, ip_address_type):
        """Sets the ip_address_type of this ISCSIBoot.


        :param ip_address_type: The ip_address_type of this ISCSIBoot.  # noqa: E501
        :type: IPAddressType
        """

        self._ip_address_type = ip_address_type

    @property
    def ip_mask_dns_via_dhcp(self):
        """Gets the ip_mask_dns_via_dhcp of this ISCSIBoot.  # noqa: E501

        Whether the iSCSI boot initiator uses DHCP to obtain the iniator name, IP address, and netmask.  # noqa: E501

        :return: The ip_mask_dns_via_dhcp of this ISCSIBoot.  # noqa: E501
        :rtype: bool
        """
        return self._ip_mask_dns_via_dhcp

    @ip_mask_dns_via_dhcp.setter
    def ip_mask_dns_via_dhcp(self, ip_mask_dns_via_dhcp):
        """Sets the ip_mask_dns_via_dhcp of this ISCSIBoot.

        Whether the iSCSI boot initiator uses DHCP to obtain the iniator name, IP address, and netmask.  # noqa: E501

        :param ip_mask_dns_via_dhcp: The ip_mask_dns_via_dhcp of this ISCSIBoot.  # noqa: E501
        :type: bool
        """

        self._ip_mask_dns_via_dhcp = ip_mask_dns_via_dhcp

    @property
    def initiator_default_gateway(self):
        """Gets the initiator_default_gateway of this ISCSIBoot.  # noqa: E501

        The IPv6 or IPv4 iSCSI boot default gateway.  # noqa: E501

        :return: The initiator_default_gateway of this ISCSIBoot.  # noqa: E501
        :rtype: str
        """
        return self._initiator_default_gateway

    @initiator_default_gateway.setter
    def initiator_default_gateway(self, initiator_default_gateway):
        """Sets the initiator_default_gateway of this ISCSIBoot.

        The IPv6 or IPv4 iSCSI boot default gateway.  # noqa: E501

        :param initiator_default_gateway: The initiator_default_gateway of this ISCSIBoot.  # noqa: E501
        :type: str
        """

        self._initiator_default_gateway = initiator_default_gateway

    @property
    def initiator_ip_address(self):
        """Gets the initiator_ip_address of this ISCSIBoot.  # noqa: E501

        The IPv6 or IPv4 address of the iSCSI initiator.  # noqa: E501

        :return: The initiator_ip_address of this ISCSIBoot.  # noqa: E501
        :rtype: str
        """
        return self._initiator_ip_address

    @initiator_ip_address.setter
    def initiator_ip_address(self, initiator_ip_address):
        """Sets the initiator_ip_address of this ISCSIBoot.

        The IPv6 or IPv4 address of the iSCSI initiator.  # noqa: E501

        :param initiator_ip_address: The initiator_ip_address of this ISCSIBoot.  # noqa: E501
        :type: str
        """

        self._initiator_ip_address = initiator_ip_address

    @property
    def initiator_name(self):
        """Gets the initiator_name of this ISCSIBoot.  # noqa: E501

        The iSCSI initiator name.  # noqa: E501

        :return: The initiator_name of this ISCSIBoot.  # noqa: E501
        :rtype: str
        """
        return self._initiator_name

    @initiator_name.setter
    def initiator_name(self, initiator_name):
        """Sets the initiator_name of this ISCSIBoot.

        The iSCSI initiator name.  # noqa: E501

        :param initiator_name: The initiator_name of this ISCSIBoot.  # noqa: E501
        :type: str
        """

        self._initiator_name = initiator_name

    @property
    def initiator_netmask(self):
        """Gets the initiator_netmask of this ISCSIBoot.  # noqa: E501

        The IPv6 or IPv4 netmask of the iSCSI boot initiator.  # noqa: E501

        :return: The initiator_netmask of this ISCSIBoot.  # noqa: E501
        :rtype: str
        """
        return self._initiator_netmask

    @initiator_netmask.setter
    def initiator_netmask(self, initiator_netmask):
        """Sets the initiator_netmask of this ISCSIBoot.

        The IPv6 or IPv4 netmask of the iSCSI boot initiator.  # noqa: E501

        :param initiator_netmask: The initiator_netmask of this ISCSIBoot.  # noqa: E501
        :type: str
        """

        self._initiator_netmask = initiator_netmask

    @property
    def mutual_chap_secret(self):
        """Gets the mutual_chap_secret of this ISCSIBoot.  # noqa: E501

        The CHAP Secret for 2-way CHAP authentication.  # noqa: E501

        :return: The mutual_chap_secret of this ISCSIBoot.  # noqa: E501
        :rtype: str
        """
        return self._mutual_chap_secret

    @mutual_chap_secret.setter
    def mutual_chap_secret(self, mutual_chap_secret):
        """Sets the mutual_chap_secret of this ISCSIBoot.

        The CHAP Secret for 2-way CHAP authentication.  # noqa: E501

        :param mutual_chap_secret: The mutual_chap_secret of this ISCSIBoot.  # noqa: E501
        :type: str
        """

        self._mutual_chap_secret = mutual_chap_secret

    @property
    def mutual_chap_username(self):
        """Gets the mutual_chap_username of this ISCSIBoot.  # noqa: E501

        The CHAP Username for 2-way CHAP authentication.  # noqa: E501

        :return: The mutual_chap_username of this ISCSIBoot.  # noqa: E501
        :rtype: str
        """
        return self._mutual_chap_username

    @mutual_chap_username.setter
    def mutual_chap_username(self, mutual_chap_username):
        """Sets the mutual_chap_username of this ISCSIBoot.

        The CHAP Username for 2-way CHAP authentication.  # noqa: E501

        :param mutual_chap_username: The mutual_chap_username of this ISCSIBoot.  # noqa: E501
        :type: str
        """

        self._mutual_chap_username = mutual_chap_username

    @property
    def primary_dns(self):
        """Gets the primary_dns of this ISCSIBoot.  # noqa: E501

        The IPv6 or IPv4 address of the primary DNS server for the iSCSI boot initiator.  # noqa: E501

        :return: The primary_dns of this ISCSIBoot.  # noqa: E501
        :rtype: str
        """
        return self._primary_dns

    @primary_dns.setter
    def primary_dns(self, primary_dns):
        """Sets the primary_dns of this ISCSIBoot.

        The IPv6 or IPv4 address of the primary DNS server for the iSCSI boot initiator.  # noqa: E501

        :param primary_dns: The primary_dns of this ISCSIBoot.  # noqa: E501
        :type: str
        """

        self._primary_dns = primary_dns

    @property
    def primary_lun(self):
        """Gets the primary_lun of this ISCSIBoot.  # noqa: E501

        The logical unit number (LUN) for the primary iSCSI boot target.  # noqa: E501

        :return: The primary_lun of this ISCSIBoot.  # noqa: E501
        :rtype: int
        """
        return self._primary_lun

    @primary_lun.setter
    def primary_lun(self, primary_lun):
        """Sets the primary_lun of this ISCSIBoot.

        The logical unit number (LUN) for the primary iSCSI boot target.  # noqa: E501

        :param primary_lun: The primary_lun of this ISCSIBoot.  # noqa: E501
        :type: int
        """

        self._primary_lun = primary_lun

    @property
    def primary_target_ip_address(self):
        """Gets the primary_target_ip_address of this ISCSIBoot.  # noqa: E501

        The IP address (IPv6 or IPv4) for the primary iSCSI boot target.  # noqa: E501

        :return: The primary_target_ip_address of this ISCSIBoot.  # noqa: E501
        :rtype: str
        """
        return self._primary_target_ip_address

    @primary_target_ip_address.setter
    def primary_target_ip_address(self, primary_target_ip_address):
        """Sets the primary_target_ip_address of this ISCSIBoot.

        The IP address (IPv6 or IPv4) for the primary iSCSI boot target.  # noqa: E501

        :param primary_target_ip_address: The primary_target_ip_address of this ISCSIBoot.  # noqa: E501
        :type: str
        """

        self._primary_target_ip_address = primary_target_ip_address

    @property
    def primary_target_name(self):
        """Gets the primary_target_name of this ISCSIBoot.  # noqa: E501

        The name of the iSCSI primary boot target.  # noqa: E501

        :return: The primary_target_name of this ISCSIBoot.  # noqa: E501
        :rtype: str
        """
        return self._primary_target_name

    @primary_target_name.setter
    def primary_target_name(self, primary_target_name):
        """Sets the primary_target_name of this ISCSIBoot.

        The name of the iSCSI primary boot target.  # noqa: E501

        :param primary_target_name: The primary_target_name of this ISCSIBoot.  # noqa: E501
        :type: str
        """

        self._primary_target_name = primary_target_name

    @property
    def primary_target_tcp_port(self):
        """Gets the primary_target_tcp_port of this ISCSIBoot.  # noqa: E501

        The TCP port for the primary iSCSI boot target.  # noqa: E501

        :return: The primary_target_tcp_port of this ISCSIBoot.  # noqa: E501
        :rtype: int
        """
        return self._primary_target_tcp_port

    @primary_target_tcp_port.setter
    def primary_target_tcp_port(self, primary_target_tcp_port):
        """Sets the primary_target_tcp_port of this ISCSIBoot.

        The TCP port for the primary iSCSI boot target.  # noqa: E501

        :param primary_target_tcp_port: The primary_target_tcp_port of this ISCSIBoot.  # noqa: E501
        :type: int
        """

        self._primary_target_tcp_port = primary_target_tcp_port

    @property
    def primary_vlan_enable(self):
        """Gets the primary_vlan_enable of this ISCSIBoot.  # noqa: E501

        This indicates if the primary VLAN is enabled.  # noqa: E501

        :return: The primary_vlan_enable of this ISCSIBoot.  # noqa: E501
        :rtype: bool
        """
        return self._primary_vlan_enable

    @primary_vlan_enable.setter
    def primary_vlan_enable(self, primary_vlan_enable):
        """Sets the primary_vlan_enable of this ISCSIBoot.

        This indicates if the primary VLAN is enabled.  # noqa: E501

        :param primary_vlan_enable: The primary_vlan_enable of this ISCSIBoot.  # noqa: E501
        :type: bool
        """

        self._primary_vlan_enable = primary_vlan_enable

    @property
    def primary_vlan_id(self):
        """Gets the primary_vlan_id of this ISCSIBoot.  # noqa: E501

        The 802.1q VLAN ID to use for iSCSI boot from the primary target.  # noqa: E501

        :return: The primary_vlan_id of this ISCSIBoot.  # noqa: E501
        :rtype: int
        """
        return self._primary_vlan_id

    @primary_vlan_id.setter
    def primary_vlan_id(self, primary_vlan_id):
        """Sets the primary_vlan_id of this ISCSIBoot.

        The 802.1q VLAN ID to use for iSCSI boot from the primary target.  # noqa: E501

        :param primary_vlan_id: The primary_vlan_id of this ISCSIBoot.  # noqa: E501
        :type: int
        """
        if primary_vlan_id is not None and primary_vlan_id > 4094:  # noqa: E501
            raise ValueError("Invalid value for `primary_vlan_id`, must be a value less than or equal to `4094`")  # noqa: E501
        if primary_vlan_id is not None and primary_vlan_id < 0:  # noqa: E501
            raise ValueError("Invalid value for `primary_vlan_id`, must be a value greater than or equal to `0`")  # noqa: E501

        self._primary_vlan_id = primary_vlan_id

    @property
    def router_advertisement_enabled(self):
        """Gets the router_advertisement_enabled of this ISCSIBoot.  # noqa: E501

        Whether IPv6 router advertisement is enabled for the iSCSI boot target.  # noqa: E501

        :return: The router_advertisement_enabled of this ISCSIBoot.  # noqa: E501
        :rtype: bool
        """
        return self._router_advertisement_enabled

    @router_advertisement_enabled.setter
    def router_advertisement_enabled(self, router_advertisement_enabled):
        """Sets the router_advertisement_enabled of this ISCSIBoot.

        Whether IPv6 router advertisement is enabled for the iSCSI boot target.  # noqa: E501

        :param router_advertisement_enabled: The router_advertisement_enabled of this ISCSIBoot.  # noqa: E501
        :type: bool
        """

        self._router_advertisement_enabled = router_advertisement_enabled

    @property
    def secondary_dns(self):
        """Gets the secondary_dns of this ISCSIBoot.  # noqa: E501

        The IPv6 or IPv4 address of the secondary DNS server for the iSCSI boot initiator.  # noqa: E501

        :return: The secondary_dns of this ISCSIBoot.  # noqa: E501
        :rtype: str
        """
        return self._secondary_dns

    @secondary_dns.setter
    def secondary_dns(self, secondary_dns):
        """Sets the secondary_dns of this ISCSIBoot.

        The IPv6 or IPv4 address of the secondary DNS server for the iSCSI boot initiator.  # noqa: E501

        :param secondary_dns: The secondary_dns of this ISCSIBoot.  # noqa: E501
        :type: str
        """

        self._secondary_dns = secondary_dns

    @property
    def secondary_lun(self):
        """Gets the secondary_lun of this ISCSIBoot.  # noqa: E501

        The logical unit number (LUN) for the secondary iSCSI boot target.  # noqa: E501

        :return: The secondary_lun of this ISCSIBoot.  # noqa: E501
        :rtype: int
        """
        return self._secondary_lun

    @secondary_lun.setter
    def secondary_lun(self, secondary_lun):
        """Sets the secondary_lun of this ISCSIBoot.

        The logical unit number (LUN) for the secondary iSCSI boot target.  # noqa: E501

        :param secondary_lun: The secondary_lun of this ISCSIBoot.  # noqa: E501
        :type: int
        """

        self._secondary_lun = secondary_lun

    @property
    def secondary_target_ip_address(self):
        """Gets the secondary_target_ip_address of this ISCSIBoot.  # noqa: E501

        The IP address (IPv6 or IPv4) for the secondary iSCSI boot target.  # noqa: E501

        :return: The secondary_target_ip_address of this ISCSIBoot.  # noqa: E501
        :rtype: str
        """
        return self._secondary_target_ip_address

    @secondary_target_ip_address.setter
    def secondary_target_ip_address(self, secondary_target_ip_address):
        """Sets the secondary_target_ip_address of this ISCSIBoot.

        The IP address (IPv6 or IPv4) for the secondary iSCSI boot target.  # noqa: E501

        :param secondary_target_ip_address: The secondary_target_ip_address of this ISCSIBoot.  # noqa: E501
        :type: str
        """

        self._secondary_target_ip_address = secondary_target_ip_address

    @property
    def secondary_target_name(self):
        """Gets the secondary_target_name of this ISCSIBoot.  # noqa: E501

        The name of the iSCSI secondary boot target.  # noqa: E501

        :return: The secondary_target_name of this ISCSIBoot.  # noqa: E501
        :rtype: str
        """
        return self._secondary_target_name

    @secondary_target_name.setter
    def secondary_target_name(self, secondary_target_name):
        """Sets the secondary_target_name of this ISCSIBoot.

        The name of the iSCSI secondary boot target.  # noqa: E501

        :param secondary_target_name: The secondary_target_name of this ISCSIBoot.  # noqa: E501
        :type: str
        """

        self._secondary_target_name = secondary_target_name

    @property
    def secondary_target_tcp_port(self):
        """Gets the secondary_target_tcp_port of this ISCSIBoot.  # noqa: E501

        The TCP port for the secondary iSCSI boot target.  # noqa: E501

        :return: The secondary_target_tcp_port of this ISCSIBoot.  # noqa: E501
        :rtype: int
        """
        return self._secondary_target_tcp_port

    @secondary_target_tcp_port.setter
    def secondary_target_tcp_port(self, secondary_target_tcp_port):
        """Sets the secondary_target_tcp_port of this ISCSIBoot.

        The TCP port for the secondary iSCSI boot target.  # noqa: E501

        :param secondary_target_tcp_port: The secondary_target_tcp_port of this ISCSIBoot.  # noqa: E501
        :type: int
        """

        self._secondary_target_tcp_port = secondary_target_tcp_port

    @property
    def secondary_vlan_enable(self):
        """Gets the secondary_vlan_enable of this ISCSIBoot.  # noqa: E501

        This indicates if the secondary VLAN is enabled.  # noqa: E501

        :return: The secondary_vlan_enable of this ISCSIBoot.  # noqa: E501
        :rtype: bool
        """
        return self._secondary_vlan_enable

    @secondary_vlan_enable.setter
    def secondary_vlan_enable(self, secondary_vlan_enable):
        """Sets the secondary_vlan_enable of this ISCSIBoot.

        This indicates if the secondary VLAN is enabled.  # noqa: E501

        :param secondary_vlan_enable: The secondary_vlan_enable of this ISCSIBoot.  # noqa: E501
        :type: bool
        """

        self._secondary_vlan_enable = secondary_vlan_enable

    @property
    def secondary_vlan_id(self):
        """Gets the secondary_vlan_id of this ISCSIBoot.  # noqa: E501

        The 802.1q VLAN ID to use for iSCSI boot from the secondary target.  # noqa: E501

        :return: The secondary_vlan_id of this ISCSIBoot.  # noqa: E501
        :rtype: int
        """
        return self._secondary_vlan_id

    @secondary_vlan_id.setter
    def secondary_vlan_id(self, secondary_vlan_id):
        """Sets the secondary_vlan_id of this ISCSIBoot.

        The 802.1q VLAN ID to use for iSCSI boot from the secondary target.  # noqa: E501

        :param secondary_vlan_id: The secondary_vlan_id of this ISCSIBoot.  # noqa: E501
        :type: int
        """
        if secondary_vlan_id is not None and secondary_vlan_id > 4094:  # noqa: E501
            raise ValueError("Invalid value for `secondary_vlan_id`, must be a value less than or equal to `4094`")  # noqa: E501
        if secondary_vlan_id is not None and secondary_vlan_id < 0:  # noqa: E501
            raise ValueError("Invalid value for `secondary_vlan_id`, must be a value greater than or equal to `0`")  # noqa: E501

        self._secondary_vlan_id = secondary_vlan_id

    @property
    def target_info_via_dhcp(self):
        """Gets the target_info_via_dhcp of this ISCSIBoot.  # noqa: E501

        Whether the iSCSI boot target name, LUN, IP address, and netmask should be obtained from DHCP.  # noqa: E501

        :return: The target_info_via_dhcp of this ISCSIBoot.  # noqa: E501
        :rtype: bool
        """
        return self._target_info_via_dhcp

    @target_info_via_dhcp.setter
    def target_info_via_dhcp(self, target_info_via_dhcp):
        """Sets the target_info_via_dhcp of this ISCSIBoot.

        Whether the iSCSI boot target name, LUN, IP address, and netmask should be obtained from DHCP.  # noqa: E501

        :param target_info_via_dhcp: The target_info_via_dhcp of this ISCSIBoot.  # noqa: E501
        :type: bool
        """

        self._target_info_via_dhcp = target_info_via_dhcp

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ISCSIBoot):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
