# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class JobStatus(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'start_time': 'datetime',
        'end_time': 'datetime',
        'percent_done': 'int',
        'job_is_done': 'bool',
        'job_call_back_is_done': 'bool',
        'results_uri': 'str'
    }

    attribute_map = {
        'id': 'ID',
        'start_time': 'StartTime',
        'end_time': 'EndTime',
        'percent_done': 'PercentDone',
        'job_is_done': 'JobIsDone',
        'job_call_back_is_done': 'JobCallBackIsDone',
        'results_uri': 'ResultsURI'
    }

    def __init__(self, id=None, start_time=None, end_time=None, percent_done=None, job_is_done=None, job_call_back_is_done=None, results_uri=None):  # noqa: E501
        """JobStatus - a model defined in OpenAPI"""  # noqa: E501

        self._id = None
        self._start_time = None
        self._end_time = None
        self._percent_done = None
        self._job_is_done = None
        self._job_call_back_is_done = None
        self._results_uri = None
        self.discriminator = None

        self.id = id
        self.start_time = start_time
        self.end_time = end_time
        self.percent_done = percent_done
        self.job_is_done = job_is_done
        self.job_call_back_is_done = job_call_back_is_done
        self.results_uri = results_uri

    @property
    def id(self):
        """Gets the id of this JobStatus.  # noqa: E501

        Unique Id to refer to a job  # noqa: E501

        :return: The id of this JobStatus.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this JobStatus.

        Unique Id to refer to a job  # noqa: E501

        :param id: The id of this JobStatus.  # noqa: E501
        :type: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def start_time(self):
        """Gets the start_time of this JobStatus.  # noqa: E501

        Time when this job started  # noqa: E501

        :return: The start_time of this JobStatus.  # noqa: E501
        :rtype: datetime
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this JobStatus.

        Time when this job started  # noqa: E501

        :param start_time: The start_time of this JobStatus.  # noqa: E501
        :type: datetime
        """
        if start_time is None:
            raise ValueError("Invalid value for `start_time`, must not be `None`")  # noqa: E501

        self._start_time = start_time

    @property
    def end_time(self):
        """Gets the end_time of this JobStatus.  # noqa: E501

        Time when this job finished  # noqa: E501

        :return: The end_time of this JobStatus.  # noqa: E501
        :rtype: datetime
        """
        return self._end_time

    @end_time.setter
    def end_time(self, end_time):
        """Sets the end_time of this JobStatus.

        Time when this job finished  # noqa: E501

        :param end_time: The end_time of this JobStatus.  # noqa: E501
        :type: datetime
        """
        if end_time is None:
            raise ValueError("Invalid value for `end_time`, must not be `None`")  # noqa: E501

        self._end_time = end_time

    @property
    def percent_done(self):
        """Gets the percent_done of this JobStatus.  # noqa: E501

        Status of this job as %age done  # noqa: E501

        :return: The percent_done of this JobStatus.  # noqa: E501
        :rtype: int
        """
        return self._percent_done

    @percent_done.setter
    def percent_done(self, percent_done):
        """Sets the percent_done of this JobStatus.

        Status of this job as %age done  # noqa: E501

        :param percent_done: The percent_done of this JobStatus.  # noqa: E501
        :type: int
        """
        if percent_done is None:
            raise ValueError("Invalid value for `percent_done`, must not be `None`")  # noqa: E501

        self._percent_done = percent_done

    @property
    def job_is_done(self):
        """Gets the job_is_done of this JobStatus.  # noqa: E501

        Shows if the job done, since PercentDone is not a definite measure  # noqa: E501

        :return: The job_is_done of this JobStatus.  # noqa: E501
        :rtype: bool
        """
        return self._job_is_done

    @job_is_done.setter
    def job_is_done(self, job_is_done):
        """Sets the job_is_done of this JobStatus.

        Shows if the job done, since PercentDone is not a definite measure  # noqa: E501

        :param job_is_done: The job_is_done of this JobStatus.  # noqa: E501
        :type: bool
        """
        if job_is_done is None:
            raise ValueError("Invalid value for `job_is_done`, must not be `None`")  # noqa: E501

        self._job_is_done = job_is_done

    @property
    def job_call_back_is_done(self):
        """Gets the job_call_back_is_done of this JobStatus.  # noqa: E501

        Shows if the callback function(if any) for the job is done as well.  # noqa: E501

        :return: The job_call_back_is_done of this JobStatus.  # noqa: E501
        :rtype: bool
        """
        return self._job_call_back_is_done

    @job_call_back_is_done.setter
    def job_call_back_is_done(self, job_call_back_is_done):
        """Sets the job_call_back_is_done of this JobStatus.

        Shows if the callback function(if any) for the job is done as well.  # noqa: E501

        :param job_call_back_is_done: The job_call_back_is_done of this JobStatus.  # noqa: E501
        :type: bool
        """
        if job_call_back_is_done is None:
            raise ValueError("Invalid value for `job_call_back_is_done`, must not be `None`")  # noqa: E501

        self._job_call_back_is_done = job_call_back_is_done

    @property
    def results_uri(self):
        """Gets the results_uri of this JobStatus.  # noqa: E501

        URI where results of the actual job results can be found  # noqa: E501

        :return: The results_uri of this JobStatus.  # noqa: E501
        :rtype: str
        """
        return self._results_uri

    @results_uri.setter
    def results_uri(self, results_uri):
        """Sets the results_uri of this JobStatus.

        URI where results of the actual job results can be found  # noqa: E501

        :param results_uri: The results_uri of this JobStatus.  # noqa: E501
        :type: str
        """
        if results_uri is None:
            raise ValueError("Invalid value for `results_uri`, must not be `None`")  # noqa: E501

        self._results_uri = results_uri

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, JobStatus):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
