# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class MemoryLocation(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'channel': 'int',
        'memory_controller': 'int',
        'slot': 'int',
        'socket': 'int'
    }

    attribute_map = {
        'channel': 'Channel',
        'memory_controller': 'MemoryController',
        'slot': 'Slot',
        'socket': 'Socket'
    }

    def __init__(self, channel=None, memory_controller=None, slot=None, socket=None):  # noqa: E501
        """MemoryLocation - a model defined in OpenAPI"""  # noqa: E501

        self._channel = None
        self._memory_controller = None
        self._slot = None
        self._socket = None
        self.discriminator = None

        self.channel = channel
        self.memory_controller = memory_controller
        self.slot = slot
        self.socket = socket

    @property
    def channel(self):
        """Gets the channel of this MemoryLocation.  # noqa: E501

        Channel number in which Memory is connected.  # noqa: E501

        :return: The channel of this MemoryLocation.  # noqa: E501
        :rtype: int
        """
        return self._channel

    @channel.setter
    def channel(self, channel):
        """Sets the channel of this MemoryLocation.

        Channel number in which Memory is connected.  # noqa: E501

        :param channel: The channel of this MemoryLocation.  # noqa: E501
        :type: int
        """

        self._channel = channel

    @property
    def memory_controller(self):
        """Gets the memory_controller of this MemoryLocation.  # noqa: E501

        Memory controller number in which Memory is connected.  # noqa: E501

        :return: The memory_controller of this MemoryLocation.  # noqa: E501
        :rtype: int
        """
        return self._memory_controller

    @memory_controller.setter
    def memory_controller(self, memory_controller):
        """Sets the memory_controller of this MemoryLocation.

        Memory controller number in which Memory is connected.  # noqa: E501

        :param memory_controller: The memory_controller of this MemoryLocation.  # noqa: E501
        :type: int
        """

        self._memory_controller = memory_controller

    @property
    def slot(self):
        """Gets the slot of this MemoryLocation.  # noqa: E501

        Slot number in which Memory is connected.  # noqa: E501

        :return: The slot of this MemoryLocation.  # noqa: E501
        :rtype: int
        """
        return self._slot

    @slot.setter
    def slot(self, slot):
        """Sets the slot of this MemoryLocation.

        Slot number in which Memory is connected.  # noqa: E501

        :param slot: The slot of this MemoryLocation.  # noqa: E501
        :type: int
        """

        self._slot = slot

    @property
    def socket(self):
        """Gets the socket of this MemoryLocation.  # noqa: E501

        Socket number in which Memory is connected.  # noqa: E501

        :return: The socket of this MemoryLocation.  # noqa: E501
        :rtype: int
        """
        return self._socket

    @socket.setter
    def socket(self, socket):
        """Sets the socket of this MemoryLocation.

        Socket number in which Memory is connected.  # noqa: E501

        :param socket: The socket of this MemoryLocation.  # noqa: E501
        :type: int
        """

        self._socket = socket

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MemoryLocation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
