# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class MemorySummary(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'memory_mirroring': 'MemoryMirroring',
        'status': 'Status',
        'total_system_memory_gi_b': 'float',
        'total_system_persistent_memory_gi_b': 'float'
    }

    attribute_map = {
        'memory_mirroring': 'MemoryMirroring',
        'status': 'Status',
        'total_system_memory_gi_b': 'TotalSystemMemoryGiB',
        'total_system_persistent_memory_gi_b': 'TotalSystemPersistentMemoryGiB'
    }

    def __init__(self, memory_mirroring=None, status=None, total_system_memory_gi_b=None, total_system_persistent_memory_gi_b=None):  # noqa: E501
        """MemorySummary - a model defined in OpenAPI"""  # noqa: E501

        self._memory_mirroring = None
        self._status = None
        self._total_system_memory_gi_b = None
        self._total_system_persistent_memory_gi_b = None
        self.discriminator = None

        if memory_mirroring is not None:
            self.memory_mirroring = memory_mirroring
        if status is not None:
            self.status = status
        self.total_system_memory_gi_b = total_system_memory_gi_b
        self.total_system_persistent_memory_gi_b = total_system_persistent_memory_gi_b

    @property
    def memory_mirroring(self):
        """Gets the memory_mirroring of this MemorySummary.  # noqa: E501


        :return: The memory_mirroring of this MemorySummary.  # noqa: E501
        :rtype: MemoryMirroring
        """
        return self._memory_mirroring

    @memory_mirroring.setter
    def memory_mirroring(self, memory_mirroring):
        """Sets the memory_mirroring of this MemorySummary.


        :param memory_mirroring: The memory_mirroring of this MemorySummary.  # noqa: E501
        :type: MemoryMirroring
        """

        self._memory_mirroring = memory_mirroring

    @property
    def status(self):
        """Gets the status of this MemorySummary.  # noqa: E501


        :return: The status of this MemorySummary.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this MemorySummary.


        :param status: The status of this MemorySummary.  # noqa: E501
        :type: Status
        """

        self._status = status

    @property
    def total_system_memory_gi_b(self):
        """Gets the total_system_memory_gi_b of this MemorySummary.  # noqa: E501

        The total configured operating system-accessible memory (RAM), measured in GiB.  # noqa: E501

        :return: The total_system_memory_gi_b of this MemorySummary.  # noqa: E501
        :rtype: float
        """
        return self._total_system_memory_gi_b

    @total_system_memory_gi_b.setter
    def total_system_memory_gi_b(self, total_system_memory_gi_b):
        """Sets the total_system_memory_gi_b of this MemorySummary.

        The total configured operating system-accessible memory (RAM), measured in GiB.  # noqa: E501

        :param total_system_memory_gi_b: The total_system_memory_gi_b of this MemorySummary.  # noqa: E501
        :type: float
        """
        if total_system_memory_gi_b is not None and total_system_memory_gi_b < 0:  # noqa: E501
            raise ValueError("Invalid value for `total_system_memory_gi_b`, must be a value greater than or equal to `0`")  # noqa: E501

        self._total_system_memory_gi_b = total_system_memory_gi_b

    @property
    def total_system_persistent_memory_gi_b(self):
        """Gets the total_system_persistent_memory_gi_b of this MemorySummary.  # noqa: E501

        The total configured, system-accessible persistent memory, measured in GiB.  # noqa: E501

        :return: The total_system_persistent_memory_gi_b of this MemorySummary.  # noqa: E501
        :rtype: float
        """
        return self._total_system_persistent_memory_gi_b

    @total_system_persistent_memory_gi_b.setter
    def total_system_persistent_memory_gi_b(self, total_system_persistent_memory_gi_b):
        """Sets the total_system_persistent_memory_gi_b of this MemorySummary.

        The total configured, system-accessible persistent memory, measured in GiB.  # noqa: E501

        :param total_system_persistent_memory_gi_b: The total_system_persistent_memory_gi_b of this MemorySummary.  # noqa: E501
        :type: float
        """
        if total_system_persistent_memory_gi_b is not None and total_system_persistent_memory_gi_b < 0:  # noqa: E501
            raise ValueError("Invalid value for `total_system_persistent_memory_gi_b`, must be a value greater than or equal to `0`")  # noqa: E501

        self._total_system_persistent_memory_gi_b = total_system_persistent_memory_gi_b

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MemorySummary):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
