# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Message(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'message': 'str',
        'message_args': 'list[str]',
        'message_id': 'str',
        'oem': 'dict(str, object)',
        'related_properties': 'list[str]',
        'resolution': 'str',
        'severity': 'str'
    }

    attribute_map = {
        'message': 'Message',
        'message_args': 'MessageArgs',
        'message_id': 'MessageId',
        'oem': 'Oem',
        'related_properties': 'RelatedProperties',
        'resolution': 'Resolution',
        'severity': 'Severity'
    }

    def __init__(self, message=None, message_args=None, message_id=None, oem=None, related_properties=None, resolution=None, severity=None):  # noqa: E501
        """Message - a model defined in OpenAPI"""  # noqa: E501

        self._message = None
        self._message_args = None
        self._message_id = None
        self._oem = None
        self._related_properties = None
        self._resolution = None
        self._severity = None
        self.discriminator = None

        self.message = message
        if message_args is not None:
            self.message_args = message_args
        self.message_id = message_id
        if oem is not None:
            self.oem = oem
        if related_properties is not None:
            self.related_properties = related_properties
        self.resolution = resolution
        self.severity = severity

    @property
    def message(self):
        """Gets the message of this Message.  # noqa: E501

        This is the human readable message, if provided.  # noqa: E501

        :return: The message of this Message.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this Message.

        This is the human readable message, if provided.  # noqa: E501

        :param message: The message of this Message.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def message_args(self):
        """Gets the message_args of this Message.  # noqa: E501

        This array of message arguments are substituted for the arguments in the message when looked up in the message registry.  # noqa: E501

        :return: The message_args of this Message.  # noqa: E501
        :rtype: list[str]
        """
        return self._message_args

    @message_args.setter
    def message_args(self, message_args):
        """Sets the message_args of this Message.

        This array of message arguments are substituted for the arguments in the message when looked up in the message registry.  # noqa: E501

        :param message_args: The message_args of this Message.  # noqa: E501
        :type: list[str]
        """

        self._message_args = message_args

    @property
    def message_id(self):
        """Gets the message_id of this Message.  # noqa: E501

        This is the key for this message which can be used to look up the message in a message registry.  # noqa: E501

        :return: The message_id of this Message.  # noqa: E501
        :rtype: str
        """
        return self._message_id

    @message_id.setter
    def message_id(self, message_id):
        """Sets the message_id of this Message.

        This is the key for this message which can be used to look up the message in a message registry.  # noqa: E501

        :param message_id: The message_id of this Message.  # noqa: E501
        :type: str
        """
        if message_id is None:
            raise ValueError("Invalid value for `message_id`, must not be `None`")  # noqa: E501

        self._message_id = message_id

    @property
    def oem(self):
        """Gets the oem of this Message.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this Message.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this Message.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this Message.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def related_properties(self):
        """Gets the related_properties of this Message.  # noqa: E501

        This is an array of properties described by the message.  # noqa: E501

        :return: The related_properties of this Message.  # noqa: E501
        :rtype: list[str]
        """
        return self._related_properties

    @related_properties.setter
    def related_properties(self, related_properties):
        """Sets the related_properties of this Message.

        This is an array of properties described by the message.  # noqa: E501

        :param related_properties: The related_properties of this Message.  # noqa: E501
        :type: list[str]
        """

        self._related_properties = related_properties

    @property
    def resolution(self):
        """Gets the resolution of this Message.  # noqa: E501

        Used to provide suggestions on how to resolve the situation that caused the error.  # noqa: E501

        :return: The resolution of this Message.  # noqa: E501
        :rtype: str
        """
        return self._resolution

    @resolution.setter
    def resolution(self, resolution):
        """Sets the resolution of this Message.

        Used to provide suggestions on how to resolve the situation that caused the error.  # noqa: E501

        :param resolution: The resolution of this Message.  # noqa: E501
        :type: str
        """

        self._resolution = resolution

    @property
    def severity(self):
        """Gets the severity of this Message.  # noqa: E501

        This is the severity of the errors.  # noqa: E501

        :return: The severity of this Message.  # noqa: E501
        :rtype: str
        """
        return self._severity

    @severity.setter
    def severity(self, severity):
        """Sets the severity of this Message.

        This is the severity of the errors.  # noqa: E501

        :param severity: The severity of this Message.  # noqa: E501
        :type: str
        """

        self._severity = severity

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Message):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
