# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Metric(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'pre_test': 'float',
        'min': 'float',
        'max': 'float',
        'avg': 'float',
        'sum': 'float',
        'unit': 'str',
        'samples_considered': 'float'
    }

    attribute_map = {
        'pre_test': 'PreTest',
        'min': 'Min',
        'max': 'Max',
        'avg': 'Avg',
        'sum': 'Sum',
        'unit': 'Unit',
        'samples_considered': 'SamplesConsidered'
    }

    def __init__(self, pre_test=None, min=None, max=None, avg=None, sum=None, unit=None, samples_considered=None):  # noqa: E501
        """Metric - a model defined in OpenAPI"""  # noqa: E501

        self._pre_test = None
        self._min = None
        self._max = None
        self._avg = None
        self._sum = None
        self._unit = None
        self._samples_considered = None
        self.discriminator = None

        self.pre_test = pre_test
        self.min = min
        self.max = max
        self.avg = avg
        if sum is not None:
            self.sum = sum
        self.unit = unit
        self.samples_considered = samples_considered

    @property
    def pre_test(self):
        """Gets the pre_test of this Metric.  # noqa: E501

        Pre-Test measurement  # noqa: E501

        :return: The pre_test of this Metric.  # noqa: E501
        :rtype: float
        """
        return self._pre_test

    @pre_test.setter
    def pre_test(self, pre_test):
        """Sets the pre_test of this Metric.

        Pre-Test measurement  # noqa: E501

        :param pre_test: The pre_test of this Metric.  # noqa: E501
        :type: float
        """
        if pre_test is None:
            raise ValueError("Invalid value for `pre_test`, must not be `None`")  # noqa: E501

        self._pre_test = pre_test

    @property
    def min(self):
        """Gets the min of this Metric.  # noqa: E501

        Min measurement.  # noqa: E501

        :return: The min of this Metric.  # noqa: E501
        :rtype: float
        """
        return self._min

    @min.setter
    def min(self, min):
        """Sets the min of this Metric.

        Min measurement.  # noqa: E501

        :param min: The min of this Metric.  # noqa: E501
        :type: float
        """
        if min is None:
            raise ValueError("Invalid value for `min`, must not be `None`")  # noqa: E501

        self._min = min

    @property
    def max(self):
        """Gets the max of this Metric.  # noqa: E501

        Max measurement.  # noqa: E501

        :return: The max of this Metric.  # noqa: E501
        :rtype: float
        """
        return self._max

    @max.setter
    def max(self, max):
        """Sets the max of this Metric.

        Max measurement.  # noqa: E501

        :param max: The max of this Metric.  # noqa: E501
        :type: float
        """
        if max is None:
            raise ValueError("Invalid value for `max`, must not be `None`")  # noqa: E501

        self._max = max

    @property
    def avg(self):
        """Gets the avg of this Metric.  # noqa: E501

        Avg measurement.  # noqa: E501

        :return: The avg of this Metric.  # noqa: E501
        :rtype: float
        """
        return self._avg

    @avg.setter
    def avg(self, avg):
        """Sets the avg of this Metric.

        Avg measurement.  # noqa: E501

        :param avg: The avg of this Metric.  # noqa: E501
        :type: float
        """
        if avg is None:
            raise ValueError("Invalid value for `avg`, must not be `None`")  # noqa: E501

        self._avg = avg

    @property
    def sum(self):
        """Gets the sum of this Metric.  # noqa: E501

        Sum total of all samples  # noqa: E501

        :return: The sum of this Metric.  # noqa: E501
        :rtype: float
        """
        return self._sum

    @sum.setter
    def sum(self, sum):
        """Sets the sum of this Metric.

        Sum total of all samples  # noqa: E501

        :param sum: The sum of this Metric.  # noqa: E501
        :type: float
        """

        self._sum = sum

    @property
    def unit(self):
        """Gets the unit of this Metric.  # noqa: E501

        Unit of the measurement.  # noqa: E501

        :return: The unit of this Metric.  # noqa: E501
        :rtype: str
        """
        return self._unit

    @unit.setter
    def unit(self, unit):
        """Sets the unit of this Metric.

        Unit of the measurement.  # noqa: E501

        :param unit: The unit of this Metric.  # noqa: E501
        :type: str
        """
        if unit is None:
            raise ValueError("Invalid value for `unit`, must not be `None`")  # noqa: E501

        self._unit = unit

    @property
    def samples_considered(self):
        """Gets the samples_considered of this Metric.  # noqa: E501

        Number of samples that were used in the calculations  # noqa: E501

        :return: The samples_considered of this Metric.  # noqa: E501
        :rtype: float
        """
        return self._samples_considered

    @samples_considered.setter
    def samples_considered(self, samples_considered):
        """Sets the samples_considered of this Metric.

        Number of samples that were used in the calculations  # noqa: E501

        :param samples_considered: The samples_considered of this Metric.  # noqa: E501
        :type: float
        """
        if samples_considered is None:
            raise ValueError("Invalid value for `samples_considered`, must not be `None`")  # noqa: E501

        self._samples_considered = samples_considered

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Metric):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
