# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class NetDevFuncMaxBWAlloc(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'max_bw_alloc_percent': 'int',
        'network_device_function': 'IdRef'
    }

    attribute_map = {
        'max_bw_alloc_percent': 'MaxBWAllocPercent',
        'network_device_function': 'NetworkDeviceFunction'
    }

    def __init__(self, max_bw_alloc_percent=None, network_device_function=None):  # noqa: E501
        """NetDevFuncMaxBWAlloc - a model defined in OpenAPI"""  # noqa: E501

        self._max_bw_alloc_percent = None
        self._network_device_function = None
        self.discriminator = None

        self.max_bw_alloc_percent = max_bw_alloc_percent
        if network_device_function is not None:
            self.network_device_function = network_device_function

    @property
    def max_bw_alloc_percent(self):
        """Gets the max_bw_alloc_percent of this NetDevFuncMaxBWAlloc.  # noqa: E501

        The maximum bandwidth allocation percentage allocated to the corresponding network device function instance.  # noqa: E501

        :return: The max_bw_alloc_percent of this NetDevFuncMaxBWAlloc.  # noqa: E501
        :rtype: int
        """
        return self._max_bw_alloc_percent

    @max_bw_alloc_percent.setter
    def max_bw_alloc_percent(self, max_bw_alloc_percent):
        """Sets the max_bw_alloc_percent of this NetDevFuncMaxBWAlloc.

        The maximum bandwidth allocation percentage allocated to the corresponding network device function instance.  # noqa: E501

        :param max_bw_alloc_percent: The max_bw_alloc_percent of this NetDevFuncMaxBWAlloc.  # noqa: E501
        :type: int
        """

        self._max_bw_alloc_percent = max_bw_alloc_percent

    @property
    def network_device_function(self):
        """Gets the network_device_function of this NetDevFuncMaxBWAlloc.  # noqa: E501


        :return: The network_device_function of this NetDevFuncMaxBWAlloc.  # noqa: E501
        :rtype: IdRef
        """
        return self._network_device_function

    @network_device_function.setter
    def network_device_function(self, network_device_function):
        """Sets the network_device_function of this NetDevFuncMaxBWAlloc.


        :param network_device_function: The network_device_function of this NetDevFuncMaxBWAlloc.  # noqa: E501
        :type: IdRef
        """

        self._network_device_function = network_device_function

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NetDevFuncMaxBWAlloc):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
