# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class NetworkAdapter(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_context': 'str',
        'odata_etag': 'str',
        'odata_id': 'str',
        'odata_type': 'str',
        'actions': 'Actions2',
        'assembly': 'IdRef',
        'controllers': 'list[Controllers]',
        'description': 'str',
        'id': 'str',
        'manufacturer': 'str',
        'model': 'str',
        'name': 'str',
        'network_device_functions': 'IdRef',
        'network_ports': 'IdRef',
        'oem': 'dict(str, object)',
        'part_number': 'str',
        'sku': 'str',
        'serial_number': 'str',
        'status': 'Status'
    }

    attribute_map = {
        'odata_context': '@odata.context',
        'odata_etag': '@odata.etag',
        'odata_id': '@odata.id',
        'odata_type': '@odata.type',
        'actions': 'Actions',
        'assembly': 'Assembly',
        'controllers': 'Controllers',
        'description': 'Description',
        'id': 'Id',
        'manufacturer': 'Manufacturer',
        'model': 'Model',
        'name': 'Name',
        'network_device_functions': 'NetworkDeviceFunctions',
        'network_ports': 'NetworkPorts',
        'oem': 'Oem',
        'part_number': 'PartNumber',
        'sku': 'SKU',
        'serial_number': 'SerialNumber',
        'status': 'Status'
    }

    def __init__(self, odata_context=None, odata_etag=None, odata_id=None, odata_type=None, actions=None, assembly=None, controllers=None, description=None, id=None, manufacturer=None, model=None, name=None, network_device_functions=None, network_ports=None, oem=None, part_number=None, sku=None, serial_number=None, status=None):  # noqa: E501
        """NetworkAdapter - a model defined in OpenAPI"""  # noqa: E501

        self._odata_context = None
        self._odata_etag = None
        self._odata_id = None
        self._odata_type = None
        self._actions = None
        self._assembly = None
        self._controllers = None
        self._description = None
        self._id = None
        self._manufacturer = None
        self._model = None
        self._name = None
        self._network_device_functions = None
        self._network_ports = None
        self._oem = None
        self._part_number = None
        self._sku = None
        self._serial_number = None
        self._status = None
        self.discriminator = None

        if odata_context is not None:
            self.odata_context = odata_context
        if odata_etag is not None:
            self.odata_etag = odata_etag
        self.odata_id = odata_id
        self.odata_type = odata_type
        if actions is not None:
            self.actions = actions
        if assembly is not None:
            self.assembly = assembly
        if controllers is not None:
            self.controllers = controllers
        if description is not None:
            self.description = description
        self.id = id
        self.manufacturer = manufacturer
        self.model = model
        self.name = name
        if network_device_functions is not None:
            self.network_device_functions = network_device_functions
        if network_ports is not None:
            self.network_ports = network_ports
        if oem is not None:
            self.oem = oem
        self.part_number = part_number
        self.sku = sku
        self.serial_number = serial_number
        if status is not None:
            self.status = status

    @property
    def odata_context(self):
        """Gets the odata_context of this NetworkAdapter.  # noqa: E501

        The OData description of a payload.  # noqa: E501

        :return: The odata_context of this NetworkAdapter.  # noqa: E501
        :rtype: str
        """
        return self._odata_context

    @odata_context.setter
    def odata_context(self, odata_context):
        """Sets the odata_context of this NetworkAdapter.

        The OData description of a payload.  # noqa: E501

        :param odata_context: The odata_context of this NetworkAdapter.  # noqa: E501
        :type: str
        """

        self._odata_context = odata_context

    @property
    def odata_etag(self):
        """Gets the odata_etag of this NetworkAdapter.  # noqa: E501

        The current ETag of the resource.  # noqa: E501

        :return: The odata_etag of this NetworkAdapter.  # noqa: E501
        :rtype: str
        """
        return self._odata_etag

    @odata_etag.setter
    def odata_etag(self, odata_etag):
        """Sets the odata_etag of this NetworkAdapter.

        The current ETag of the resource.  # noqa: E501

        :param odata_etag: The odata_etag of this NetworkAdapter.  # noqa: E501
        :type: str
        """

        self._odata_etag = odata_etag

    @property
    def odata_id(self):
        """Gets the odata_id of this NetworkAdapter.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this NetworkAdapter.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this NetworkAdapter.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this NetworkAdapter.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def odata_type(self):
        """Gets the odata_type of this NetworkAdapter.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this NetworkAdapter.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this NetworkAdapter.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this NetworkAdapter.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def actions(self):
        """Gets the actions of this NetworkAdapter.  # noqa: E501


        :return: The actions of this NetworkAdapter.  # noqa: E501
        :rtype: Actions2
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this NetworkAdapter.


        :param actions: The actions of this NetworkAdapter.  # noqa: E501
        :type: Actions2
        """

        self._actions = actions

    @property
    def assembly(self):
        """Gets the assembly of this NetworkAdapter.  # noqa: E501


        :return: The assembly of this NetworkAdapter.  # noqa: E501
        :rtype: IdRef
        """
        return self._assembly

    @assembly.setter
    def assembly(self, assembly):
        """Sets the assembly of this NetworkAdapter.


        :param assembly: The assembly of this NetworkAdapter.  # noqa: E501
        :type: IdRef
        """

        self._assembly = assembly

    @property
    def controllers(self):
        """Gets the controllers of this NetworkAdapter.  # noqa: E501

        The set of network controllers ASICs that make up this NetworkAdapter.  # noqa: E501

        :return: The controllers of this NetworkAdapter.  # noqa: E501
        :rtype: list[Controllers]
        """
        return self._controllers

    @controllers.setter
    def controllers(self, controllers):
        """Sets the controllers of this NetworkAdapter.

        The set of network controllers ASICs that make up this NetworkAdapter.  # noqa: E501

        :param controllers: The controllers of this NetworkAdapter.  # noqa: E501
        :type: list[Controllers]
        """

        self._controllers = controllers

    @property
    def description(self):
        """Gets the description of this NetworkAdapter.  # noqa: E501

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :return: The description of this NetworkAdapter.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this NetworkAdapter.

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :param description: The description of this NetworkAdapter.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def id(self):
        """Gets the id of this NetworkAdapter.  # noqa: E501

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :return: The id of this NetworkAdapter.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this NetworkAdapter.

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :param id: The id of this NetworkAdapter.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def manufacturer(self):
        """Gets the manufacturer of this NetworkAdapter.  # noqa: E501

        The manufacturer or OEM of this network adapter.  # noqa: E501

        :return: The manufacturer of this NetworkAdapter.  # noqa: E501
        :rtype: str
        """
        return self._manufacturer

    @manufacturer.setter
    def manufacturer(self, manufacturer):
        """Sets the manufacturer of this NetworkAdapter.

        The manufacturer or OEM of this network adapter.  # noqa: E501

        :param manufacturer: The manufacturer of this NetworkAdapter.  # noqa: E501
        :type: str
        """

        self._manufacturer = manufacturer

    @property
    def model(self):
        """Gets the model of this NetworkAdapter.  # noqa: E501

        The model string for this network adapter.  # noqa: E501

        :return: The model of this NetworkAdapter.  # noqa: E501
        :rtype: str
        """
        return self._model

    @model.setter
    def model(self, model):
        """Sets the model of this NetworkAdapter.

        The model string for this network adapter.  # noqa: E501

        :param model: The model of this NetworkAdapter.  # noqa: E501
        :type: str
        """

        self._model = model

    @property
    def name(self):
        """Gets the name of this NetworkAdapter.  # noqa: E501

        The name of the resource or array member.  # noqa: E501

        :return: The name of this NetworkAdapter.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this NetworkAdapter.

        The name of the resource or array member.  # noqa: E501

        :param name: The name of this NetworkAdapter.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def network_device_functions(self):
        """Gets the network_device_functions of this NetworkAdapter.  # noqa: E501


        :return: The network_device_functions of this NetworkAdapter.  # noqa: E501
        :rtype: IdRef
        """
        return self._network_device_functions

    @network_device_functions.setter
    def network_device_functions(self, network_device_functions):
        """Sets the network_device_functions of this NetworkAdapter.


        :param network_device_functions: The network_device_functions of this NetworkAdapter.  # noqa: E501
        :type: IdRef
        """

        self._network_device_functions = network_device_functions

    @property
    def network_ports(self):
        """Gets the network_ports of this NetworkAdapter.  # noqa: E501


        :return: The network_ports of this NetworkAdapter.  # noqa: E501
        :rtype: IdRef
        """
        return self._network_ports

    @network_ports.setter
    def network_ports(self, network_ports):
        """Sets the network_ports of this NetworkAdapter.


        :param network_ports: The network_ports of this NetworkAdapter.  # noqa: E501
        :type: IdRef
        """

        self._network_ports = network_ports

    @property
    def oem(self):
        """Gets the oem of this NetworkAdapter.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this NetworkAdapter.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this NetworkAdapter.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this NetworkAdapter.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def part_number(self):
        """Gets the part_number of this NetworkAdapter.  # noqa: E501

        Part number for this network adapter.  # noqa: E501

        :return: The part_number of this NetworkAdapter.  # noqa: E501
        :rtype: str
        """
        return self._part_number

    @part_number.setter
    def part_number(self, part_number):
        """Sets the part_number of this NetworkAdapter.

        Part number for this network adapter.  # noqa: E501

        :param part_number: The part_number of this NetworkAdapter.  # noqa: E501
        :type: str
        """

        self._part_number = part_number

    @property
    def sku(self):
        """Gets the sku of this NetworkAdapter.  # noqa: E501

        The manufacturer SKU for this network adapter.  # noqa: E501

        :return: The sku of this NetworkAdapter.  # noqa: E501
        :rtype: str
        """
        return self._sku

    @sku.setter
    def sku(self, sku):
        """Sets the sku of this NetworkAdapter.

        The manufacturer SKU for this network adapter.  # noqa: E501

        :param sku: The sku of this NetworkAdapter.  # noqa: E501
        :type: str
        """

        self._sku = sku

    @property
    def serial_number(self):
        """Gets the serial_number of this NetworkAdapter.  # noqa: E501

        The serial number for this network adapter.  # noqa: E501

        :return: The serial_number of this NetworkAdapter.  # noqa: E501
        :rtype: str
        """
        return self._serial_number

    @serial_number.setter
    def serial_number(self, serial_number):
        """Sets the serial_number of this NetworkAdapter.

        The serial number for this network adapter.  # noqa: E501

        :param serial_number: The serial_number of this NetworkAdapter.  # noqa: E501
        :type: str
        """

        self._serial_number = serial_number

    @property
    def status(self):
        """Gets the status of this NetworkAdapter.  # noqa: E501


        :return: The status of this NetworkAdapter.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this NetworkAdapter.


        :param status: The status of this NetworkAdapter.  # noqa: E501
        :type: Status
        """

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NetworkAdapter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
