# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class NetworkDeviceFunction(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_context': 'str',
        'odata_etag': 'str',
        'odata_id': 'str',
        'odata_type': 'str',
        'actions': 'Actions2',
        'assignable_physical_ports': 'list[IdRef2]',
        'assignable_physical_portsodata_count': 'int',
        'boot_mode': 'BootMode',
        'description': 'str',
        'device_enabled': 'bool',
        'ethernet': 'Ethernet',
        'fibre_channel': 'FibreChannel',
        'id': 'str',
        'links': 'Links2',
        'max_virtual_functions': 'int',
        'name': 'str',
        'net_dev_func_capabilities': 'list[NetworkDeviceTechnology]',
        'net_dev_func_type': 'NetworkDeviceTechnology',
        'oem': 'dict(str, object)',
        'physical_port_assignment': 'IdRef2',
        'status': 'Status',
        'virtual_functions_enabled': 'bool',
        'i_scsi_boot': 'ISCSIBoot'
    }

    attribute_map = {
        'odata_context': '@odata.context',
        'odata_etag': '@odata.etag',
        'odata_id': '@odata.id',
        'odata_type': '@odata.type',
        'actions': 'Actions',
        'assignable_physical_ports': 'AssignablePhysicalPorts',
        'assignable_physical_portsodata_count': 'AssignablePhysicalPorts@odata.count',
        'boot_mode': 'BootMode',
        'description': 'Description',
        'device_enabled': 'DeviceEnabled',
        'ethernet': 'Ethernet',
        'fibre_channel': 'FibreChannel',
        'id': 'Id',
        'links': 'Links',
        'max_virtual_functions': 'MaxVirtualFunctions',
        'name': 'Name',
        'net_dev_func_capabilities': 'NetDevFuncCapabilities',
        'net_dev_func_type': 'NetDevFuncType',
        'oem': 'Oem',
        'physical_port_assignment': 'PhysicalPortAssignment',
        'status': 'Status',
        'virtual_functions_enabled': 'VirtualFunctionsEnabled',
        'i_scsi_boot': 'iSCSIBoot'
    }

    def __init__(self, odata_context=None, odata_etag=None, odata_id=None, odata_type=None, actions=None, assignable_physical_ports=None, assignable_physical_portsodata_count=None, boot_mode=None, description=None, device_enabled=None, ethernet=None, fibre_channel=None, id=None, links=None, max_virtual_functions=None, name=None, net_dev_func_capabilities=None, net_dev_func_type=None, oem=None, physical_port_assignment=None, status=None, virtual_functions_enabled=None, i_scsi_boot=None):  # noqa: E501
        """NetworkDeviceFunction - a model defined in OpenAPI"""  # noqa: E501

        self._odata_context = None
        self._odata_etag = None
        self._odata_id = None
        self._odata_type = None
        self._actions = None
        self._assignable_physical_ports = None
        self._assignable_physical_portsodata_count = None
        self._boot_mode = None
        self._description = None
        self._device_enabled = None
        self._ethernet = None
        self._fibre_channel = None
        self._id = None
        self._links = None
        self._max_virtual_functions = None
        self._name = None
        self._net_dev_func_capabilities = None
        self._net_dev_func_type = None
        self._oem = None
        self._physical_port_assignment = None
        self._status = None
        self._virtual_functions_enabled = None
        self._i_scsi_boot = None
        self.discriminator = None

        if odata_context is not None:
            self.odata_context = odata_context
        if odata_etag is not None:
            self.odata_etag = odata_etag
        self.odata_id = odata_id
        self.odata_type = odata_type
        if actions is not None:
            self.actions = actions
        if assignable_physical_ports is not None:
            self.assignable_physical_ports = assignable_physical_ports
        if assignable_physical_portsodata_count is not None:
            self.assignable_physical_portsodata_count = assignable_physical_portsodata_count
        if boot_mode is not None:
            self.boot_mode = boot_mode
        if description is not None:
            self.description = description
        self.device_enabled = device_enabled
        if ethernet is not None:
            self.ethernet = ethernet
        if fibre_channel is not None:
            self.fibre_channel = fibre_channel
        self.id = id
        if links is not None:
            self.links = links
        self.max_virtual_functions = max_virtual_functions
        self.name = name
        if net_dev_func_capabilities is not None:
            self.net_dev_func_capabilities = net_dev_func_capabilities
        if net_dev_func_type is not None:
            self.net_dev_func_type = net_dev_func_type
        if oem is not None:
            self.oem = oem
        if physical_port_assignment is not None:
            self.physical_port_assignment = physical_port_assignment
        if status is not None:
            self.status = status
        self.virtual_functions_enabled = virtual_functions_enabled
        if i_scsi_boot is not None:
            self.i_scsi_boot = i_scsi_boot

    @property
    def odata_context(self):
        """Gets the odata_context of this NetworkDeviceFunction.  # noqa: E501

        The OData description of a payload.  # noqa: E501

        :return: The odata_context of this NetworkDeviceFunction.  # noqa: E501
        :rtype: str
        """
        return self._odata_context

    @odata_context.setter
    def odata_context(self, odata_context):
        """Sets the odata_context of this NetworkDeviceFunction.

        The OData description of a payload.  # noqa: E501

        :param odata_context: The odata_context of this NetworkDeviceFunction.  # noqa: E501
        :type: str
        """

        self._odata_context = odata_context

    @property
    def odata_etag(self):
        """Gets the odata_etag of this NetworkDeviceFunction.  # noqa: E501

        The current ETag of the resource.  # noqa: E501

        :return: The odata_etag of this NetworkDeviceFunction.  # noqa: E501
        :rtype: str
        """
        return self._odata_etag

    @odata_etag.setter
    def odata_etag(self, odata_etag):
        """Sets the odata_etag of this NetworkDeviceFunction.

        The current ETag of the resource.  # noqa: E501

        :param odata_etag: The odata_etag of this NetworkDeviceFunction.  # noqa: E501
        :type: str
        """

        self._odata_etag = odata_etag

    @property
    def odata_id(self):
        """Gets the odata_id of this NetworkDeviceFunction.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this NetworkDeviceFunction.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this NetworkDeviceFunction.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this NetworkDeviceFunction.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def odata_type(self):
        """Gets the odata_type of this NetworkDeviceFunction.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this NetworkDeviceFunction.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this NetworkDeviceFunction.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this NetworkDeviceFunction.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def actions(self):
        """Gets the actions of this NetworkDeviceFunction.  # noqa: E501


        :return: The actions of this NetworkDeviceFunction.  # noqa: E501
        :rtype: Actions2
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this NetworkDeviceFunction.


        :param actions: The actions of this NetworkDeviceFunction.  # noqa: E501
        :type: Actions2
        """

        self._actions = actions

    @property
    def assignable_physical_ports(self):
        """Gets the assignable_physical_ports of this NetworkDeviceFunction.  # noqa: E501

        The array of physical port references that this network device function may be assigned to.  # noqa: E501

        :return: The assignable_physical_ports of this NetworkDeviceFunction.  # noqa: E501
        :rtype: list[IdRef2]
        """
        return self._assignable_physical_ports

    @assignable_physical_ports.setter
    def assignable_physical_ports(self, assignable_physical_ports):
        """Sets the assignable_physical_ports of this NetworkDeviceFunction.

        The array of physical port references that this network device function may be assigned to.  # noqa: E501

        :param assignable_physical_ports: The assignable_physical_ports of this NetworkDeviceFunction.  # noqa: E501
        :type: list[IdRef2]
        """

        self._assignable_physical_ports = assignable_physical_ports

    @property
    def assignable_physical_portsodata_count(self):
        """Gets the assignable_physical_portsodata_count of this NetworkDeviceFunction.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The assignable_physical_portsodata_count of this NetworkDeviceFunction.  # noqa: E501
        :rtype: int
        """
        return self._assignable_physical_portsodata_count

    @assignable_physical_portsodata_count.setter
    def assignable_physical_portsodata_count(self, assignable_physical_portsodata_count):
        """Sets the assignable_physical_portsodata_count of this NetworkDeviceFunction.

        The number of items in a collection.  # noqa: E501

        :param assignable_physical_portsodata_count: The assignable_physical_portsodata_count of this NetworkDeviceFunction.  # noqa: E501
        :type: int
        """

        self._assignable_physical_portsodata_count = assignable_physical_portsodata_count

    @property
    def boot_mode(self):
        """Gets the boot_mode of this NetworkDeviceFunction.  # noqa: E501


        :return: The boot_mode of this NetworkDeviceFunction.  # noqa: E501
        :rtype: BootMode
        """
        return self._boot_mode

    @boot_mode.setter
    def boot_mode(self, boot_mode):
        """Sets the boot_mode of this NetworkDeviceFunction.


        :param boot_mode: The boot_mode of this NetworkDeviceFunction.  # noqa: E501
        :type: BootMode
        """

        self._boot_mode = boot_mode

    @property
    def description(self):
        """Gets the description of this NetworkDeviceFunction.  # noqa: E501

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :return: The description of this NetworkDeviceFunction.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this NetworkDeviceFunction.

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :param description: The description of this NetworkDeviceFunction.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def device_enabled(self):
        """Gets the device_enabled of this NetworkDeviceFunction.  # noqa: E501

        Whether the network device function is enabled.  # noqa: E501

        :return: The device_enabled of this NetworkDeviceFunction.  # noqa: E501
        :rtype: bool
        """
        return self._device_enabled

    @device_enabled.setter
    def device_enabled(self, device_enabled):
        """Sets the device_enabled of this NetworkDeviceFunction.

        Whether the network device function is enabled.  # noqa: E501

        :param device_enabled: The device_enabled of this NetworkDeviceFunction.  # noqa: E501
        :type: bool
        """

        self._device_enabled = device_enabled

    @property
    def ethernet(self):
        """Gets the ethernet of this NetworkDeviceFunction.  # noqa: E501


        :return: The ethernet of this NetworkDeviceFunction.  # noqa: E501
        :rtype: Ethernet
        """
        return self._ethernet

    @ethernet.setter
    def ethernet(self, ethernet):
        """Sets the ethernet of this NetworkDeviceFunction.


        :param ethernet: The ethernet of this NetworkDeviceFunction.  # noqa: E501
        :type: Ethernet
        """

        self._ethernet = ethernet

    @property
    def fibre_channel(self):
        """Gets the fibre_channel of this NetworkDeviceFunction.  # noqa: E501


        :return: The fibre_channel of this NetworkDeviceFunction.  # noqa: E501
        :rtype: FibreChannel
        """
        return self._fibre_channel

    @fibre_channel.setter
    def fibre_channel(self, fibre_channel):
        """Sets the fibre_channel of this NetworkDeviceFunction.


        :param fibre_channel: The fibre_channel of this NetworkDeviceFunction.  # noqa: E501
        :type: FibreChannel
        """

        self._fibre_channel = fibre_channel

    @property
    def id(self):
        """Gets the id of this NetworkDeviceFunction.  # noqa: E501

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :return: The id of this NetworkDeviceFunction.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this NetworkDeviceFunction.

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :param id: The id of this NetworkDeviceFunction.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def links(self):
        """Gets the links of this NetworkDeviceFunction.  # noqa: E501


        :return: The links of this NetworkDeviceFunction.  # noqa: E501
        :rtype: Links2
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this NetworkDeviceFunction.


        :param links: The links of this NetworkDeviceFunction.  # noqa: E501
        :type: Links2
        """

        self._links = links

    @property
    def max_virtual_functions(self):
        """Gets the max_virtual_functions of this NetworkDeviceFunction.  # noqa: E501

        The number of virtual functions (VFs) that are available for this Network Device Function.  # noqa: E501

        :return: The max_virtual_functions of this NetworkDeviceFunction.  # noqa: E501
        :rtype: int
        """
        return self._max_virtual_functions

    @max_virtual_functions.setter
    def max_virtual_functions(self, max_virtual_functions):
        """Sets the max_virtual_functions of this NetworkDeviceFunction.

        The number of virtual functions (VFs) that are available for this Network Device Function.  # noqa: E501

        :param max_virtual_functions: The max_virtual_functions of this NetworkDeviceFunction.  # noqa: E501
        :type: int
        """

        self._max_virtual_functions = max_virtual_functions

    @property
    def name(self):
        """Gets the name of this NetworkDeviceFunction.  # noqa: E501

        The name of the resource or array member.  # noqa: E501

        :return: The name of this NetworkDeviceFunction.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this NetworkDeviceFunction.

        The name of the resource or array member.  # noqa: E501

        :param name: The name of this NetworkDeviceFunction.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def net_dev_func_capabilities(self):
        """Gets the net_dev_func_capabilities of this NetworkDeviceFunction.  # noqa: E501

        Capabilities of this network device function.  # noqa: E501

        :return: The net_dev_func_capabilities of this NetworkDeviceFunction.  # noqa: E501
        :rtype: list[NetworkDeviceTechnology]
        """
        return self._net_dev_func_capabilities

    @net_dev_func_capabilities.setter
    def net_dev_func_capabilities(self, net_dev_func_capabilities):
        """Sets the net_dev_func_capabilities of this NetworkDeviceFunction.

        Capabilities of this network device function.  # noqa: E501

        :param net_dev_func_capabilities: The net_dev_func_capabilities of this NetworkDeviceFunction.  # noqa: E501
        :type: list[NetworkDeviceTechnology]
        """

        self._net_dev_func_capabilities = net_dev_func_capabilities

    @property
    def net_dev_func_type(self):
        """Gets the net_dev_func_type of this NetworkDeviceFunction.  # noqa: E501


        :return: The net_dev_func_type of this NetworkDeviceFunction.  # noqa: E501
        :rtype: NetworkDeviceTechnology
        """
        return self._net_dev_func_type

    @net_dev_func_type.setter
    def net_dev_func_type(self, net_dev_func_type):
        """Sets the net_dev_func_type of this NetworkDeviceFunction.


        :param net_dev_func_type: The net_dev_func_type of this NetworkDeviceFunction.  # noqa: E501
        :type: NetworkDeviceTechnology
        """

        self._net_dev_func_type = net_dev_func_type

    @property
    def oem(self):
        """Gets the oem of this NetworkDeviceFunction.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this NetworkDeviceFunction.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this NetworkDeviceFunction.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this NetworkDeviceFunction.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def physical_port_assignment(self):
        """Gets the physical_port_assignment of this NetworkDeviceFunction.  # noqa: E501


        :return: The physical_port_assignment of this NetworkDeviceFunction.  # noqa: E501
        :rtype: IdRef2
        """
        return self._physical_port_assignment

    @physical_port_assignment.setter
    def physical_port_assignment(self, physical_port_assignment):
        """Sets the physical_port_assignment of this NetworkDeviceFunction.


        :param physical_port_assignment: The physical_port_assignment of this NetworkDeviceFunction.  # noqa: E501
        :type: IdRef2
        """

        self._physical_port_assignment = physical_port_assignment

    @property
    def status(self):
        """Gets the status of this NetworkDeviceFunction.  # noqa: E501


        :return: The status of this NetworkDeviceFunction.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this NetworkDeviceFunction.


        :param status: The status of this NetworkDeviceFunction.  # noqa: E501
        :type: Status
        """

        self._status = status

    @property
    def virtual_functions_enabled(self):
        """Gets the virtual_functions_enabled of this NetworkDeviceFunction.  # noqa: E501

        Whether Single Root I/O Virtualization (SR-IOV) Virual Functions (VFs) are enabled for this Network Device Function.  # noqa: E501

        :return: The virtual_functions_enabled of this NetworkDeviceFunction.  # noqa: E501
        :rtype: bool
        """
        return self._virtual_functions_enabled

    @virtual_functions_enabled.setter
    def virtual_functions_enabled(self, virtual_functions_enabled):
        """Sets the virtual_functions_enabled of this NetworkDeviceFunction.

        Whether Single Root I/O Virtualization (SR-IOV) Virual Functions (VFs) are enabled for this Network Device Function.  # noqa: E501

        :param virtual_functions_enabled: The virtual_functions_enabled of this NetworkDeviceFunction.  # noqa: E501
        :type: bool
        """

        self._virtual_functions_enabled = virtual_functions_enabled

    @property
    def i_scsi_boot(self):
        """Gets the i_scsi_boot of this NetworkDeviceFunction.  # noqa: E501


        :return: The i_scsi_boot of this NetworkDeviceFunction.  # noqa: E501
        :rtype: ISCSIBoot
        """
        return self._i_scsi_boot

    @i_scsi_boot.setter
    def i_scsi_boot(self, i_scsi_boot):
        """Sets the i_scsi_boot of this NetworkDeviceFunction.


        :param i_scsi_boot: The i_scsi_boot of this NetworkDeviceFunction.  # noqa: E501
        :type: ISCSIBoot
        """

        self._i_scsi_boot = i_scsi_boot

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NetworkDeviceFunction):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
