# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class NetworkInterface(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_context': 'str',
        'odata_etag': 'str',
        'odata_id': 'str',
        'odata_type': 'str',
        'actions': 'Actions2',
        'description': 'str',
        'id': 'str',
        'links': 'Links2',
        'name': 'str',
        'network_device_functions': 'IdRef2',
        'network_ports': 'IdRef2',
        'oem': 'dict(str, object)',
        'status': 'Status'
    }

    attribute_map = {
        'odata_context': '@odata.context',
        'odata_etag': '@odata.etag',
        'odata_id': '@odata.id',
        'odata_type': '@odata.type',
        'actions': 'Actions',
        'description': 'Description',
        'id': 'Id',
        'links': 'Links',
        'name': 'Name',
        'network_device_functions': 'NetworkDeviceFunctions',
        'network_ports': 'NetworkPorts',
        'oem': 'Oem',
        'status': 'Status'
    }

    def __init__(self, odata_context=None, odata_etag=None, odata_id=None, odata_type=None, actions=None, description=None, id=None, links=None, name=None, network_device_functions=None, network_ports=None, oem=None, status=None):  # noqa: E501
        """NetworkInterface - a model defined in OpenAPI"""  # noqa: E501

        self._odata_context = None
        self._odata_etag = None
        self._odata_id = None
        self._odata_type = None
        self._actions = None
        self._description = None
        self._id = None
        self._links = None
        self._name = None
        self._network_device_functions = None
        self._network_ports = None
        self._oem = None
        self._status = None
        self.discriminator = None

        if odata_context is not None:
            self.odata_context = odata_context
        if odata_etag is not None:
            self.odata_etag = odata_etag
        self.odata_id = odata_id
        self.odata_type = odata_type
        if actions is not None:
            self.actions = actions
        if description is not None:
            self.description = description
        self.id = id
        if links is not None:
            self.links = links
        self.name = name
        if network_device_functions is not None:
            self.network_device_functions = network_device_functions
        if network_ports is not None:
            self.network_ports = network_ports
        if oem is not None:
            self.oem = oem
        if status is not None:
            self.status = status

    @property
    def odata_context(self):
        """Gets the odata_context of this NetworkInterface.  # noqa: E501

        The OData description of a payload.  # noqa: E501

        :return: The odata_context of this NetworkInterface.  # noqa: E501
        :rtype: str
        """
        return self._odata_context

    @odata_context.setter
    def odata_context(self, odata_context):
        """Sets the odata_context of this NetworkInterface.

        The OData description of a payload.  # noqa: E501

        :param odata_context: The odata_context of this NetworkInterface.  # noqa: E501
        :type: str
        """

        self._odata_context = odata_context

    @property
    def odata_etag(self):
        """Gets the odata_etag of this NetworkInterface.  # noqa: E501

        The current ETag of the resource.  # noqa: E501

        :return: The odata_etag of this NetworkInterface.  # noqa: E501
        :rtype: str
        """
        return self._odata_etag

    @odata_etag.setter
    def odata_etag(self, odata_etag):
        """Sets the odata_etag of this NetworkInterface.

        The current ETag of the resource.  # noqa: E501

        :param odata_etag: The odata_etag of this NetworkInterface.  # noqa: E501
        :type: str
        """

        self._odata_etag = odata_etag

    @property
    def odata_id(self):
        """Gets the odata_id of this NetworkInterface.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this NetworkInterface.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this NetworkInterface.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this NetworkInterface.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def odata_type(self):
        """Gets the odata_type of this NetworkInterface.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this NetworkInterface.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this NetworkInterface.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this NetworkInterface.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def actions(self):
        """Gets the actions of this NetworkInterface.  # noqa: E501


        :return: The actions of this NetworkInterface.  # noqa: E501
        :rtype: Actions2
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this NetworkInterface.


        :param actions: The actions of this NetworkInterface.  # noqa: E501
        :type: Actions2
        """

        self._actions = actions

    @property
    def description(self):
        """Gets the description of this NetworkInterface.  # noqa: E501

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :return: The description of this NetworkInterface.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this NetworkInterface.

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :param description: The description of this NetworkInterface.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def id(self):
        """Gets the id of this NetworkInterface.  # noqa: E501

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :return: The id of this NetworkInterface.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this NetworkInterface.

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :param id: The id of this NetworkInterface.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def links(self):
        """Gets the links of this NetworkInterface.  # noqa: E501


        :return: The links of this NetworkInterface.  # noqa: E501
        :rtype: Links2
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this NetworkInterface.


        :param links: The links of this NetworkInterface.  # noqa: E501
        :type: Links2
        """

        self._links = links

    @property
    def name(self):
        """Gets the name of this NetworkInterface.  # noqa: E501

        The name of the resource or array member.  # noqa: E501

        :return: The name of this NetworkInterface.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this NetworkInterface.

        The name of the resource or array member.  # noqa: E501

        :param name: The name of this NetworkInterface.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def network_device_functions(self):
        """Gets the network_device_functions of this NetworkInterface.  # noqa: E501


        :return: The network_device_functions of this NetworkInterface.  # noqa: E501
        :rtype: IdRef2
        """
        return self._network_device_functions

    @network_device_functions.setter
    def network_device_functions(self, network_device_functions):
        """Sets the network_device_functions of this NetworkInterface.


        :param network_device_functions: The network_device_functions of this NetworkInterface.  # noqa: E501
        :type: IdRef2
        """

        self._network_device_functions = network_device_functions

    @property
    def network_ports(self):
        """Gets the network_ports of this NetworkInterface.  # noqa: E501


        :return: The network_ports of this NetworkInterface.  # noqa: E501
        :rtype: IdRef2
        """
        return self._network_ports

    @network_ports.setter
    def network_ports(self, network_ports):
        """Sets the network_ports of this NetworkInterface.


        :param network_ports: The network_ports of this NetworkInterface.  # noqa: E501
        :type: IdRef2
        """

        self._network_ports = network_ports

    @property
    def oem(self):
        """Gets the oem of this NetworkInterface.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this NetworkInterface.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this NetworkInterface.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this NetworkInterface.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def status(self):
        """Gets the status of this NetworkInterface.  # noqa: E501


        :return: The status of this NetworkInterface.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this NetworkInterface.


        :param status: The status of this NetworkInterface.  # noqa: E501
        :type: Status
        """

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NetworkInterface):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
