# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class NetworkObjectsCollection(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'membersodata_count': 'int',
        'members': 'list[IdRef2]',
        'odata_type': 'str'
    }

    attribute_map = {
        'membersodata_count': 'Members@odata.count',
        'members': 'Members',
        'odata_type': '@odata.type'
    }

    def __init__(self, membersodata_count=None, members=None, odata_type=None):  # noqa: E501
        """NetworkObjectsCollection - a model defined in OpenAPI"""  # noqa: E501

        self._membersodata_count = None
        self._members = None
        self._odata_type = None
        self.discriminator = None

        self.membersodata_count = membersodata_count
        self.members = members
        self.odata_type = odata_type

    @property
    def membersodata_count(self):
        """Gets the membersodata_count of this NetworkObjectsCollection.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The membersodata_count of this NetworkObjectsCollection.  # noqa: E501
        :rtype: int
        """
        return self._membersodata_count

    @membersodata_count.setter
    def membersodata_count(self, membersodata_count):
        """Sets the membersodata_count of this NetworkObjectsCollection.

        The number of items in a collection.  # noqa: E501

        :param membersodata_count: The membersodata_count of this NetworkObjectsCollection.  # noqa: E501
        :type: int
        """
        if membersodata_count is None:
            raise ValueError("Invalid value for `membersodata_count`, must not be `None`")  # noqa: E501

        self._membersodata_count = membersodata_count

    @property
    def members(self):
        """Gets the members of this NetworkObjectsCollection.  # noqa: E501

        The members of this collection.  # noqa: E501

        :return: The members of this NetworkObjectsCollection.  # noqa: E501
        :rtype: list[IdRef2]
        """
        return self._members

    @members.setter
    def members(self, members):
        """Sets the members of this NetworkObjectsCollection.

        The members of this collection.  # noqa: E501

        :param members: The members of this NetworkObjectsCollection.  # noqa: E501
        :type: list[IdRef2]
        """
        if members is None:
            raise ValueError("Invalid value for `members`, must not be `None`")  # noqa: E501

        self._members = members

    @property
    def odata_type(self):
        """Gets the odata_type of this NetworkObjectsCollection.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this NetworkObjectsCollection.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this NetworkObjectsCollection.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this NetworkObjectsCollection.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NetworkObjectsCollection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
