# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class NicPartitioning(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'npar_capable': 'bool',
        'npar_enabled': 'bool'
    }

    attribute_map = {
        'npar_capable': 'NparCapable',
        'npar_enabled': 'NparEnabled'
    }

    def __init__(self, npar_capable=None, npar_enabled=None):  # noqa: E501
        """NicPartitioning - a model defined in OpenAPI"""  # noqa: E501

        self._npar_capable = None
        self._npar_enabled = None
        self.discriminator = None

        self.npar_capable = npar_capable
        self.npar_enabled = npar_enabled

    @property
    def npar_capable(self):
        """Gets the npar_capable of this NicPartitioning.  # noqa: E501

        Indicates whether or not NIC function partitioning is supported by a controller.  # noqa: E501

        :return: The npar_capable of this NicPartitioning.  # noqa: E501
        :rtype: bool
        """
        return self._npar_capable

    @npar_capable.setter
    def npar_capable(self, npar_capable):
        """Sets the npar_capable of this NicPartitioning.

        Indicates whether or not NIC function partitioning is supported by a controller.  # noqa: E501

        :param npar_capable: The npar_capable of this NicPartitioning.  # noqa: E501
        :type: bool
        """

        self._npar_capable = npar_capable

    @property
    def npar_enabled(self):
        """Gets the npar_enabled of this NicPartitioning.  # noqa: E501

        When true, NIC function partitioning is active on this controller.  # noqa: E501

        :return: The npar_enabled of this NicPartitioning.  # noqa: E501
        :rtype: bool
        """
        return self._npar_enabled

    @npar_enabled.setter
    def npar_enabled(self, npar_enabled):
        """Sets the npar_enabled of this NicPartitioning.

        When true, NIC function partitioning is active on this controller.  # noqa: E501

        :param npar_enabled: The npar_enabled of this NicPartitioning.  # noqa: E501
        :type: bool
        """

        self._npar_enabled = npar_enabled

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NicPartitioning):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
