# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class NPIV(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'max_device_logins': 'int',
        'max_port_logins': 'int'
    }

    attribute_map = {
        'max_device_logins': 'MaxDeviceLogins',
        'max_port_logins': 'MaxPortLogins'
    }

    def __init__(self, max_device_logins=None, max_port_logins=None):  # noqa: E501
        """NPIV - a model defined in OpenAPI"""  # noqa: E501

        self._max_device_logins = None
        self._max_port_logins = None
        self.discriminator = None

        self.max_device_logins = max_device_logins
        self.max_port_logins = max_port_logins

    @property
    def max_device_logins(self):
        """Gets the max_device_logins of this NPIV.  # noqa: E501

        The maximum number of N_Port ID Virtualization (NPIV) logins allowed simultaneously from all ports on this controller.  # noqa: E501

        :return: The max_device_logins of this NPIV.  # noqa: E501
        :rtype: int
        """
        return self._max_device_logins

    @max_device_logins.setter
    def max_device_logins(self, max_device_logins):
        """Sets the max_device_logins of this NPIV.

        The maximum number of N_Port ID Virtualization (NPIV) logins allowed simultaneously from all ports on this controller.  # noqa: E501

        :param max_device_logins: The max_device_logins of this NPIV.  # noqa: E501
        :type: int
        """

        self._max_device_logins = max_device_logins

    @property
    def max_port_logins(self):
        """Gets the max_port_logins of this NPIV.  # noqa: E501

        The maximum number of N_Port ID Virtualization (NPIV) logins allowed per physical port on this controller.  # noqa: E501

        :return: The max_port_logins of this NPIV.  # noqa: E501
        :rtype: int
        """
        return self._max_port_logins

    @max_port_logins.setter
    def max_port_logins(self, max_port_logins):
        """Sets the max_port_logins of this NPIV.

        The maximum number of N_Port ID Virtualization (NPIV) logins allowed per physical port on this controller.  # noqa: E501

        :param max_port_logins: The max_port_logins of this NPIV.  # noqa: E501
        :type: int
        """

        self._max_port_logins = max_port_logins

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NPIV):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
