# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PagerDutyOp(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'start_time': 'str',
        'state': 'OpState2',
        'message': 'str',
        'description': 'str',
        'service_key': 'str',
        'diag_test': 'bool'
    }

    attribute_map = {
        'start_time': 'StartTime',
        'state': 'State',
        'message': 'Message',
        'description': 'Description',
        'service_key': 'ServiceKey',
        'diag_test': 'DiagTest'
    }

    def __init__(self, start_time=None, state=None, message=None, description=None, service_key=None, diag_test=None):  # noqa: E501
        """PagerDutyOp - a model defined in OpenAPI"""  # noqa: E501

        self._start_time = None
        self._state = None
        self._message = None
        self._description = None
        self._service_key = None
        self._diag_test = None
        self.discriminator = None

        self.start_time = start_time
        self.state = state
        self.message = message
        self.description = description
        self.service_key = service_key
        self.diag_test = diag_test

    @property
    def start_time(self):
        """Gets the start_time of this PagerDutyOp.  # noqa: E501

        Property indicates the UTC time at which the operation was triggered  # noqa: E501

        :return: The start_time of this PagerDutyOp.  # noqa: E501
        :rtype: str
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this PagerDutyOp.

        Property indicates the UTC time at which the operation was triggered  # noqa: E501

        :param start_time: The start_time of this PagerDutyOp.  # noqa: E501
        :type: str
        """
        if start_time is None:
            raise ValueError("Invalid value for `start_time`, must not be `None`")  # noqa: E501

        self._start_time = start_time

    @property
    def state(self):
        """Gets the state of this PagerDutyOp.  # noqa: E501


        :return: The state of this PagerDutyOp.  # noqa: E501
        :rtype: OpState2
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this PagerDutyOp.


        :param state: The state of this PagerDutyOp.  # noqa: E501
        :type: OpState2
        """
        if state is None:
            raise ValueError("Invalid value for `state`, must not be `None`")  # noqa: E501

        self._state = state

    @property
    def message(self):
        """Gets the message of this PagerDutyOp.  # noqa: E501

        Property provides a more descriptive status of the operation that is in progress.  # noqa: E501

        :return: The message of this PagerDutyOp.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this PagerDutyOp.

        Property provides a more descriptive status of the operation that is in progress.  # noqa: E501

        :param message: The message of this PagerDutyOp.  # noqa: E501
        :type: str
        """
        if message is None:
            raise ValueError("Invalid value for `message`, must not be `None`")  # noqa: E501

        self._message = message

    @property
    def description(self):
        """Gets the description of this PagerDutyOp.  # noqa: E501

        Property sets the user provided comments for which the pagerduty is triggered.  # noqa: E501

        :return: The description of this PagerDutyOp.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this PagerDutyOp.

        Property sets the user provided comments for which the pagerduty is triggered.  # noqa: E501

        :param description: The description of this PagerDutyOp.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def service_key(self):
        """Gets the service_key of this PagerDutyOp.  # noqa: E501

        Property sets the user provided ServiceKey when the pagerduty is triggered.  # noqa: E501

        :return: The service_key of this PagerDutyOp.  # noqa: E501
        :rtype: str
        """
        return self._service_key

    @service_key.setter
    def service_key(self, service_key):
        """Sets the service_key of this PagerDutyOp.

        Property sets the user provided ServiceKey when the pagerduty is triggered.  # noqa: E501

        :param service_key: The service_key of this PagerDutyOp.  # noqa: E501
        :type: str
        """

        self._service_key = service_key

    @property
    def diag_test(self):
        """Gets the diag_test of this PagerDutyOp.  # noqa: E501

        Property used to trigger diagnostic test for callhome.  # noqa: E501

        :return: The diag_test of this PagerDutyOp.  # noqa: E501
        :rtype: bool
        """
        return self._diag_test

    @diag_test.setter
    def diag_test(self, diag_test):
        """Sets the diag_test of this PagerDutyOp.

        Property used to trigger diagnostic test for callhome.  # noqa: E501

        :param diag_test: The diag_test of this PagerDutyOp.  # noqa: E501
        :type: bool
        """

        self._diag_test = diag_test

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PagerDutyOp):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
