# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PCIeDeviceJSON(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_id': 'str',
        'odata_type': 'str',
        'bdf': 'str',
        'id': 'str',
        'links': 'Links',
        'name': 'str',
        'pc_ie_interface': 'PCIeInf',
        'status': 'Status',
        'pc_ie_device_error_count': 'PCIeErrorCount',
        'pc_ie_device_error_reporting': 'PCIeErrorReporting'
    }

    attribute_map = {
        'odata_id': '@odata.id',
        'odata_type': '@odata.type',
        'bdf': 'BDF',
        'id': 'ID',
        'links': 'Links',
        'name': 'Name',
        'pc_ie_interface': 'PCIeInterface',
        'status': 'Status',
        'pc_ie_device_error_count': 'PCIeDeviceErrorCount',
        'pc_ie_device_error_reporting': 'PCIeDeviceErrorReporting'
    }

    def __init__(self, odata_id=None, odata_type=None, bdf=None, id=None, links=None, name=None, pc_ie_interface=None, status=None, pc_ie_device_error_count=None, pc_ie_device_error_reporting=None):  # noqa: E501
        """PCIeDeviceJSON - a model defined in OpenAPI"""  # noqa: E501

        self._odata_id = None
        self._odata_type = None
        self._bdf = None
        self._id = None
        self._links = None
        self._name = None
        self._pc_ie_interface = None
        self._status = None
        self._pc_ie_device_error_count = None
        self._pc_ie_device_error_reporting = None
        self.discriminator = None

        self.odata_id = odata_id
        self.odata_type = odata_type
        self.bdf = bdf
        self.id = id
        if links is not None:
            self.links = links
        self.name = name
        if pc_ie_interface is not None:
            self.pc_ie_interface = pc_ie_interface
        if status is not None:
            self.status = status
        if pc_ie_device_error_count is not None:
            self.pc_ie_device_error_count = pc_ie_device_error_count
        if pc_ie_device_error_reporting is not None:
            self.pc_ie_device_error_reporting = pc_ie_device_error_reporting

    @property
    def odata_id(self):
        """Gets the odata_id of this PCIeDeviceJSON.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this PCIeDeviceJSON.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this PCIeDeviceJSON.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this PCIeDeviceJSON.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def odata_type(self):
        """Gets the odata_type of this PCIeDeviceJSON.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this PCIeDeviceJSON.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this PCIeDeviceJSON.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this PCIeDeviceJSON.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def bdf(self):
        """Gets the bdf of this PCIeDeviceJSON.  # noqa: E501

        PCIe BusDeviceFunc address.  # noqa: E501

        :return: The bdf of this PCIeDeviceJSON.  # noqa: E501
        :rtype: str
        """
        return self._bdf

    @bdf.setter
    def bdf(self, bdf):
        """Sets the bdf of this PCIeDeviceJSON.

        PCIe BusDeviceFunc address.  # noqa: E501

        :param bdf: The bdf of this PCIeDeviceJSON.  # noqa: E501
        :type: str
        """
        if bdf is None:
            raise ValueError("Invalid value for `bdf`, must not be `None`")  # noqa: E501

        self._bdf = bdf

    @property
    def id(self):
        """Gets the id of this PCIeDeviceJSON.  # noqa: E501

        Uniquely identifies the resource within a collection of resources.  # noqa: E501

        :return: The id of this PCIeDeviceJSON.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PCIeDeviceJSON.

        Uniquely identifies the resource within a collection of resources.  # noqa: E501

        :param id: The id of this PCIeDeviceJSON.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def links(self):
        """Gets the links of this PCIeDeviceJSON.  # noqa: E501


        :return: The links of this PCIeDeviceJSON.  # noqa: E501
        :rtype: Links
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this PCIeDeviceJSON.


        :param links: The links of this PCIeDeviceJSON.  # noqa: E501
        :type: Links
        """

        self._links = links

    @property
    def name(self):
        """Gets the name of this PCIeDeviceJSON.  # noqa: E501

        The name of the resource or array element.  # noqa: E501

        :return: The name of this PCIeDeviceJSON.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PCIeDeviceJSON.

        The name of the resource or array element.  # noqa: E501

        :param name: The name of this PCIeDeviceJSON.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def pc_ie_interface(self):
        """Gets the pc_ie_interface of this PCIeDeviceJSON.  # noqa: E501


        :return: The pc_ie_interface of this PCIeDeviceJSON.  # noqa: E501
        :rtype: PCIeInf
        """
        return self._pc_ie_interface

    @pc_ie_interface.setter
    def pc_ie_interface(self, pc_ie_interface):
        """Sets the pc_ie_interface of this PCIeDeviceJSON.


        :param pc_ie_interface: The pc_ie_interface of this PCIeDeviceJSON.  # noqa: E501
        :type: PCIeInf
        """

        self._pc_ie_interface = pc_ie_interface

    @property
    def status(self):
        """Gets the status of this PCIeDeviceJSON.  # noqa: E501


        :return: The status of this PCIeDeviceJSON.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this PCIeDeviceJSON.


        :param status: The status of this PCIeDeviceJSON.  # noqa: E501
        :type: Status
        """

        self._status = status

    @property
    def pc_ie_device_error_count(self):
        """Gets the pc_ie_device_error_count of this PCIeDeviceJSON.  # noqa: E501


        :return: The pc_ie_device_error_count of this PCIeDeviceJSON.  # noqa: E501
        :rtype: PCIeErrorCount
        """
        return self._pc_ie_device_error_count

    @pc_ie_device_error_count.setter
    def pc_ie_device_error_count(self, pc_ie_device_error_count):
        """Sets the pc_ie_device_error_count of this PCIeDeviceJSON.


        :param pc_ie_device_error_count: The pc_ie_device_error_count of this PCIeDeviceJSON.  # noqa: E501
        :type: PCIeErrorCount
        """

        self._pc_ie_device_error_count = pc_ie_device_error_count

    @property
    def pc_ie_device_error_reporting(self):
        """Gets the pc_ie_device_error_reporting of this PCIeDeviceJSON.  # noqa: E501


        :return: The pc_ie_device_error_reporting of this PCIeDeviceJSON.  # noqa: E501
        :rtype: PCIeErrorReporting
        """
        return self._pc_ie_device_error_reporting

    @pc_ie_device_error_reporting.setter
    def pc_ie_device_error_reporting(self, pc_ie_device_error_reporting):
        """Sets the pc_ie_device_error_reporting of this PCIeDeviceJSON.


        :param pc_ie_device_error_reporting: The pc_ie_device_error_reporting of this PCIeDeviceJSON.  # noqa: E501
        :type: PCIeErrorReporting
        """

        self._pc_ie_device_error_reporting = pc_ie_device_error_reporting

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PCIeDeviceJSON):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
