# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PCIeError(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_type': 'str',
        'bus': 'Byte',
        'device': 'Byte',
        'device_id': 'int',
        'error_time_stamp': 'str',
        'first_pcie_error': 'str',
        'function': 'Byte',
        'raw_error_data': 'RawError2',
        'second_pcie_error': 'str',
        'vendor_id': 'int'
    }

    attribute_map = {
        'odata_type': '@odata.type',
        'bus': 'Bus',
        'device': 'Device',
        'device_id': 'DeviceID',
        'error_time_stamp': 'ErrorTimeStamp',
        'first_pcie_error': 'FirstPcieError',
        'function': 'Function',
        'raw_error_data': 'RawErrorData',
        'second_pcie_error': 'SecondPcieError',
        'vendor_id': 'VendorID'
    }

    def __init__(self, odata_type=None, bus=None, device=None, device_id=None, error_time_stamp=None, first_pcie_error=None, function=None, raw_error_data=None, second_pcie_error=None, vendor_id=None):  # noqa: E501
        """PCIeError - a model defined in OpenAPI"""  # noqa: E501

        self._odata_type = None
        self._bus = None
        self._device = None
        self._device_id = None
        self._error_time_stamp = None
        self._first_pcie_error = None
        self._function = None
        self._raw_error_data = None
        self._second_pcie_error = None
        self._vendor_id = None
        self.discriminator = None

        self.odata_type = odata_type
        self.bus = bus
        self.device = device
        self.device_id = device_id
        self.error_time_stamp = error_time_stamp
        self.first_pcie_error = first_pcie_error
        self.function = function
        self.raw_error_data = raw_error_data
        self.second_pcie_error = second_pcie_error
        self.vendor_id = vendor_id

    @property
    def odata_type(self):
        """Gets the odata_type of this PCIeError.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this PCIeError.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this PCIeError.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this PCIeError.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def bus(self):
        """Gets the bus of this PCIeError.  # noqa: E501

        Bus on which the error occurred.  # noqa: E501

        :return: The bus of this PCIeError.  # noqa: E501
        :rtype: Byte
        """
        return self._bus

    @bus.setter
    def bus(self, bus):
        """Sets the bus of this PCIeError.

        Bus on which the error occurred.  # noqa: E501

        :param bus: The bus of this PCIeError.  # noqa: E501
        :type: Byte
        """
        if bus is None:
            raise ValueError("Invalid value for `bus`, must not be `None`")  # noqa: E501

        self._bus = bus

    @property
    def device(self):
        """Gets the device of this PCIeError.  # noqa: E501

        Device on which the error occurred.  # noqa: E501

        :return: The device of this PCIeError.  # noqa: E501
        :rtype: Byte
        """
        return self._device

    @device.setter
    def device(self, device):
        """Sets the device of this PCIeError.

        Device on which the error occurred.  # noqa: E501

        :param device: The device of this PCIeError.  # noqa: E501
        :type: Byte
        """
        if device is None:
            raise ValueError("Invalid value for `device`, must not be `None`")  # noqa: E501

        self._device = device

    @property
    def device_id(self):
        """Gets the device_id of this PCIeError.  # noqa: E501

        DeviceID of PCIe device.  # noqa: E501

        :return: The device_id of this PCIeError.  # noqa: E501
        :rtype: int
        """
        return self._device_id

    @device_id.setter
    def device_id(self, device_id):
        """Sets the device_id of this PCIeError.

        DeviceID of PCIe device.  # noqa: E501

        :param device_id: The device_id of this PCIeError.  # noqa: E501
        :type: int
        """
        if device_id is None:
            raise ValueError("Invalid value for `device_id`, must not be `None`")  # noqa: E501

        self._device_id = device_id

    @property
    def error_time_stamp(self):
        """Gets the error_time_stamp of this PCIeError.  # noqa: E501

        Timestamp of the log in Sel record list.  # noqa: E501

        :return: The error_time_stamp of this PCIeError.  # noqa: E501
        :rtype: str
        """
        return self._error_time_stamp

    @error_time_stamp.setter
    def error_time_stamp(self, error_time_stamp):
        """Sets the error_time_stamp of this PCIeError.

        Timestamp of the log in Sel record list.  # noqa: E501

        :param error_time_stamp: The error_time_stamp of this PCIeError.  # noqa: E501
        :type: str
        """
        if error_time_stamp is None:
            raise ValueError("Invalid value for `error_time_stamp`, must not be `None`")  # noqa: E501

        self._error_time_stamp = error_time_stamp

    @property
    def first_pcie_error(self):
        """Gets the first_pcie_error of this PCIeError.  # noqa: E501

        The first error.  # noqa: E501

        :return: The first_pcie_error of this PCIeError.  # noqa: E501
        :rtype: str
        """
        return self._first_pcie_error

    @first_pcie_error.setter
    def first_pcie_error(self, first_pcie_error):
        """Sets the first_pcie_error of this PCIeError.

        The first error.  # noqa: E501

        :param first_pcie_error: The first_pcie_error of this PCIeError.  # noqa: E501
        :type: str
        """
        if first_pcie_error is None:
            raise ValueError("Invalid value for `first_pcie_error`, must not be `None`")  # noqa: E501

        self._first_pcie_error = first_pcie_error

    @property
    def function(self):
        """Gets the function of this PCIeError.  # noqa: E501

        Function on which the error occurred.  # noqa: E501

        :return: The function of this PCIeError.  # noqa: E501
        :rtype: Byte
        """
        return self._function

    @function.setter
    def function(self, function):
        """Sets the function of this PCIeError.

        Function on which the error occurred.  # noqa: E501

        :param function: The function of this PCIeError.  # noqa: E501
        :type: Byte
        """
        if function is None:
            raise ValueError("Invalid value for `function`, must not be `None`")  # noqa: E501

        self._function = function

    @property
    def raw_error_data(self):
        """Gets the raw_error_data of this PCIeError.  # noqa: E501


        :return: The raw_error_data of this PCIeError.  # noqa: E501
        :rtype: RawError2
        """
        return self._raw_error_data

    @raw_error_data.setter
    def raw_error_data(self, raw_error_data):
        """Sets the raw_error_data of this PCIeError.


        :param raw_error_data: The raw_error_data of this PCIeError.  # noqa: E501
        :type: RawError2
        """
        if raw_error_data is None:
            raise ValueError("Invalid value for `raw_error_data`, must not be `None`")  # noqa: E501

        self._raw_error_data = raw_error_data

    @property
    def second_pcie_error(self):
        """Gets the second_pcie_error of this PCIeError.  # noqa: E501

        The second error.  # noqa: E501

        :return: The second_pcie_error of this PCIeError.  # noqa: E501
        :rtype: str
        """
        return self._second_pcie_error

    @second_pcie_error.setter
    def second_pcie_error(self, second_pcie_error):
        """Sets the second_pcie_error of this PCIeError.

        The second error.  # noqa: E501

        :param second_pcie_error: The second_pcie_error of this PCIeError.  # noqa: E501
        :type: str
        """
        if second_pcie_error is None:
            raise ValueError("Invalid value for `second_pcie_error`, must not be `None`")  # noqa: E501

        self._second_pcie_error = second_pcie_error

    @property
    def vendor_id(self):
        """Gets the vendor_id of this PCIeError.  # noqa: E501

        Vendor ID for the Memory device.  # noqa: E501

        :return: The vendor_id of this PCIeError.  # noqa: E501
        :rtype: int
        """
        return self._vendor_id

    @vendor_id.setter
    def vendor_id(self, vendor_id):
        """Sets the vendor_id of this PCIeError.

        Vendor ID for the Memory device.  # noqa: E501

        :param vendor_id: The vendor_id of this PCIeError.  # noqa: E501
        :type: int
        """
        if vendor_id is None:
            raise ValueError("Invalid value for `vendor_id`, must not be `None`")  # noqa: E501

        self._vendor_id = vendor_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PCIeError):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
