# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PCIeErrorCount(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'correctable_count': 'int',
        'correctable_timestamp': 'list[str]',
        'uncorrectable_count': 'int',
        'uncorrectable_timestamp': 'list[str]',
        'correctable_raw_sel': 'list[str]',
        'uncorrectable_raw_sel': 'list[str]'
    }

    attribute_map = {
        'correctable_count': 'CorrectableCount',
        'correctable_timestamp': 'CorrectableTimestamp',
        'uncorrectable_count': 'UncorrectableCount',
        'uncorrectable_timestamp': 'UncorrectableTimestamp',
        'correctable_raw_sel': 'CorrectableRawSEL',
        'uncorrectable_raw_sel': 'UncorrectableRawSEL'
    }

    def __init__(self, correctable_count=None, correctable_timestamp=None, uncorrectable_count=None, uncorrectable_timestamp=None, correctable_raw_sel=None, uncorrectable_raw_sel=None):  # noqa: E501
        """PCIeErrorCount - a model defined in OpenAPI"""  # noqa: E501

        self._correctable_count = None
        self._correctable_timestamp = None
        self._uncorrectable_count = None
        self._uncorrectable_timestamp = None
        self._correctable_raw_sel = None
        self._uncorrectable_raw_sel = None
        self.discriminator = None

        self.correctable_count = correctable_count
        self.correctable_timestamp = correctable_timestamp
        self.uncorrectable_count = uncorrectable_count
        self.uncorrectable_timestamp = uncorrectable_timestamp
        self.correctable_raw_sel = correctable_raw_sel
        self.uncorrectable_raw_sel = uncorrectable_raw_sel

    @property
    def correctable_count(self):
        """Gets the correctable_count of this PCIeErrorCount.  # noqa: E501

        Accumulated correctable error count.  # noqa: E501

        :return: The correctable_count of this PCIeErrorCount.  # noqa: E501
        :rtype: int
        """
        return self._correctable_count

    @correctable_count.setter
    def correctable_count(self, correctable_count):
        """Sets the correctable_count of this PCIeErrorCount.

        Accumulated correctable error count.  # noqa: E501

        :param correctable_count: The correctable_count of this PCIeErrorCount.  # noqa: E501
        :type: int
        """
        if correctable_count is None:
            raise ValueError("Invalid value for `correctable_count`, must not be `None`")  # noqa: E501

        self._correctable_count = correctable_count

    @property
    def correctable_timestamp(self):
        """Gets the correctable_timestamp of this PCIeErrorCount.  # noqa: E501

        Accumulated correctable error timestamp.  # noqa: E501

        :return: The correctable_timestamp of this PCIeErrorCount.  # noqa: E501
        :rtype: list[str]
        """
        return self._correctable_timestamp

    @correctable_timestamp.setter
    def correctable_timestamp(self, correctable_timestamp):
        """Sets the correctable_timestamp of this PCIeErrorCount.

        Accumulated correctable error timestamp.  # noqa: E501

        :param correctable_timestamp: The correctable_timestamp of this PCIeErrorCount.  # noqa: E501
        :type: list[str]
        """
        if correctable_timestamp is None:
            raise ValueError("Invalid value for `correctable_timestamp`, must not be `None`")  # noqa: E501

        self._correctable_timestamp = correctable_timestamp

    @property
    def uncorrectable_count(self):
        """Gets the uncorrectable_count of this PCIeErrorCount.  # noqa: E501

        Accumulated uncorrectable error count.  # noqa: E501

        :return: The uncorrectable_count of this PCIeErrorCount.  # noqa: E501
        :rtype: int
        """
        return self._uncorrectable_count

    @uncorrectable_count.setter
    def uncorrectable_count(self, uncorrectable_count):
        """Sets the uncorrectable_count of this PCIeErrorCount.

        Accumulated uncorrectable error count.  # noqa: E501

        :param uncorrectable_count: The uncorrectable_count of this PCIeErrorCount.  # noqa: E501
        :type: int
        """
        if uncorrectable_count is None:
            raise ValueError("Invalid value for `uncorrectable_count`, must not be `None`")  # noqa: E501

        self._uncorrectable_count = uncorrectable_count

    @property
    def uncorrectable_timestamp(self):
        """Gets the uncorrectable_timestamp of this PCIeErrorCount.  # noqa: E501

        Accumulated uncorrectable error timestamp.  # noqa: E501

        :return: The uncorrectable_timestamp of this PCIeErrorCount.  # noqa: E501
        :rtype: list[str]
        """
        return self._uncorrectable_timestamp

    @uncorrectable_timestamp.setter
    def uncorrectable_timestamp(self, uncorrectable_timestamp):
        """Sets the uncorrectable_timestamp of this PCIeErrorCount.

        Accumulated uncorrectable error timestamp.  # noqa: E501

        :param uncorrectable_timestamp: The uncorrectable_timestamp of this PCIeErrorCount.  # noqa: E501
        :type: list[str]
        """
        if uncorrectable_timestamp is None:
            raise ValueError("Invalid value for `uncorrectable_timestamp`, must not be `None`")  # noqa: E501

        self._uncorrectable_timestamp = uncorrectable_timestamp

    @property
    def correctable_raw_sel(self):
        """Gets the correctable_raw_sel of this PCIeErrorCount.  # noqa: E501

        Accumulated correctable error of raw data.  # noqa: E501

        :return: The correctable_raw_sel of this PCIeErrorCount.  # noqa: E501
        :rtype: list[str]
        """
        return self._correctable_raw_sel

    @correctable_raw_sel.setter
    def correctable_raw_sel(self, correctable_raw_sel):
        """Sets the correctable_raw_sel of this PCIeErrorCount.

        Accumulated correctable error of raw data.  # noqa: E501

        :param correctable_raw_sel: The correctable_raw_sel of this PCIeErrorCount.  # noqa: E501
        :type: list[str]
        """
        if correctable_raw_sel is None:
            raise ValueError("Invalid value for `correctable_raw_sel`, must not be `None`")  # noqa: E501

        self._correctable_raw_sel = correctable_raw_sel

    @property
    def uncorrectable_raw_sel(self):
        """Gets the uncorrectable_raw_sel of this PCIeErrorCount.  # noqa: E501

        Accumulated correctable error of raw data.  # noqa: E501

        :return: The uncorrectable_raw_sel of this PCIeErrorCount.  # noqa: E501
        :rtype: list[str]
        """
        return self._uncorrectable_raw_sel

    @uncorrectable_raw_sel.setter
    def uncorrectable_raw_sel(self, uncorrectable_raw_sel):
        """Sets the uncorrectable_raw_sel of this PCIeErrorCount.

        Accumulated correctable error of raw data.  # noqa: E501

        :param uncorrectable_raw_sel: The uncorrectable_raw_sel of this PCIeErrorCount.  # noqa: E501
        :type: list[str]
        """
        if uncorrectable_raw_sel is None:
            raise ValueError("Invalid value for `uncorrectable_raw_sel`, must not be `None`")  # noqa: E501

        self._uncorrectable_raw_sel = uncorrectable_raw_sel

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PCIeErrorCount):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
