# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PCIeErrorReporting(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'correctable_error': 'bool',
        'fatal_error': 'bool',
        'nonfatal_error': 'bool',
        'unsupported_request_error': 'bool',
        'capability_control': 'str',
        'correctable_error_mask': 'str',
        'correctable_error_status': 'str',
        'uncorrectable_error_severity': 'str',
        'uncorrectable_error_status': 'str',
        'uncorrectable_error_mask': 'str',
        'device_correctable_error': 'bool',
        'device_non_fatal_error': 'bool',
        'device_fatal_error': 'bool',
        'device_unsupported_request_error': 'bool'
    }

    attribute_map = {
        'correctable_error': 'CorrectableError',
        'fatal_error': 'FatalError',
        'nonfatal_error': 'NonfatalError',
        'unsupported_request_error': 'UnsupportedRequestError',
        'capability_control': 'CapabilityControl',
        'correctable_error_mask': 'CorrectableErrorMask',
        'correctable_error_status': 'CorrectableErrorStatus',
        'uncorrectable_error_severity': 'UncorrectableErrorSeverity',
        'uncorrectable_error_status': 'UncorrectableErrorStatus',
        'uncorrectable_error_mask': 'UncorrectableErrorMask',
        'device_correctable_error': 'DeviceCorrectableError',
        'device_non_fatal_error': 'DeviceNonFatalError',
        'device_fatal_error': 'DeviceFatalError',
        'device_unsupported_request_error': 'DeviceUnsupportedRequestError'
    }

    def __init__(self, correctable_error=None, fatal_error=None, nonfatal_error=None, unsupported_request_error=None, capability_control=None, correctable_error_mask=None, correctable_error_status=None, uncorrectable_error_severity=None, uncorrectable_error_status=None, uncorrectable_error_mask=None, device_correctable_error=None, device_non_fatal_error=None, device_fatal_error=None, device_unsupported_request_error=None):  # noqa: E501
        """PCIeErrorReporting - a model defined in OpenAPI"""  # noqa: E501

        self._correctable_error = None
        self._fatal_error = None
        self._nonfatal_error = None
        self._unsupported_request_error = None
        self._capability_control = None
        self._correctable_error_mask = None
        self._correctable_error_status = None
        self._uncorrectable_error_severity = None
        self._uncorrectable_error_status = None
        self._uncorrectable_error_mask = None
        self._device_correctable_error = None
        self._device_non_fatal_error = None
        self._device_fatal_error = None
        self._device_unsupported_request_error = None
        self.discriminator = None

        self.correctable_error = correctable_error
        self.fatal_error = fatal_error
        self.nonfatal_error = nonfatal_error
        self.unsupported_request_error = unsupported_request_error
        self.capability_control = capability_control
        self.correctable_error_mask = correctable_error_mask
        self.correctable_error_status = correctable_error_status
        self.uncorrectable_error_severity = uncorrectable_error_severity
        self.uncorrectable_error_status = uncorrectable_error_status
        self.uncorrectable_error_mask = uncorrectable_error_mask
        self.device_correctable_error = device_correctable_error
        self.device_non_fatal_error = device_non_fatal_error
        self.device_fatal_error = device_fatal_error
        self.device_unsupported_request_error = device_unsupported_request_error

    @property
    def correctable_error(self):
        """Gets the correctable_error of this PCIeErrorReporting.  # noqa: E501

        This is the flag of Correctable Error reporting.  # noqa: E501

        :return: The correctable_error of this PCIeErrorReporting.  # noqa: E501
        :rtype: bool
        """
        return self._correctable_error

    @correctable_error.setter
    def correctable_error(self, correctable_error):
        """Sets the correctable_error of this PCIeErrorReporting.

        This is the flag of Correctable Error reporting.  # noqa: E501

        :param correctable_error: The correctable_error of this PCIeErrorReporting.  # noqa: E501
        :type: bool
        """
        if correctable_error is None:
            raise ValueError("Invalid value for `correctable_error`, must not be `None`")  # noqa: E501

        self._correctable_error = correctable_error

    @property
    def fatal_error(self):
        """Gets the fatal_error of this PCIeErrorReporting.  # noqa: E501

        This is the flag of Fatal Error reporting.  # noqa: E501

        :return: The fatal_error of this PCIeErrorReporting.  # noqa: E501
        :rtype: bool
        """
        return self._fatal_error

    @fatal_error.setter
    def fatal_error(self, fatal_error):
        """Sets the fatal_error of this PCIeErrorReporting.

        This is the flag of Fatal Error reporting.  # noqa: E501

        :param fatal_error: The fatal_error of this PCIeErrorReporting.  # noqa: E501
        :type: bool
        """
        if fatal_error is None:
            raise ValueError("Invalid value for `fatal_error`, must not be `None`")  # noqa: E501

        self._fatal_error = fatal_error

    @property
    def nonfatal_error(self):
        """Gets the nonfatal_error of this PCIeErrorReporting.  # noqa: E501

        This is the flag of Nonfatal Error reporting.  # noqa: E501

        :return: The nonfatal_error of this PCIeErrorReporting.  # noqa: E501
        :rtype: bool
        """
        return self._nonfatal_error

    @nonfatal_error.setter
    def nonfatal_error(self, nonfatal_error):
        """Sets the nonfatal_error of this PCIeErrorReporting.

        This is the flag of Nonfatal Error reporting.  # noqa: E501

        :param nonfatal_error: The nonfatal_error of this PCIeErrorReporting.  # noqa: E501
        :type: bool
        """
        if nonfatal_error is None:
            raise ValueError("Invalid value for `nonfatal_error`, must not be `None`")  # noqa: E501

        self._nonfatal_error = nonfatal_error

    @property
    def unsupported_request_error(self):
        """Gets the unsupported_request_error of this PCIeErrorReporting.  # noqa: E501

        This is the flag of Unsupported Request Error reporting.  # noqa: E501

        :return: The unsupported_request_error of this PCIeErrorReporting.  # noqa: E501
        :rtype: bool
        """
        return self._unsupported_request_error

    @unsupported_request_error.setter
    def unsupported_request_error(self, unsupported_request_error):
        """Sets the unsupported_request_error of this PCIeErrorReporting.

        This is the flag of Unsupported Request Error reporting.  # noqa: E501

        :param unsupported_request_error: The unsupported_request_error of this PCIeErrorReporting.  # noqa: E501
        :type: bool
        """
        if unsupported_request_error is None:
            raise ValueError("Invalid value for `unsupported_request_error`, must not be `None`")  # noqa: E501

        self._unsupported_request_error = unsupported_request_error

    @property
    def capability_control(self):
        """Gets the capability_control of this PCIeErrorReporting.  # noqa: E501

        A read from hardware register.  # noqa: E501

        :return: The capability_control of this PCIeErrorReporting.  # noqa: E501
        :rtype: str
        """
        return self._capability_control

    @capability_control.setter
    def capability_control(self, capability_control):
        """Sets the capability_control of this PCIeErrorReporting.

        A read from hardware register.  # noqa: E501

        :param capability_control: The capability_control of this PCIeErrorReporting.  # noqa: E501
        :type: str
        """
        if capability_control is None:
            raise ValueError("Invalid value for `capability_control`, must not be `None`")  # noqa: E501

        self._capability_control = capability_control

    @property
    def correctable_error_mask(self):
        """Gets the correctable_error_mask of this PCIeErrorReporting.  # noqa: E501

        A read from hardware register.  # noqa: E501

        :return: The correctable_error_mask of this PCIeErrorReporting.  # noqa: E501
        :rtype: str
        """
        return self._correctable_error_mask

    @correctable_error_mask.setter
    def correctable_error_mask(self, correctable_error_mask):
        """Sets the correctable_error_mask of this PCIeErrorReporting.

        A read from hardware register.  # noqa: E501

        :param correctable_error_mask: The correctable_error_mask of this PCIeErrorReporting.  # noqa: E501
        :type: str
        """
        if correctable_error_mask is None:
            raise ValueError("Invalid value for `correctable_error_mask`, must not be `None`")  # noqa: E501

        self._correctable_error_mask = correctable_error_mask

    @property
    def correctable_error_status(self):
        """Gets the correctable_error_status of this PCIeErrorReporting.  # noqa: E501

        A read from hardware register.  # noqa: E501

        :return: The correctable_error_status of this PCIeErrorReporting.  # noqa: E501
        :rtype: str
        """
        return self._correctable_error_status

    @correctable_error_status.setter
    def correctable_error_status(self, correctable_error_status):
        """Sets the correctable_error_status of this PCIeErrorReporting.

        A read from hardware register.  # noqa: E501

        :param correctable_error_status: The correctable_error_status of this PCIeErrorReporting.  # noqa: E501
        :type: str
        """
        if correctable_error_status is None:
            raise ValueError("Invalid value for `correctable_error_status`, must not be `None`")  # noqa: E501

        self._correctable_error_status = correctable_error_status

    @property
    def uncorrectable_error_severity(self):
        """Gets the uncorrectable_error_severity of this PCIeErrorReporting.  # noqa: E501

        A read from hardware register.  # noqa: E501

        :return: The uncorrectable_error_severity of this PCIeErrorReporting.  # noqa: E501
        :rtype: str
        """
        return self._uncorrectable_error_severity

    @uncorrectable_error_severity.setter
    def uncorrectable_error_severity(self, uncorrectable_error_severity):
        """Sets the uncorrectable_error_severity of this PCIeErrorReporting.

        A read from hardware register.  # noqa: E501

        :param uncorrectable_error_severity: The uncorrectable_error_severity of this PCIeErrorReporting.  # noqa: E501
        :type: str
        """
        if uncorrectable_error_severity is None:
            raise ValueError("Invalid value for `uncorrectable_error_severity`, must not be `None`")  # noqa: E501

        self._uncorrectable_error_severity = uncorrectable_error_severity

    @property
    def uncorrectable_error_status(self):
        """Gets the uncorrectable_error_status of this PCIeErrorReporting.  # noqa: E501

        A read from hardware register.  # noqa: E501

        :return: The uncorrectable_error_status of this PCIeErrorReporting.  # noqa: E501
        :rtype: str
        """
        return self._uncorrectable_error_status

    @uncorrectable_error_status.setter
    def uncorrectable_error_status(self, uncorrectable_error_status):
        """Sets the uncorrectable_error_status of this PCIeErrorReporting.

        A read from hardware register.  # noqa: E501

        :param uncorrectable_error_status: The uncorrectable_error_status of this PCIeErrorReporting.  # noqa: E501
        :type: str
        """
        if uncorrectable_error_status is None:
            raise ValueError("Invalid value for `uncorrectable_error_status`, must not be `None`")  # noqa: E501

        self._uncorrectable_error_status = uncorrectable_error_status

    @property
    def uncorrectable_error_mask(self):
        """Gets the uncorrectable_error_mask of this PCIeErrorReporting.  # noqa: E501

        A read from hardware register.  # noqa: E501

        :return: The uncorrectable_error_mask of this PCIeErrorReporting.  # noqa: E501
        :rtype: str
        """
        return self._uncorrectable_error_mask

    @uncorrectable_error_mask.setter
    def uncorrectable_error_mask(self, uncorrectable_error_mask):
        """Sets the uncorrectable_error_mask of this PCIeErrorReporting.

        A read from hardware register.  # noqa: E501

        :param uncorrectable_error_mask: The uncorrectable_error_mask of this PCIeErrorReporting.  # noqa: E501
        :type: str
        """
        if uncorrectable_error_mask is None:
            raise ValueError("Invalid value for `uncorrectable_error_mask`, must not be `None`")  # noqa: E501

        self._uncorrectable_error_mask = uncorrectable_error_mask

    @property
    def device_correctable_error(self):
        """Gets the device_correctable_error of this PCIeErrorReporting.  # noqa: E501

        A read from hardware register.  # noqa: E501

        :return: The device_correctable_error of this PCIeErrorReporting.  # noqa: E501
        :rtype: bool
        """
        return self._device_correctable_error

    @device_correctable_error.setter
    def device_correctable_error(self, device_correctable_error):
        """Sets the device_correctable_error of this PCIeErrorReporting.

        A read from hardware register.  # noqa: E501

        :param device_correctable_error: The device_correctable_error of this PCIeErrorReporting.  # noqa: E501
        :type: bool
        """
        if device_correctable_error is None:
            raise ValueError("Invalid value for `device_correctable_error`, must not be `None`")  # noqa: E501

        self._device_correctable_error = device_correctable_error

    @property
    def device_non_fatal_error(self):
        """Gets the device_non_fatal_error of this PCIeErrorReporting.  # noqa: E501

        A read from hardware register.  # noqa: E501

        :return: The device_non_fatal_error of this PCIeErrorReporting.  # noqa: E501
        :rtype: bool
        """
        return self._device_non_fatal_error

    @device_non_fatal_error.setter
    def device_non_fatal_error(self, device_non_fatal_error):
        """Sets the device_non_fatal_error of this PCIeErrorReporting.

        A read from hardware register.  # noqa: E501

        :param device_non_fatal_error: The device_non_fatal_error of this PCIeErrorReporting.  # noqa: E501
        :type: bool
        """
        if device_non_fatal_error is None:
            raise ValueError("Invalid value for `device_non_fatal_error`, must not be `None`")  # noqa: E501

        self._device_non_fatal_error = device_non_fatal_error

    @property
    def device_fatal_error(self):
        """Gets the device_fatal_error of this PCIeErrorReporting.  # noqa: E501

        A read from hardware register.  # noqa: E501

        :return: The device_fatal_error of this PCIeErrorReporting.  # noqa: E501
        :rtype: bool
        """
        return self._device_fatal_error

    @device_fatal_error.setter
    def device_fatal_error(self, device_fatal_error):
        """Sets the device_fatal_error of this PCIeErrorReporting.

        A read from hardware register.  # noqa: E501

        :param device_fatal_error: The device_fatal_error of this PCIeErrorReporting.  # noqa: E501
        :type: bool
        """
        if device_fatal_error is None:
            raise ValueError("Invalid value for `device_fatal_error`, must not be `None`")  # noqa: E501

        self._device_fatal_error = device_fatal_error

    @property
    def device_unsupported_request_error(self):
        """Gets the device_unsupported_request_error of this PCIeErrorReporting.  # noqa: E501

        A read from hardware register.  # noqa: E501

        :return: The device_unsupported_request_error of this PCIeErrorReporting.  # noqa: E501
        :rtype: bool
        """
        return self._device_unsupported_request_error

    @device_unsupported_request_error.setter
    def device_unsupported_request_error(self, device_unsupported_request_error):
        """Sets the device_unsupported_request_error of this PCIeErrorReporting.

        A read from hardware register.  # noqa: E501

        :param device_unsupported_request_error: The device_unsupported_request_error of this PCIeErrorReporting.  # noqa: E501
        :type: bool
        """
        if device_unsupported_request_error is None:
            raise ValueError("Invalid value for `device_unsupported_request_error`, must not be `None`")  # noqa: E501

        self._device_unsupported_request_error = device_unsupported_request_error

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PCIeErrorReporting):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
