# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PCIeErrors(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_type': 'str',
        'error_count': 'int',
        'error_list': 'list[PCIeError]'
    }

    attribute_map = {
        'odata_type': '@odata.type',
        'error_count': 'ErrorCount',
        'error_list': 'ErrorList'
    }

    def __init__(self, odata_type=None, error_count=None, error_list=None):  # noqa: E501
        """PCIeErrors - a model defined in OpenAPI"""  # noqa: E501

        self._odata_type = None
        self._error_count = None
        self._error_list = None
        self.discriminator = None

        self.odata_type = odata_type
        self.error_count = error_count
        self.error_list = error_list

    @property
    def odata_type(self):
        """Gets the odata_type of this PCIeErrors.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this PCIeErrors.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this PCIeErrors.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this PCIeErrors.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def error_count(self):
        """Gets the error_count of this PCIeErrors.  # noqa: E501

        Number of PCIe errors.  # noqa: E501

        :return: The error_count of this PCIeErrors.  # noqa: E501
        :rtype: int
        """
        return self._error_count

    @error_count.setter
    def error_count(self, error_count):
        """Sets the error_count of this PCIeErrors.

        Number of PCIe errors.  # noqa: E501

        :param error_count: The error_count of this PCIeErrors.  # noqa: E501
        :type: int
        """
        if error_count is None:
            raise ValueError("Invalid value for `error_count`, must not be `None`")  # noqa: E501

        self._error_count = error_count

    @property
    def error_list(self):
        """Gets the error_list of this PCIeErrors.  # noqa: E501

        A list of errors.  # noqa: E501

        :return: The error_list of this PCIeErrors.  # noqa: E501
        :rtype: list[PCIeError]
        """
        return self._error_list

    @error_list.setter
    def error_list(self, error_list):
        """Sets the error_list of this PCIeErrors.

        A list of errors.  # noqa: E501

        :param error_list: The error_list of this PCIeErrors.  # noqa: E501
        :type: list[PCIeError]
        """
        if error_list is None:
            raise ValueError("Invalid value for `error_list`, must not be `None`")  # noqa: E501

        self._error_list = error_list

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PCIeErrors):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
