# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PCIeInf(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'device_type': 'str',
        'is_accessible': 'bool',
        'lanes_in_use': 'int',
        'max_lanes': 'int',
        'max_pc_ie_type': 'str',
        'pc_ie_type': 'str',
        'current_speed': 'int',
        'current_width': 'int',
        'expected_lanes': 'int',
        'expected_speed': 'int',
        'parent_child': 'PCIeParentChildInf',
        'slot': 'PCIeSlot',
        'pc_ie_device_id': 'PCIeDeviceID',
        'performance_state': 'int'
    }

    attribute_map = {
        'device_type': 'DeviceType',
        'is_accessible': 'IsAccessible',
        'lanes_in_use': 'LanesInUse',
        'max_lanes': 'MaxLanes',
        'max_pc_ie_type': 'MaxPCIeType',
        'pc_ie_type': 'PCIeType',
        'current_speed': 'CurrentSpeed',
        'current_width': 'CurrentWidth',
        'expected_lanes': 'ExpectedLanes',
        'expected_speed': 'ExpectedSpeed',
        'parent_child': 'ParentChild',
        'slot': 'Slot',
        'pc_ie_device_id': 'PCIeDeviceID',
        'performance_state': 'PerformanceState'
    }

    def __init__(self, device_type=None, is_accessible=None, lanes_in_use=None, max_lanes=None, max_pc_ie_type=None, pc_ie_type=None, current_speed=None, current_width=None, expected_lanes=None, expected_speed=None, parent_child=None, slot=None, pc_ie_device_id=None, performance_state=None):  # noqa: E501
        """PCIeInf - a model defined in OpenAPI"""  # noqa: E501

        self._device_type = None
        self._is_accessible = None
        self._lanes_in_use = None
        self._max_lanes = None
        self._max_pc_ie_type = None
        self._pc_ie_type = None
        self._current_speed = None
        self._current_width = None
        self._expected_lanes = None
        self._expected_speed = None
        self._parent_child = None
        self._slot = None
        self._pc_ie_device_id = None
        self._performance_state = None
        self.discriminator = None

        self.device_type = device_type
        self.is_accessible = is_accessible
        self.lanes_in_use = lanes_in_use
        self.max_lanes = max_lanes
        self.max_pc_ie_type = max_pc_ie_type
        self.pc_ie_type = pc_ie_type
        self.current_speed = current_speed
        self.current_width = current_width
        self.expected_lanes = expected_lanes
        self.expected_speed = expected_speed
        self.parent_child = parent_child
        self.slot = slot
        if pc_ie_device_id is not None:
            self.pc_ie_device_id = pc_ie_device_id
        if performance_state is not None:
            self.performance_state = performance_state

    @property
    def device_type(self):
        """Gets the device_type of this PCIeInf.  # noqa: E501

        This is device type.  # noqa: E501

        :return: The device_type of this PCIeInf.  # noqa: E501
        :rtype: str
        """
        return self._device_type

    @device_type.setter
    def device_type(self, device_type):
        """Sets the device_type of this PCIeInf.

        This is device type.  # noqa: E501

        :param device_type: The device_type of this PCIeInf.  # noqa: E501
        :type: str
        """
        if device_type is None:
            raise ValueError("Invalid value for `device_type`, must not be `None`")  # noqa: E501

        self._device_type = device_type

    @property
    def is_accessible(self):
        """Gets the is_accessible of this PCIeInf.  # noqa: E501

        This is device flag showing if the device is accessible via PCIe bus.  # noqa: E501

        :return: The is_accessible of this PCIeInf.  # noqa: E501
        :rtype: bool
        """
        return self._is_accessible

    @is_accessible.setter
    def is_accessible(self, is_accessible):
        """Sets the is_accessible of this PCIeInf.

        This is device flag showing if the device is accessible via PCIe bus.  # noqa: E501

        :param is_accessible: The is_accessible of this PCIeInf.  # noqa: E501
        :type: bool
        """
        if is_accessible is None:
            raise ValueError("Invalid value for `is_accessible`, must not be `None`")  # noqa: E501

        self._is_accessible = is_accessible

    @property
    def lanes_in_use(self):
        """Gets the lanes_in_use of this PCIeInf.  # noqa: E501

        This is the number of PCIe lanes in use by this device.  # noqa: E501

        :return: The lanes_in_use of this PCIeInf.  # noqa: E501
        :rtype: int
        """
        return self._lanes_in_use

    @lanes_in_use.setter
    def lanes_in_use(self, lanes_in_use):
        """Sets the lanes_in_use of this PCIeInf.

        This is the number of PCIe lanes in use by this device.  # noqa: E501

        :param lanes_in_use: The lanes_in_use of this PCIeInf.  # noqa: E501
        :type: int
        """
        if lanes_in_use is None:
            raise ValueError("Invalid value for `lanes_in_use`, must not be `None`")  # noqa: E501

        self._lanes_in_use = lanes_in_use

    @property
    def max_lanes(self):
        """Gets the max_lanes of this PCIeInf.  # noqa: E501

        This is the number of PCIe lanes supported by this device.  # noqa: E501

        :return: The max_lanes of this PCIeInf.  # noqa: E501
        :rtype: int
        """
        return self._max_lanes

    @max_lanes.setter
    def max_lanes(self, max_lanes):
        """Sets the max_lanes of this PCIeInf.

        This is the number of PCIe lanes supported by this device.  # noqa: E501

        :param max_lanes: The max_lanes of this PCIeInf.  # noqa: E501
        :type: int
        """
        if max_lanes is None:
            raise ValueError("Invalid value for `max_lanes`, must not be `None`")  # noqa: E501

        self._max_lanes = max_lanes

    @property
    def max_pc_ie_type(self):
        """Gets the max_pc_ie_type of this PCIeInf.  # noqa: E501

        The highest version of the PCIe specification supported by this device.  # noqa: E501

        :return: The max_pc_ie_type of this PCIeInf.  # noqa: E501
        :rtype: str
        """
        return self._max_pc_ie_type

    @max_pc_ie_type.setter
    def max_pc_ie_type(self, max_pc_ie_type):
        """Sets the max_pc_ie_type of this PCIeInf.

        The highest version of the PCIe specification supported by this device.  # noqa: E501

        :param max_pc_ie_type: The max_pc_ie_type of this PCIeInf.  # noqa: E501
        :type: str
        """
        if max_pc_ie_type is None:
            raise ValueError("Invalid value for `max_pc_ie_type`, must not be `None`")  # noqa: E501

        self._max_pc_ie_type = max_pc_ie_type

    @property
    def pc_ie_type(self):
        """Gets the pc_ie_type of this PCIeInf.  # noqa: E501

        The version of the PCIe specification in use by this device.  # noqa: E501

        :return: The pc_ie_type of this PCIeInf.  # noqa: E501
        :rtype: str
        """
        return self._pc_ie_type

    @pc_ie_type.setter
    def pc_ie_type(self, pc_ie_type):
        """Sets the pc_ie_type of this PCIeInf.

        The version of the PCIe specification in use by this device.  # noqa: E501

        :param pc_ie_type: The pc_ie_type of this PCIeInf.  # noqa: E501
        :type: str
        """
        if pc_ie_type is None:
            raise ValueError("Invalid value for `pc_ie_type`, must not be `None`")  # noqa: E501

        self._pc_ie_type = pc_ie_type

    @property
    def current_speed(self):
        """Gets the current_speed of this PCIeInf.  # noqa: E501

        This is the current speed running in the PCIe lanes.  # noqa: E501

        :return: The current_speed of this PCIeInf.  # noqa: E501
        :rtype: int
        """
        return self._current_speed

    @current_speed.setter
    def current_speed(self, current_speed):
        """Sets the current_speed of this PCIeInf.

        This is the current speed running in the PCIe lanes.  # noqa: E501

        :param current_speed: The current_speed of this PCIeInf.  # noqa: E501
        :type: int
        """
        if current_speed is None:
            raise ValueError("Invalid value for `current_speed`, must not be `None`")  # noqa: E501

        self._current_speed = current_speed

    @property
    def current_width(self):
        """Gets the current_width of this PCIeInf.  # noqa: E501

        This is the current width used in the PCIe lanes.  # noqa: E501

        :return: The current_width of this PCIeInf.  # noqa: E501
        :rtype: int
        """
        return self._current_width

    @current_width.setter
    def current_width(self, current_width):
        """Sets the current_width of this PCIeInf.

        This is the current width used in the PCIe lanes.  # noqa: E501

        :param current_width: The current_width of this PCIeInf.  # noqa: E501
        :type: int
        """
        if current_width is None:
            raise ValueError("Invalid value for `current_width`, must not be `None`")  # noqa: E501

        self._current_width = current_width

    @property
    def expected_lanes(self):
        """Gets the expected_lanes of this PCIeInf.  # noqa: E501

        The expected number of PCIe lanes.  # noqa: E501

        :return: The expected_lanes of this PCIeInf.  # noqa: E501
        :rtype: int
        """
        return self._expected_lanes

    @expected_lanes.setter
    def expected_lanes(self, expected_lanes):
        """Sets the expected_lanes of this PCIeInf.

        The expected number of PCIe lanes.  # noqa: E501

        :param expected_lanes: The expected_lanes of this PCIeInf.  # noqa: E501
        :type: int
        """
        if expected_lanes is None:
            raise ValueError("Invalid value for `expected_lanes`, must not be `None`")  # noqa: E501

        self._expected_lanes = expected_lanes

    @property
    def expected_speed(self):
        """Gets the expected_speed of this PCIeInf.  # noqa: E501

        The expected speed of PCIe lanes.  # noqa: E501

        :return: The expected_speed of this PCIeInf.  # noqa: E501
        :rtype: int
        """
        return self._expected_speed

    @expected_speed.setter
    def expected_speed(self, expected_speed):
        """Sets the expected_speed of this PCIeInf.

        The expected speed of PCIe lanes.  # noqa: E501

        :param expected_speed: The expected_speed of this PCIeInf.  # noqa: E501
        :type: int
        """
        if expected_speed is None:
            raise ValueError("Invalid value for `expected_speed`, must not be `None`")  # noqa: E501

        self._expected_speed = expected_speed

    @property
    def parent_child(self):
        """Gets the parent_child of this PCIeInf.  # noqa: E501


        :return: The parent_child of this PCIeInf.  # noqa: E501
        :rtype: PCIeParentChildInf
        """
        return self._parent_child

    @parent_child.setter
    def parent_child(self, parent_child):
        """Sets the parent_child of this PCIeInf.


        :param parent_child: The parent_child of this PCIeInf.  # noqa: E501
        :type: PCIeParentChildInf
        """
        if parent_child is None:
            raise ValueError("Invalid value for `parent_child`, must not be `None`")  # noqa: E501

        self._parent_child = parent_child

    @property
    def slot(self):
        """Gets the slot of this PCIeInf.  # noqa: E501


        :return: The slot of this PCIeInf.  # noqa: E501
        :rtype: PCIeSlot
        """
        return self._slot

    @slot.setter
    def slot(self, slot):
        """Sets the slot of this PCIeInf.


        :param slot: The slot of this PCIeInf.  # noqa: E501
        :type: PCIeSlot
        """
        if slot is None:
            raise ValueError("Invalid value for `slot`, must not be `None`")  # noqa: E501

        self._slot = slot

    @property
    def pc_ie_device_id(self):
        """Gets the pc_ie_device_id of this PCIeInf.  # noqa: E501


        :return: The pc_ie_device_id of this PCIeInf.  # noqa: E501
        :rtype: PCIeDeviceID
        """
        return self._pc_ie_device_id

    @pc_ie_device_id.setter
    def pc_ie_device_id(self, pc_ie_device_id):
        """Sets the pc_ie_device_id of this PCIeInf.


        :param pc_ie_device_id: The pc_ie_device_id of this PCIeInf.  # noqa: E501
        :type: PCIeDeviceID
        """

        self._pc_ie_device_id = pc_ie_device_id

    @property
    def performance_state(self):
        """Gets the performance_state of this PCIeInf.  # noqa: E501

        GPU Performance State  # noqa: E501

        :return: The performance_state of this PCIeInf.  # noqa: E501
        :rtype: int
        """
        return self._performance_state

    @performance_state.setter
    def performance_state(self, performance_state):
        """Sets the performance_state of this PCIeInf.

        GPU Performance State  # noqa: E501

        :param performance_state: The performance_state of this PCIeInf.  # noqa: E501
        :type: int
        """

        self._performance_state = performance_state

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PCIeInf):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
