# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PCIeInterface(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'lanes_in_use': 'int',
        'max_lanes': 'int',
        'max_pc_ie_type': 'PCIeTypes',
        'oem': 'dict(str, object)',
        'pc_ie_type': 'PCIeTypes'
    }

    attribute_map = {
        'lanes_in_use': 'LanesInUse',
        'max_lanes': 'MaxLanes',
        'max_pc_ie_type': 'MaxPCIeType',
        'oem': 'Oem',
        'pc_ie_type': 'PCIeType'
    }

    def __init__(self, lanes_in_use=None, max_lanes=None, max_pc_ie_type=None, oem=None, pc_ie_type=None):  # noqa: E501
        """PCIeInterface - a model defined in OpenAPI"""  # noqa: E501

        self._lanes_in_use = None
        self._max_lanes = None
        self._max_pc_ie_type = None
        self._oem = None
        self._pc_ie_type = None
        self.discriminator = None

        self.lanes_in_use = lanes_in_use
        self.max_lanes = max_lanes
        if max_pc_ie_type is not None:
            self.max_pc_ie_type = max_pc_ie_type
        if oem is not None:
            self.oem = oem
        if pc_ie_type is not None:
            self.pc_ie_type = pc_ie_type

    @property
    def lanes_in_use(self):
        """Gets the lanes_in_use of this PCIeInterface.  # noqa: E501

        The number of PCIe lanes in use by this device.  # noqa: E501

        :return: The lanes_in_use of this PCIeInterface.  # noqa: E501
        :rtype: int
        """
        return self._lanes_in_use

    @lanes_in_use.setter
    def lanes_in_use(self, lanes_in_use):
        """Sets the lanes_in_use of this PCIeInterface.

        The number of PCIe lanes in use by this device.  # noqa: E501

        :param lanes_in_use: The lanes_in_use of this PCIeInterface.  # noqa: E501
        :type: int
        """
        if lanes_in_use is not None and lanes_in_use > 32:  # noqa: E501
            raise ValueError("Invalid value for `lanes_in_use`, must be a value less than or equal to `32`")  # noqa: E501

        self._lanes_in_use = lanes_in_use

    @property
    def max_lanes(self):
        """Gets the max_lanes of this PCIeInterface.  # noqa: E501

        The number of PCIe lanes supported by this device.  # noqa: E501

        :return: The max_lanes of this PCIeInterface.  # noqa: E501
        :rtype: int
        """
        return self._max_lanes

    @max_lanes.setter
    def max_lanes(self, max_lanes):
        """Sets the max_lanes of this PCIeInterface.

        The number of PCIe lanes supported by this device.  # noqa: E501

        :param max_lanes: The max_lanes of this PCIeInterface.  # noqa: E501
        :type: int
        """
        if max_lanes is not None and max_lanes > 32:  # noqa: E501
            raise ValueError("Invalid value for `max_lanes`, must be a value less than or equal to `32`")  # noqa: E501

        self._max_lanes = max_lanes

    @property
    def max_pc_ie_type(self):
        """Gets the max_pc_ie_type of this PCIeInterface.  # noqa: E501


        :return: The max_pc_ie_type of this PCIeInterface.  # noqa: E501
        :rtype: PCIeTypes
        """
        return self._max_pc_ie_type

    @max_pc_ie_type.setter
    def max_pc_ie_type(self, max_pc_ie_type):
        """Sets the max_pc_ie_type of this PCIeInterface.


        :param max_pc_ie_type: The max_pc_ie_type of this PCIeInterface.  # noqa: E501
        :type: PCIeTypes
        """

        self._max_pc_ie_type = max_pc_ie_type

    @property
    def oem(self):
        """Gets the oem of this PCIeInterface.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this PCIeInterface.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this PCIeInterface.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this PCIeInterface.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def pc_ie_type(self):
        """Gets the pc_ie_type of this PCIeInterface.  # noqa: E501


        :return: The pc_ie_type of this PCIeInterface.  # noqa: E501
        :rtype: PCIeTypes
        """
        return self._pc_ie_type

    @pc_ie_type.setter
    def pc_ie_type(self, pc_ie_type):
        """Sets the pc_ie_type of this PCIeInterface.


        :param pc_ie_type: The pc_ie_type of this PCIeInterface.  # noqa: E501
        :type: PCIeTypes
        """

        self._pc_ie_type = pc_ie_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PCIeInterface):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
