# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PCIeParentChildInf(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_id': 'str',
        'odata_type': 'str',
        'bdf': 'str',
        'device_type': 'str',
        'max_lanes': 'int',
        'max_pc_ie_type': 'str',
        'performance_state': 'int'
    }

    attribute_map = {
        'odata_id': '@odata.id',
        'odata_type': '@odata.type',
        'bdf': 'BDF',
        'device_type': 'DeviceType',
        'max_lanes': 'MaxLanes',
        'max_pc_ie_type': 'MaxPCIeType',
        'performance_state': 'PerformanceState'
    }

    def __init__(self, odata_id=None, odata_type=None, bdf=None, device_type=None, max_lanes=None, max_pc_ie_type=None, performance_state=None):  # noqa: E501
        """PCIeParentChildInf - a model defined in OpenAPI"""  # noqa: E501

        self._odata_id = None
        self._odata_type = None
        self._bdf = None
        self._device_type = None
        self._max_lanes = None
        self._max_pc_ie_type = None
        self._performance_state = None
        self.discriminator = None

        self.odata_id = odata_id
        if odata_type is not None:
            self.odata_type = odata_type
        self.bdf = bdf
        self.device_type = device_type
        self.max_lanes = max_lanes
        self.max_pc_ie_type = max_pc_ie_type
        if performance_state is not None:
            self.performance_state = performance_state

    @property
    def odata_id(self):
        """Gets the odata_id of this PCIeParentChildInf.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this PCIeParentChildInf.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this PCIeParentChildInf.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this PCIeParentChildInf.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def odata_type(self):
        """Gets the odata_type of this PCIeParentChildInf.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this PCIeParentChildInf.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this PCIeParentChildInf.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this PCIeParentChildInf.  # noqa: E501
        :type: str
        """

        self._odata_type = odata_type

    @property
    def bdf(self):
        """Gets the bdf of this PCIeParentChildInf.  # noqa: E501

        PCIe BusDeviceFunc address.  # noqa: E501

        :return: The bdf of this PCIeParentChildInf.  # noqa: E501
        :rtype: str
        """
        return self._bdf

    @bdf.setter
    def bdf(self, bdf):
        """Sets the bdf of this PCIeParentChildInf.

        PCIe BusDeviceFunc address.  # noqa: E501

        :param bdf: The bdf of this PCIeParentChildInf.  # noqa: E501
        :type: str
        """
        if bdf is None:
            raise ValueError("Invalid value for `bdf`, must not be `None`")  # noqa: E501

        self._bdf = bdf

    @property
    def device_type(self):
        """Gets the device_type of this PCIeParentChildInf.  # noqa: E501

        This is device type.  # noqa: E501

        :return: The device_type of this PCIeParentChildInf.  # noqa: E501
        :rtype: str
        """
        return self._device_type

    @device_type.setter
    def device_type(self, device_type):
        """Sets the device_type of this PCIeParentChildInf.

        This is device type.  # noqa: E501

        :param device_type: The device_type of this PCIeParentChildInf.  # noqa: E501
        :type: str
        """
        if device_type is None:
            raise ValueError("Invalid value for `device_type`, must not be `None`")  # noqa: E501

        self._device_type = device_type

    @property
    def max_lanes(self):
        """Gets the max_lanes of this PCIeParentChildInf.  # noqa: E501

        This is the number of PCIe lanes supported by this device.  # noqa: E501

        :return: The max_lanes of this PCIeParentChildInf.  # noqa: E501
        :rtype: int
        """
        return self._max_lanes

    @max_lanes.setter
    def max_lanes(self, max_lanes):
        """Sets the max_lanes of this PCIeParentChildInf.

        This is the number of PCIe lanes supported by this device.  # noqa: E501

        :param max_lanes: The max_lanes of this PCIeParentChildInf.  # noqa: E501
        :type: int
        """
        if max_lanes is None:
            raise ValueError("Invalid value for `max_lanes`, must not be `None`")  # noqa: E501

        self._max_lanes = max_lanes

    @property
    def max_pc_ie_type(self):
        """Gets the max_pc_ie_type of this PCIeParentChildInf.  # noqa: E501

        The highest version of the PCIe specification supported by this device.  # noqa: E501

        :return: The max_pc_ie_type of this PCIeParentChildInf.  # noqa: E501
        :rtype: str
        """
        return self._max_pc_ie_type

    @max_pc_ie_type.setter
    def max_pc_ie_type(self, max_pc_ie_type):
        """Sets the max_pc_ie_type of this PCIeParentChildInf.

        The highest version of the PCIe specification supported by this device.  # noqa: E501

        :param max_pc_ie_type: The max_pc_ie_type of this PCIeParentChildInf.  # noqa: E501
        :type: str
        """
        if max_pc_ie_type is None:
            raise ValueError("Invalid value for `max_pc_ie_type`, must not be `None`")  # noqa: E501

        self._max_pc_ie_type = max_pc_ie_type

    @property
    def performance_state(self):
        """Gets the performance_state of this PCIeParentChildInf.  # noqa: E501

        GPU Performance State  # noqa: E501

        :return: The performance_state of this PCIeParentChildInf.  # noqa: E501
        :rtype: int
        """
        return self._performance_state

    @performance_state.setter
    def performance_state(self, performance_state):
        """Sets the performance_state of this PCIeParentChildInf.

        GPU Performance State  # noqa: E501

        :param performance_state: The performance_state of this PCIeParentChildInf.  # noqa: E501
        :type: int
        """

        self._performance_state = performance_state

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PCIeParentChildInf):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
