# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PCIeSlot(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'hot_plug_supported': 'bool',
        'presence': 'bool',
        'slot_number': 'int'
    }

    attribute_map = {
        'hot_plug_supported': 'HotPlugSupported',
        'presence': 'Presence',
        'slot_number': 'SlotNumber'
    }

    def __init__(self, hot_plug_supported=None, presence=None, slot_number=None):  # noqa: E501
        """PCIeSlot - a model defined in OpenAPI"""  # noqa: E501

        self._hot_plug_supported = None
        self._presence = None
        self._slot_number = None
        self.discriminator = None

        self.hot_plug_supported = hot_plug_supported
        self.presence = presence
        if slot_number is not None:
            self.slot_number = slot_number

    @property
    def hot_plug_supported(self):
        """Gets the hot_plug_supported of this PCIeSlot.  # noqa: E501

        This is the flag of Hot Plug supported.  # noqa: E501

        :return: The hot_plug_supported of this PCIeSlot.  # noqa: E501
        :rtype: bool
        """
        return self._hot_plug_supported

    @hot_plug_supported.setter
    def hot_plug_supported(self, hot_plug_supported):
        """Sets the hot_plug_supported of this PCIeSlot.

        This is the flag of Hot Plug supported.  # noqa: E501

        :param hot_plug_supported: The hot_plug_supported of this PCIeSlot.  # noqa: E501
        :type: bool
        """
        if hot_plug_supported is None:
            raise ValueError("Invalid value for `hot_plug_supported`, must not be `None`")  # noqa: E501

        self._hot_plug_supported = hot_plug_supported

    @property
    def presence(self):
        """Gets the presence of this PCIeSlot.  # noqa: E501

        This is the flag of Presence Detected.  # noqa: E501

        :return: The presence of this PCIeSlot.  # noqa: E501
        :rtype: bool
        """
        return self._presence

    @presence.setter
    def presence(self, presence):
        """Sets the presence of this PCIeSlot.

        This is the flag of Presence Detected.  # noqa: E501

        :param presence: The presence of this PCIeSlot.  # noqa: E501
        :type: bool
        """
        if presence is None:
            raise ValueError("Invalid value for `presence`, must not be `None`")  # noqa: E501

        self._presence = presence

    @property
    def slot_number(self):
        """Gets the slot_number of this PCIeSlot.  # noqa: E501

        This is the Slot Number of the port supported.  # noqa: E501

        :return: The slot_number of this PCIeSlot.  # noqa: E501
        :rtype: int
        """
        return self._slot_number

    @slot_number.setter
    def slot_number(self, slot_number):
        """Sets the slot_number of this PCIeSlot.

        This is the Slot Number of the port supported.  # noqa: E501

        :param slot_number: The slot_number of this PCIeSlot.  # noqa: E501
        :type: int
        """

        self._slot_number = slot_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PCIeSlot):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
