# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PCIeSystemJSON(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_context': 'str',
        'odata_id': 'str',
        'odata_type': 'str',
        'members': 'list[PCIeMemberjson]',
        'membersodata_count': 'int',
        'name': 'str',
        'pc_ie_count': 'int'
    }

    attribute_map = {
        'odata_context': '@odata.context',
        'odata_id': '@odata.id',
        'odata_type': '@odata.type',
        'members': 'Members',
        'membersodata_count': 'Members@odata.count',
        'name': 'Name',
        'pc_ie_count': 'PCIeCount'
    }

    def __init__(self, odata_context=None, odata_id=None, odata_type=None, members=None, membersodata_count=None, name=None, pc_ie_count=None):  # noqa: E501
        """PCIeSystemJSON - a model defined in OpenAPI"""  # noqa: E501

        self._odata_context = None
        self._odata_id = None
        self._odata_type = None
        self._members = None
        self._membersodata_count = None
        self._name = None
        self._pc_ie_count = None
        self.discriminator = None

        self.odata_context = odata_context
        self.odata_id = odata_id
        self.odata_type = odata_type
        self.members = members
        self.membersodata_count = membersodata_count
        self.name = name
        self.pc_ie_count = pc_ie_count

    @property
    def odata_context(self):
        """Gets the odata_context of this PCIeSystemJSON.  # noqa: E501

        The OData description of a payload.  # noqa: E501

        :return: The odata_context of this PCIeSystemJSON.  # noqa: E501
        :rtype: str
        """
        return self._odata_context

    @odata_context.setter
    def odata_context(self, odata_context):
        """Sets the odata_context of this PCIeSystemJSON.

        The OData description of a payload.  # noqa: E501

        :param odata_context: The odata_context of this PCIeSystemJSON.  # noqa: E501
        :type: str
        """
        if odata_context is None:
            raise ValueError("Invalid value for `odata_context`, must not be `None`")  # noqa: E501

        self._odata_context = odata_context

    @property
    def odata_id(self):
        """Gets the odata_id of this PCIeSystemJSON.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this PCIeSystemJSON.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this PCIeSystemJSON.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this PCIeSystemJSON.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def odata_type(self):
        """Gets the odata_type of this PCIeSystemJSON.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this PCIeSystemJSON.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this PCIeSystemJSON.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this PCIeSystemJSON.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def members(self):
        """Gets the members of this PCIeSystemJSON.  # noqa: E501

        Contains the members of this collection.  # noqa: E501

        :return: The members of this PCIeSystemJSON.  # noqa: E501
        :rtype: list[PCIeMemberjson]
        """
        return self._members

    @members.setter
    def members(self, members):
        """Sets the members of this PCIeSystemJSON.

        Contains the members of this collection.  # noqa: E501

        :param members: The members of this PCIeSystemJSON.  # noqa: E501
        :type: list[PCIeMemberjson]
        """
        if members is None:
            raise ValueError("Invalid value for `members`, must not be `None`")  # noqa: E501

        self._members = members

    @property
    def membersodata_count(self):
        """Gets the membersodata_count of this PCIeSystemJSON.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The membersodata_count of this PCIeSystemJSON.  # noqa: E501
        :rtype: int
        """
        return self._membersodata_count

    @membersodata_count.setter
    def membersodata_count(self, membersodata_count):
        """Sets the membersodata_count of this PCIeSystemJSON.

        The number of items in a collection.  # noqa: E501

        :param membersodata_count: The membersodata_count of this PCIeSystemJSON.  # noqa: E501
        :type: int
        """
        if membersodata_count is None:
            raise ValueError("Invalid value for `membersodata_count`, must not be `None`")  # noqa: E501

        self._membersodata_count = membersodata_count

    @property
    def name(self):
        """Gets the name of this PCIeSystemJSON.  # noqa: E501

        The name of the resource or array element.  # noqa: E501

        :return: The name of this PCIeSystemJSON.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PCIeSystemJSON.

        The name of the resource or array element.  # noqa: E501

        :param name: The name of this PCIeSystemJSON.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def pc_ie_count(self):
        """Gets the pc_ie_count of this PCIeSystemJSON.  # noqa: E501

        The number of PCIe devices in this platform.  # noqa: E501

        :return: The pc_ie_count of this PCIeSystemJSON.  # noqa: E501
        :rtype: int
        """
        return self._pc_ie_count

    @pc_ie_count.setter
    def pc_ie_count(self, pc_ie_count):
        """Sets the pc_ie_count of this PCIeSystemJSON.

        The number of PCIe devices in this platform.  # noqa: E501

        :param pc_ie_count: The pc_ie_count of this PCIeSystemJSON.  # noqa: E501
        :type: int
        """
        if pc_ie_count is None:
            raise ValueError("Invalid value for `pc_ie_count`, must not be `None`")  # noqa: E501

        self._pc_ie_count = pc_ie_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PCIeSystemJSON):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
