# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PlatformInventory(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'membersodata_count': 'int',
        'history_available_from': 'datetime',
        'summary': 'dict(str, list[PlatformInventoryEntry])',
        'details': 'dict(str, list[PlatformInventoryEntry])',
        'sample_entry': 'PlatformInventoryEntry'
    }

    attribute_map = {
        'membersodata_count': 'Members@odata.count',
        'history_available_from': 'HistoryAvailableFrom',
        'summary': 'Summary',
        'details': 'Details',
        'sample_entry': 'SampleEntry'
    }

    def __init__(self, membersodata_count=None, history_available_from=None, summary=None, details=None, sample_entry=None):  # noqa: E501
        """PlatformInventory - a model defined in OpenAPI"""  # noqa: E501

        self._membersodata_count = None
        self._history_available_from = None
        self._summary = None
        self._details = None
        self._sample_entry = None
        self.discriminator = None

        self.membersodata_count = membersodata_count
        self.history_available_from = history_available_from
        self.summary = summary
        self.details = details
        if sample_entry is not None:
            self.sample_entry = sample_entry

    @property
    def membersodata_count(self):
        """Gets the membersodata_count of this PlatformInventory.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The membersodata_count of this PlatformInventory.  # noqa: E501
        :rtype: int
        """
        return self._membersodata_count

    @membersodata_count.setter
    def membersodata_count(self, membersodata_count):
        """Sets the membersodata_count of this PlatformInventory.

        The number of items in a collection.  # noqa: E501

        :param membersodata_count: The membersodata_count of this PlatformInventory.  # noqa: E501
        :type: int
        """
        if membersodata_count is None:
            raise ValueError("Invalid value for `membersodata_count`, must not be `None`")  # noqa: E501

        self._membersodata_count = membersodata_count

    @property
    def history_available_from(self):
        """Gets the history_available_from of this PlatformInventory.  # noqa: E501

        Time when NVSM started tracking inventory on this system.  # noqa: E501

        :return: The history_available_from of this PlatformInventory.  # noqa: E501
        :rtype: datetime
        """
        return self._history_available_from

    @history_available_from.setter
    def history_available_from(self, history_available_from):
        """Sets the history_available_from of this PlatformInventory.

        Time when NVSM started tracking inventory on this system.  # noqa: E501

        :param history_available_from: The history_available_from of this PlatformInventory.  # noqa: E501
        :type: datetime
        """
        if history_available_from is None:
            raise ValueError("Invalid value for `history_available_from`, must not be `None`")  # noqa: E501

        self._history_available_from = history_available_from

    @property
    def summary(self):
        """Gets the summary of this PlatformInventory.  # noqa: E501

        Short summary showing history of components that ever populated this slot  # noqa: E501

        :return: The summary of this PlatformInventory.  # noqa: E501
        :rtype: dict(str, list[PlatformInventoryEntry])
        """
        return self._summary

    @summary.setter
    def summary(self, summary):
        """Sets the summary of this PlatformInventory.

        Short summary showing history of components that ever populated this slot  # noqa: E501

        :param summary: The summary of this PlatformInventory.  # noqa: E501
        :type: dict(str, list[PlatformInventoryEntry])
        """
        if summary is None:
            raise ValueError("Invalid value for `summary`, must not be `None`")  # noqa: E501

        self._summary = summary

    @property
    def details(self):
        """Gets the details of this PlatformInventory.  # noqa: E501

        Detailed history of components that ever populated this slot  # noqa: E501

        :return: The details of this PlatformInventory.  # noqa: E501
        :rtype: dict(str, list[PlatformInventoryEntry])
        """
        return self._details

    @details.setter
    def details(self, details):
        """Sets the details of this PlatformInventory.

        Detailed history of components that ever populated this slot  # noqa: E501

        :param details: The details of this PlatformInventory.  # noqa: E501
        :type: dict(str, list[PlatformInventoryEntry])
        """
        if details is None:
            raise ValueError("Invalid value for `details`, must not be `None`")  # noqa: E501

        self._details = details

    @property
    def sample_entry(self):
        """Gets the sample_entry of this PlatformInventory.  # noqa: E501


        :return: The sample_entry of this PlatformInventory.  # noqa: E501
        :rtype: PlatformInventoryEntry
        """
        return self._sample_entry

    @sample_entry.setter
    def sample_entry(self, sample_entry):
        """Sets the sample_entry of this PlatformInventory.


        :param sample_entry: The sample_entry of this PlatformInventory.  # noqa: E501
        :type: PlatformInventoryEntry
        """

        self._sample_entry = sample_entry

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PlatformInventory):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
