# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PlatformInventoryEntry(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'part_number': 'str',
        'serial_number': 'str',
        'first_seen_at': 'datetime',
        'last_seen_at': 'datetime',
        'last_known_details': 'object'
    }

    attribute_map = {
        'part_number': 'PartNumber',
        'serial_number': 'SerialNumber',
        'first_seen_at': 'FirstSeenAt',
        'last_seen_at': 'LastSeenAt',
        'last_known_details': 'LastKnownDetails'
    }

    def __init__(self, part_number=None, serial_number=None, first_seen_at=None, last_seen_at=None, last_known_details=None):  # noqa: E501
        """PlatformInventoryEntry - a model defined in OpenAPI"""  # noqa: E501

        self._part_number = None
        self._serial_number = None
        self._first_seen_at = None
        self._last_seen_at = None
        self._last_known_details = None
        self.discriminator = None

        self.part_number = part_number
        self.serial_number = serial_number
        self.first_seen_at = first_seen_at
        self.last_seen_at = last_seen_at
        self.last_known_details = last_known_details

    @property
    def part_number(self):
        """Gets the part_number of this PlatformInventoryEntry.  # noqa: E501

        Part number of the component is/was installed in the slot.  # noqa: E501

        :return: The part_number of this PlatformInventoryEntry.  # noqa: E501
        :rtype: str
        """
        return self._part_number

    @part_number.setter
    def part_number(self, part_number):
        """Sets the part_number of this PlatformInventoryEntry.

        Part number of the component is/was installed in the slot.  # noqa: E501

        :param part_number: The part_number of this PlatformInventoryEntry.  # noqa: E501
        :type: str
        """
        if part_number is None:
            raise ValueError("Invalid value for `part_number`, must not be `None`")  # noqa: E501

        self._part_number = part_number

    @property
    def serial_number(self):
        """Gets the serial_number of this PlatformInventoryEntry.  # noqa: E501

        Serial number of the component is/was installed in the slot.  # noqa: E501

        :return: The serial_number of this PlatformInventoryEntry.  # noqa: E501
        :rtype: str
        """
        return self._serial_number

    @serial_number.setter
    def serial_number(self, serial_number):
        """Sets the serial_number of this PlatformInventoryEntry.

        Serial number of the component is/was installed in the slot.  # noqa: E501

        :param serial_number: The serial_number of this PlatformInventoryEntry.  # noqa: E501
        :type: str
        """
        if serial_number is None:
            raise ValueError("Invalid value for `serial_number`, must not be `None`")  # noqa: E501

        self._serial_number = serial_number

    @property
    def first_seen_at(self):
        """Gets the first_seen_at of this PlatformInventoryEntry.  # noqa: E501

        Time when this component was first seen in this slot.  # noqa: E501

        :return: The first_seen_at of this PlatformInventoryEntry.  # noqa: E501
        :rtype: datetime
        """
        return self._first_seen_at

    @first_seen_at.setter
    def first_seen_at(self, first_seen_at):
        """Sets the first_seen_at of this PlatformInventoryEntry.

        Time when this component was first seen in this slot.  # noqa: E501

        :param first_seen_at: The first_seen_at of this PlatformInventoryEntry.  # noqa: E501
        :type: datetime
        """
        if first_seen_at is None:
            raise ValueError("Invalid value for `first_seen_at`, must not be `None`")  # noqa: E501

        self._first_seen_at = first_seen_at

    @property
    def last_seen_at(self):
        """Gets the last_seen_at of this PlatformInventoryEntry.  # noqa: E501

        Time when this component was last seen in this slot.  # noqa: E501

        :return: The last_seen_at of this PlatformInventoryEntry.  # noqa: E501
        :rtype: datetime
        """
        return self._last_seen_at

    @last_seen_at.setter
    def last_seen_at(self, last_seen_at):
        """Sets the last_seen_at of this PlatformInventoryEntry.

        Time when this component was last seen in this slot.  # noqa: E501

        :param last_seen_at: The last_seen_at of this PlatformInventoryEntry.  # noqa: E501
        :type: datetime
        """
        if last_seen_at is None:
            raise ValueError("Invalid value for `last_seen_at`, must not be `None`")  # noqa: E501

        self._last_seen_at = last_seen_at

    @property
    def last_known_details(self):
        """Gets the last_known_details of this PlatformInventoryEntry.  # noqa: E501

        The last known details about this component.  # noqa: E501

        :return: The last_known_details of this PlatformInventoryEntry.  # noqa: E501
        :rtype: object
        """
        return self._last_known_details

    @last_known_details.setter
    def last_known_details(self, last_known_details):
        """Sets the last_known_details of this PlatformInventoryEntry.

        The last known details about this component.  # noqa: E501

        :param last_known_details: The last_known_details of this PlatformInventoryEntry.  # noqa: E501
        :type: object
        """
        if last_known_details is None:
            raise ValueError("Invalid value for `last_known_details`, must not be `None`")  # noqa: E501

        self._last_known_details = last_known_details

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PlatformInventoryEntry):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
