# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Power(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_context': 'str',
        'odata_etag': 'str',
        'odata_id': 'str',
        'odata_type': 'str',
        'actions': 'Actions2',
        'description': 'str',
        'id': 'str',
        'name': 'str',
        'oem': 'dict(str, object)',
        'power_control': 'list[PowerControl]',
        'power_controlodata_count': 'int',
        'power_supplies': 'list[PowerSupply]',
        'power_suppliesodata_count': 'int',
        'redundancy': 'list[IdRef]',
        'redundancyodata_count': 'int',
        'voltages': 'list[Voltage]',
        'voltagesodata_count': 'int'
    }

    attribute_map = {
        'odata_context': '@odata.context',
        'odata_etag': '@odata.etag',
        'odata_id': '@odata.id',
        'odata_type': '@odata.type',
        'actions': 'Actions',
        'description': 'Description',
        'id': 'Id',
        'name': 'Name',
        'oem': 'Oem',
        'power_control': 'PowerControl',
        'power_controlodata_count': 'PowerControl@odata.count',
        'power_supplies': 'PowerSupplies',
        'power_suppliesodata_count': 'PowerSupplies@odata.count',
        'redundancy': 'Redundancy',
        'redundancyodata_count': 'Redundancy@odata.count',
        'voltages': 'Voltages',
        'voltagesodata_count': 'Voltages@odata.count'
    }

    def __init__(self, odata_context=None, odata_etag=None, odata_id=None, odata_type=None, actions=None, description=None, id=None, name=None, oem=None, power_control=None, power_controlodata_count=None, power_supplies=None, power_suppliesodata_count=None, redundancy=None, redundancyodata_count=None, voltages=None, voltagesodata_count=None):  # noqa: E501
        """Power - a model defined in OpenAPI"""  # noqa: E501

        self._odata_context = None
        self._odata_etag = None
        self._odata_id = None
        self._odata_type = None
        self._actions = None
        self._description = None
        self._id = None
        self._name = None
        self._oem = None
        self._power_control = None
        self._power_controlodata_count = None
        self._power_supplies = None
        self._power_suppliesodata_count = None
        self._redundancy = None
        self._redundancyodata_count = None
        self._voltages = None
        self._voltagesodata_count = None
        self.discriminator = None

        if odata_context is not None:
            self.odata_context = odata_context
        if odata_etag is not None:
            self.odata_etag = odata_etag
        self.odata_id = odata_id
        self.odata_type = odata_type
        if actions is not None:
            self.actions = actions
        if description is not None:
            self.description = description
        self.id = id
        self.name = name
        if oem is not None:
            self.oem = oem
        if power_control is not None:
            self.power_control = power_control
        if power_controlodata_count is not None:
            self.power_controlodata_count = power_controlodata_count
        if power_supplies is not None:
            self.power_supplies = power_supplies
        if power_suppliesodata_count is not None:
            self.power_suppliesodata_count = power_suppliesodata_count
        if redundancy is not None:
            self.redundancy = redundancy
        if redundancyodata_count is not None:
            self.redundancyodata_count = redundancyodata_count
        if voltages is not None:
            self.voltages = voltages
        if voltagesodata_count is not None:
            self.voltagesodata_count = voltagesodata_count

    @property
    def odata_context(self):
        """Gets the odata_context of this Power.  # noqa: E501

        The OData description of a payload.  # noqa: E501

        :return: The odata_context of this Power.  # noqa: E501
        :rtype: str
        """
        return self._odata_context

    @odata_context.setter
    def odata_context(self, odata_context):
        """Sets the odata_context of this Power.

        The OData description of a payload.  # noqa: E501

        :param odata_context: The odata_context of this Power.  # noqa: E501
        :type: str
        """

        self._odata_context = odata_context

    @property
    def odata_etag(self):
        """Gets the odata_etag of this Power.  # noqa: E501

        The current ETag of the resource.  # noqa: E501

        :return: The odata_etag of this Power.  # noqa: E501
        :rtype: str
        """
        return self._odata_etag

    @odata_etag.setter
    def odata_etag(self, odata_etag):
        """Sets the odata_etag of this Power.

        The current ETag of the resource.  # noqa: E501

        :param odata_etag: The odata_etag of this Power.  # noqa: E501
        :type: str
        """

        self._odata_etag = odata_etag

    @property
    def odata_id(self):
        """Gets the odata_id of this Power.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this Power.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this Power.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this Power.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def odata_type(self):
        """Gets the odata_type of this Power.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this Power.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this Power.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this Power.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def actions(self):
        """Gets the actions of this Power.  # noqa: E501


        :return: The actions of this Power.  # noqa: E501
        :rtype: Actions2
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this Power.


        :param actions: The actions of this Power.  # noqa: E501
        :type: Actions2
        """

        self._actions = actions

    @property
    def description(self):
        """Gets the description of this Power.  # noqa: E501

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :return: The description of this Power.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Power.

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :param description: The description of this Power.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def id(self):
        """Gets the id of this Power.  # noqa: E501

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :return: The id of this Power.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Power.

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :param id: The id of this Power.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this Power.  # noqa: E501

        The name of the resource or array member.  # noqa: E501

        :return: The name of this Power.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Power.

        The name of the resource or array member.  # noqa: E501

        :param name: The name of this Power.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def oem(self):
        """Gets the oem of this Power.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this Power.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this Power.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this Power.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def power_control(self):
        """Gets the power_control of this Power.  # noqa: E501

        This is the definition for power control function (power reading/limiting).  # noqa: E501

        :return: The power_control of this Power.  # noqa: E501
        :rtype: list[PowerControl]
        """
        return self._power_control

    @power_control.setter
    def power_control(self, power_control):
        """Sets the power_control of this Power.

        This is the definition for power control function (power reading/limiting).  # noqa: E501

        :param power_control: The power_control of this Power.  # noqa: E501
        :type: list[PowerControl]
        """

        self._power_control = power_control

    @property
    def power_controlodata_count(self):
        """Gets the power_controlodata_count of this Power.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The power_controlodata_count of this Power.  # noqa: E501
        :rtype: int
        """
        return self._power_controlodata_count

    @power_controlodata_count.setter
    def power_controlodata_count(self, power_controlodata_count):
        """Sets the power_controlodata_count of this Power.

        The number of items in a collection.  # noqa: E501

        :param power_controlodata_count: The power_controlodata_count of this Power.  # noqa: E501
        :type: int
        """

        self._power_controlodata_count = power_controlodata_count

    @property
    def power_supplies(self):
        """Gets the power_supplies of this Power.  # noqa: E501

        Details of the power supplies associated with this system or device.  # noqa: E501

        :return: The power_supplies of this Power.  # noqa: E501
        :rtype: list[PowerSupply]
        """
        return self._power_supplies

    @power_supplies.setter
    def power_supplies(self, power_supplies):
        """Sets the power_supplies of this Power.

        Details of the power supplies associated with this system or device.  # noqa: E501

        :param power_supplies: The power_supplies of this Power.  # noqa: E501
        :type: list[PowerSupply]
        """

        self._power_supplies = power_supplies

    @property
    def power_suppliesodata_count(self):
        """Gets the power_suppliesodata_count of this Power.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The power_suppliesodata_count of this Power.  # noqa: E501
        :rtype: int
        """
        return self._power_suppliesodata_count

    @power_suppliesodata_count.setter
    def power_suppliesodata_count(self, power_suppliesodata_count):
        """Sets the power_suppliesodata_count of this Power.

        The number of items in a collection.  # noqa: E501

        :param power_suppliesodata_count: The power_suppliesodata_count of this Power.  # noqa: E501
        :type: int
        """

        self._power_suppliesodata_count = power_suppliesodata_count

    @property
    def redundancy(self):
        """Gets the redundancy of this Power.  # noqa: E501

        Redundancy information for the power subsystem of this system or device.  # noqa: E501

        :return: The redundancy of this Power.  # noqa: E501
        :rtype: list[IdRef]
        """
        return self._redundancy

    @redundancy.setter
    def redundancy(self, redundancy):
        """Sets the redundancy of this Power.

        Redundancy information for the power subsystem of this system or device.  # noqa: E501

        :param redundancy: The redundancy of this Power.  # noqa: E501
        :type: list[IdRef]
        """

        self._redundancy = redundancy

    @property
    def redundancyodata_count(self):
        """Gets the redundancyodata_count of this Power.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The redundancyodata_count of this Power.  # noqa: E501
        :rtype: int
        """
        return self._redundancyodata_count

    @redundancyodata_count.setter
    def redundancyodata_count(self, redundancyodata_count):
        """Sets the redundancyodata_count of this Power.

        The number of items in a collection.  # noqa: E501

        :param redundancyodata_count: The redundancyodata_count of this Power.  # noqa: E501
        :type: int
        """

        self._redundancyodata_count = redundancyodata_count

    @property
    def voltages(self):
        """Gets the voltages of this Power.  # noqa: E501

        This is the definition for voltage sensors.  # noqa: E501

        :return: The voltages of this Power.  # noqa: E501
        :rtype: list[Voltage]
        """
        return self._voltages

    @voltages.setter
    def voltages(self, voltages):
        """Sets the voltages of this Power.

        This is the definition for voltage sensors.  # noqa: E501

        :param voltages: The voltages of this Power.  # noqa: E501
        :type: list[Voltage]
        """

        self._voltages = voltages

    @property
    def voltagesodata_count(self):
        """Gets the voltagesodata_count of this Power.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The voltagesodata_count of this Power.  # noqa: E501
        :rtype: int
        """
        return self._voltagesodata_count

    @voltagesodata_count.setter
    def voltagesodata_count(self, voltagesodata_count):
        """Sets the voltagesodata_count of this Power.

        The number of items in a collection.  # noqa: E501

        :param voltagesodata_count: The voltagesodata_count of this Power.  # noqa: E501
        :type: int
        """

        self._voltagesodata_count = voltagesodata_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Power):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
