# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Power2(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'power_draw': 'str',
        'power_limit': 'str',
        'power_limit_default': 'str',
        'power_limit_enforced': 'str',
        'power_limit_max': 'str',
        'power_limit_min': 'str',
        'power_management_support': 'str'
    }

    attribute_map = {
        'power_draw': 'PowerDraw',
        'power_limit': 'PowerLimit',
        'power_limit_default': 'PowerLimitDefault',
        'power_limit_enforced': 'PowerLimitEnforced',
        'power_limit_max': 'PowerLimitMax',
        'power_limit_min': 'PowerLimitMin',
        'power_management_support': 'PowerManagementSupport'
    }

    def __init__(self, power_draw=None, power_limit=None, power_limit_default=None, power_limit_enforced=None, power_limit_max=None, power_limit_min=None, power_management_support=None):  # noqa: E501
        """Power2 - a model defined in OpenAPI"""  # noqa: E501

        self._power_draw = None
        self._power_limit = None
        self._power_limit_default = None
        self._power_limit_enforced = None
        self._power_limit_max = None
        self._power_limit_min = None
        self._power_management_support = None
        self.discriminator = None

        self.power_draw = power_draw
        self.power_limit = power_limit
        self.power_limit_default = power_limit_default
        self.power_limit_enforced = power_limit_enforced
        self.power_limit_max = power_limit_max
        self.power_limit_min = power_limit_min
        self.power_management_support = power_management_support

    @property
    def power_draw(self):
        """Gets the power_draw of this Power2.  # noqa: E501

        The last measured power draw for the entire board, in watts.  # noqa: E501

        :return: The power_draw of this Power2.  # noqa: E501
        :rtype: str
        """
        return self._power_draw

    @power_draw.setter
    def power_draw(self, power_draw):
        """Sets the power_draw of this Power2.

        The last measured power draw for the entire board, in watts.  # noqa: E501

        :param power_draw: The power_draw of this Power2.  # noqa: E501
        :type: str
        """
        if power_draw is None:
            raise ValueError("Invalid value for `power_draw`, must not be `None`")  # noqa: E501

        self._power_draw = power_draw

    @property
    def power_limit(self):
        """Gets the power_limit of this Power2.  # noqa: E501

        The software power limit, in watts.  # noqa: E501

        :return: The power_limit of this Power2.  # noqa: E501
        :rtype: str
        """
        return self._power_limit

    @power_limit.setter
    def power_limit(self, power_limit):
        """Sets the power_limit of this Power2.

        The software power limit, in watts.  # noqa: E501

        :param power_limit: The power_limit of this Power2.  # noqa: E501
        :type: str
        """
        if power_limit is None:
            raise ValueError("Invalid value for `power_limit`, must not be `None`")  # noqa: E501

        self._power_limit = power_limit

    @property
    def power_limit_default(self):
        """Gets the power_limit_default of this Power2.  # noqa: E501

        The default power management algorithm's power ceiling, in watts.  # noqa: E501

        :return: The power_limit_default of this Power2.  # noqa: E501
        :rtype: str
        """
        return self._power_limit_default

    @power_limit_default.setter
    def power_limit_default(self, power_limit_default):
        """Sets the power_limit_default of this Power2.

        The default power management algorithm's power ceiling, in watts.  # noqa: E501

        :param power_limit_default: The power_limit_default of this Power2.  # noqa: E501
        :type: str
        """
        if power_limit_default is None:
            raise ValueError("Invalid value for `power_limit_default`, must not be `None`")  # noqa: E501

        self._power_limit_default = power_limit_default

    @property
    def power_limit_enforced(self):
        """Gets the power_limit_enforced of this Power2.  # noqa: E501

        The power management algorithm's power ceiling, in watts.  # noqa: E501

        :return: The power_limit_enforced of this Power2.  # noqa: E501
        :rtype: str
        """
        return self._power_limit_enforced

    @power_limit_enforced.setter
    def power_limit_enforced(self, power_limit_enforced):
        """Sets the power_limit_enforced of this Power2.

        The power management algorithm's power ceiling, in watts.  # noqa: E501

        :param power_limit_enforced: The power_limit_enforced of this Power2.  # noqa: E501
        :type: str
        """
        if power_limit_enforced is None:
            raise ValueError("Invalid value for `power_limit_enforced`, must not be `None`")  # noqa: E501

        self._power_limit_enforced = power_limit_enforced

    @property
    def power_limit_max(self):
        """Gets the power_limit_max of this Power2.  # noqa: E501

        The maximum value in watts that power limit can be set to. Only on supported devices from Kepler family.  # noqa: E501

        :return: The power_limit_max of this Power2.  # noqa: E501
        :rtype: str
        """
        return self._power_limit_max

    @power_limit_max.setter
    def power_limit_max(self, power_limit_max):
        """Sets the power_limit_max of this Power2.

        The maximum value in watts that power limit can be set to. Only on supported devices from Kepler family.  # noqa: E501

        :param power_limit_max: The power_limit_max of this Power2.  # noqa: E501
        :type: str
        """
        if power_limit_max is None:
            raise ValueError("Invalid value for `power_limit_max`, must not be `None`")  # noqa: E501

        self._power_limit_max = power_limit_max

    @property
    def power_limit_min(self):
        """Gets the power_limit_min of this Power2.  # noqa: E501

        The minimum value in watts that power limit can be set to. Only on supported devices from Kepler family.  # noqa: E501

        :return: The power_limit_min of this Power2.  # noqa: E501
        :rtype: str
        """
        return self._power_limit_min

    @power_limit_min.setter
    def power_limit_min(self, power_limit_min):
        """Sets the power_limit_min of this Power2.

        The minimum value in watts that power limit can be set to. Only on supported devices from Kepler family.  # noqa: E501

        :param power_limit_min: The power_limit_min of this Power2.  # noqa: E501
        :type: str
        """
        if power_limit_min is None:
            raise ValueError("Invalid value for `power_limit_min`, must not be `None`")  # noqa: E501

        self._power_limit_min = power_limit_min

    @property
    def power_management_support(self):
        """Gets the power_management_support of this Power2.  # noqa: E501

        A flag that indicates whether power management is enabled. Either \"Supported\" or \"N/A\". Requires Inforom PWR object version 3.0 or higher or Kepler device.  # noqa: E501

        :return: The power_management_support of this Power2.  # noqa: E501
        :rtype: str
        """
        return self._power_management_support

    @power_management_support.setter
    def power_management_support(self, power_management_support):
        """Sets the power_management_support of this Power2.

        A flag that indicates whether power management is enabled. Either \"Supported\" or \"N/A\". Requires Inforom PWR object version 3.0 or higher or Kepler device.  # noqa: E501

        :param power_management_support: The power_management_support of this Power2.  # noqa: E501
        :type: str
        """
        if power_management_support is None:
            raise ValueError("Invalid value for `power_management_support`, must not be `None`")  # noqa: E501

        self._power_management_support = power_management_support

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Power2):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
