# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PowerControl(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_id': 'str',
        'actions': 'PowerControlActions',
        'member_id': 'str',
        'name': 'str',
        'oem': 'dict(str, object)',
        'physical_context': 'IdRef',
        'power_allocated_watts': 'float',
        'power_available_watts': 'float',
        'power_capacity_watts': 'float',
        'power_consumed_watts': 'float',
        'power_limit': 'PowerLimit',
        'power_metrics': 'PowerMetric',
        'power_requested_watts': 'float',
        'related_item': 'list[IdRef]',
        'related_itemodata_count': 'int',
        'status': 'Status'
    }

    attribute_map = {
        'odata_id': '@odata.id',
        'actions': 'Actions',
        'member_id': 'MemberId',
        'name': 'Name',
        'oem': 'Oem',
        'physical_context': 'PhysicalContext',
        'power_allocated_watts': 'PowerAllocatedWatts',
        'power_available_watts': 'PowerAvailableWatts',
        'power_capacity_watts': 'PowerCapacityWatts',
        'power_consumed_watts': 'PowerConsumedWatts',
        'power_limit': 'PowerLimit',
        'power_metrics': 'PowerMetrics',
        'power_requested_watts': 'PowerRequestedWatts',
        'related_item': 'RelatedItem',
        'related_itemodata_count': 'RelatedItem@odata.count',
        'status': 'Status'
    }

    def __init__(self, odata_id=None, actions=None, member_id=None, name=None, oem=None, physical_context=None, power_allocated_watts=None, power_available_watts=None, power_capacity_watts=None, power_consumed_watts=None, power_limit=None, power_metrics=None, power_requested_watts=None, related_item=None, related_itemodata_count=None, status=None):  # noqa: E501
        """PowerControl - a model defined in OpenAPI"""  # noqa: E501

        self._odata_id = None
        self._actions = None
        self._member_id = None
        self._name = None
        self._oem = None
        self._physical_context = None
        self._power_allocated_watts = None
        self._power_available_watts = None
        self._power_capacity_watts = None
        self._power_consumed_watts = None
        self._power_limit = None
        self._power_metrics = None
        self._power_requested_watts = None
        self._related_item = None
        self._related_itemodata_count = None
        self._status = None
        self.discriminator = None

        self.odata_id = odata_id
        if actions is not None:
            self.actions = actions
        self.member_id = member_id
        self.name = name
        if oem is not None:
            self.oem = oem
        if physical_context is not None:
            self.physical_context = physical_context
        self.power_allocated_watts = power_allocated_watts
        self.power_available_watts = power_available_watts
        self.power_capacity_watts = power_capacity_watts
        self.power_consumed_watts = power_consumed_watts
        if power_limit is not None:
            self.power_limit = power_limit
        if power_metrics is not None:
            self.power_metrics = power_metrics
        self.power_requested_watts = power_requested_watts
        if related_item is not None:
            self.related_item = related_item
        if related_itemodata_count is not None:
            self.related_itemodata_count = related_itemodata_count
        if status is not None:
            self.status = status

    @property
    def odata_id(self):
        """Gets the odata_id of this PowerControl.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this PowerControl.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this PowerControl.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this PowerControl.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def actions(self):
        """Gets the actions of this PowerControl.  # noqa: E501


        :return: The actions of this PowerControl.  # noqa: E501
        :rtype: PowerControlActions
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this PowerControl.


        :param actions: The actions of this PowerControl.  # noqa: E501
        :type: PowerControlActions
        """

        self._actions = actions

    @property
    def member_id(self):
        """Gets the member_id of this PowerControl.  # noqa: E501

        This is the identifier for the member within the collection.  # noqa: E501

        :return: The member_id of this PowerControl.  # noqa: E501
        :rtype: str
        """
        return self._member_id

    @member_id.setter
    def member_id(self, member_id):
        """Sets the member_id of this PowerControl.

        This is the identifier for the member within the collection.  # noqa: E501

        :param member_id: The member_id of this PowerControl.  # noqa: E501
        :type: str
        """
        if member_id is None:
            raise ValueError("Invalid value for `member_id`, must not be `None`")  # noqa: E501

        self._member_id = member_id

    @property
    def name(self):
        """Gets the name of this PowerControl.  # noqa: E501

        Power Control Function name.  # noqa: E501

        :return: The name of this PowerControl.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PowerControl.

        Power Control Function name.  # noqa: E501

        :param name: The name of this PowerControl.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def oem(self):
        """Gets the oem of this PowerControl.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this PowerControl.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this PowerControl.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this PowerControl.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def physical_context(self):
        """Gets the physical_context of this PowerControl.  # noqa: E501


        :return: The physical_context of this PowerControl.  # noqa: E501
        :rtype: IdRef
        """
        return self._physical_context

    @physical_context.setter
    def physical_context(self, physical_context):
        """Sets the physical_context of this PowerControl.


        :param physical_context: The physical_context of this PowerControl.  # noqa: E501
        :type: IdRef
        """

        self._physical_context = physical_context

    @property
    def power_allocated_watts(self):
        """Gets the power_allocated_watts of this PowerControl.  # noqa: E501

        The total amount of power that has been allocated (or budegeted)to  chassis resources.  # noqa: E501

        :return: The power_allocated_watts of this PowerControl.  # noqa: E501
        :rtype: float
        """
        return self._power_allocated_watts

    @power_allocated_watts.setter
    def power_allocated_watts(self, power_allocated_watts):
        """Sets the power_allocated_watts of this PowerControl.

        The total amount of power that has been allocated (or budegeted)to  chassis resources.  # noqa: E501

        :param power_allocated_watts: The power_allocated_watts of this PowerControl.  # noqa: E501
        :type: float
        """
        if power_allocated_watts is not None and power_allocated_watts < 0:  # noqa: E501
            raise ValueError("Invalid value for `power_allocated_watts`, must be a value greater than or equal to `0`")  # noqa: E501

        self._power_allocated_watts = power_allocated_watts

    @property
    def power_available_watts(self):
        """Gets the power_available_watts of this PowerControl.  # noqa: E501

        The amount of power not already budgeted and therefore available for additional allocation. (powerCapacity - powerAllocated).  This indicates how much reserve power capacity is left.  # noqa: E501

        :return: The power_available_watts of this PowerControl.  # noqa: E501
        :rtype: float
        """
        return self._power_available_watts

    @power_available_watts.setter
    def power_available_watts(self, power_available_watts):
        """Sets the power_available_watts of this PowerControl.

        The amount of power not already budgeted and therefore available for additional allocation. (powerCapacity - powerAllocated).  This indicates how much reserve power capacity is left.  # noqa: E501

        :param power_available_watts: The power_available_watts of this PowerControl.  # noqa: E501
        :type: float
        """
        if power_available_watts is not None and power_available_watts < 0:  # noqa: E501
            raise ValueError("Invalid value for `power_available_watts`, must be a value greater than or equal to `0`")  # noqa: E501

        self._power_available_watts = power_available_watts

    @property
    def power_capacity_watts(self):
        """Gets the power_capacity_watts of this PowerControl.  # noqa: E501

        The total amount of power available to the chassis for allocation. This may the power supply capacity, or power budget assigned to the chassis from an up-stream chassis.  # noqa: E501

        :return: The power_capacity_watts of this PowerControl.  # noqa: E501
        :rtype: float
        """
        return self._power_capacity_watts

    @power_capacity_watts.setter
    def power_capacity_watts(self, power_capacity_watts):
        """Sets the power_capacity_watts of this PowerControl.

        The total amount of power available to the chassis for allocation. This may the power supply capacity, or power budget assigned to the chassis from an up-stream chassis.  # noqa: E501

        :param power_capacity_watts: The power_capacity_watts of this PowerControl.  # noqa: E501
        :type: float
        """
        if power_capacity_watts is not None and power_capacity_watts < 0:  # noqa: E501
            raise ValueError("Invalid value for `power_capacity_watts`, must be a value greater than or equal to `0`")  # noqa: E501

        self._power_capacity_watts = power_capacity_watts

    @property
    def power_consumed_watts(self):
        """Gets the power_consumed_watts of this PowerControl.  # noqa: E501

        The actual power being consumed by the chassis.  # noqa: E501

        :return: The power_consumed_watts of this PowerControl.  # noqa: E501
        :rtype: float
        """
        return self._power_consumed_watts

    @power_consumed_watts.setter
    def power_consumed_watts(self, power_consumed_watts):
        """Sets the power_consumed_watts of this PowerControl.

        The actual power being consumed by the chassis.  # noqa: E501

        :param power_consumed_watts: The power_consumed_watts of this PowerControl.  # noqa: E501
        :type: float
        """
        if power_consumed_watts is not None and power_consumed_watts < 0:  # noqa: E501
            raise ValueError("Invalid value for `power_consumed_watts`, must be a value greater than or equal to `0`")  # noqa: E501

        self._power_consumed_watts = power_consumed_watts

    @property
    def power_limit(self):
        """Gets the power_limit of this PowerControl.  # noqa: E501


        :return: The power_limit of this PowerControl.  # noqa: E501
        :rtype: PowerLimit
        """
        return self._power_limit

    @power_limit.setter
    def power_limit(self, power_limit):
        """Sets the power_limit of this PowerControl.


        :param power_limit: The power_limit of this PowerControl.  # noqa: E501
        :type: PowerLimit
        """

        self._power_limit = power_limit

    @property
    def power_metrics(self):
        """Gets the power_metrics of this PowerControl.  # noqa: E501


        :return: The power_metrics of this PowerControl.  # noqa: E501
        :rtype: PowerMetric
        """
        return self._power_metrics

    @power_metrics.setter
    def power_metrics(self, power_metrics):
        """Sets the power_metrics of this PowerControl.


        :param power_metrics: The power_metrics of this PowerControl.  # noqa: E501
        :type: PowerMetric
        """

        self._power_metrics = power_metrics

    @property
    def power_requested_watts(self):
        """Gets the power_requested_watts of this PowerControl.  # noqa: E501

        The potential power that the chassis resources are requesting which may be higher than the current level being consumed since requested power includes budget that the chassis resource wants for future use.  # noqa: E501

        :return: The power_requested_watts of this PowerControl.  # noqa: E501
        :rtype: float
        """
        return self._power_requested_watts

    @power_requested_watts.setter
    def power_requested_watts(self, power_requested_watts):
        """Sets the power_requested_watts of this PowerControl.

        The potential power that the chassis resources are requesting which may be higher than the current level being consumed since requested power includes budget that the chassis resource wants for future use.  # noqa: E501

        :param power_requested_watts: The power_requested_watts of this PowerControl.  # noqa: E501
        :type: float
        """
        if power_requested_watts is not None and power_requested_watts < 0:  # noqa: E501
            raise ValueError("Invalid value for `power_requested_watts`, must be a value greater than or equal to `0`")  # noqa: E501

        self._power_requested_watts = power_requested_watts

    @property
    def related_item(self):
        """Gets the related_item of this PowerControl.  # noqa: E501

        The ID(s) of the resources associated with this Power Limit.  # noqa: E501

        :return: The related_item of this PowerControl.  # noqa: E501
        :rtype: list[IdRef]
        """
        return self._related_item

    @related_item.setter
    def related_item(self, related_item):
        """Sets the related_item of this PowerControl.

        The ID(s) of the resources associated with this Power Limit.  # noqa: E501

        :param related_item: The related_item of this PowerControl.  # noqa: E501
        :type: list[IdRef]
        """

        self._related_item = related_item

    @property
    def related_itemodata_count(self):
        """Gets the related_itemodata_count of this PowerControl.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The related_itemodata_count of this PowerControl.  # noqa: E501
        :rtype: int
        """
        return self._related_itemodata_count

    @related_itemodata_count.setter
    def related_itemodata_count(self, related_itemodata_count):
        """Sets the related_itemodata_count of this PowerControl.

        The number of items in a collection.  # noqa: E501

        :param related_itemodata_count: The related_itemodata_count of this PowerControl.  # noqa: E501
        :type: int
        """

        self._related_itemodata_count = related_itemodata_count

    @property
    def status(self):
        """Gets the status of this PowerControl.  # noqa: E501


        :return: The status of this PowerControl.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this PowerControl.


        :param status: The status of this PowerControl.  # noqa: E501
        :type: Status
        """

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PowerControl):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
