# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PowerLimit(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'correction_in_ms': 'int',
        'limit_exception': 'PowerLimitException',
        'limit_in_watts': 'float'
    }

    attribute_map = {
        'correction_in_ms': 'CorrectionInMs',
        'limit_exception': 'LimitException',
        'limit_in_watts': 'LimitInWatts'
    }

    def __init__(self, correction_in_ms=None, limit_exception=None, limit_in_watts=None):  # noqa: E501
        """PowerLimit - a model defined in OpenAPI"""  # noqa: E501

        self._correction_in_ms = None
        self._limit_exception = None
        self._limit_in_watts = None
        self.discriminator = None

        self.correction_in_ms = correction_in_ms
        if limit_exception is not None:
            self.limit_exception = limit_exception
        self.limit_in_watts = limit_in_watts

    @property
    def correction_in_ms(self):
        """Gets the correction_in_ms of this PowerLimit.  # noqa: E501

        The time required for the limiting process to reduce power consumption to below the limit.  # noqa: E501

        :return: The correction_in_ms of this PowerLimit.  # noqa: E501
        :rtype: int
        """
        return self._correction_in_ms

    @correction_in_ms.setter
    def correction_in_ms(self, correction_in_ms):
        """Sets the correction_in_ms of this PowerLimit.

        The time required for the limiting process to reduce power consumption to below the limit.  # noqa: E501

        :param correction_in_ms: The correction_in_ms of this PowerLimit.  # noqa: E501
        :type: int
        """

        self._correction_in_ms = correction_in_ms

    @property
    def limit_exception(self):
        """Gets the limit_exception of this PowerLimit.  # noqa: E501


        :return: The limit_exception of this PowerLimit.  # noqa: E501
        :rtype: PowerLimitException
        """
        return self._limit_exception

    @limit_exception.setter
    def limit_exception(self, limit_exception):
        """Sets the limit_exception of this PowerLimit.


        :param limit_exception: The limit_exception of this PowerLimit.  # noqa: E501
        :type: PowerLimitException
        """

        self._limit_exception = limit_exception

    @property
    def limit_in_watts(self):
        """Gets the limit_in_watts of this PowerLimit.  # noqa: E501

        The Power limit in watts. Set to null to disable power capping.  # noqa: E501

        :return: The limit_in_watts of this PowerLimit.  # noqa: E501
        :rtype: float
        """
        return self._limit_in_watts

    @limit_in_watts.setter
    def limit_in_watts(self, limit_in_watts):
        """Sets the limit_in_watts of this PowerLimit.

        The Power limit in watts. Set to null to disable power capping.  # noqa: E501

        :param limit_in_watts: The limit_in_watts of this PowerLimit.  # noqa: E501
        :type: float
        """
        if limit_in_watts is not None and limit_in_watts < 0:  # noqa: E501
            raise ValueError("Invalid value for `limit_in_watts`, must be a value greater than or equal to `0`")  # noqa: E501

        self._limit_in_watts = limit_in_watts

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PowerLimit):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
