# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PowerManagementPolicy(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'average_power_budget_milli_watts': 'int',
        'max_tdp_milli_watts': 'int',
        'peak_power_budget_milli_watts': 'int',
        'policy_enabled': 'bool'
    }

    attribute_map = {
        'average_power_budget_milli_watts': 'AveragePowerBudgetMilliWatts',
        'max_tdp_milli_watts': 'MaxTDPMilliWatts',
        'peak_power_budget_milli_watts': 'PeakPowerBudgetMilliWatts',
        'policy_enabled': 'PolicyEnabled'
    }

    def __init__(self, average_power_budget_milli_watts=None, max_tdp_milli_watts=None, peak_power_budget_milli_watts=None, policy_enabled=None):  # noqa: E501
        """PowerManagementPolicy - a model defined in OpenAPI"""  # noqa: E501

        self._average_power_budget_milli_watts = None
        self._max_tdp_milli_watts = None
        self._peak_power_budget_milli_watts = None
        self._policy_enabled = None
        self.discriminator = None

        self.average_power_budget_milli_watts = average_power_budget_milli_watts
        self.max_tdp_milli_watts = max_tdp_milli_watts
        self.peak_power_budget_milli_watts = peak_power_budget_milli_watts
        self.policy_enabled = policy_enabled

    @property
    def average_power_budget_milli_watts(self):
        """Gets the average_power_budget_milli_watts of this PowerManagementPolicy.  # noqa: E501

        Average power budget in milli watts.  # noqa: E501

        :return: The average_power_budget_milli_watts of this PowerManagementPolicy.  # noqa: E501
        :rtype: int
        """
        return self._average_power_budget_milli_watts

    @average_power_budget_milli_watts.setter
    def average_power_budget_milli_watts(self, average_power_budget_milli_watts):
        """Sets the average_power_budget_milli_watts of this PowerManagementPolicy.

        Average power budget in milli watts.  # noqa: E501

        :param average_power_budget_milli_watts: The average_power_budget_milli_watts of this PowerManagementPolicy.  # noqa: E501
        :type: int
        """

        self._average_power_budget_milli_watts = average_power_budget_milli_watts

    @property
    def max_tdp_milli_watts(self):
        """Gets the max_tdp_milli_watts of this PowerManagementPolicy.  # noqa: E501

        Maximum TDP in milli watts.  # noqa: E501

        :return: The max_tdp_milli_watts of this PowerManagementPolicy.  # noqa: E501
        :rtype: int
        """
        return self._max_tdp_milli_watts

    @max_tdp_milli_watts.setter
    def max_tdp_milli_watts(self, max_tdp_milli_watts):
        """Sets the max_tdp_milli_watts of this PowerManagementPolicy.

        Maximum TDP in milli watts.  # noqa: E501

        :param max_tdp_milli_watts: The max_tdp_milli_watts of this PowerManagementPolicy.  # noqa: E501
        :type: int
        """

        self._max_tdp_milli_watts = max_tdp_milli_watts

    @property
    def peak_power_budget_milli_watts(self):
        """Gets the peak_power_budget_milli_watts of this PowerManagementPolicy.  # noqa: E501

        Peak power budget in milli watts.  # noqa: E501

        :return: The peak_power_budget_milli_watts of this PowerManagementPolicy.  # noqa: E501
        :rtype: int
        """
        return self._peak_power_budget_milli_watts

    @peak_power_budget_milli_watts.setter
    def peak_power_budget_milli_watts(self, peak_power_budget_milli_watts):
        """Sets the peak_power_budget_milli_watts of this PowerManagementPolicy.

        Peak power budget in milli watts.  # noqa: E501

        :param peak_power_budget_milli_watts: The peak_power_budget_milli_watts of this PowerManagementPolicy.  # noqa: E501
        :type: int
        """

        self._peak_power_budget_milli_watts = peak_power_budget_milli_watts

    @property
    def policy_enabled(self):
        """Gets the policy_enabled of this PowerManagementPolicy.  # noqa: E501

        Power management policy enabled status.  # noqa: E501

        :return: The policy_enabled of this PowerManagementPolicy.  # noqa: E501
        :rtype: bool
        """
        return self._policy_enabled

    @policy_enabled.setter
    def policy_enabled(self, policy_enabled):
        """Sets the policy_enabled of this PowerManagementPolicy.

        Power management policy enabled status.  # noqa: E501

        :param policy_enabled: The policy_enabled of this PowerManagementPolicy.  # noqa: E501
        :type: bool
        """

        self._policy_enabled = policy_enabled

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PowerManagementPolicy):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
