# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PowerMetric(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'average_consumed_watts': 'float',
        'interval_in_min': 'int',
        'max_consumed_watts': 'float',
        'min_consumed_watts': 'float'
    }

    attribute_map = {
        'average_consumed_watts': 'AverageConsumedWatts',
        'interval_in_min': 'IntervalInMin',
        'max_consumed_watts': 'MaxConsumedWatts',
        'min_consumed_watts': 'MinConsumedWatts'
    }

    def __init__(self, average_consumed_watts=None, interval_in_min=None, max_consumed_watts=None, min_consumed_watts=None):  # noqa: E501
        """PowerMetric - a model defined in OpenAPI"""  # noqa: E501

        self._average_consumed_watts = None
        self._interval_in_min = None
        self._max_consumed_watts = None
        self._min_consumed_watts = None
        self.discriminator = None

        self.average_consumed_watts = average_consumed_watts
        self.interval_in_min = interval_in_min
        self.max_consumed_watts = max_consumed_watts
        self.min_consumed_watts = min_consumed_watts

    @property
    def average_consumed_watts(self):
        """Gets the average_consumed_watts of this PowerMetric.  # noqa: E501

        The average power level over the measurement window (the last IntervalInMin minutes).  # noqa: E501

        :return: The average_consumed_watts of this PowerMetric.  # noqa: E501
        :rtype: float
        """
        return self._average_consumed_watts

    @average_consumed_watts.setter
    def average_consumed_watts(self, average_consumed_watts):
        """Sets the average_consumed_watts of this PowerMetric.

        The average power level over the measurement window (the last IntervalInMin minutes).  # noqa: E501

        :param average_consumed_watts: The average_consumed_watts of this PowerMetric.  # noqa: E501
        :type: float
        """
        if average_consumed_watts is not None and average_consumed_watts < 0:  # noqa: E501
            raise ValueError("Invalid value for `average_consumed_watts`, must be a value greater than or equal to `0`")  # noqa: E501

        self._average_consumed_watts = average_consumed_watts

    @property
    def interval_in_min(self):
        """Gets the interval_in_min of this PowerMetric.  # noqa: E501

        The time interval (or window) in which the PowerMetrics are measured over.  # noqa: E501

        :return: The interval_in_min of this PowerMetric.  # noqa: E501
        :rtype: int
        """
        return self._interval_in_min

    @interval_in_min.setter
    def interval_in_min(self, interval_in_min):
        """Sets the interval_in_min of this PowerMetric.

        The time interval (or window) in which the PowerMetrics are measured over.  # noqa: E501

        :param interval_in_min: The interval_in_min of this PowerMetric.  # noqa: E501
        :type: int
        """
        if interval_in_min is not None and interval_in_min < 0:  # noqa: E501
            raise ValueError("Invalid value for `interval_in_min`, must be a value greater than or equal to `0`")  # noqa: E501

        self._interval_in_min = interval_in_min

    @property
    def max_consumed_watts(self):
        """Gets the max_consumed_watts of this PowerMetric.  # noqa: E501

        The highest power consumption level that has occured over the measurement window (the last IntervalInMin minutes).  # noqa: E501

        :return: The max_consumed_watts of this PowerMetric.  # noqa: E501
        :rtype: float
        """
        return self._max_consumed_watts

    @max_consumed_watts.setter
    def max_consumed_watts(self, max_consumed_watts):
        """Sets the max_consumed_watts of this PowerMetric.

        The highest power consumption level that has occured over the measurement window (the last IntervalInMin minutes).  # noqa: E501

        :param max_consumed_watts: The max_consumed_watts of this PowerMetric.  # noqa: E501
        :type: float
        """
        if max_consumed_watts is not None and max_consumed_watts < 0:  # noqa: E501
            raise ValueError("Invalid value for `max_consumed_watts`, must be a value greater than or equal to `0`")  # noqa: E501

        self._max_consumed_watts = max_consumed_watts

    @property
    def min_consumed_watts(self):
        """Gets the min_consumed_watts of this PowerMetric.  # noqa: E501

        The lowest power consumption level over the measurement window (the last IntervalInMin minutes).  # noqa: E501

        :return: The min_consumed_watts of this PowerMetric.  # noqa: E501
        :rtype: float
        """
        return self._min_consumed_watts

    @min_consumed_watts.setter
    def min_consumed_watts(self, min_consumed_watts):
        """Sets the min_consumed_watts of this PowerMetric.

        The lowest power consumption level over the measurement window (the last IntervalInMin minutes).  # noqa: E501

        :param min_consumed_watts: The min_consumed_watts of this PowerMetric.  # noqa: E501
        :type: float
        """
        if min_consumed_watts is not None and min_consumed_watts < 0:  # noqa: E501
            raise ValueError("Invalid value for `min_consumed_watts`, must be a value greater than or equal to `0`")  # noqa: E501

        self._min_consumed_watts = min_consumed_watts

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PowerMetric):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
