# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PowerSupply(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_id': 'str',
        'actions': 'PowerSupplyActions',
        'assembly': 'IdRef',
        'efficiency_percent': 'float',
        'firmware_version': 'str',
        'hot_pluggable': 'bool',
        'indicator_led': 'IndicatorLED2',
        'input_ranges': 'list[InputRange]',
        'last_power_output_watts': 'float',
        'line_input_voltage': 'float',
        'line_input_voltage_type': 'LineInputVoltageType',
        'location': 'Location',
        'manufacturer': 'str',
        'member_id': 'str',
        'model': 'str',
        'name': 'str',
        'oem': 'dict(str, object)',
        'part_number': 'str',
        'power_capacity_watts': 'float',
        'power_input_watts': 'float',
        'power_output_watts': 'float',
        'power_supply_type': 'PowerSupplyType',
        'redundancy': 'list[IdRef]',
        'redundancyodata_count': 'int',
        'related_item': 'list[IdRef]',
        'related_itemodata_count': 'int',
        'serial_number': 'str',
        'spare_part_number': 'str',
        'status': 'Status'
    }

    attribute_map = {
        'odata_id': '@odata.id',
        'actions': 'Actions',
        'assembly': 'Assembly',
        'efficiency_percent': 'EfficiencyPercent',
        'firmware_version': 'FirmwareVersion',
        'hot_pluggable': 'HotPluggable',
        'indicator_led': 'IndicatorLED',
        'input_ranges': 'InputRanges',
        'last_power_output_watts': 'LastPowerOutputWatts',
        'line_input_voltage': 'LineInputVoltage',
        'line_input_voltage_type': 'LineInputVoltageType',
        'location': 'Location',
        'manufacturer': 'Manufacturer',
        'member_id': 'MemberId',
        'model': 'Model',
        'name': 'Name',
        'oem': 'Oem',
        'part_number': 'PartNumber',
        'power_capacity_watts': 'PowerCapacityWatts',
        'power_input_watts': 'PowerInputWatts',
        'power_output_watts': 'PowerOutputWatts',
        'power_supply_type': 'PowerSupplyType',
        'redundancy': 'Redundancy',
        'redundancyodata_count': 'Redundancy@odata.count',
        'related_item': 'RelatedItem',
        'related_itemodata_count': 'RelatedItem@odata.count',
        'serial_number': 'SerialNumber',
        'spare_part_number': 'SparePartNumber',
        'status': 'Status'
    }

    def __init__(self, odata_id=None, actions=None, assembly=None, efficiency_percent=None, firmware_version=None, hot_pluggable=None, indicator_led=None, input_ranges=None, last_power_output_watts=None, line_input_voltage=None, line_input_voltage_type=None, location=None, manufacturer=None, member_id=None, model=None, name=None, oem=None, part_number=None, power_capacity_watts=None, power_input_watts=None, power_output_watts=None, power_supply_type=None, redundancy=None, redundancyodata_count=None, related_item=None, related_itemodata_count=None, serial_number=None, spare_part_number=None, status=None):  # noqa: E501
        """PowerSupply - a model defined in OpenAPI"""  # noqa: E501

        self._odata_id = None
        self._actions = None
        self._assembly = None
        self._efficiency_percent = None
        self._firmware_version = None
        self._hot_pluggable = None
        self._indicator_led = None
        self._input_ranges = None
        self._last_power_output_watts = None
        self._line_input_voltage = None
        self._line_input_voltage_type = None
        self._location = None
        self._manufacturer = None
        self._member_id = None
        self._model = None
        self._name = None
        self._oem = None
        self._part_number = None
        self._power_capacity_watts = None
        self._power_input_watts = None
        self._power_output_watts = None
        self._power_supply_type = None
        self._redundancy = None
        self._redundancyodata_count = None
        self._related_item = None
        self._related_itemodata_count = None
        self._serial_number = None
        self._spare_part_number = None
        self._status = None
        self.discriminator = None

        self.odata_id = odata_id
        if actions is not None:
            self.actions = actions
        if assembly is not None:
            self.assembly = assembly
        self.efficiency_percent = efficiency_percent
        self.firmware_version = firmware_version
        self.hot_pluggable = hot_pluggable
        if indicator_led is not None:
            self.indicator_led = indicator_led
        if input_ranges is not None:
            self.input_ranges = input_ranges
        self.last_power_output_watts = last_power_output_watts
        self.line_input_voltage = line_input_voltage
        if line_input_voltage_type is not None:
            self.line_input_voltage_type = line_input_voltage_type
        if location is not None:
            self.location = location
        self.manufacturer = manufacturer
        self.member_id = member_id
        self.model = model
        self.name = name
        if oem is not None:
            self.oem = oem
        self.part_number = part_number
        self.power_capacity_watts = power_capacity_watts
        self.power_input_watts = power_input_watts
        self.power_output_watts = power_output_watts
        if power_supply_type is not None:
            self.power_supply_type = power_supply_type
        if redundancy is not None:
            self.redundancy = redundancy
        if redundancyodata_count is not None:
            self.redundancyodata_count = redundancyodata_count
        if related_item is not None:
            self.related_item = related_item
        if related_itemodata_count is not None:
            self.related_itemodata_count = related_itemodata_count
        self.serial_number = serial_number
        self.spare_part_number = spare_part_number
        if status is not None:
            self.status = status

    @property
    def odata_id(self):
        """Gets the odata_id of this PowerSupply.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this PowerSupply.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this PowerSupply.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this PowerSupply.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def actions(self):
        """Gets the actions of this PowerSupply.  # noqa: E501


        :return: The actions of this PowerSupply.  # noqa: E501
        :rtype: PowerSupplyActions
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this PowerSupply.


        :param actions: The actions of this PowerSupply.  # noqa: E501
        :type: PowerSupplyActions
        """

        self._actions = actions

    @property
    def assembly(self):
        """Gets the assembly of this PowerSupply.  # noqa: E501


        :return: The assembly of this PowerSupply.  # noqa: E501
        :rtype: IdRef
        """
        return self._assembly

    @assembly.setter
    def assembly(self, assembly):
        """Sets the assembly of this PowerSupply.


        :param assembly: The assembly of this PowerSupply.  # noqa: E501
        :type: IdRef
        """

        self._assembly = assembly

    @property
    def efficiency_percent(self):
        """Gets the efficiency_percent of this PowerSupply.  # noqa: E501

        The measured efficiency of this Power Supply as a percentage.  # noqa: E501

        :return: The efficiency_percent of this PowerSupply.  # noqa: E501
        :rtype: float
        """
        return self._efficiency_percent

    @efficiency_percent.setter
    def efficiency_percent(self, efficiency_percent):
        """Sets the efficiency_percent of this PowerSupply.

        The measured efficiency of this Power Supply as a percentage.  # noqa: E501

        :param efficiency_percent: The efficiency_percent of this PowerSupply.  # noqa: E501
        :type: float
        """
        if efficiency_percent is not None and efficiency_percent > 100:  # noqa: E501
            raise ValueError("Invalid value for `efficiency_percent`, must be a value less than or equal to `100`")  # noqa: E501
        if efficiency_percent is not None and efficiency_percent < 0:  # noqa: E501
            raise ValueError("Invalid value for `efficiency_percent`, must be a value greater than or equal to `0`")  # noqa: E501

        self._efficiency_percent = efficiency_percent

    @property
    def firmware_version(self):
        """Gets the firmware_version of this PowerSupply.  # noqa: E501

        The firmware version for this Power Supply.  # noqa: E501

        :return: The firmware_version of this PowerSupply.  # noqa: E501
        :rtype: str
        """
        return self._firmware_version

    @firmware_version.setter
    def firmware_version(self, firmware_version):
        """Sets the firmware_version of this PowerSupply.

        The firmware version for this Power Supply.  # noqa: E501

        :param firmware_version: The firmware_version of this PowerSupply.  # noqa: E501
        :type: str
        """

        self._firmware_version = firmware_version

    @property
    def hot_pluggable(self):
        """Gets the hot_pluggable of this PowerSupply.  # noqa: E501

        Indicates if this device can be inserted or removed while the equipment is in operation.  # noqa: E501

        :return: The hot_pluggable of this PowerSupply.  # noqa: E501
        :rtype: bool
        """
        return self._hot_pluggable

    @hot_pluggable.setter
    def hot_pluggable(self, hot_pluggable):
        """Sets the hot_pluggable of this PowerSupply.

        Indicates if this device can be inserted or removed while the equipment is in operation.  # noqa: E501

        :param hot_pluggable: The hot_pluggable of this PowerSupply.  # noqa: E501
        :type: bool
        """

        self._hot_pluggable = hot_pluggable

    @property
    def indicator_led(self):
        """Gets the indicator_led of this PowerSupply.  # noqa: E501


        :return: The indicator_led of this PowerSupply.  # noqa: E501
        :rtype: IndicatorLED2
        """
        return self._indicator_led

    @indicator_led.setter
    def indicator_led(self, indicator_led):
        """Sets the indicator_led of this PowerSupply.


        :param indicator_led: The indicator_led of this PowerSupply.  # noqa: E501
        :type: IndicatorLED2
        """

        self._indicator_led = indicator_led

    @property
    def input_ranges(self):
        """Gets the input_ranges of this PowerSupply.  # noqa: E501

        This is the input ranges that the power supply can use.  # noqa: E501

        :return: The input_ranges of this PowerSupply.  # noqa: E501
        :rtype: list[InputRange]
        """
        return self._input_ranges

    @input_ranges.setter
    def input_ranges(self, input_ranges):
        """Sets the input_ranges of this PowerSupply.

        This is the input ranges that the power supply can use.  # noqa: E501

        :param input_ranges: The input_ranges of this PowerSupply.  # noqa: E501
        :type: list[InputRange]
        """

        self._input_ranges = input_ranges

    @property
    def last_power_output_watts(self):
        """Gets the last_power_output_watts of this PowerSupply.  # noqa: E501

        The average power output of this Power Supply.  # noqa: E501

        :return: The last_power_output_watts of this PowerSupply.  # noqa: E501
        :rtype: float
        """
        return self._last_power_output_watts

    @last_power_output_watts.setter
    def last_power_output_watts(self, last_power_output_watts):
        """Sets the last_power_output_watts of this PowerSupply.

        The average power output of this Power Supply.  # noqa: E501

        :param last_power_output_watts: The last_power_output_watts of this PowerSupply.  # noqa: E501
        :type: float
        """
        if last_power_output_watts is not None and last_power_output_watts < 0:  # noqa: E501
            raise ValueError("Invalid value for `last_power_output_watts`, must be a value greater than or equal to `0`")  # noqa: E501

        self._last_power_output_watts = last_power_output_watts

    @property
    def line_input_voltage(self):
        """Gets the line_input_voltage of this PowerSupply.  # noqa: E501

        The line input voltage at which the Power Supply is operating.  # noqa: E501

        :return: The line_input_voltage of this PowerSupply.  # noqa: E501
        :rtype: float
        """
        return self._line_input_voltage

    @line_input_voltage.setter
    def line_input_voltage(self, line_input_voltage):
        """Sets the line_input_voltage of this PowerSupply.

        The line input voltage at which the Power Supply is operating.  # noqa: E501

        :param line_input_voltage: The line_input_voltage of this PowerSupply.  # noqa: E501
        :type: float
        """

        self._line_input_voltage = line_input_voltage

    @property
    def line_input_voltage_type(self):
        """Gets the line_input_voltage_type of this PowerSupply.  # noqa: E501


        :return: The line_input_voltage_type of this PowerSupply.  # noqa: E501
        :rtype: LineInputVoltageType
        """
        return self._line_input_voltage_type

    @line_input_voltage_type.setter
    def line_input_voltage_type(self, line_input_voltage_type):
        """Sets the line_input_voltage_type of this PowerSupply.


        :param line_input_voltage_type: The line_input_voltage_type of this PowerSupply.  # noqa: E501
        :type: LineInputVoltageType
        """

        self._line_input_voltage_type = line_input_voltage_type

    @property
    def location(self):
        """Gets the location of this PowerSupply.  # noqa: E501


        :return: The location of this PowerSupply.  # noqa: E501
        :rtype: Location
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this PowerSupply.


        :param location: The location of this PowerSupply.  # noqa: E501
        :type: Location
        """

        self._location = location

    @property
    def manufacturer(self):
        """Gets the manufacturer of this PowerSupply.  # noqa: E501

        This is the manufacturer of this power supply.  # noqa: E501

        :return: The manufacturer of this PowerSupply.  # noqa: E501
        :rtype: str
        """
        return self._manufacturer

    @manufacturer.setter
    def manufacturer(self, manufacturer):
        """Sets the manufacturer of this PowerSupply.

        This is the manufacturer of this power supply.  # noqa: E501

        :param manufacturer: The manufacturer of this PowerSupply.  # noqa: E501
        :type: str
        """

        self._manufacturer = manufacturer

    @property
    def member_id(self):
        """Gets the member_id of this PowerSupply.  # noqa: E501

        This is the identifier for the member within the collection.  # noqa: E501

        :return: The member_id of this PowerSupply.  # noqa: E501
        :rtype: str
        """
        return self._member_id

    @member_id.setter
    def member_id(self, member_id):
        """Sets the member_id of this PowerSupply.

        This is the identifier for the member within the collection.  # noqa: E501

        :param member_id: The member_id of this PowerSupply.  # noqa: E501
        :type: str
        """
        if member_id is None:
            raise ValueError("Invalid value for `member_id`, must not be `None`")  # noqa: E501

        self._member_id = member_id

    @property
    def model(self):
        """Gets the model of this PowerSupply.  # noqa: E501

        The model number for this Power Supply.  # noqa: E501

        :return: The model of this PowerSupply.  # noqa: E501
        :rtype: str
        """
        return self._model

    @model.setter
    def model(self, model):
        """Sets the model of this PowerSupply.

        The model number for this Power Supply.  # noqa: E501

        :param model: The model of this PowerSupply.  # noqa: E501
        :type: str
        """

        self._model = model

    @property
    def name(self):
        """Gets the name of this PowerSupply.  # noqa: E501

        The name of the Power Supply.  # noqa: E501

        :return: The name of this PowerSupply.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PowerSupply.

        The name of the Power Supply.  # noqa: E501

        :param name: The name of this PowerSupply.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def oem(self):
        """Gets the oem of this PowerSupply.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this PowerSupply.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this PowerSupply.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this PowerSupply.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def part_number(self):
        """Gets the part_number of this PowerSupply.  # noqa: E501

        The part number for this Power Supply.  # noqa: E501

        :return: The part_number of this PowerSupply.  # noqa: E501
        :rtype: str
        """
        return self._part_number

    @part_number.setter
    def part_number(self, part_number):
        """Sets the part_number of this PowerSupply.

        The part number for this Power Supply.  # noqa: E501

        :param part_number: The part_number of this PowerSupply.  # noqa: E501
        :type: str
        """

        self._part_number = part_number

    @property
    def power_capacity_watts(self):
        """Gets the power_capacity_watts of this PowerSupply.  # noqa: E501

        The maximum capacity of this Power Supply.  # noqa: E501

        :return: The power_capacity_watts of this PowerSupply.  # noqa: E501
        :rtype: float
        """
        return self._power_capacity_watts

    @power_capacity_watts.setter
    def power_capacity_watts(self, power_capacity_watts):
        """Sets the power_capacity_watts of this PowerSupply.

        The maximum capacity of this Power Supply.  # noqa: E501

        :param power_capacity_watts: The power_capacity_watts of this PowerSupply.  # noqa: E501
        :type: float
        """
        if power_capacity_watts is not None and power_capacity_watts < 0:  # noqa: E501
            raise ValueError("Invalid value for `power_capacity_watts`, must be a value greater than or equal to `0`")  # noqa: E501

        self._power_capacity_watts = power_capacity_watts

    @property
    def power_input_watts(self):
        """Gets the power_input_watts of this PowerSupply.  # noqa: E501

        The measured input power of this Power Supply.  # noqa: E501

        :return: The power_input_watts of this PowerSupply.  # noqa: E501
        :rtype: float
        """
        return self._power_input_watts

    @power_input_watts.setter
    def power_input_watts(self, power_input_watts):
        """Sets the power_input_watts of this PowerSupply.

        The measured input power of this Power Supply.  # noqa: E501

        :param power_input_watts: The power_input_watts of this PowerSupply.  # noqa: E501
        :type: float
        """
        if power_input_watts is not None and power_input_watts < 0:  # noqa: E501
            raise ValueError("Invalid value for `power_input_watts`, must be a value greater than or equal to `0`")  # noqa: E501

        self._power_input_watts = power_input_watts

    @property
    def power_output_watts(self):
        """Gets the power_output_watts of this PowerSupply.  # noqa: E501

        The measured output power of this Power Supply.  # noqa: E501

        :return: The power_output_watts of this PowerSupply.  # noqa: E501
        :rtype: float
        """
        return self._power_output_watts

    @power_output_watts.setter
    def power_output_watts(self, power_output_watts):
        """Sets the power_output_watts of this PowerSupply.

        The measured output power of this Power Supply.  # noqa: E501

        :param power_output_watts: The power_output_watts of this PowerSupply.  # noqa: E501
        :type: float
        """
        if power_output_watts is not None and power_output_watts < 0:  # noqa: E501
            raise ValueError("Invalid value for `power_output_watts`, must be a value greater than or equal to `0`")  # noqa: E501

        self._power_output_watts = power_output_watts

    @property
    def power_supply_type(self):
        """Gets the power_supply_type of this PowerSupply.  # noqa: E501


        :return: The power_supply_type of this PowerSupply.  # noqa: E501
        :rtype: PowerSupplyType
        """
        return self._power_supply_type

    @power_supply_type.setter
    def power_supply_type(self, power_supply_type):
        """Sets the power_supply_type of this PowerSupply.


        :param power_supply_type: The power_supply_type of this PowerSupply.  # noqa: E501
        :type: PowerSupplyType
        """

        self._power_supply_type = power_supply_type

    @property
    def redundancy(self):
        """Gets the redundancy of this PowerSupply.  # noqa: E501

        This structure is used to show redundancy for power supplies.  The Component ids will reference the members of the redundancy groups.  # noqa: E501

        :return: The redundancy of this PowerSupply.  # noqa: E501
        :rtype: list[IdRef]
        """
        return self._redundancy

    @redundancy.setter
    def redundancy(self, redundancy):
        """Sets the redundancy of this PowerSupply.

        This structure is used to show redundancy for power supplies.  The Component ids will reference the members of the redundancy groups.  # noqa: E501

        :param redundancy: The redundancy of this PowerSupply.  # noqa: E501
        :type: list[IdRef]
        """

        self._redundancy = redundancy

    @property
    def redundancyodata_count(self):
        """Gets the redundancyodata_count of this PowerSupply.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The redundancyodata_count of this PowerSupply.  # noqa: E501
        :rtype: int
        """
        return self._redundancyodata_count

    @redundancyodata_count.setter
    def redundancyodata_count(self, redundancyodata_count):
        """Sets the redundancyodata_count of this PowerSupply.

        The number of items in a collection.  # noqa: E501

        :param redundancyodata_count: The redundancyodata_count of this PowerSupply.  # noqa: E501
        :type: int
        """

        self._redundancyodata_count = redundancyodata_count

    @property
    def related_item(self):
        """Gets the related_item of this PowerSupply.  # noqa: E501

        The ID(s) of the resources associated with this Power Limit.  # noqa: E501

        :return: The related_item of this PowerSupply.  # noqa: E501
        :rtype: list[IdRef]
        """
        return self._related_item

    @related_item.setter
    def related_item(self, related_item):
        """Sets the related_item of this PowerSupply.

        The ID(s) of the resources associated with this Power Limit.  # noqa: E501

        :param related_item: The related_item of this PowerSupply.  # noqa: E501
        :type: list[IdRef]
        """

        self._related_item = related_item

    @property
    def related_itemodata_count(self):
        """Gets the related_itemodata_count of this PowerSupply.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The related_itemodata_count of this PowerSupply.  # noqa: E501
        :rtype: int
        """
        return self._related_itemodata_count

    @related_itemodata_count.setter
    def related_itemodata_count(self, related_itemodata_count):
        """Sets the related_itemodata_count of this PowerSupply.

        The number of items in a collection.  # noqa: E501

        :param related_itemodata_count: The related_itemodata_count of this PowerSupply.  # noqa: E501
        :type: int
        """

        self._related_itemodata_count = related_itemodata_count

    @property
    def serial_number(self):
        """Gets the serial_number of this PowerSupply.  # noqa: E501

        The serial number for this Power Supply.  # noqa: E501

        :return: The serial_number of this PowerSupply.  # noqa: E501
        :rtype: str
        """
        return self._serial_number

    @serial_number.setter
    def serial_number(self, serial_number):
        """Sets the serial_number of this PowerSupply.

        The serial number for this Power Supply.  # noqa: E501

        :param serial_number: The serial_number of this PowerSupply.  # noqa: E501
        :type: str
        """

        self._serial_number = serial_number

    @property
    def spare_part_number(self):
        """Gets the spare_part_number of this PowerSupply.  # noqa: E501

        The spare part number for this Power Supply.  # noqa: E501

        :return: The spare_part_number of this PowerSupply.  # noqa: E501
        :rtype: str
        """
        return self._spare_part_number

    @spare_part_number.setter
    def spare_part_number(self, spare_part_number):
        """Sets the spare_part_number of this PowerSupply.

        The spare part number for this Power Supply.  # noqa: E501

        :param spare_part_number: The spare_part_number of this PowerSupply.  # noqa: E501
        :type: str
        """

        self._spare_part_number = spare_part_number

    @property
    def status(self):
        """Gets the status of this PowerSupply.  # noqa: E501


        :return: The status of this PowerSupply.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this PowerSupply.


        :param status: The status of this PowerSupply.  # noqa: E501
        :type: Status
        """

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PowerSupply):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
