# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Processor(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_context': 'str',
        'odata_etag': 'str',
        'odata_id': 'str',
        'odata_type': 'str',
        'acceleration_functions': 'IdRef',
        'actions': 'Actions2',
        'assembly': 'IdRef',
        'description': 'str',
        'fpga': 'FPGA',
        'id': 'str',
        'instruction_set': 'InstructionSet',
        'links': 'Links2',
        'location': 'Location',
        'manufacturer': 'str',
        'max_speed_m_hz': 'int',
        'max_tdp_watts': 'int',
        'metrics': 'IdRef',
        'model': 'str',
        'name': 'str',
        'oem': 'dict(str, object)',
        'processor_architecture': 'ProcessorArchitecture',
        'processor_id': 'ProcessorId',
        'processor_memory': 'list[ProcessorMemory]',
        'processor_type': 'ProcessorType',
        'socket': 'str',
        'status': 'Status',
        'sub_processors': 'IdRef',
        'tdp_watts': 'int',
        'total_cores': 'int',
        'total_threads': 'int',
        'uuid': 'str'
    }

    attribute_map = {
        'odata_context': '@odata.context',
        'odata_etag': '@odata.etag',
        'odata_id': '@odata.id',
        'odata_type': '@odata.type',
        'acceleration_functions': 'AccelerationFunctions',
        'actions': 'Actions',
        'assembly': 'Assembly',
        'description': 'Description',
        'fpga': 'FPGA',
        'id': 'Id',
        'instruction_set': 'InstructionSet',
        'links': 'Links',
        'location': 'Location',
        'manufacturer': 'Manufacturer',
        'max_speed_m_hz': 'MaxSpeedMHz',
        'max_tdp_watts': 'MaxTDPWatts',
        'metrics': 'Metrics',
        'model': 'Model',
        'name': 'Name',
        'oem': 'Oem',
        'processor_architecture': 'ProcessorArchitecture',
        'processor_id': 'ProcessorId',
        'processor_memory': 'ProcessorMemory',
        'processor_type': 'ProcessorType',
        'socket': 'Socket',
        'status': 'Status',
        'sub_processors': 'SubProcessors',
        'tdp_watts': 'TDPWatts',
        'total_cores': 'TotalCores',
        'total_threads': 'TotalThreads',
        'uuid': 'UUID'
    }

    def __init__(self, odata_context=None, odata_etag=None, odata_id=None, odata_type=None, acceleration_functions=None, actions=None, assembly=None, description=None, fpga=None, id=None, instruction_set=None, links=None, location=None, manufacturer=None, max_speed_m_hz=None, max_tdp_watts=None, metrics=None, model=None, name=None, oem=None, processor_architecture=None, processor_id=None, processor_memory=None, processor_type=None, socket=None, status=None, sub_processors=None, tdp_watts=None, total_cores=None, total_threads=None, uuid=None):  # noqa: E501
        """Processor - a model defined in OpenAPI"""  # noqa: E501

        self._odata_context = None
        self._odata_etag = None
        self._odata_id = None
        self._odata_type = None
        self._acceleration_functions = None
        self._actions = None
        self._assembly = None
        self._description = None
        self._fpga = None
        self._id = None
        self._instruction_set = None
        self._links = None
        self._location = None
        self._manufacturer = None
        self._max_speed_m_hz = None
        self._max_tdp_watts = None
        self._metrics = None
        self._model = None
        self._name = None
        self._oem = None
        self._processor_architecture = None
        self._processor_id = None
        self._processor_memory = None
        self._processor_type = None
        self._socket = None
        self._status = None
        self._sub_processors = None
        self._tdp_watts = None
        self._total_cores = None
        self._total_threads = None
        self._uuid = None
        self.discriminator = None

        if odata_context is not None:
            self.odata_context = odata_context
        if odata_etag is not None:
            self.odata_etag = odata_etag
        self.odata_id = odata_id
        self.odata_type = odata_type
        if acceleration_functions is not None:
            self.acceleration_functions = acceleration_functions
        if actions is not None:
            self.actions = actions
        if assembly is not None:
            self.assembly = assembly
        if description is not None:
            self.description = description
        if fpga is not None:
            self.fpga = fpga
        self.id = id
        if instruction_set is not None:
            self.instruction_set = instruction_set
        if links is not None:
            self.links = links
        if location is not None:
            self.location = location
        self.manufacturer = manufacturer
        self.max_speed_m_hz = max_speed_m_hz
        self.max_tdp_watts = max_tdp_watts
        if metrics is not None:
            self.metrics = metrics
        self.model = model
        self.name = name
        if oem is not None:
            self.oem = oem
        if processor_architecture is not None:
            self.processor_architecture = processor_architecture
        if processor_id is not None:
            self.processor_id = processor_id
        if processor_memory is not None:
            self.processor_memory = processor_memory
        if processor_type is not None:
            self.processor_type = processor_type
        self.socket = socket
        if status is not None:
            self.status = status
        if sub_processors is not None:
            self.sub_processors = sub_processors
        self.tdp_watts = tdp_watts
        self.total_cores = total_cores
        self.total_threads = total_threads
        if uuid is not None:
            self.uuid = uuid

    @property
    def odata_context(self):
        """Gets the odata_context of this Processor.  # noqa: E501

        The OData description of a payload.  # noqa: E501

        :return: The odata_context of this Processor.  # noqa: E501
        :rtype: str
        """
        return self._odata_context

    @odata_context.setter
    def odata_context(self, odata_context):
        """Sets the odata_context of this Processor.

        The OData description of a payload.  # noqa: E501

        :param odata_context: The odata_context of this Processor.  # noqa: E501
        :type: str
        """

        self._odata_context = odata_context

    @property
    def odata_etag(self):
        """Gets the odata_etag of this Processor.  # noqa: E501

        The current ETag of the resource.  # noqa: E501

        :return: The odata_etag of this Processor.  # noqa: E501
        :rtype: str
        """
        return self._odata_etag

    @odata_etag.setter
    def odata_etag(self, odata_etag):
        """Sets the odata_etag of this Processor.

        The current ETag of the resource.  # noqa: E501

        :param odata_etag: The odata_etag of this Processor.  # noqa: E501
        :type: str
        """

        self._odata_etag = odata_etag

    @property
    def odata_id(self):
        """Gets the odata_id of this Processor.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this Processor.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this Processor.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this Processor.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def odata_type(self):
        """Gets the odata_type of this Processor.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this Processor.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this Processor.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this Processor.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def acceleration_functions(self):
        """Gets the acceleration_functions of this Processor.  # noqa: E501


        :return: The acceleration_functions of this Processor.  # noqa: E501
        :rtype: IdRef
        """
        return self._acceleration_functions

    @acceleration_functions.setter
    def acceleration_functions(self, acceleration_functions):
        """Sets the acceleration_functions of this Processor.


        :param acceleration_functions: The acceleration_functions of this Processor.  # noqa: E501
        :type: IdRef
        """

        self._acceleration_functions = acceleration_functions

    @property
    def actions(self):
        """Gets the actions of this Processor.  # noqa: E501


        :return: The actions of this Processor.  # noqa: E501
        :rtype: Actions2
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this Processor.


        :param actions: The actions of this Processor.  # noqa: E501
        :type: Actions2
        """

        self._actions = actions

    @property
    def assembly(self):
        """Gets the assembly of this Processor.  # noqa: E501


        :return: The assembly of this Processor.  # noqa: E501
        :rtype: IdRef
        """
        return self._assembly

    @assembly.setter
    def assembly(self, assembly):
        """Sets the assembly of this Processor.


        :param assembly: The assembly of this Processor.  # noqa: E501
        :type: IdRef
        """

        self._assembly = assembly

    @property
    def description(self):
        """Gets the description of this Processor.  # noqa: E501

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :return: The description of this Processor.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Processor.

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :param description: The description of this Processor.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def fpga(self):
        """Gets the fpga of this Processor.  # noqa: E501


        :return: The fpga of this Processor.  # noqa: E501
        :rtype: FPGA
        """
        return self._fpga

    @fpga.setter
    def fpga(self, fpga):
        """Sets the fpga of this Processor.


        :param fpga: The fpga of this Processor.  # noqa: E501
        :type: FPGA
        """

        self._fpga = fpga

    @property
    def id(self):
        """Gets the id of this Processor.  # noqa: E501

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :return: The id of this Processor.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Processor.

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :param id: The id of this Processor.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def instruction_set(self):
        """Gets the instruction_set of this Processor.  # noqa: E501


        :return: The instruction_set of this Processor.  # noqa: E501
        :rtype: InstructionSet
        """
        return self._instruction_set

    @instruction_set.setter
    def instruction_set(self, instruction_set):
        """Sets the instruction_set of this Processor.


        :param instruction_set: The instruction_set of this Processor.  # noqa: E501
        :type: InstructionSet
        """

        self._instruction_set = instruction_set

    @property
    def links(self):
        """Gets the links of this Processor.  # noqa: E501


        :return: The links of this Processor.  # noqa: E501
        :rtype: Links2
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this Processor.


        :param links: The links of this Processor.  # noqa: E501
        :type: Links2
        """

        self._links = links

    @property
    def location(self):
        """Gets the location of this Processor.  # noqa: E501


        :return: The location of this Processor.  # noqa: E501
        :rtype: Location
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this Processor.


        :param location: The location of this Processor.  # noqa: E501
        :type: Location
        """

        self._location = location

    @property
    def manufacturer(self):
        """Gets the manufacturer of this Processor.  # noqa: E501

        The processor manufacturer.  # noqa: E501

        :return: The manufacturer of this Processor.  # noqa: E501
        :rtype: str
        """
        return self._manufacturer

    @manufacturer.setter
    def manufacturer(self, manufacturer):
        """Sets the manufacturer of this Processor.

        The processor manufacturer.  # noqa: E501

        :param manufacturer: The manufacturer of this Processor.  # noqa: E501
        :type: str
        """

        self._manufacturer = manufacturer

    @property
    def max_speed_m_hz(self):
        """Gets the max_speed_m_hz of this Processor.  # noqa: E501

        The maximum clock speed of the processor.  # noqa: E501

        :return: The max_speed_m_hz of this Processor.  # noqa: E501
        :rtype: int
        """
        return self._max_speed_m_hz

    @max_speed_m_hz.setter
    def max_speed_m_hz(self, max_speed_m_hz):
        """Sets the max_speed_m_hz of this Processor.

        The maximum clock speed of the processor.  # noqa: E501

        :param max_speed_m_hz: The max_speed_m_hz of this Processor.  # noqa: E501
        :type: int
        """

        self._max_speed_m_hz = max_speed_m_hz

    @property
    def max_tdp_watts(self):
        """Gets the max_tdp_watts of this Processor.  # noqa: E501

        The maximum Thermal Design Power (TDP) in watts.  # noqa: E501

        :return: The max_tdp_watts of this Processor.  # noqa: E501
        :rtype: int
        """
        return self._max_tdp_watts

    @max_tdp_watts.setter
    def max_tdp_watts(self, max_tdp_watts):
        """Sets the max_tdp_watts of this Processor.

        The maximum Thermal Design Power (TDP) in watts.  # noqa: E501

        :param max_tdp_watts: The max_tdp_watts of this Processor.  # noqa: E501
        :type: int
        """

        self._max_tdp_watts = max_tdp_watts

    @property
    def metrics(self):
        """Gets the metrics of this Processor.  # noqa: E501


        :return: The metrics of this Processor.  # noqa: E501
        :rtype: IdRef
        """
        return self._metrics

    @metrics.setter
    def metrics(self, metrics):
        """Sets the metrics of this Processor.


        :param metrics: The metrics of this Processor.  # noqa: E501
        :type: IdRef
        """

        self._metrics = metrics

    @property
    def model(self):
        """Gets the model of this Processor.  # noqa: E501

        The product model number of this device.  # noqa: E501

        :return: The model of this Processor.  # noqa: E501
        :rtype: str
        """
        return self._model

    @model.setter
    def model(self, model):
        """Sets the model of this Processor.

        The product model number of this device.  # noqa: E501

        :param model: The model of this Processor.  # noqa: E501
        :type: str
        """

        self._model = model

    @property
    def name(self):
        """Gets the name of this Processor.  # noqa: E501

        The name of the resource or array member.  # noqa: E501

        :return: The name of this Processor.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Processor.

        The name of the resource or array member.  # noqa: E501

        :param name: The name of this Processor.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def oem(self):
        """Gets the oem of this Processor.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this Processor.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this Processor.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this Processor.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def processor_architecture(self):
        """Gets the processor_architecture of this Processor.  # noqa: E501


        :return: The processor_architecture of this Processor.  # noqa: E501
        :rtype: ProcessorArchitecture
        """
        return self._processor_architecture

    @processor_architecture.setter
    def processor_architecture(self, processor_architecture):
        """Sets the processor_architecture of this Processor.


        :param processor_architecture: The processor_architecture of this Processor.  # noqa: E501
        :type: ProcessorArchitecture
        """

        self._processor_architecture = processor_architecture

    @property
    def processor_id(self):
        """Gets the processor_id of this Processor.  # noqa: E501


        :return: The processor_id of this Processor.  # noqa: E501
        :rtype: ProcessorId
        """
        return self._processor_id

    @processor_id.setter
    def processor_id(self, processor_id):
        """Sets the processor_id of this Processor.


        :param processor_id: The processor_id of this Processor.  # noqa: E501
        :type: ProcessorId
        """

        self._processor_id = processor_id

    @property
    def processor_memory(self):
        """Gets the processor_memory of this Processor.  # noqa: E501

        The memory directly attached or integrated witin this Procesor.  # noqa: E501

        :return: The processor_memory of this Processor.  # noqa: E501
        :rtype: list[ProcessorMemory]
        """
        return self._processor_memory

    @processor_memory.setter
    def processor_memory(self, processor_memory):
        """Sets the processor_memory of this Processor.

        The memory directly attached or integrated witin this Procesor.  # noqa: E501

        :param processor_memory: The processor_memory of this Processor.  # noqa: E501
        :type: list[ProcessorMemory]
        """

        self._processor_memory = processor_memory

    @property
    def processor_type(self):
        """Gets the processor_type of this Processor.  # noqa: E501


        :return: The processor_type of this Processor.  # noqa: E501
        :rtype: ProcessorType
        """
        return self._processor_type

    @processor_type.setter
    def processor_type(self, processor_type):
        """Sets the processor_type of this Processor.


        :param processor_type: The processor_type of this Processor.  # noqa: E501
        :type: ProcessorType
        """

        self._processor_type = processor_type

    @property
    def socket(self):
        """Gets the socket of this Processor.  # noqa: E501

        The socket or location of the processor.  # noqa: E501

        :return: The socket of this Processor.  # noqa: E501
        :rtype: str
        """
        return self._socket

    @socket.setter
    def socket(self, socket):
        """Sets the socket of this Processor.

        The socket or location of the processor.  # noqa: E501

        :param socket: The socket of this Processor.  # noqa: E501
        :type: str
        """

        self._socket = socket

    @property
    def status(self):
        """Gets the status of this Processor.  # noqa: E501


        :return: The status of this Processor.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this Processor.


        :param status: The status of this Processor.  # noqa: E501
        :type: Status
        """

        self._status = status

    @property
    def sub_processors(self):
        """Gets the sub_processors of this Processor.  # noqa: E501


        :return: The sub_processors of this Processor.  # noqa: E501
        :rtype: IdRef
        """
        return self._sub_processors

    @sub_processors.setter
    def sub_processors(self, sub_processors):
        """Sets the sub_processors of this Processor.


        :param sub_processors: The sub_processors of this Processor.  # noqa: E501
        :type: IdRef
        """

        self._sub_processors = sub_processors

    @property
    def tdp_watts(self):
        """Gets the tdp_watts of this Processor.  # noqa: E501

        The nominal Thermal Design Power (TDP) in watts.  # noqa: E501

        :return: The tdp_watts of this Processor.  # noqa: E501
        :rtype: int
        """
        return self._tdp_watts

    @tdp_watts.setter
    def tdp_watts(self, tdp_watts):
        """Sets the tdp_watts of this Processor.

        The nominal Thermal Design Power (TDP) in watts.  # noqa: E501

        :param tdp_watts: The tdp_watts of this Processor.  # noqa: E501
        :type: int
        """

        self._tdp_watts = tdp_watts

    @property
    def total_cores(self):
        """Gets the total_cores of this Processor.  # noqa: E501

        The total number of cores contained in this processor.  # noqa: E501

        :return: The total_cores of this Processor.  # noqa: E501
        :rtype: int
        """
        return self._total_cores

    @total_cores.setter
    def total_cores(self, total_cores):
        """Sets the total_cores of this Processor.

        The total number of cores contained in this processor.  # noqa: E501

        :param total_cores: The total_cores of this Processor.  # noqa: E501
        :type: int
        """

        self._total_cores = total_cores

    @property
    def total_threads(self):
        """Gets the total_threads of this Processor.  # noqa: E501

        The total number of execution threads supported by this processor.  # noqa: E501

        :return: The total_threads of this Processor.  # noqa: E501
        :rtype: int
        """
        return self._total_threads

    @total_threads.setter
    def total_threads(self, total_threads):
        """Sets the total_threads of this Processor.

        The total number of execution threads supported by this processor.  # noqa: E501

        :param total_threads: The total_threads of this Processor.  # noqa: E501
        :type: int
        """

        self._total_threads = total_threads

    @property
    def uuid(self):
        """Gets the uuid of this Processor.  # noqa: E501


        :return: The uuid of this Processor.  # noqa: E501
        :rtype: str
        """
        return self._uuid

    @uuid.setter
    def uuid(self, uuid):
        """Sets the uuid of this Processor.


        :param uuid: The uuid of this Processor.  # noqa: E501
        :type: str
        """
        if uuid is not None and not re.search(r'([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12})', uuid):  # noqa: E501
            raise ValueError(r"Invalid value for `uuid`, must be a follow pattern or equal to `/([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12})/`")  # noqa: E501

        self._uuid = uuid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Processor):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
