# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class ProcessorCollection(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_context': 'str',
        'odata_etag': 'str',
        'odata_id': 'str',
        'odata_type': 'str',
        'description': 'str',
        'members': 'list[IdRef2]',
        'membersodata_count': 'int',
        'membersodata_next_link': 'str',
        'name': 'str',
        'oem': 'dict(str, object)'
    }

    attribute_map = {
        'odata_context': '@odata.context',
        'odata_etag': '@odata.etag',
        'odata_id': '@odata.id',
        'odata_type': '@odata.type',
        'description': 'Description',
        'members': 'Members',
        'membersodata_count': 'Members@odata.count',
        'membersodata_next_link': 'Members@odata.nextLink',
        'name': 'Name',
        'oem': 'Oem'
    }

    def __init__(self, odata_context=None, odata_etag=None, odata_id=None, odata_type=None, description=None, members=None, membersodata_count=None, membersodata_next_link=None, name=None, oem=None):  # noqa: E501
        """ProcessorCollection - a model defined in OpenAPI"""  # noqa: E501

        self._odata_context = None
        self._odata_etag = None
        self._odata_id = None
        self._odata_type = None
        self._description = None
        self._members = None
        self._membersodata_count = None
        self._membersodata_next_link = None
        self._name = None
        self._oem = None
        self.discriminator = None

        if odata_context is not None:
            self.odata_context = odata_context
        if odata_etag is not None:
            self.odata_etag = odata_etag
        self.odata_id = odata_id
        self.odata_type = odata_type
        if description is not None:
            self.description = description
        self.members = members
        self.membersodata_count = membersodata_count
        if membersodata_next_link is not None:
            self.membersodata_next_link = membersodata_next_link
        self.name = name
        if oem is not None:
            self.oem = oem

    @property
    def odata_context(self):
        """Gets the odata_context of this ProcessorCollection.  # noqa: E501

        The OData description of a payload.  # noqa: E501

        :return: The odata_context of this ProcessorCollection.  # noqa: E501
        :rtype: str
        """
        return self._odata_context

    @odata_context.setter
    def odata_context(self, odata_context):
        """Sets the odata_context of this ProcessorCollection.

        The OData description of a payload.  # noqa: E501

        :param odata_context: The odata_context of this ProcessorCollection.  # noqa: E501
        :type: str
        """

        self._odata_context = odata_context

    @property
    def odata_etag(self):
        """Gets the odata_etag of this ProcessorCollection.  # noqa: E501

        The current ETag of the resource.  # noqa: E501

        :return: The odata_etag of this ProcessorCollection.  # noqa: E501
        :rtype: str
        """
        return self._odata_etag

    @odata_etag.setter
    def odata_etag(self, odata_etag):
        """Sets the odata_etag of this ProcessorCollection.

        The current ETag of the resource.  # noqa: E501

        :param odata_etag: The odata_etag of this ProcessorCollection.  # noqa: E501
        :type: str
        """

        self._odata_etag = odata_etag

    @property
    def odata_id(self):
        """Gets the odata_id of this ProcessorCollection.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this ProcessorCollection.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this ProcessorCollection.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this ProcessorCollection.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def odata_type(self):
        """Gets the odata_type of this ProcessorCollection.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this ProcessorCollection.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this ProcessorCollection.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this ProcessorCollection.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def description(self):
        """Gets the description of this ProcessorCollection.  # noqa: E501

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :return: The description of this ProcessorCollection.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ProcessorCollection.

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :param description: The description of this ProcessorCollection.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def members(self):
        """Gets the members of this ProcessorCollection.  # noqa: E501

        The members of this collection.  # noqa: E501

        :return: The members of this ProcessorCollection.  # noqa: E501
        :rtype: list[IdRef2]
        """
        return self._members

    @members.setter
    def members(self, members):
        """Sets the members of this ProcessorCollection.

        The members of this collection.  # noqa: E501

        :param members: The members of this ProcessorCollection.  # noqa: E501
        :type: list[IdRef2]
        """
        if members is None:
            raise ValueError("Invalid value for `members`, must not be `None`")  # noqa: E501

        self._members = members

    @property
    def membersodata_count(self):
        """Gets the membersodata_count of this ProcessorCollection.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The membersodata_count of this ProcessorCollection.  # noqa: E501
        :rtype: int
        """
        return self._membersodata_count

    @membersodata_count.setter
    def membersodata_count(self, membersodata_count):
        """Sets the membersodata_count of this ProcessorCollection.

        The number of items in a collection.  # noqa: E501

        :param membersodata_count: The membersodata_count of this ProcessorCollection.  # noqa: E501
        :type: int
        """
        if membersodata_count is None:
            raise ValueError("Invalid value for `membersodata_count`, must not be `None`")  # noqa: E501

        self._membersodata_count = membersodata_count

    @property
    def membersodata_next_link(self):
        """Gets the membersodata_next_link of this ProcessorCollection.  # noqa: E501

        The URI to the resource containing the next set of partial members.  # noqa: E501

        :return: The membersodata_next_link of this ProcessorCollection.  # noqa: E501
        :rtype: str
        """
        return self._membersodata_next_link

    @membersodata_next_link.setter
    def membersodata_next_link(self, membersodata_next_link):
        """Sets the membersodata_next_link of this ProcessorCollection.

        The URI to the resource containing the next set of partial members.  # noqa: E501

        :param membersodata_next_link: The membersodata_next_link of this ProcessorCollection.  # noqa: E501
        :type: str
        """

        self._membersodata_next_link = membersodata_next_link

    @property
    def name(self):
        """Gets the name of this ProcessorCollection.  # noqa: E501

        The name of the resource or array member.  # noqa: E501

        :return: The name of this ProcessorCollection.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ProcessorCollection.

        The name of the resource or array member.  # noqa: E501

        :param name: The name of this ProcessorCollection.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def oem(self):
        """Gets the oem of this ProcessorCollection.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this ProcessorCollection.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this ProcessorCollection.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this ProcessorCollection.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProcessorCollection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
