# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class ProcessorError(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'processor_vendor': 'str',
        'processor_id': 'str',
        'error_message': 'str',
        'error_time_stamp': 'str',
        'raw_error_data': 'RawError',
        'odata_type': 'str'
    }

    attribute_map = {
        'processor_vendor': 'ProcessorVendor',
        'processor_id': 'ProcessorId',
        'error_message': 'ErrorMessage',
        'error_time_stamp': 'ErrorTimeStamp',
        'raw_error_data': 'RawErrorData',
        'odata_type': '@odata.type'
    }

    def __init__(self, processor_vendor=None, processor_id=None, error_message=None, error_time_stamp=None, raw_error_data=None, odata_type=None):  # noqa: E501
        """ProcessorError - a model defined in OpenAPI"""  # noqa: E501

        self._processor_vendor = None
        self._processor_id = None
        self._error_message = None
        self._error_time_stamp = None
        self._raw_error_data = None
        self._odata_type = None
        self.discriminator = None

        self.processor_vendor = processor_vendor
        self.processor_id = processor_id
        self.error_message = error_message
        self.error_time_stamp = error_time_stamp
        self.raw_error_data = raw_error_data
        self.odata_type = odata_type

    @property
    def processor_vendor(self):
        """Gets the processor_vendor of this ProcessorError.  # noqa: E501

        the processor vendor  # noqa: E501

        :return: The processor_vendor of this ProcessorError.  # noqa: E501
        :rtype: str
        """
        return self._processor_vendor

    @processor_vendor.setter
    def processor_vendor(self, processor_vendor):
        """Sets the processor_vendor of this ProcessorError.

        the processor vendor  # noqa: E501

        :param processor_vendor: The processor_vendor of this ProcessorError.  # noqa: E501
        :type: str
        """
        if processor_vendor is None:
            raise ValueError("Invalid value for `processor_vendor`, must not be `None`")  # noqa: E501

        self._processor_vendor = processor_vendor

    @property
    def processor_id(self):
        """Gets the processor_id of this ProcessorError.  # noqa: E501

        the processor id  # noqa: E501

        :return: The processor_id of this ProcessorError.  # noqa: E501
        :rtype: str
        """
        return self._processor_id

    @processor_id.setter
    def processor_id(self, processor_id):
        """Sets the processor_id of this ProcessorError.

        the processor id  # noqa: E501

        :param processor_id: The processor_id of this ProcessorError.  # noqa: E501
        :type: str
        """
        if processor_id is None:
            raise ValueError("Invalid value for `processor_id`, must not be `None`")  # noqa: E501

        self._processor_id = processor_id

    @property
    def error_message(self):
        """Gets the error_message of this ProcessorError.  # noqa: E501

        the error message  # noqa: E501

        :return: The error_message of this ProcessorError.  # noqa: E501
        :rtype: str
        """
        return self._error_message

    @error_message.setter
    def error_message(self, error_message):
        """Sets the error_message of this ProcessorError.

        the error message  # noqa: E501

        :param error_message: The error_message of this ProcessorError.  # noqa: E501
        :type: str
        """
        if error_message is None:
            raise ValueError("Invalid value for `error_message`, must not be `None`")  # noqa: E501

        self._error_message = error_message

    @property
    def error_time_stamp(self):
        """Gets the error_time_stamp of this ProcessorError.  # noqa: E501

        the error time stamp  # noqa: E501

        :return: The error_time_stamp of this ProcessorError.  # noqa: E501
        :rtype: str
        """
        return self._error_time_stamp

    @error_time_stamp.setter
    def error_time_stamp(self, error_time_stamp):
        """Sets the error_time_stamp of this ProcessorError.

        the error time stamp  # noqa: E501

        :param error_time_stamp: The error_time_stamp of this ProcessorError.  # noqa: E501
        :type: str
        """
        if error_time_stamp is None:
            raise ValueError("Invalid value for `error_time_stamp`, must not be `None`")  # noqa: E501

        self._error_time_stamp = error_time_stamp

    @property
    def raw_error_data(self):
        """Gets the raw_error_data of this ProcessorError.  # noqa: E501


        :return: The raw_error_data of this ProcessorError.  # noqa: E501
        :rtype: RawError
        """
        return self._raw_error_data

    @raw_error_data.setter
    def raw_error_data(self, raw_error_data):
        """Sets the raw_error_data of this ProcessorError.


        :param raw_error_data: The raw_error_data of this ProcessorError.  # noqa: E501
        :type: RawError
        """
        if raw_error_data is None:
            raise ValueError("Invalid value for `raw_error_data`, must not be `None`")  # noqa: E501

        self._raw_error_data = raw_error_data

    @property
    def odata_type(self):
        """Gets the odata_type of this ProcessorError.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this ProcessorError.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this ProcessorError.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this ProcessorError.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProcessorError):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
