# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class ProcessorId(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'effective_family': 'str',
        'effective_model': 'str',
        'identification_registers': 'str',
        'microcode_info': 'str',
        'step': 'str',
        'vendor_id': 'str'
    }

    attribute_map = {
        'effective_family': 'EffectiveFamily',
        'effective_model': 'EffectiveModel',
        'identification_registers': 'IdentificationRegisters',
        'microcode_info': 'MicrocodeInfo',
        'step': 'Step',
        'vendor_id': 'VendorId'
    }

    def __init__(self, effective_family=None, effective_model=None, identification_registers=None, microcode_info=None, step=None, vendor_id=None):  # noqa: E501
        """ProcessorId - a model defined in OpenAPI"""  # noqa: E501

        self._effective_family = None
        self._effective_model = None
        self._identification_registers = None
        self._microcode_info = None
        self._step = None
        self._vendor_id = None
        self.discriminator = None

        self.effective_family = effective_family
        self.effective_model = effective_model
        self.identification_registers = identification_registers
        self.microcode_info = microcode_info
        self.step = step
        self.vendor_id = vendor_id

    @property
    def effective_family(self):
        """Gets the effective_family of this ProcessorId.  # noqa: E501

        The effective Family for this processor.  # noqa: E501

        :return: The effective_family of this ProcessorId.  # noqa: E501
        :rtype: str
        """
        return self._effective_family

    @effective_family.setter
    def effective_family(self, effective_family):
        """Sets the effective_family of this ProcessorId.

        The effective Family for this processor.  # noqa: E501

        :param effective_family: The effective_family of this ProcessorId.  # noqa: E501
        :type: str
        """

        self._effective_family = effective_family

    @property
    def effective_model(self):
        """Gets the effective_model of this ProcessorId.  # noqa: E501

        The effective Model for this processor.  # noqa: E501

        :return: The effective_model of this ProcessorId.  # noqa: E501
        :rtype: str
        """
        return self._effective_model

    @effective_model.setter
    def effective_model(self, effective_model):
        """Sets the effective_model of this ProcessorId.

        The effective Model for this processor.  # noqa: E501

        :param effective_model: The effective_model of this ProcessorId.  # noqa: E501
        :type: str
        """

        self._effective_model = effective_model

    @property
    def identification_registers(self):
        """Gets the identification_registers of this ProcessorId.  # noqa: E501

        The contents of the Identification Registers (CPUID) for this processor.  # noqa: E501

        :return: The identification_registers of this ProcessorId.  # noqa: E501
        :rtype: str
        """
        return self._identification_registers

    @identification_registers.setter
    def identification_registers(self, identification_registers):
        """Sets the identification_registers of this ProcessorId.

        The contents of the Identification Registers (CPUID) for this processor.  # noqa: E501

        :param identification_registers: The identification_registers of this ProcessorId.  # noqa: E501
        :type: str
        """

        self._identification_registers = identification_registers

    @property
    def microcode_info(self):
        """Gets the microcode_info of this ProcessorId.  # noqa: E501

        The Microcode Information for this processor.  # noqa: E501

        :return: The microcode_info of this ProcessorId.  # noqa: E501
        :rtype: str
        """
        return self._microcode_info

    @microcode_info.setter
    def microcode_info(self, microcode_info):
        """Sets the microcode_info of this ProcessorId.

        The Microcode Information for this processor.  # noqa: E501

        :param microcode_info: The microcode_info of this ProcessorId.  # noqa: E501
        :type: str
        """

        self._microcode_info = microcode_info

    @property
    def step(self):
        """Gets the step of this ProcessorId.  # noqa: E501

        The Step value for this processor.  # noqa: E501

        :return: The step of this ProcessorId.  # noqa: E501
        :rtype: str
        """
        return self._step

    @step.setter
    def step(self, step):
        """Sets the step of this ProcessorId.

        The Step value for this processor.  # noqa: E501

        :param step: The step of this ProcessorId.  # noqa: E501
        :type: str
        """

        self._step = step

    @property
    def vendor_id(self):
        """Gets the vendor_id of this ProcessorId.  # noqa: E501

        The Vendor Identification for this processor.  # noqa: E501

        :return: The vendor_id of this ProcessorId.  # noqa: E501
        :rtype: str
        """
        return self._vendor_id

    @vendor_id.setter
    def vendor_id(self, vendor_id):
        """Sets the vendor_id of this ProcessorId.

        The Vendor Identification for this processor.  # noqa: E501

        :param vendor_id: The vendor_id of this ProcessorId.  # noqa: E501
        :type: str
        """

        self._vendor_id = vendor_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProcessorId):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
