# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class ProcessorMemory(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'capacity_mi_b': 'int',
        'integrated_memory': 'bool',
        'memory_type': 'ProcessorMemoryType',
        'speed_m_hz': 'int'
    }

    attribute_map = {
        'capacity_mi_b': 'CapacityMiB',
        'integrated_memory': 'IntegratedMemory',
        'memory_type': 'MemoryType',
        'speed_m_hz': 'SpeedMHz'
    }

    def __init__(self, capacity_mi_b=None, integrated_memory=None, memory_type=None, speed_m_hz=None):  # noqa: E501
        """ProcessorMemory - a model defined in OpenAPI"""  # noqa: E501

        self._capacity_mi_b = None
        self._integrated_memory = None
        self._memory_type = None
        self._speed_m_hz = None
        self.discriminator = None

        self.capacity_mi_b = capacity_mi_b
        self.integrated_memory = integrated_memory
        if memory_type is not None:
            self.memory_type = memory_type
        self.speed_m_hz = speed_m_hz

    @property
    def capacity_mi_b(self):
        """Gets the capacity_mi_b of this ProcessorMemory.  # noqa: E501

        The memory capacity in MiB.  # noqa: E501

        :return: The capacity_mi_b of this ProcessorMemory.  # noqa: E501
        :rtype: int
        """
        return self._capacity_mi_b

    @capacity_mi_b.setter
    def capacity_mi_b(self, capacity_mi_b):
        """Sets the capacity_mi_b of this ProcessorMemory.

        The memory capacity in MiB.  # noqa: E501

        :param capacity_mi_b: The capacity_mi_b of this ProcessorMemory.  # noqa: E501
        :type: int
        """

        self._capacity_mi_b = capacity_mi_b

    @property
    def integrated_memory(self):
        """Gets the integrated_memory of this ProcessorMemory.  # noqa: E501

        This indicates whether this memory is integrated within the Processor.  # noqa: E501

        :return: The integrated_memory of this ProcessorMemory.  # noqa: E501
        :rtype: bool
        """
        return self._integrated_memory

    @integrated_memory.setter
    def integrated_memory(self, integrated_memory):
        """Sets the integrated_memory of this ProcessorMemory.

        This indicates whether this memory is integrated within the Processor.  # noqa: E501

        :param integrated_memory: The integrated_memory of this ProcessorMemory.  # noqa: E501
        :type: bool
        """

        self._integrated_memory = integrated_memory

    @property
    def memory_type(self):
        """Gets the memory_type of this ProcessorMemory.  # noqa: E501


        :return: The memory_type of this ProcessorMemory.  # noqa: E501
        :rtype: ProcessorMemoryType
        """
        return self._memory_type

    @memory_type.setter
    def memory_type(self, memory_type):
        """Sets the memory_type of this ProcessorMemory.


        :param memory_type: The memory_type of this ProcessorMemory.  # noqa: E501
        :type: ProcessorMemoryType
        """

        self._memory_type = memory_type

    @property
    def speed_m_hz(self):
        """Gets the speed_m_hz of this ProcessorMemory.  # noqa: E501

        The operating speed of the memory in MHz.  # noqa: E501

        :return: The speed_m_hz of this ProcessorMemory.  # noqa: E501
        :rtype: int
        """
        return self._speed_m_hz

    @speed_m_hz.setter
    def speed_m_hz(self, speed_m_hz):
        """Sets the speed_m_hz of this ProcessorMemory.

        The operating speed of the memory in MHz.  # noqa: E501

        :param speed_m_hz: The speed_m_hz of this ProcessorMemory.  # noqa: E501
        :type: int
        """

        self._speed_m_hz = speed_m_hz

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProcessorMemory):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
