# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class ProcessorSummary(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'count': 'int',
        'logical_processor_count': 'int',
        'model': 'str',
        'status': 'Status'
    }

    attribute_map = {
        'count': 'Count',
        'logical_processor_count': 'LogicalProcessorCount',
        'model': 'Model',
        'status': 'Status'
    }

    def __init__(self, count=None, logical_processor_count=None, model=None, status=None):  # noqa: E501
        """ProcessorSummary - a model defined in OpenAPI"""  # noqa: E501

        self._count = None
        self._logical_processor_count = None
        self._model = None
        self._status = None
        self.discriminator = None

        self.count = count
        self.logical_processor_count = logical_processor_count
        self.model = model
        if status is not None:
            self.status = status

    @property
    def count(self):
        """Gets the count of this ProcessorSummary.  # noqa: E501

        The number of physical processors in the system.  # noqa: E501

        :return: The count of this ProcessorSummary.  # noqa: E501
        :rtype: int
        """
        return self._count

    @count.setter
    def count(self, count):
        """Sets the count of this ProcessorSummary.

        The number of physical processors in the system.  # noqa: E501

        :param count: The count of this ProcessorSummary.  # noqa: E501
        :type: int
        """
        if count is not None and count < 0:  # noqa: E501
            raise ValueError("Invalid value for `count`, must be a value greater than or equal to `0`")  # noqa: E501

        self._count = count

    @property
    def logical_processor_count(self):
        """Gets the logical_processor_count of this ProcessorSummary.  # noqa: E501

        The number of logical processors in the system.  # noqa: E501

        :return: The logical_processor_count of this ProcessorSummary.  # noqa: E501
        :rtype: int
        """
        return self._logical_processor_count

    @logical_processor_count.setter
    def logical_processor_count(self, logical_processor_count):
        """Sets the logical_processor_count of this ProcessorSummary.

        The number of logical processors in the system.  # noqa: E501

        :param logical_processor_count: The logical_processor_count of this ProcessorSummary.  # noqa: E501
        :type: int
        """
        if logical_processor_count is not None and logical_processor_count < 0:  # noqa: E501
            raise ValueError("Invalid value for `logical_processor_count`, must be a value greater than or equal to `0`")  # noqa: E501

        self._logical_processor_count = logical_processor_count

    @property
    def model(self):
        """Gets the model of this ProcessorSummary.  # noqa: E501

        The processor model for the primary or majority of processors in this system.  # noqa: E501

        :return: The model of this ProcessorSummary.  # noqa: E501
        :rtype: str
        """
        return self._model

    @model.setter
    def model(self, model):
        """Sets the model of this ProcessorSummary.

        The processor model for the primary or majority of processors in this system.  # noqa: E501

        :param model: The model of this ProcessorSummary.  # noqa: E501
        :type: str
        """

        self._model = model

    @property
    def status(self):
        """Gets the status of this ProcessorSummary.  # noqa: E501


        :return: The status of this ProcessorSummary.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this ProcessorSummary.


        :param status: The status of this ProcessorSummary.  # noqa: E501
        :type: Status
        """

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProcessorSummary):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
