# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class ProtocolFeaturesSupported(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'excerpt_query': 'bool',
        'expand_query': 'Expand',
        'filter_query': 'bool',
        'only_member_query': 'bool',
        'select_query': 'bool'
    }

    attribute_map = {
        'excerpt_query': 'ExcerptQuery',
        'expand_query': 'ExpandQuery',
        'filter_query': 'FilterQuery',
        'only_member_query': 'OnlyMemberQuery',
        'select_query': 'SelectQuery'
    }

    def __init__(self, excerpt_query=None, expand_query=None, filter_query=None, only_member_query=None, select_query=None):  # noqa: E501
        """ProtocolFeaturesSupported - a model defined in OpenAPI"""  # noqa: E501

        self._excerpt_query = None
        self._expand_query = None
        self._filter_query = None
        self._only_member_query = None
        self._select_query = None
        self.discriminator = None

        if excerpt_query is not None:
            self.excerpt_query = excerpt_query
        if expand_query is not None:
            self.expand_query = expand_query
        if filter_query is not None:
            self.filter_query = filter_query
        if only_member_query is not None:
            self.only_member_query = only_member_query
        if select_query is not None:
            self.select_query = select_query

    @property
    def excerpt_query(self):
        """Gets the excerpt_query of this ProtocolFeaturesSupported.  # noqa: E501

        This indicates whether the 'excerpt' query parameter is supported.  # noqa: E501

        :return: The excerpt_query of this ProtocolFeaturesSupported.  # noqa: E501
        :rtype: bool
        """
        return self._excerpt_query

    @excerpt_query.setter
    def excerpt_query(self, excerpt_query):
        """Sets the excerpt_query of this ProtocolFeaturesSupported.

        This indicates whether the 'excerpt' query parameter is supported.  # noqa: E501

        :param excerpt_query: The excerpt_query of this ProtocolFeaturesSupported.  # noqa: E501
        :type: bool
        """

        self._excerpt_query = excerpt_query

    @property
    def expand_query(self):
        """Gets the expand_query of this ProtocolFeaturesSupported.  # noqa: E501


        :return: The expand_query of this ProtocolFeaturesSupported.  # noqa: E501
        :rtype: Expand
        """
        return self._expand_query

    @expand_query.setter
    def expand_query(self, expand_query):
        """Sets the expand_query of this ProtocolFeaturesSupported.


        :param expand_query: The expand_query of this ProtocolFeaturesSupported.  # noqa: E501
        :type: Expand
        """

        self._expand_query = expand_query

    @property
    def filter_query(self):
        """Gets the filter_query of this ProtocolFeaturesSupported.  # noqa: E501

        This indicates whether the $filter query parameter is supported.  # noqa: E501

        :return: The filter_query of this ProtocolFeaturesSupported.  # noqa: E501
        :rtype: bool
        """
        return self._filter_query

    @filter_query.setter
    def filter_query(self, filter_query):
        """Sets the filter_query of this ProtocolFeaturesSupported.

        This indicates whether the $filter query parameter is supported.  # noqa: E501

        :param filter_query: The filter_query of this ProtocolFeaturesSupported.  # noqa: E501
        :type: bool
        """

        self._filter_query = filter_query

    @property
    def only_member_query(self):
        """Gets the only_member_query of this ProtocolFeaturesSupported.  # noqa: E501

        This indicates whether the 'only' query parameter is supported.  # noqa: E501

        :return: The only_member_query of this ProtocolFeaturesSupported.  # noqa: E501
        :rtype: bool
        """
        return self._only_member_query

    @only_member_query.setter
    def only_member_query(self, only_member_query):
        """Sets the only_member_query of this ProtocolFeaturesSupported.

        This indicates whether the 'only' query parameter is supported.  # noqa: E501

        :param only_member_query: The only_member_query of this ProtocolFeaturesSupported.  # noqa: E501
        :type: bool
        """

        self._only_member_query = only_member_query

    @property
    def select_query(self):
        """Gets the select_query of this ProtocolFeaturesSupported.  # noqa: E501

        This indicates whether the $select query parameter is supported.  # noqa: E501

        :return: The select_query of this ProtocolFeaturesSupported.  # noqa: E501
        :rtype: bool
        """
        return self._select_query

    @select_query.setter
    def select_query(self, select_query):
        """Sets the select_query of this ProtocolFeaturesSupported.

        This indicates whether the $select query parameter is supported.  # noqa: E501

        :param select_query: The select_query of this ProtocolFeaturesSupported.  # noqa: E501
        :type: bool
        """

        self._select_query = select_query

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProtocolFeaturesSupported):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
