# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class RedfishErrorError(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'message_extended_info': 'list[Message]',
        'code': 'str',
        'message': 'str'
    }

    attribute_map = {
        'message_extended_info': '@Message.ExtendedInfo',
        'code': 'code',
        'message': 'message'
    }

    def __init__(self, message_extended_info=None, code=None, message=None):  # noqa: E501
        """RedfishErrorError - a model defined in OpenAPI"""  # noqa: E501

        self._message_extended_info = None
        self._code = None
        self._message = None
        self.discriminator = None

        if message_extended_info is not None:
            self.message_extended_info = message_extended_info
        self.code = code
        self.message = message

    @property
    def message_extended_info(self):
        """Gets the message_extended_info of this RedfishErrorError.  # noqa: E501

        An array of message objects describing one or more error message(s).  # noqa: E501

        :return: The message_extended_info of this RedfishErrorError.  # noqa: E501
        :rtype: list[Message]
        """
        return self._message_extended_info

    @message_extended_info.setter
    def message_extended_info(self, message_extended_info):
        """Sets the message_extended_info of this RedfishErrorError.

        An array of message objects describing one or more error message(s).  # noqa: E501

        :param message_extended_info: The message_extended_info of this RedfishErrorError.  # noqa: E501
        :type: list[Message]
        """

        self._message_extended_info = message_extended_info

    @property
    def code(self):
        """Gets the code of this RedfishErrorError.  # noqa: E501

        A string indicating a specific MessageId from the message registry.  # noqa: E501

        :return: The code of this RedfishErrorError.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this RedfishErrorError.

        A string indicating a specific MessageId from the message registry.  # noqa: E501

        :param code: The code of this RedfishErrorError.  # noqa: E501
        :type: str
        """
        if code is None:
            raise ValueError("Invalid value for `code`, must not be `None`")  # noqa: E501

        self._code = code

    @property
    def message(self):
        """Gets the message of this RedfishErrorError.  # noqa: E501

        A human-readable error message corresponding to the message in the message registry.  # noqa: E501

        :return: The message of this RedfishErrorError.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this RedfishErrorError.

        A human-readable error message corresponding to the message in the message registry.  # noqa: E501

        :param message: The message of this RedfishErrorError.  # noqa: E501
        :type: str
        """
        if message is None:
            raise ValueError("Invalid value for `message`, must not be `None`")  # noqa: E501

        self._message = message

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RedfishErrorError):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
