# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Redundancy(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_id': 'str',
        'max_num_supported': 'int',
        'member_id': 'str',
        'min_num_needed': 'int',
        'mode': 'RedundancyMode',
        'name': 'str',
        'oem': 'dict(str, object)',
        'redundancy_set': 'list[IdRef2]',
        'redundancy_setodata_count': 'int',
        'status': 'Status'
    }

    attribute_map = {
        'odata_id': '@odata.id',
        'max_num_supported': 'MaxNumSupported',
        'member_id': 'MemberId',
        'min_num_needed': 'MinNumNeeded',
        'mode': 'Mode',
        'name': 'Name',
        'oem': 'Oem',
        'redundancy_set': 'RedundancySet',
        'redundancy_setodata_count': 'RedundancySet@odata.count',
        'status': 'Status'
    }

    def __init__(self, odata_id=None, max_num_supported=None, member_id=None, min_num_needed=None, mode=None, name=None, oem=None, redundancy_set=None, redundancy_setodata_count=None, status=None):  # noqa: E501
        """Redundancy - a model defined in OpenAPI"""  # noqa: E501

        self._odata_id = None
        self._max_num_supported = None
        self._member_id = None
        self._min_num_needed = None
        self._mode = None
        self._name = None
        self._oem = None
        self._redundancy_set = None
        self._redundancy_setodata_count = None
        self._status = None
        self.discriminator = None

        self.odata_id = odata_id
        self.max_num_supported = max_num_supported
        self.member_id = member_id
        self.min_num_needed = min_num_needed
        self.mode = mode
        self.name = name
        if oem is not None:
            self.oem = oem
        self.redundancy_set = redundancy_set
        if redundancy_setodata_count is not None:
            self.redundancy_setodata_count = redundancy_setodata_count
        self.status = status

    @property
    def odata_id(self):
        """Gets the odata_id of this Redundancy.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this Redundancy.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this Redundancy.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this Redundancy.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def max_num_supported(self):
        """Gets the max_num_supported of this Redundancy.  # noqa: E501

        The maximum number of members allowable for this particular redundancy group.  # noqa: E501

        :return: The max_num_supported of this Redundancy.  # noqa: E501
        :rtype: int
        """
        return self._max_num_supported

    @max_num_supported.setter
    def max_num_supported(self, max_num_supported):
        """Sets the max_num_supported of this Redundancy.

        The maximum number of members allowable for this particular redundancy group.  # noqa: E501

        :param max_num_supported: The max_num_supported of this Redundancy.  # noqa: E501
        :type: int
        """

        self._max_num_supported = max_num_supported

    @property
    def member_id(self):
        """Gets the member_id of this Redundancy.  # noqa: E501

        The identifier for the member within the collection.  # noqa: E501

        :return: The member_id of this Redundancy.  # noqa: E501
        :rtype: str
        """
        return self._member_id

    @member_id.setter
    def member_id(self, member_id):
        """Sets the member_id of this Redundancy.

        The identifier for the member within the collection.  # noqa: E501

        :param member_id: The member_id of this Redundancy.  # noqa: E501
        :type: str
        """
        if member_id is None:
            raise ValueError("Invalid value for `member_id`, must not be `None`")  # noqa: E501

        self._member_id = member_id

    @property
    def min_num_needed(self):
        """Gets the min_num_needed of this Redundancy.  # noqa: E501

        The minimum number of members needed for this group to be redundant.  # noqa: E501

        :return: The min_num_needed of this Redundancy.  # noqa: E501
        :rtype: int
        """
        return self._min_num_needed

    @min_num_needed.setter
    def min_num_needed(self, min_num_needed):
        """Sets the min_num_needed of this Redundancy.

        The minimum number of members needed for this group to be redundant.  # noqa: E501

        :param min_num_needed: The min_num_needed of this Redundancy.  # noqa: E501
        :type: int
        """

        self._min_num_needed = min_num_needed

    @property
    def mode(self):
        """Gets the mode of this Redundancy.  # noqa: E501


        :return: The mode of this Redundancy.  # noqa: E501
        :rtype: RedundancyMode
        """
        return self._mode

    @mode.setter
    def mode(self, mode):
        """Sets the mode of this Redundancy.


        :param mode: The mode of this Redundancy.  # noqa: E501
        :type: RedundancyMode
        """
        if mode is None:
            raise ValueError("Invalid value for `mode`, must not be `None`")  # noqa: E501

        self._mode = mode

    @property
    def name(self):
        """Gets the name of this Redundancy.  # noqa: E501

        The name of the resource or array member.  # noqa: E501

        :return: The name of this Redundancy.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Redundancy.

        The name of the resource or array member.  # noqa: E501

        :param name: The name of this Redundancy.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def oem(self):
        """Gets the oem of this Redundancy.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this Redundancy.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this Redundancy.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this Redundancy.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def redundancy_set(self):
        """Gets the redundancy_set of this Redundancy.  # noqa: E501

        The links to components of this redundancy set.  # noqa: E501

        :return: The redundancy_set of this Redundancy.  # noqa: E501
        :rtype: list[IdRef2]
        """
        return self._redundancy_set

    @redundancy_set.setter
    def redundancy_set(self, redundancy_set):
        """Sets the redundancy_set of this Redundancy.

        The links to components of this redundancy set.  # noqa: E501

        :param redundancy_set: The redundancy_set of this Redundancy.  # noqa: E501
        :type: list[IdRef2]
        """
        if redundancy_set is None:
            raise ValueError("Invalid value for `redundancy_set`, must not be `None`")  # noqa: E501

        self._redundancy_set = redundancy_set

    @property
    def redundancy_setodata_count(self):
        """Gets the redundancy_setodata_count of this Redundancy.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The redundancy_setodata_count of this Redundancy.  # noqa: E501
        :rtype: int
        """
        return self._redundancy_setodata_count

    @redundancy_setodata_count.setter
    def redundancy_setodata_count(self, redundancy_setodata_count):
        """Sets the redundancy_setodata_count of this Redundancy.

        The number of items in a collection.  # noqa: E501

        :param redundancy_setodata_count: The redundancy_setodata_count of this Redundancy.  # noqa: E501
        :type: int
        """

        self._redundancy_setodata_count = redundancy_setodata_count

    @property
    def status(self):
        """Gets the status of this Redundancy.  # noqa: E501


        :return: The status of this Redundancy.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this Redundancy.


        :param status: The status of this Redundancy.  # noqa: E501
        :type: Status
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Redundancy):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
