# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class RegionSet(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'memory_classification': 'MemoryClassification',
        'offset_mi_b': 'int',
        'passphrase_enabled': 'bool',
        'passphrase_state': 'bool',
        'region_id': 'str',
        'size_mi_b': 'int'
    }

    attribute_map = {
        'memory_classification': 'MemoryClassification',
        'offset_mi_b': 'OffsetMiB',
        'passphrase_enabled': 'PassphraseEnabled',
        'passphrase_state': 'PassphraseState',
        'region_id': 'RegionId',
        'size_mi_b': 'SizeMiB'
    }

    def __init__(self, memory_classification=None, offset_mi_b=None, passphrase_enabled=None, passphrase_state=None, region_id=None, size_mi_b=None):  # noqa: E501
        """RegionSet - a model defined in OpenAPI"""  # noqa: E501

        self._memory_classification = None
        self._offset_mi_b = None
        self._passphrase_enabled = None
        self._passphrase_state = None
        self._region_id = None
        self._size_mi_b = None
        self.discriminator = None

        if memory_classification is not None:
            self.memory_classification = memory_classification
        self.offset_mi_b = offset_mi_b
        self.passphrase_enabled = passphrase_enabled
        self.passphrase_state = passphrase_state
        self.region_id = region_id
        self.size_mi_b = size_mi_b

    @property
    def memory_classification(self):
        """Gets the memory_classification of this RegionSet.  # noqa: E501


        :return: The memory_classification of this RegionSet.  # noqa: E501
        :rtype: MemoryClassification
        """
        return self._memory_classification

    @memory_classification.setter
    def memory_classification(self, memory_classification):
        """Sets the memory_classification of this RegionSet.


        :param memory_classification: The memory_classification of this RegionSet.  # noqa: E501
        :type: MemoryClassification
        """

        self._memory_classification = memory_classification

    @property
    def offset_mi_b(self):
        """Gets the offset_mi_b of this RegionSet.  # noqa: E501

        Offset with in the Memory that corresponds to the starting of this memory region in mebibytes (MiB).  # noqa: E501

        :return: The offset_mi_b of this RegionSet.  # noqa: E501
        :rtype: int
        """
        return self._offset_mi_b

    @offset_mi_b.setter
    def offset_mi_b(self, offset_mi_b):
        """Sets the offset_mi_b of this RegionSet.

        Offset with in the Memory that corresponds to the starting of this memory region in mebibytes (MiB).  # noqa: E501

        :param offset_mi_b: The offset_mi_b of this RegionSet.  # noqa: E501
        :type: int
        """

        self._offset_mi_b = offset_mi_b

    @property
    def passphrase_enabled(self):
        """Gets the passphrase_enabled of this RegionSet.  # noqa: E501

        Indicates if the passphrase is enabled for this region.  # noqa: E501

        :return: The passphrase_enabled of this RegionSet.  # noqa: E501
        :rtype: bool
        """
        return self._passphrase_enabled

    @passphrase_enabled.setter
    def passphrase_enabled(self, passphrase_enabled):
        """Sets the passphrase_enabled of this RegionSet.

        Indicates if the passphrase is enabled for this region.  # noqa: E501

        :param passphrase_enabled: The passphrase_enabled of this RegionSet.  # noqa: E501
        :type: bool
        """

        self._passphrase_enabled = passphrase_enabled

    @property
    def passphrase_state(self):
        """Gets the passphrase_state of this RegionSet.  # noqa: E501

        State of the passphrase for this region.  # noqa: E501

        :return: The passphrase_state of this RegionSet.  # noqa: E501
        :rtype: bool
        """
        return self._passphrase_state

    @passphrase_state.setter
    def passphrase_state(self, passphrase_state):
        """Sets the passphrase_state of this RegionSet.

        State of the passphrase for this region.  # noqa: E501

        :param passphrase_state: The passphrase_state of this RegionSet.  # noqa: E501
        :type: bool
        """

        self._passphrase_state = passphrase_state

    @property
    def region_id(self):
        """Gets the region_id of this RegionSet.  # noqa: E501

        Unique region ID representing a specific region within the Memory.  # noqa: E501

        :return: The region_id of this RegionSet.  # noqa: E501
        :rtype: str
        """
        return self._region_id

    @region_id.setter
    def region_id(self, region_id):
        """Sets the region_id of this RegionSet.

        Unique region ID representing a specific region within the Memory.  # noqa: E501

        :param region_id: The region_id of this RegionSet.  # noqa: E501
        :type: str
        """

        self._region_id = region_id

    @property
    def size_mi_b(self):
        """Gets the size_mi_b of this RegionSet.  # noqa: E501

        Size of this memory region in mebibytes (MiB).  # noqa: E501

        :return: The size_mi_b of this RegionSet.  # noqa: E501
        :rtype: int
        """
        return self._size_mi_b

    @size_mi_b.setter
    def size_mi_b(self, size_mi_b):
        """Sets the size_mi_b of this RegionSet.

        Size of this memory region in mebibytes (MiB).  # noqa: E501

        :param size_mi_b: The size_mi_b of this RegionSet.  # noqa: E501
        :type: int
        """

        self._size_mi_b = size_mi_b

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RegionSet):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
