# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class SecurityCapabilities(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'configuration_lock_capable': 'bool',
        'data_lock_capable': 'bool',
        'max_passphrase_count': 'int',
        'passphrase_capable': 'bool',
        'passphrase_lock_limit': 'int',
        'security_states': 'list[SecurityStates]'
    }

    attribute_map = {
        'configuration_lock_capable': 'ConfigurationLockCapable',
        'data_lock_capable': 'DataLockCapable',
        'max_passphrase_count': 'MaxPassphraseCount',
        'passphrase_capable': 'PassphraseCapable',
        'passphrase_lock_limit': 'PassphraseLockLimit',
        'security_states': 'SecurityStates'
    }

    def __init__(self, configuration_lock_capable=None, data_lock_capable=None, max_passphrase_count=None, passphrase_capable=None, passphrase_lock_limit=None, security_states=None):  # noqa: E501
        """SecurityCapabilities - a model defined in OpenAPI"""  # noqa: E501

        self._configuration_lock_capable = None
        self._data_lock_capable = None
        self._max_passphrase_count = None
        self._passphrase_capable = None
        self._passphrase_lock_limit = None
        self._security_states = None
        self.discriminator = None

        self.configuration_lock_capable = configuration_lock_capable
        self.data_lock_capable = data_lock_capable
        self.max_passphrase_count = max_passphrase_count
        self.passphrase_capable = passphrase_capable
        self.passphrase_lock_limit = passphrase_lock_limit
        if security_states is not None:
            self.security_states = security_states

    @property
    def configuration_lock_capable(self):
        """Gets the configuration_lock_capable of this SecurityCapabilities.  # noqa: E501

        Support for locking the configuration.  # noqa: E501

        :return: The configuration_lock_capable of this SecurityCapabilities.  # noqa: E501
        :rtype: bool
        """
        return self._configuration_lock_capable

    @configuration_lock_capable.setter
    def configuration_lock_capable(self, configuration_lock_capable):
        """Sets the configuration_lock_capable of this SecurityCapabilities.

        Support for locking the configuration.  # noqa: E501

        :param configuration_lock_capable: The configuration_lock_capable of this SecurityCapabilities.  # noqa: E501
        :type: bool
        """

        self._configuration_lock_capable = configuration_lock_capable

    @property
    def data_lock_capable(self):
        """Gets the data_lock_capable of this SecurityCapabilities.  # noqa: E501

        Support for data locking.  # noqa: E501

        :return: The data_lock_capable of this SecurityCapabilities.  # noqa: E501
        :rtype: bool
        """
        return self._data_lock_capable

    @data_lock_capable.setter
    def data_lock_capable(self, data_lock_capable):
        """Sets the data_lock_capable of this SecurityCapabilities.

        Support for data locking.  # noqa: E501

        :param data_lock_capable: The data_lock_capable of this SecurityCapabilities.  # noqa: E501
        :type: bool
        """

        self._data_lock_capable = data_lock_capable

    @property
    def max_passphrase_count(self):
        """Gets the max_passphrase_count of this SecurityCapabilities.  # noqa: E501

        Maximum number of passphrases supported for this Memory.  # noqa: E501

        :return: The max_passphrase_count of this SecurityCapabilities.  # noqa: E501
        :rtype: int
        """
        return self._max_passphrase_count

    @max_passphrase_count.setter
    def max_passphrase_count(self, max_passphrase_count):
        """Sets the max_passphrase_count of this SecurityCapabilities.

        Maximum number of passphrases supported for this Memory.  # noqa: E501

        :param max_passphrase_count: The max_passphrase_count of this SecurityCapabilities.  # noqa: E501
        :type: int
        """

        self._max_passphrase_count = max_passphrase_count

    @property
    def passphrase_capable(self):
        """Gets the passphrase_capable of this SecurityCapabilities.  # noqa: E501

        Memory passphrase set capability.  # noqa: E501

        :return: The passphrase_capable of this SecurityCapabilities.  # noqa: E501
        :rtype: bool
        """
        return self._passphrase_capable

    @passphrase_capable.setter
    def passphrase_capable(self, passphrase_capable):
        """Sets the passphrase_capable of this SecurityCapabilities.

        Memory passphrase set capability.  # noqa: E501

        :param passphrase_capable: The passphrase_capable of this SecurityCapabilities.  # noqa: E501
        :type: bool
        """

        self._passphrase_capable = passphrase_capable

    @property
    def passphrase_lock_limit(self):
        """Gets the passphrase_lock_limit of this SecurityCapabilities.  # noqa: E501

        Maximum number of incorrect passphrase attempts allowed before memory is locked.  # noqa: E501

        :return: The passphrase_lock_limit of this SecurityCapabilities.  # noqa: E501
        :rtype: int
        """
        return self._passphrase_lock_limit

    @passphrase_lock_limit.setter
    def passphrase_lock_limit(self, passphrase_lock_limit):
        """Sets the passphrase_lock_limit of this SecurityCapabilities.

        Maximum number of incorrect passphrase attempts allowed before memory is locked.  # noqa: E501

        :param passphrase_lock_limit: The passphrase_lock_limit of this SecurityCapabilities.  # noqa: E501
        :type: int
        """

        self._passphrase_lock_limit = passphrase_lock_limit

    @property
    def security_states(self):
        """Gets the security_states of this SecurityCapabilities.  # noqa: E501

        Security states supported by the Memory.  # noqa: E501

        :return: The security_states of this SecurityCapabilities.  # noqa: E501
        :rtype: list[SecurityStates]
        """
        return self._security_states

    @security_states.setter
    def security_states(self, security_states):
        """Sets the security_states of this SecurityCapabilities.

        Security states supported by the Memory.  # noqa: E501

        :param security_states: The security_states of this SecurityCapabilities.  # noqa: E501
        :type: list[SecurityStates]
        """

        self._security_states = security_states

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SecurityCapabilities):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
