# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class SoftwareInfo(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'base_os_version': 'str',
        'kernel_version': 'str',
        'os_version': 'str'
    }

    attribute_map = {
        'base_os_version': 'BaseOSVersion',
        'kernel_version': 'KernelVersion',
        'os_version': 'OSVersion'
    }

    def __init__(self, base_os_version=None, kernel_version=None, os_version=None):  # noqa: E501
        """SoftwareInfo - a model defined in OpenAPI"""  # noqa: E501

        self._base_os_version = None
        self._kernel_version = None
        self._os_version = None
        self.discriminator = None

        if base_os_version is not None:
            self.base_os_version = base_os_version
        self.kernel_version = kernel_version
        self.os_version = os_version

    @property
    def base_os_version(self):
        """Gets the base_os_version of this SoftwareInfo.  # noqa: E501


        :return: The base_os_version of this SoftwareInfo.  # noqa: E501
        :rtype: str
        """
        return self._base_os_version

    @base_os_version.setter
    def base_os_version(self, base_os_version):
        """Sets the base_os_version of this SoftwareInfo.


        :param base_os_version: The base_os_version of this SoftwareInfo.  # noqa: E501
        :type: str
        """

        self._base_os_version = base_os_version

    @property
    def kernel_version(self):
        """Gets the kernel_version of this SoftwareInfo.  # noqa: E501


        :return: The kernel_version of this SoftwareInfo.  # noqa: E501
        :rtype: str
        """
        return self._kernel_version

    @kernel_version.setter
    def kernel_version(self, kernel_version):
        """Sets the kernel_version of this SoftwareInfo.


        :param kernel_version: The kernel_version of this SoftwareInfo.  # noqa: E501
        :type: str
        """
        if kernel_version is None:
            raise ValueError("Invalid value for `kernel_version`, must not be `None`")  # noqa: E501

        self._kernel_version = kernel_version

    @property
    def os_version(self):
        """Gets the os_version of this SoftwareInfo.  # noqa: E501


        :return: The os_version of this SoftwareInfo.  # noqa: E501
        :rtype: str
        """
        return self._os_version

    @os_version.setter
    def os_version(self, os_version):
        """Sets the os_version of this SoftwareInfo.


        :param os_version: The os_version of this SoftwareInfo.  # noqa: E501
        :type: str
        """
        if os_version is None:
            raise ValueError("Invalid value for `os_version`, must not be `None`")  # noqa: E501

        self._os_version = os_version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SoftwareInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
