# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Specifications(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'compute_capability': 'str',
        'max_pc_ie_gen': 'str',
        'max_pc_ie_link_width': 'str',
        'max_speeds': 'ClockSpeed',
        'memory_size': 'str',
        'pc_ie_bridge_chip_type': 'str',
        'supported_speeds': 'list[SupportedSpeed]'
    }

    attribute_map = {
        'compute_capability': 'ComputeCapability',
        'max_pc_ie_gen': 'MaxPCIeGen',
        'max_pc_ie_link_width': 'MaxPCIeLinkWidth',
        'max_speeds': 'MaxSpeeds',
        'memory_size': 'MemorySize',
        'pc_ie_bridge_chip_type': 'PCIeBridgeChipType',
        'supported_speeds': 'SupportedSpeeds'
    }

    def __init__(self, compute_capability=None, max_pc_ie_gen=None, max_pc_ie_link_width=None, max_speeds=None, memory_size=None, pc_ie_bridge_chip_type=None, supported_speeds=None):  # noqa: E501
        """Specifications - a model defined in OpenAPI"""  # noqa: E501

        self._compute_capability = None
        self._max_pc_ie_gen = None
        self._max_pc_ie_link_width = None
        self._max_speeds = None
        self._memory_size = None
        self._pc_ie_bridge_chip_type = None
        self._supported_speeds = None
        self.discriminator = None

        self.compute_capability = compute_capability
        self.max_pc_ie_gen = max_pc_ie_gen
        self.max_pc_ie_link_width = max_pc_ie_link_width
        self.max_speeds = max_speeds
        self.memory_size = memory_size
        self.pc_ie_bridge_chip_type = pc_ie_bridge_chip_type
        self.supported_speeds = supported_speeds

    @property
    def compute_capability(self):
        """Gets the compute_capability of this Specifications.  # noqa: E501

        CUDA compute capability version.  # noqa: E501

        :return: The compute_capability of this Specifications.  # noqa: E501
        :rtype: str
        """
        return self._compute_capability

    @compute_capability.setter
    def compute_capability(self, compute_capability):
        """Sets the compute_capability of this Specifications.

        CUDA compute capability version.  # noqa: E501

        :param compute_capability: The compute_capability of this Specifications.  # noqa: E501
        :type: str
        """
        if compute_capability is None:
            raise ValueError("Invalid value for `compute_capability`, must not be `None`")  # noqa: E501

        self._compute_capability = compute_capability

    @property
    def max_pc_ie_gen(self):
        """Gets the max_pc_ie_gen of this Specifications.  # noqa: E501

        The maximum link generation possible with this GPU and system configuration.  # noqa: E501

        :return: The max_pc_ie_gen of this Specifications.  # noqa: E501
        :rtype: str
        """
        return self._max_pc_ie_gen

    @max_pc_ie_gen.setter
    def max_pc_ie_gen(self, max_pc_ie_gen):
        """Sets the max_pc_ie_gen of this Specifications.

        The maximum link generation possible with this GPU and system configuration.  # noqa: E501

        :param max_pc_ie_gen: The max_pc_ie_gen of this Specifications.  # noqa: E501
        :type: str
        """
        if max_pc_ie_gen is None:
            raise ValueError("Invalid value for `max_pc_ie_gen`, must not be `None`")  # noqa: E501

        self._max_pc_ie_gen = max_pc_ie_gen

    @property
    def max_pc_ie_link_width(self):
        """Gets the max_pc_ie_link_width of this Specifications.  # noqa: E501

        The maximum link width possible with this GPU and system configuration.  # noqa: E501

        :return: The max_pc_ie_link_width of this Specifications.  # noqa: E501
        :rtype: str
        """
        return self._max_pc_ie_link_width

    @max_pc_ie_link_width.setter
    def max_pc_ie_link_width(self, max_pc_ie_link_width):
        """Sets the max_pc_ie_link_width of this Specifications.

        The maximum link width possible with this GPU and system configuration.  # noqa: E501

        :param max_pc_ie_link_width: The max_pc_ie_link_width of this Specifications.  # noqa: E501
        :type: str
        """
        if max_pc_ie_link_width is None:
            raise ValueError("Invalid value for `max_pc_ie_link_width`, must not be `None`")  # noqa: E501

        self._max_pc_ie_link_width = max_pc_ie_link_width

    @property
    def max_speeds(self):
        """Gets the max_speeds of this Specifications.  # noqa: E501


        :return: The max_speeds of this Specifications.  # noqa: E501
        :rtype: ClockSpeed
        """
        return self._max_speeds

    @max_speeds.setter
    def max_speeds(self, max_speeds):
        """Sets the max_speeds of this Specifications.


        :param max_speeds: The max_speeds of this Specifications.  # noqa: E501
        :type: ClockSpeed
        """
        if max_speeds is None:
            raise ValueError("Invalid value for `max_speeds`, must not be `None`")  # noqa: E501

        self._max_speeds = max_speeds

    @property
    def memory_size(self):
        """Gets the memory_size of this Specifications.  # noqa: E501

        Total size memory present in the GPU.  # noqa: E501

        :return: The memory_size of this Specifications.  # noqa: E501
        :rtype: str
        """
        return self._memory_size

    @memory_size.setter
    def memory_size(self, memory_size):
        """Sets the memory_size of this Specifications.

        Total size memory present in the GPU.  # noqa: E501

        :param memory_size: The memory_size of this Specifications.  # noqa: E501
        :type: str
        """
        if memory_size is None:
            raise ValueError("Invalid value for `memory_size`, must not be `None`")  # noqa: E501

        self._memory_size = memory_size

    @property
    def pc_ie_bridge_chip_type(self):
        """Gets the pc_ie_bridge_chip_type of this Specifications.  # noqa: E501

        The type of bridge chip. Reported as N/A if doesn't exist.  # noqa: E501

        :return: The pc_ie_bridge_chip_type of this Specifications.  # noqa: E501
        :rtype: str
        """
        return self._pc_ie_bridge_chip_type

    @pc_ie_bridge_chip_type.setter
    def pc_ie_bridge_chip_type(self, pc_ie_bridge_chip_type):
        """Sets the pc_ie_bridge_chip_type of this Specifications.

        The type of bridge chip. Reported as N/A if doesn't exist.  # noqa: E501

        :param pc_ie_bridge_chip_type: The pc_ie_bridge_chip_type of this Specifications.  # noqa: E501
        :type: str
        """
        if pc_ie_bridge_chip_type is None:
            raise ValueError("Invalid value for `pc_ie_bridge_chip_type`, must not be `None`")  # noqa: E501

        self._pc_ie_bridge_chip_type = pc_ie_bridge_chip_type

    @property
    def supported_speeds(self):
        """Gets the supported_speeds of this Specifications.  # noqa: E501

        List of possible memory and graphics clocks combinations that the GPU can operate on (not taking into account HW brake reduced clocks).'  # noqa: E501

        :return: The supported_speeds of this Specifications.  # noqa: E501
        :rtype: list[SupportedSpeed]
        """
        return self._supported_speeds

    @supported_speeds.setter
    def supported_speeds(self, supported_speeds):
        """Sets the supported_speeds of this Specifications.

        List of possible memory and graphics clocks combinations that the GPU can operate on (not taking into account HW brake reduced clocks).'  # noqa: E501

        :param supported_speeds: The supported_speeds of this Specifications.  # noqa: E501
        :type: list[SupportedSpeed]
        """
        if supported_speeds is None:
            raise ValueError("Invalid value for `supported_speeds`, must not be `None`")  # noqa: E501

        self._supported_speeds = supported_speeds

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Specifications):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
