# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class SRIOV(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'sriovvepa_capable': 'bool'
    }

    attribute_map = {
        'sriovvepa_capable': 'SRIOVVEPACapable'
    }

    def __init__(self, sriovvepa_capable=None):  # noqa: E501
        """SRIOV - a model defined in OpenAPI"""  # noqa: E501

        self._sriovvepa_capable = None
        self.discriminator = None

        self.sriovvepa_capable = sriovvepa_capable

    @property
    def sriovvepa_capable(self):
        """Gets the sriovvepa_capable of this SRIOV.  # noqa: E501

        Whether this controller supports Single Root Input/Output Virtualization (SR-IOV) in Virtual Ethernet Port Aggregator (VEPA) mode.  # noqa: E501

        :return: The sriovvepa_capable of this SRIOV.  # noqa: E501
        :rtype: bool
        """
        return self._sriovvepa_capable

    @sriovvepa_capable.setter
    def sriovvepa_capable(self, sriovvepa_capable):
        """Sets the sriovvepa_capable of this SRIOV.

        Whether this controller supports Single Root Input/Output Virtualization (SR-IOV) in Virtual Ethernet Port Aggregator (VEPA) mode.  # noqa: E501

        :param sriovvepa_capable: The sriovvepa_capable of this SRIOV.  # noqa: E501
        :type: bool
        """

        self._sriovvepa_capable = sriovvepa_capable

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SRIOV):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
