# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Stats(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'bar1_memory_usage': 'ResourceUsage',
        'error_stats': 'ErrorStat',
        'frame_buffer_memory_usage': 'ResourceUsage',
        'nvlink_counters_per_link': 'list[NvlinkCounters]',
        'pc_ie_replay_counter': 'int',
        'pc_ie_rx_throughput': 'str',
        'pc_ie_tx_throughput': 'str',
        'performance_state': 'str',
        'gpu_throttle_reasons': 'GPUThrottleReasons',
        'usage_memory_fb': 'str',
        'user_processes': 'list[GPUProcess]',
        'util_decoder': 'str',
        'util_encoder': 'str',
        'util_gpu': 'str',
        'util_memory': 'str',
        'violations': 'Violations'
    }

    attribute_map = {
        'bar1_memory_usage': 'Bar1MemoryUsage',
        'error_stats': 'ErrorStats',
        'frame_buffer_memory_usage': 'FrameBufferMemoryUsage',
        'nvlink_counters_per_link': 'NvlinkCountersPerLink',
        'pc_ie_replay_counter': 'PCIeReplayCounter',
        'pc_ie_rx_throughput': 'PCIeRxThroughput',
        'pc_ie_tx_throughput': 'PCIeTxThroughput',
        'performance_state': 'PerformanceState',
        'gpu_throttle_reasons': 'GPUThrottleReasons',
        'usage_memory_fb': 'UsageMemoryFB',
        'user_processes': 'UserProcesses',
        'util_decoder': 'UtilDecoder',
        'util_encoder': 'UtilEncoder',
        'util_gpu': 'UtilGPU',
        'util_memory': 'UtilMemory',
        'violations': 'Violations'
    }

    def __init__(self, bar1_memory_usage=None, error_stats=None, frame_buffer_memory_usage=None, nvlink_counters_per_link=None, pc_ie_replay_counter=None, pc_ie_rx_throughput=None, pc_ie_tx_throughput=None, performance_state=None, gpu_throttle_reasons=None, usage_memory_fb=None, user_processes=None, util_decoder=None, util_encoder=None, util_gpu=None, util_memory=None, violations=None):  # noqa: E501
        """Stats - a model defined in OpenAPI"""  # noqa: E501

        self._bar1_memory_usage = None
        self._error_stats = None
        self._frame_buffer_memory_usage = None
        self._nvlink_counters_per_link = None
        self._pc_ie_replay_counter = None
        self._pc_ie_rx_throughput = None
        self._pc_ie_tx_throughput = None
        self._performance_state = None
        self._gpu_throttle_reasons = None
        self._usage_memory_fb = None
        self._user_processes = None
        self._util_decoder = None
        self._util_encoder = None
        self._util_gpu = None
        self._util_memory = None
        self._violations = None
        self.discriminator = None

        self.bar1_memory_usage = bar1_memory_usage
        self.error_stats = error_stats
        self.frame_buffer_memory_usage = frame_buffer_memory_usage
        self.nvlink_counters_per_link = nvlink_counters_per_link
        self.pc_ie_replay_counter = pc_ie_replay_counter
        self.pc_ie_rx_throughput = pc_ie_rx_throughput
        self.pc_ie_tx_throughput = pc_ie_tx_throughput
        self.performance_state = performance_state
        self.gpu_throttle_reasons = gpu_throttle_reasons
        self.usage_memory_fb = usage_memory_fb
        self.user_processes = user_processes
        self.util_decoder = util_decoder
        self.util_encoder = util_encoder
        self.util_gpu = util_gpu
        self.util_memory = util_memory
        self.violations = violations

    @property
    def bar1_memory_usage(self):
        """Gets the bar1_memory_usage of this Stats.  # noqa: E501


        :return: The bar1_memory_usage of this Stats.  # noqa: E501
        :rtype: ResourceUsage
        """
        return self._bar1_memory_usage

    @bar1_memory_usage.setter
    def bar1_memory_usage(self, bar1_memory_usage):
        """Sets the bar1_memory_usage of this Stats.


        :param bar1_memory_usage: The bar1_memory_usage of this Stats.  # noqa: E501
        :type: ResourceUsage
        """
        if bar1_memory_usage is None:
            raise ValueError("Invalid value for `bar1_memory_usage`, must not be `None`")  # noqa: E501

        self._bar1_memory_usage = bar1_memory_usage

    @property
    def error_stats(self):
        """Gets the error_stats of this Stats.  # noqa: E501


        :return: The error_stats of this Stats.  # noqa: E501
        :rtype: ErrorStat
        """
        return self._error_stats

    @error_stats.setter
    def error_stats(self, error_stats):
        """Sets the error_stats of this Stats.


        :param error_stats: The error_stats of this Stats.  # noqa: E501
        :type: ErrorStat
        """
        if error_stats is None:
            raise ValueError("Invalid value for `error_stats`, must not be `None`")  # noqa: E501

        self._error_stats = error_stats

    @property
    def frame_buffer_memory_usage(self):
        """Gets the frame_buffer_memory_usage of this Stats.  # noqa: E501


        :return: The frame_buffer_memory_usage of this Stats.  # noqa: E501
        :rtype: ResourceUsage
        """
        return self._frame_buffer_memory_usage

    @frame_buffer_memory_usage.setter
    def frame_buffer_memory_usage(self, frame_buffer_memory_usage):
        """Sets the frame_buffer_memory_usage of this Stats.


        :param frame_buffer_memory_usage: The frame_buffer_memory_usage of this Stats.  # noqa: E501
        :type: ResourceUsage
        """
        if frame_buffer_memory_usage is None:
            raise ValueError("Invalid value for `frame_buffer_memory_usage`, must not be `None`")  # noqa: E501

        self._frame_buffer_memory_usage = frame_buffer_memory_usage

    @property
    def nvlink_counters_per_link(self):
        """Gets the nvlink_counters_per_link of this Stats.  # noqa: E501

        NVLink related metrics for this GPU.  # noqa: E501

        :return: The nvlink_counters_per_link of this Stats.  # noqa: E501
        :rtype: list[NvlinkCounters]
        """
        return self._nvlink_counters_per_link

    @nvlink_counters_per_link.setter
    def nvlink_counters_per_link(self, nvlink_counters_per_link):
        """Sets the nvlink_counters_per_link of this Stats.

        NVLink related metrics for this GPU.  # noqa: E501

        :param nvlink_counters_per_link: The nvlink_counters_per_link of this Stats.  # noqa: E501
        :type: list[NvlinkCounters]
        """
        if nvlink_counters_per_link is None:
            raise ValueError("Invalid value for `nvlink_counters_per_link`, must not be `None`")  # noqa: E501

        self._nvlink_counters_per_link = nvlink_counters_per_link

    @property
    def pc_ie_replay_counter(self):
        """Gets the pc_ie_replay_counter of this Stats.  # noqa: E501

        This is the internal counter that records various errors on the PCIe bus.  # noqa: E501

        :return: The pc_ie_replay_counter of this Stats.  # noqa: E501
        :rtype: int
        """
        return self._pc_ie_replay_counter

    @pc_ie_replay_counter.setter
    def pc_ie_replay_counter(self, pc_ie_replay_counter):
        """Sets the pc_ie_replay_counter of this Stats.

        This is the internal counter that records various errors on the PCIe bus.  # noqa: E501

        :param pc_ie_replay_counter: The pc_ie_replay_counter of this Stats.  # noqa: E501
        :type: int
        """
        if pc_ie_replay_counter is None:
            raise ValueError("Invalid value for `pc_ie_replay_counter`, must not be `None`")  # noqa: E501

        self._pc_ie_replay_counter = pc_ie_replay_counter

    @property
    def pc_ie_rx_throughput(self):
        """Gets the pc_ie_rx_throughput of this Stats.  # noqa: E501

        The GPU-centric receive throughput across the PCIe bus in MB/s over the past 20ms. Only supported on Maxwell architectures and newer.  # noqa: E501

        :return: The pc_ie_rx_throughput of this Stats.  # noqa: E501
        :rtype: str
        """
        return self._pc_ie_rx_throughput

    @pc_ie_rx_throughput.setter
    def pc_ie_rx_throughput(self, pc_ie_rx_throughput):
        """Sets the pc_ie_rx_throughput of this Stats.

        The GPU-centric receive throughput across the PCIe bus in MB/s over the past 20ms. Only supported on Maxwell architectures and newer.  # noqa: E501

        :param pc_ie_rx_throughput: The pc_ie_rx_throughput of this Stats.  # noqa: E501
        :type: str
        """
        if pc_ie_rx_throughput is None:
            raise ValueError("Invalid value for `pc_ie_rx_throughput`, must not be `None`")  # noqa: E501

        self._pc_ie_rx_throughput = pc_ie_rx_throughput

    @property
    def pc_ie_tx_throughput(self):
        """Gets the pc_ie_tx_throughput of this Stats.  # noqa: E501

        The GPU-centric transmission throughput across the PCIe bus in MB/s over the past 20ms. Only supported on Maxwell architectures and newer.  # noqa: E501

        :return: The pc_ie_tx_throughput of this Stats.  # noqa: E501
        :rtype: str
        """
        return self._pc_ie_tx_throughput

    @pc_ie_tx_throughput.setter
    def pc_ie_tx_throughput(self, pc_ie_tx_throughput):
        """Sets the pc_ie_tx_throughput of this Stats.

        The GPU-centric transmission throughput across the PCIe bus in MB/s over the past 20ms. Only supported on Maxwell architectures and newer.  # noqa: E501

        :param pc_ie_tx_throughput: The pc_ie_tx_throughput of this Stats.  # noqa: E501
        :type: str
        """
        if pc_ie_tx_throughput is None:
            raise ValueError("Invalid value for `pc_ie_tx_throughput`, must not be `None`")  # noqa: E501

        self._pc_ie_tx_throughput = pc_ie_tx_throughput

    @property
    def performance_state(self):
        """Gets the performance_state of this Stats.  # noqa: E501

        The current performance state for the GPU. States range from P0 (maximum performance) to P12 (minimum performance).  # noqa: E501

        :return: The performance_state of this Stats.  # noqa: E501
        :rtype: str
        """
        return self._performance_state

    @performance_state.setter
    def performance_state(self, performance_state):
        """Sets the performance_state of this Stats.

        The current performance state for the GPU. States range from P0 (maximum performance) to P12 (minimum performance).  # noqa: E501

        :param performance_state: The performance_state of this Stats.  # noqa: E501
        :type: str
        """
        if performance_state is None:
            raise ValueError("Invalid value for `performance_state`, must not be `None`")  # noqa: E501

        self._performance_state = performance_state

    @property
    def gpu_throttle_reasons(self):
        """Gets the gpu_throttle_reasons of this Stats.  # noqa: E501


        :return: The gpu_throttle_reasons of this Stats.  # noqa: E501
        :rtype: GPUThrottleReasons
        """
        return self._gpu_throttle_reasons

    @gpu_throttle_reasons.setter
    def gpu_throttle_reasons(self, gpu_throttle_reasons):
        """Sets the gpu_throttle_reasons of this Stats.


        :param gpu_throttle_reasons: The gpu_throttle_reasons of this Stats.  # noqa: E501
        :type: GPUThrottleReasons
        """
        if gpu_throttle_reasons is None:
            raise ValueError("Invalid value for `gpu_throttle_reasons`, must not be `None`")  # noqa: E501

        self._gpu_throttle_reasons = gpu_throttle_reasons

    @property
    def usage_memory_fb(self):
        """Gets the usage_memory_fb of this Stats.  # noqa: E501

        Usage Memory Frame Buffer.  # noqa: E501

        :return: The usage_memory_fb of this Stats.  # noqa: E501
        :rtype: str
        """
        return self._usage_memory_fb

    @usage_memory_fb.setter
    def usage_memory_fb(self, usage_memory_fb):
        """Sets the usage_memory_fb of this Stats.

        Usage Memory Frame Buffer.  # noqa: E501

        :param usage_memory_fb: The usage_memory_fb of this Stats.  # noqa: E501
        :type: str
        """
        if usage_memory_fb is None:
            raise ValueError("Invalid value for `usage_memory_fb`, must not be `None`")  # noqa: E501

        self._usage_memory_fb = usage_memory_fb

    @property
    def user_processes(self):
        """Gets the user_processes of this Stats.  # noqa: E501

        List of processes having Compute or Graphics Context on the device.  # noqa: E501

        :return: The user_processes of this Stats.  # noqa: E501
        :rtype: list[GPUProcess]
        """
        return self._user_processes

    @user_processes.setter
    def user_processes(self, user_processes):
        """Sets the user_processes of this Stats.

        List of processes having Compute or Graphics Context on the device.  # noqa: E501

        :param user_processes: The user_processes of this Stats.  # noqa: E501
        :type: list[GPUProcess]
        """
        if user_processes is None:
            raise ValueError("Invalid value for `user_processes`, must not be `None`")  # noqa: E501

        self._user_processes = user_processes

    @property
    def util_decoder(self):
        """Gets the util_decoder of this Stats.  # noqa: E501

        Percent of time over the past sample period during which the GPU\\xe2\\x80\\x99s video decoder was being used.  # noqa: E501

        :return: The util_decoder of this Stats.  # noqa: E501
        :rtype: str
        """
        return self._util_decoder

    @util_decoder.setter
    def util_decoder(self, util_decoder):
        """Sets the util_decoder of this Stats.

        Percent of time over the past sample period during which the GPU\\xe2\\x80\\x99s video decoder was being used.  # noqa: E501

        :param util_decoder: The util_decoder of this Stats.  # noqa: E501
        :type: str
        """
        if util_decoder is None:
            raise ValueError("Invalid value for `util_decoder`, must not be `None`")  # noqa: E501

        self._util_decoder = util_decoder

    @property
    def util_encoder(self):
        """Gets the util_encoder of this Stats.  # noqa: E501

        Percent of time over the past sample period during which the GPU video encoder was being used.  # noqa: E501

        :return: The util_encoder of this Stats.  # noqa: E501
        :rtype: str
        """
        return self._util_encoder

    @util_encoder.setter
    def util_encoder(self, util_encoder):
        """Sets the util_encoder of this Stats.

        Percent of time over the past sample period during which the GPU video encoder was being used.  # noqa: E501

        :param util_encoder: The util_encoder of this Stats.  # noqa: E501
        :type: str
        """
        if util_encoder is None:
            raise ValueError("Invalid value for `util_encoder`, must not be `None`")  # noqa: E501

        self._util_encoder = util_encoder

    @property
    def util_gpu(self):
        """Gets the util_gpu of this Stats.  # noqa: E501

        Percent of time over the past sample period during which one or more kernels was executing on the GPU. The sample period may be between 1 second and 1/6 second depending on the product.  # noqa: E501

        :return: The util_gpu of this Stats.  # noqa: E501
        :rtype: str
        """
        return self._util_gpu

    @util_gpu.setter
    def util_gpu(self, util_gpu):
        """Sets the util_gpu of this Stats.

        Percent of time over the past sample period during which one or more kernels was executing on the GPU. The sample period may be between 1 second and 1/6 second depending on the product.  # noqa: E501

        :param util_gpu: The util_gpu of this Stats.  # noqa: E501
        :type: str
        """
        if util_gpu is None:
            raise ValueError("Invalid value for `util_gpu`, must not be `None`")  # noqa: E501

        self._util_gpu = util_gpu

    @property
    def util_memory(self):
        """Gets the util_memory of this Stats.  # noqa: E501

        Percent of time over the past sample period during which global (device) memory was being read or written. The sample period may be between 1 second and 1/6 second depending on the product.  # noqa: E501

        :return: The util_memory of this Stats.  # noqa: E501
        :rtype: str
        """
        return self._util_memory

    @util_memory.setter
    def util_memory(self, util_memory):
        """Sets the util_memory of this Stats.

        Percent of time over the past sample period during which global (device) memory was being read or written. The sample period may be between 1 second and 1/6 second depending on the product.  # noqa: E501

        :param util_memory: The util_memory of this Stats.  # noqa: E501
        :type: str
        """
        if util_memory is None:
            raise ValueError("Invalid value for `util_memory`, must not be `None`")  # noqa: E501

        self._util_memory = util_memory

    @property
    def violations(self):
        """Gets the violations of this Stats.  # noqa: E501


        :return: The violations of this Stats.  # noqa: E501
        :rtype: Violations
        """
        return self._violations

    @violations.setter
    def violations(self, violations):
        """Sets the violations of this Stats.


        :param violations: The violations of this Stats.  # noqa: E501
        :type: Violations
        """
        if violations is None:
            raise ValueError("Invalid value for `violations`, must not be `None`")  # noqa: E501

        self._violations = violations

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Stats):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
