# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Storage(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_id': 'str',
        'odata_context': 'str',
        'odata_etag': 'str',
        'odata_type': 'str',
        'actions': 'Actions2',
        'description': 'str',
        'drives': 'list[IdRef2]',
        'drivesodata_count': 'int',
        'id': 'str',
        'links': 'Links2',
        'name': 'str',
        'oem': 'dict(str, object)',
        'redundancy': 'list[Redundancy]',
        'redundancyodata_count': 'int',
        'status': 'Status',
        'storage_controllers': 'list[StorageController]',
        'storage_controllersodata_count': 'int',
        'volumes': 'IdRef2'
    }

    attribute_map = {
        'odata_id': '@odata.id',
        'odata_context': '@odata.context',
        'odata_etag': '@odata.etag',
        'odata_type': '@odata.type',
        'actions': 'Actions',
        'description': 'Description',
        'drives': 'Drives',
        'drivesodata_count': 'Drives@odata.count',
        'id': 'Id',
        'links': 'Links',
        'name': 'Name',
        'oem': 'Oem',
        'redundancy': 'Redundancy',
        'redundancyodata_count': 'Redundancy@odata.count',
        'status': 'Status',
        'storage_controllers': 'StorageControllers',
        'storage_controllersodata_count': 'StorageControllers@odata.count',
        'volumes': 'Volumes'
    }

    def __init__(self, odata_id=None, odata_context=None, odata_etag=None, odata_type=None, actions=None, description=None, drives=None, drivesodata_count=None, id=None, links=None, name=None, oem=None, redundancy=None, redundancyodata_count=None, status=None, storage_controllers=None, storage_controllersodata_count=None, volumes=None):  # noqa: E501
        """Storage - a model defined in OpenAPI"""  # noqa: E501

        self._odata_id = None
        self._odata_context = None
        self._odata_etag = None
        self._odata_type = None
        self._actions = None
        self._description = None
        self._drives = None
        self._drivesodata_count = None
        self._id = None
        self._links = None
        self._name = None
        self._oem = None
        self._redundancy = None
        self._redundancyodata_count = None
        self._status = None
        self._storage_controllers = None
        self._storage_controllersodata_count = None
        self._volumes = None
        self.discriminator = None

        self.odata_id = odata_id
        if odata_context is not None:
            self.odata_context = odata_context
        if odata_etag is not None:
            self.odata_etag = odata_etag
        self.odata_type = odata_type
        if actions is not None:
            self.actions = actions
        if description is not None:
            self.description = description
        if drives is not None:
            self.drives = drives
        if drivesodata_count is not None:
            self.drivesodata_count = drivesodata_count
        self.id = id
        if links is not None:
            self.links = links
        self.name = name
        if oem is not None:
            self.oem = oem
        if redundancy is not None:
            self.redundancy = redundancy
        if redundancyodata_count is not None:
            self.redundancyodata_count = redundancyodata_count
        if status is not None:
            self.status = status
        if storage_controllers is not None:
            self.storage_controllers = storage_controllers
        if storage_controllersodata_count is not None:
            self.storage_controllersodata_count = storage_controllersodata_count
        if volumes is not None:
            self.volumes = volumes

    @property
    def odata_id(self):
        """Gets the odata_id of this Storage.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this Storage.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this Storage.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this Storage.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def odata_context(self):
        """Gets the odata_context of this Storage.  # noqa: E501

        The OData description of a payload.  # noqa: E501

        :return: The odata_context of this Storage.  # noqa: E501
        :rtype: str
        """
        return self._odata_context

    @odata_context.setter
    def odata_context(self, odata_context):
        """Sets the odata_context of this Storage.

        The OData description of a payload.  # noqa: E501

        :param odata_context: The odata_context of this Storage.  # noqa: E501
        :type: str
        """

        self._odata_context = odata_context

    @property
    def odata_etag(self):
        """Gets the odata_etag of this Storage.  # noqa: E501

        The current ETag of the resource.  # noqa: E501

        :return: The odata_etag of this Storage.  # noqa: E501
        :rtype: str
        """
        return self._odata_etag

    @odata_etag.setter
    def odata_etag(self, odata_etag):
        """Sets the odata_etag of this Storage.

        The current ETag of the resource.  # noqa: E501

        :param odata_etag: The odata_etag of this Storage.  # noqa: E501
        :type: str
        """

        self._odata_etag = odata_etag

    @property
    def odata_type(self):
        """Gets the odata_type of this Storage.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this Storage.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this Storage.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this Storage.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def actions(self):
        """Gets the actions of this Storage.  # noqa: E501


        :return: The actions of this Storage.  # noqa: E501
        :rtype: Actions2
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this Storage.


        :param actions: The actions of this Storage.  # noqa: E501
        :type: Actions2
        """

        self._actions = actions

    @property
    def description(self):
        """Gets the description of this Storage.  # noqa: E501

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :return: The description of this Storage.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Storage.

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :param description: The description of this Storage.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def drives(self):
        """Gets the drives of this Storage.  # noqa: E501

        The set of drives attached to the storage controllers that this resource represents.  # noqa: E501

        :return: The drives of this Storage.  # noqa: E501
        :rtype: list[IdRef2]
        """
        return self._drives

    @drives.setter
    def drives(self, drives):
        """Sets the drives of this Storage.

        The set of drives attached to the storage controllers that this resource represents.  # noqa: E501

        :param drives: The drives of this Storage.  # noqa: E501
        :type: list[IdRef2]
        """

        self._drives = drives

    @property
    def drivesodata_count(self):
        """Gets the drivesodata_count of this Storage.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The drivesodata_count of this Storage.  # noqa: E501
        :rtype: int
        """
        return self._drivesodata_count

    @drivesodata_count.setter
    def drivesodata_count(self, drivesodata_count):
        """Sets the drivesodata_count of this Storage.

        The number of items in a collection.  # noqa: E501

        :param drivesodata_count: The drivesodata_count of this Storage.  # noqa: E501
        :type: int
        """

        self._drivesodata_count = drivesodata_count

    @property
    def id(self):
        """Gets the id of this Storage.  # noqa: E501

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :return: The id of this Storage.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Storage.

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :param id: The id of this Storage.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def links(self):
        """Gets the links of this Storage.  # noqa: E501


        :return: The links of this Storage.  # noqa: E501
        :rtype: Links2
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this Storage.


        :param links: The links of this Storage.  # noqa: E501
        :type: Links2
        """

        self._links = links

    @property
    def name(self):
        """Gets the name of this Storage.  # noqa: E501

        The name of the resource or array member.  # noqa: E501

        :return: The name of this Storage.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Storage.

        The name of the resource or array member.  # noqa: E501

        :param name: The name of this Storage.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def oem(self):
        """Gets the oem of this Storage.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this Storage.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this Storage.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this Storage.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def redundancy(self):
        """Gets the redundancy of this Storage.  # noqa: E501

        Redundancy information for the storage subsystem.  # noqa: E501

        :return: The redundancy of this Storage.  # noqa: E501
        :rtype: list[Redundancy]
        """
        return self._redundancy

    @redundancy.setter
    def redundancy(self, redundancy):
        """Sets the redundancy of this Storage.

        Redundancy information for the storage subsystem.  # noqa: E501

        :param redundancy: The redundancy of this Storage.  # noqa: E501
        :type: list[Redundancy]
        """

        self._redundancy = redundancy

    @property
    def redundancyodata_count(self):
        """Gets the redundancyodata_count of this Storage.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The redundancyodata_count of this Storage.  # noqa: E501
        :rtype: int
        """
        return self._redundancyodata_count

    @redundancyodata_count.setter
    def redundancyodata_count(self, redundancyodata_count):
        """Sets the redundancyodata_count of this Storage.

        The number of items in a collection.  # noqa: E501

        :param redundancyodata_count: The redundancyodata_count of this Storage.  # noqa: E501
        :type: int
        """

        self._redundancyodata_count = redundancyodata_count

    @property
    def status(self):
        """Gets the status of this Storage.  # noqa: E501


        :return: The status of this Storage.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this Storage.


        :param status: The status of this Storage.  # noqa: E501
        :type: Status
        """

        self._status = status

    @property
    def storage_controllers(self):
        """Gets the storage_controllers of this Storage.  # noqa: E501

        The set of storage controllers that this resource represents.  # noqa: E501

        :return: The storage_controllers of this Storage.  # noqa: E501
        :rtype: list[StorageController]
        """
        return self._storage_controllers

    @storage_controllers.setter
    def storage_controllers(self, storage_controllers):
        """Sets the storage_controllers of this Storage.

        The set of storage controllers that this resource represents.  # noqa: E501

        :param storage_controllers: The storage_controllers of this Storage.  # noqa: E501
        :type: list[StorageController]
        """

        self._storage_controllers = storage_controllers

    @property
    def storage_controllersodata_count(self):
        """Gets the storage_controllersodata_count of this Storage.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The storage_controllersodata_count of this Storage.  # noqa: E501
        :rtype: int
        """
        return self._storage_controllersodata_count

    @storage_controllersodata_count.setter
    def storage_controllersodata_count(self, storage_controllersodata_count):
        """Sets the storage_controllersodata_count of this Storage.

        The number of items in a collection.  # noqa: E501

        :param storage_controllersodata_count: The storage_controllersodata_count of this Storage.  # noqa: E501
        :type: int
        """

        self._storage_controllersodata_count = storage_controllersodata_count

    @property
    def volumes(self):
        """Gets the volumes of this Storage.  # noqa: E501


        :return: The volumes of this Storage.  # noqa: E501
        :rtype: IdRef2
        """
        return self._volumes

    @volumes.setter
    def volumes(self, volumes):
        """Sets the volumes of this Storage.


        :param volumes: The volumes of this Storage.  # noqa: E501
        :type: IdRef2
        """

        self._volumes = volumes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Storage):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
