# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class StorageController(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_id': 'str',
        'asset_tag': 'str',
        'firmware_version': 'str',
        'identifiers': 'list[Identifier]',
        'manufacturer': 'str',
        'member_id': 'str',
        'model': 'str',
        'oem': 'dict(str, object)',
        'part_number': 'str',
        'sku': 'str',
        'serial_number': 'str',
        'speed_gbps': 'float',
        'status': 'Status',
        'supported_controller_protocols': 'list[Protocol]',
        'supported_device_protocols': 'list[Protocol]'
    }

    attribute_map = {
        'odata_id': '@odata.id',
        'asset_tag': 'AssetTag',
        'firmware_version': 'FirmwareVersion',
        'identifiers': 'Identifiers',
        'manufacturer': 'Manufacturer',
        'member_id': 'MemberId',
        'model': 'Model',
        'oem': 'Oem',
        'part_number': 'PartNumber',
        'sku': 'SKU',
        'serial_number': 'SerialNumber',
        'speed_gbps': 'SpeedGbps',
        'status': 'Status',
        'supported_controller_protocols': 'SupportedControllerProtocols',
        'supported_device_protocols': 'SupportedDeviceProtocols'
    }

    def __init__(self, odata_id=None, asset_tag=None, firmware_version=None, identifiers=None, manufacturer=None, member_id=None, model=None, oem=None, part_number=None, sku=None, serial_number=None, speed_gbps=None, status=None, supported_controller_protocols=None, supported_device_protocols=None):  # noqa: E501
        """StorageController - a model defined in OpenAPI"""  # noqa: E501

        self._odata_id = None
        self._asset_tag = None
        self._firmware_version = None
        self._identifiers = None
        self._manufacturer = None
        self._member_id = None
        self._model = None
        self._oem = None
        self._part_number = None
        self._sku = None
        self._serial_number = None
        self._speed_gbps = None
        self._status = None
        self._supported_controller_protocols = None
        self._supported_device_protocols = None
        self.discriminator = None

        self.odata_id = odata_id
        self.asset_tag = asset_tag
        self.firmware_version = firmware_version
        if identifiers is not None:
            self.identifiers = identifiers
        self.manufacturer = manufacturer
        self.member_id = member_id
        self.model = model
        if oem is not None:
            self.oem = oem
        self.part_number = part_number
        self.sku = sku
        self.serial_number = serial_number
        self.speed_gbps = speed_gbps
        if status is not None:
            self.status = status
        if supported_controller_protocols is not None:
            self.supported_controller_protocols = supported_controller_protocols
        if supported_device_protocols is not None:
            self.supported_device_protocols = supported_device_protocols

    @property
    def odata_id(self):
        """Gets the odata_id of this StorageController.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this StorageController.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this StorageController.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this StorageController.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def asset_tag(self):
        """Gets the asset_tag of this StorageController.  # noqa: E501

        The user-assigned asset tag for this storage controller.  # noqa: E501

        :return: The asset_tag of this StorageController.  # noqa: E501
        :rtype: str
        """
        return self._asset_tag

    @asset_tag.setter
    def asset_tag(self, asset_tag):
        """Sets the asset_tag of this StorageController.

        The user-assigned asset tag for this storage controller.  # noqa: E501

        :param asset_tag: The asset_tag of this StorageController.  # noqa: E501
        :type: str
        """

        self._asset_tag = asset_tag

    @property
    def firmware_version(self):
        """Gets the firmware_version of this StorageController.  # noqa: E501

        The firmware version of this storage controller.  # noqa: E501

        :return: The firmware_version of this StorageController.  # noqa: E501
        :rtype: str
        """
        return self._firmware_version

    @firmware_version.setter
    def firmware_version(self, firmware_version):
        """Sets the firmware_version of this StorageController.

        The firmware version of this storage controller.  # noqa: E501

        :param firmware_version: The firmware_version of this StorageController.  # noqa: E501
        :type: str
        """

        self._firmware_version = firmware_version

    @property
    def identifiers(self):
        """Gets the identifiers of this StorageController.  # noqa: E501

        The durable names for the storage controller.  # noqa: E501

        :return: The identifiers of this StorageController.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._identifiers

    @identifiers.setter
    def identifiers(self, identifiers):
        """Sets the identifiers of this StorageController.

        The durable names for the storage controller.  # noqa: E501

        :param identifiers: The identifiers of this StorageController.  # noqa: E501
        :type: list[Identifier]
        """

        self._identifiers = identifiers

    @property
    def manufacturer(self):
        """Gets the manufacturer of this StorageController.  # noqa: E501

        The manufacturer of this storage controller.  # noqa: E501

        :return: The manufacturer of this StorageController.  # noqa: E501
        :rtype: str
        """
        return self._manufacturer

    @manufacturer.setter
    def manufacturer(self, manufacturer):
        """Sets the manufacturer of this StorageController.

        The manufacturer of this storage controller.  # noqa: E501

        :param manufacturer: The manufacturer of this StorageController.  # noqa: E501
        :type: str
        """

        self._manufacturer = manufacturer

    @property
    def member_id(self):
        """Gets the member_id of this StorageController.  # noqa: E501

        The identifier for the member within the collection.  # noqa: E501

        :return: The member_id of this StorageController.  # noqa: E501
        :rtype: str
        """
        return self._member_id

    @member_id.setter
    def member_id(self, member_id):
        """Sets the member_id of this StorageController.

        The identifier for the member within the collection.  # noqa: E501

        :param member_id: The member_id of this StorageController.  # noqa: E501
        :type: str
        """
        if member_id is None:
            raise ValueError("Invalid value for `member_id`, must not be `None`")  # noqa: E501

        self._member_id = member_id

    @property
    def model(self):
        """Gets the model of this StorageController.  # noqa: E501

        The model number for the storage controller.  # noqa: E501

        :return: The model of this StorageController.  # noqa: E501
        :rtype: str
        """
        return self._model

    @model.setter
    def model(self, model):
        """Sets the model of this StorageController.

        The model number for the storage controller.  # noqa: E501

        :param model: The model of this StorageController.  # noqa: E501
        :type: str
        """

        self._model = model

    @property
    def oem(self):
        """Gets the oem of this StorageController.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this StorageController.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this StorageController.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this StorageController.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def part_number(self):
        """Gets the part_number of this StorageController.  # noqa: E501

        The part number for this storage controller.  # noqa: E501

        :return: The part_number of this StorageController.  # noqa: E501
        :rtype: str
        """
        return self._part_number

    @part_number.setter
    def part_number(self, part_number):
        """Sets the part_number of this StorageController.

        The part number for this storage controller.  # noqa: E501

        :param part_number: The part_number of this StorageController.  # noqa: E501
        :type: str
        """

        self._part_number = part_number

    @property
    def sku(self):
        """Gets the sku of this StorageController.  # noqa: E501

        The SKU for this storage controller.  # noqa: E501

        :return: The sku of this StorageController.  # noqa: E501
        :rtype: str
        """
        return self._sku

    @sku.setter
    def sku(self, sku):
        """Sets the sku of this StorageController.

        The SKU for this storage controller.  # noqa: E501

        :param sku: The sku of this StorageController.  # noqa: E501
        :type: str
        """

        self._sku = sku

    @property
    def serial_number(self):
        """Gets the serial_number of this StorageController.  # noqa: E501

        The serial number for this storage controller.  # noqa: E501

        :return: The serial_number of this StorageController.  # noqa: E501
        :rtype: str
        """
        return self._serial_number

    @serial_number.setter
    def serial_number(self, serial_number):
        """Sets the serial_number of this StorageController.

        The serial number for this storage controller.  # noqa: E501

        :param serial_number: The serial_number of this StorageController.  # noqa: E501
        :type: str
        """

        self._serial_number = serial_number

    @property
    def speed_gbps(self):
        """Gets the speed_gbps of this StorageController.  # noqa: E501

        The maximum speed of the storage controller's device interface.  # noqa: E501

        :return: The speed_gbps of this StorageController.  # noqa: E501
        :rtype: float
        """
        return self._speed_gbps

    @speed_gbps.setter
    def speed_gbps(self, speed_gbps):
        """Sets the speed_gbps of this StorageController.

        The maximum speed of the storage controller's device interface.  # noqa: E501

        :param speed_gbps: The speed_gbps of this StorageController.  # noqa: E501
        :type: float
        """
        if speed_gbps is not None and speed_gbps < 0:  # noqa: E501
            raise ValueError("Invalid value for `speed_gbps`, must be a value greater than or equal to `0`")  # noqa: E501

        self._speed_gbps = speed_gbps

    @property
    def status(self):
        """Gets the status of this StorageController.  # noqa: E501


        :return: The status of this StorageController.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this StorageController.


        :param status: The status of this StorageController.  # noqa: E501
        :type: Status
        """

        self._status = status

    @property
    def supported_controller_protocols(self):
        """Gets the supported_controller_protocols of this StorageController.  # noqa: E501

        The supported set of protocols for communicating to this storage controller.  # noqa: E501

        :return: The supported_controller_protocols of this StorageController.  # noqa: E501
        :rtype: list[Protocol]
        """
        return self._supported_controller_protocols

    @supported_controller_protocols.setter
    def supported_controller_protocols(self, supported_controller_protocols):
        """Sets the supported_controller_protocols of this StorageController.

        The supported set of protocols for communicating to this storage controller.  # noqa: E501

        :param supported_controller_protocols: The supported_controller_protocols of this StorageController.  # noqa: E501
        :type: list[Protocol]
        """

        self._supported_controller_protocols = supported_controller_protocols

    @property
    def supported_device_protocols(self):
        """Gets the supported_device_protocols of this StorageController.  # noqa: E501

        The protocols that the storage controller can use to communicate with attached devices.  # noqa: E501

        :return: The supported_device_protocols of this StorageController.  # noqa: E501
        :rtype: list[Protocol]
        """
        return self._supported_device_protocols

    @supported_device_protocols.setter
    def supported_device_protocols(self, supported_device_protocols):
        """Sets the supported_device_protocols of this StorageController.

        The protocols that the storage controller can use to communicate with attached devices.  # noqa: E501

        :param supported_device_protocols: The supported_device_protocols of this StorageController.  # noqa: E501
        :type: list[Protocol]
        """

        self._supported_device_protocols = supported_device_protocols

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StorageController):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
