# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class StressPostRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'duration': 'int',
        'gpu': 'Bool',
        'cpu': 'Bool',
        'memory': 'Bool',
        'storage': 'Bool',
        'nic': 'Bool',
        'kill': 'Bool'
    }

    attribute_map = {
        'duration': 'Duration',
        'gpu': 'GPU',
        'cpu': 'CPU',
        'memory': 'Memory',
        'storage': 'Storage',
        'nic': 'NIC',
        'kill': 'Kill'
    }

    def __init__(self, duration=None, gpu=None, cpu=None, memory=None, storage=None, nic=None, kill=None):  # noqa: E501
        """StressPostRequest - a model defined in OpenAPI"""  # noqa: E501

        self._duration = None
        self._gpu = None
        self._cpu = None
        self._memory = None
        self._storage = None
        self._nic = None
        self._kill = None
        self.discriminator = None

        self.duration = duration
        self.gpu = gpu
        self.cpu = cpu
        self.memory = memory
        self.storage = storage
        self.nic = nic
        self.kill = kill

    @property
    def duration(self):
        """Gets the duration of this StressPostRequest.  # noqa: E501

        Duration of how long to run test for in seconds  # noqa: E501

        :return: The duration of this StressPostRequest.  # noqa: E501
        :rtype: int
        """
        return self._duration

    @duration.setter
    def duration(self, duration):
        """Sets the duration of this StressPostRequest.

        Duration of how long to run test for in seconds  # noqa: E501

        :param duration: The duration of this StressPostRequest.  # noqa: E501
        :type: int
        """
        if duration is None:
            raise ValueError("Invalid value for `duration`, must not be `None`")  # noqa: E501

        self._duration = duration

    @property
    def gpu(self):
        """Gets the gpu of this StressPostRequest.  # noqa: E501

        Whether or not to stress the GPU subsystem  # noqa: E501

        :return: The gpu of this StressPostRequest.  # noqa: E501
        :rtype: Bool
        """
        return self._gpu

    @gpu.setter
    def gpu(self, gpu):
        """Sets the gpu of this StressPostRequest.

        Whether or not to stress the GPU subsystem  # noqa: E501

        :param gpu: The gpu of this StressPostRequest.  # noqa: E501
        :type: Bool
        """
        if gpu is None:
            raise ValueError("Invalid value for `gpu`, must not be `None`")  # noqa: E501

        self._gpu = gpu

    @property
    def cpu(self):
        """Gets the cpu of this StressPostRequest.  # noqa: E501

        Whether or not to stress the CPU subsystem  # noqa: E501

        :return: The cpu of this StressPostRequest.  # noqa: E501
        :rtype: Bool
        """
        return self._cpu

    @cpu.setter
    def cpu(self, cpu):
        """Sets the cpu of this StressPostRequest.

        Whether or not to stress the CPU subsystem  # noqa: E501

        :param cpu: The cpu of this StressPostRequest.  # noqa: E501
        :type: Bool
        """
        if cpu is None:
            raise ValueError("Invalid value for `cpu`, must not be `None`")  # noqa: E501

        self._cpu = cpu

    @property
    def memory(self):
        """Gets the memory of this StressPostRequest.  # noqa: E501

        Whether or not to stress the Memory subsystem  # noqa: E501

        :return: The memory of this StressPostRequest.  # noqa: E501
        :rtype: Bool
        """
        return self._memory

    @memory.setter
    def memory(self, memory):
        """Sets the memory of this StressPostRequest.

        Whether or not to stress the Memory subsystem  # noqa: E501

        :param memory: The memory of this StressPostRequest.  # noqa: E501
        :type: Bool
        """
        if memory is None:
            raise ValueError("Invalid value for `memory`, must not be `None`")  # noqa: E501

        self._memory = memory

    @property
    def storage(self):
        """Gets the storage of this StressPostRequest.  # noqa: E501

        Whether or not to stress the Storage subsystem  # noqa: E501

        :return: The storage of this StressPostRequest.  # noqa: E501
        :rtype: Bool
        """
        return self._storage

    @storage.setter
    def storage(self, storage):
        """Sets the storage of this StressPostRequest.

        Whether or not to stress the Storage subsystem  # noqa: E501

        :param storage: The storage of this StressPostRequest.  # noqa: E501
        :type: Bool
        """
        if storage is None:
            raise ValueError("Invalid value for `storage`, must not be `None`")  # noqa: E501

        self._storage = storage

    @property
    def nic(self):
        """Gets the nic of this StressPostRequest.  # noqa: E501

        Whether or not to stress the NIC subsystem  # noqa: E501

        :return: The nic of this StressPostRequest.  # noqa: E501
        :rtype: Bool
        """
        return self._nic

    @nic.setter
    def nic(self, nic):
        """Sets the nic of this StressPostRequest.

        Whether or not to stress the NIC subsystem  # noqa: E501

        :param nic: The nic of this StressPostRequest.  # noqa: E501
        :type: Bool
        """
        if nic is None:
            raise ValueError("Invalid value for `nic`, must not be `None`")  # noqa: E501

        self._nic = nic

    @property
    def kill(self):
        """Gets the kill of this StressPostRequest.  # noqa: E501

        Whether or not to kill the running tests  # noqa: E501

        :return: The kill of this StressPostRequest.  # noqa: E501
        :rtype: Bool
        """
        return self._kill

    @kill.setter
    def kill(self, kill):
        """Sets the kill of this StressPostRequest.

        Whether or not to kill the running tests  # noqa: E501

        :param kill: The kill of this StressPostRequest.  # noqa: E501
        :type: Bool
        """
        if kill is None:
            raise ValueError("Invalid value for `kill`, must not be `None`")  # noqa: E501

        self._kill = kill

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StressPostRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
