# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class StressResult(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'gpu': 'GeneralResultStruct',
        'cpu': 'GeneralResultStruct',
        'memory': 'GeneralResultStruct',
        'storage': 'GeneralResultStruct',
        'pc_ie': 'GeneralResultStruct',
        'nic': 'GeneralResultStruct',
        'gpu_temp': 'Metrics',
        'cpu_temp': 'Metrics',
        'mem_temp': 'Metrics',
        'powerdraw': 'Metrics',
        'fanspeed': 'Metrics',
        'gpu_load': 'Metrics',
        'cpu_load': 'Metrics',
        'mem_load': 'Metrics',
        'disk_load': 'Metrics',
        'approx_time_left': 'str',
        'time_started': 'str',
        'time_ended': 'str',
        'alerts': 'str'
    }

    attribute_map = {
        'gpu': 'GPU',
        'cpu': 'CPU',
        'memory': 'Memory',
        'storage': 'Storage',
        'pc_ie': 'PCIe',
        'nic': 'NIC',
        'gpu_temp': 'GPU_TEMP',
        'cpu_temp': 'CPU_TEMP',
        'mem_temp': 'MEM_TEMP',
        'powerdraw': 'POWERDRAW',
        'fanspeed': 'FANSPEED',
        'gpu_load': 'GPU_LOAD',
        'cpu_load': 'CPU_LOAD',
        'mem_load': 'MEM_LOAD',
        'disk_load': 'DISK_LOAD',
        'approx_time_left': 'ApproxTimeLeft',
        'time_started': 'TimeStarted',
        'time_ended': 'TimeEnded',
        'alerts': 'Alerts'
    }

    def __init__(self, gpu=None, cpu=None, memory=None, storage=None, pc_ie=None, nic=None, gpu_temp=None, cpu_temp=None, mem_temp=None, powerdraw=None, fanspeed=None, gpu_load=None, cpu_load=None, mem_load=None, disk_load=None, approx_time_left=None, time_started=None, time_ended=None, alerts=None):  # noqa: E501
        """StressResult - a model defined in OpenAPI"""  # noqa: E501

        self._gpu = None
        self._cpu = None
        self._memory = None
        self._storage = None
        self._pc_ie = None
        self._nic = None
        self._gpu_temp = None
        self._cpu_temp = None
        self._mem_temp = None
        self._powerdraw = None
        self._fanspeed = None
        self._gpu_load = None
        self._cpu_load = None
        self._mem_load = None
        self._disk_load = None
        self._approx_time_left = None
        self._time_started = None
        self._time_ended = None
        self._alerts = None
        self.discriminator = None

        self.gpu = gpu
        self.cpu = cpu
        self.memory = memory
        self.storage = storage
        self.pc_ie = pc_ie
        self.nic = nic
        self.gpu_temp = gpu_temp
        self.cpu_temp = cpu_temp
        self.mem_temp = mem_temp
        self.powerdraw = powerdraw
        self.fanspeed = fanspeed
        self.gpu_load = gpu_load
        self.cpu_load = cpu_load
        self.mem_load = mem_load
        self.disk_load = disk_load
        self.approx_time_left = approx_time_left
        self.time_started = time_started
        self.time_ended = time_ended
        self.alerts = alerts

    @property
    def gpu(self):
        """Gets the gpu of this StressResult.  # noqa: E501


        :return: The gpu of this StressResult.  # noqa: E501
        :rtype: GeneralResultStruct
        """
        return self._gpu

    @gpu.setter
    def gpu(self, gpu):
        """Sets the gpu of this StressResult.


        :param gpu: The gpu of this StressResult.  # noqa: E501
        :type: GeneralResultStruct
        """
        if gpu is None:
            raise ValueError("Invalid value for `gpu`, must not be `None`")  # noqa: E501

        self._gpu = gpu

    @property
    def cpu(self):
        """Gets the cpu of this StressResult.  # noqa: E501


        :return: The cpu of this StressResult.  # noqa: E501
        :rtype: GeneralResultStruct
        """
        return self._cpu

    @cpu.setter
    def cpu(self, cpu):
        """Sets the cpu of this StressResult.


        :param cpu: The cpu of this StressResult.  # noqa: E501
        :type: GeneralResultStruct
        """
        if cpu is None:
            raise ValueError("Invalid value for `cpu`, must not be `None`")  # noqa: E501

        self._cpu = cpu

    @property
    def memory(self):
        """Gets the memory of this StressResult.  # noqa: E501


        :return: The memory of this StressResult.  # noqa: E501
        :rtype: GeneralResultStruct
        """
        return self._memory

    @memory.setter
    def memory(self, memory):
        """Sets the memory of this StressResult.


        :param memory: The memory of this StressResult.  # noqa: E501
        :type: GeneralResultStruct
        """
        if memory is None:
            raise ValueError("Invalid value for `memory`, must not be `None`")  # noqa: E501

        self._memory = memory

    @property
    def storage(self):
        """Gets the storage of this StressResult.  # noqa: E501


        :return: The storage of this StressResult.  # noqa: E501
        :rtype: GeneralResultStruct
        """
        return self._storage

    @storage.setter
    def storage(self, storage):
        """Sets the storage of this StressResult.


        :param storage: The storage of this StressResult.  # noqa: E501
        :type: GeneralResultStruct
        """
        if storage is None:
            raise ValueError("Invalid value for `storage`, must not be `None`")  # noqa: E501

        self._storage = storage

    @property
    def pc_ie(self):
        """Gets the pc_ie of this StressResult.  # noqa: E501


        :return: The pc_ie of this StressResult.  # noqa: E501
        :rtype: GeneralResultStruct
        """
        return self._pc_ie

    @pc_ie.setter
    def pc_ie(self, pc_ie):
        """Sets the pc_ie of this StressResult.


        :param pc_ie: The pc_ie of this StressResult.  # noqa: E501
        :type: GeneralResultStruct
        """
        if pc_ie is None:
            raise ValueError("Invalid value for `pc_ie`, must not be `None`")  # noqa: E501

        self._pc_ie = pc_ie

    @property
    def nic(self):
        """Gets the nic of this StressResult.  # noqa: E501


        :return: The nic of this StressResult.  # noqa: E501
        :rtype: GeneralResultStruct
        """
        return self._nic

    @nic.setter
    def nic(self, nic):
        """Sets the nic of this StressResult.


        :param nic: The nic of this StressResult.  # noqa: E501
        :type: GeneralResultStruct
        """
        if nic is None:
            raise ValueError("Invalid value for `nic`, must not be `None`")  # noqa: E501

        self._nic = nic

    @property
    def gpu_temp(self):
        """Gets the gpu_temp of this StressResult.  # noqa: E501


        :return: The gpu_temp of this StressResult.  # noqa: E501
        :rtype: Metrics
        """
        return self._gpu_temp

    @gpu_temp.setter
    def gpu_temp(self, gpu_temp):
        """Sets the gpu_temp of this StressResult.


        :param gpu_temp: The gpu_temp of this StressResult.  # noqa: E501
        :type: Metrics
        """
        if gpu_temp is None:
            raise ValueError("Invalid value for `gpu_temp`, must not be `None`")  # noqa: E501

        self._gpu_temp = gpu_temp

    @property
    def cpu_temp(self):
        """Gets the cpu_temp of this StressResult.  # noqa: E501


        :return: The cpu_temp of this StressResult.  # noqa: E501
        :rtype: Metrics
        """
        return self._cpu_temp

    @cpu_temp.setter
    def cpu_temp(self, cpu_temp):
        """Sets the cpu_temp of this StressResult.


        :param cpu_temp: The cpu_temp of this StressResult.  # noqa: E501
        :type: Metrics
        """
        if cpu_temp is None:
            raise ValueError("Invalid value for `cpu_temp`, must not be `None`")  # noqa: E501

        self._cpu_temp = cpu_temp

    @property
    def mem_temp(self):
        """Gets the mem_temp of this StressResult.  # noqa: E501


        :return: The mem_temp of this StressResult.  # noqa: E501
        :rtype: Metrics
        """
        return self._mem_temp

    @mem_temp.setter
    def mem_temp(self, mem_temp):
        """Sets the mem_temp of this StressResult.


        :param mem_temp: The mem_temp of this StressResult.  # noqa: E501
        :type: Metrics
        """
        if mem_temp is None:
            raise ValueError("Invalid value for `mem_temp`, must not be `None`")  # noqa: E501

        self._mem_temp = mem_temp

    @property
    def powerdraw(self):
        """Gets the powerdraw of this StressResult.  # noqa: E501


        :return: The powerdraw of this StressResult.  # noqa: E501
        :rtype: Metrics
        """
        return self._powerdraw

    @powerdraw.setter
    def powerdraw(self, powerdraw):
        """Sets the powerdraw of this StressResult.


        :param powerdraw: The powerdraw of this StressResult.  # noqa: E501
        :type: Metrics
        """
        if powerdraw is None:
            raise ValueError("Invalid value for `powerdraw`, must not be `None`")  # noqa: E501

        self._powerdraw = powerdraw

    @property
    def fanspeed(self):
        """Gets the fanspeed of this StressResult.  # noqa: E501


        :return: The fanspeed of this StressResult.  # noqa: E501
        :rtype: Metrics
        """
        return self._fanspeed

    @fanspeed.setter
    def fanspeed(self, fanspeed):
        """Sets the fanspeed of this StressResult.


        :param fanspeed: The fanspeed of this StressResult.  # noqa: E501
        :type: Metrics
        """
        if fanspeed is None:
            raise ValueError("Invalid value for `fanspeed`, must not be `None`")  # noqa: E501

        self._fanspeed = fanspeed

    @property
    def gpu_load(self):
        """Gets the gpu_load of this StressResult.  # noqa: E501


        :return: The gpu_load of this StressResult.  # noqa: E501
        :rtype: Metrics
        """
        return self._gpu_load

    @gpu_load.setter
    def gpu_load(self, gpu_load):
        """Sets the gpu_load of this StressResult.


        :param gpu_load: The gpu_load of this StressResult.  # noqa: E501
        :type: Metrics
        """
        if gpu_load is None:
            raise ValueError("Invalid value for `gpu_load`, must not be `None`")  # noqa: E501

        self._gpu_load = gpu_load

    @property
    def cpu_load(self):
        """Gets the cpu_load of this StressResult.  # noqa: E501


        :return: The cpu_load of this StressResult.  # noqa: E501
        :rtype: Metrics
        """
        return self._cpu_load

    @cpu_load.setter
    def cpu_load(self, cpu_load):
        """Sets the cpu_load of this StressResult.


        :param cpu_load: The cpu_load of this StressResult.  # noqa: E501
        :type: Metrics
        """
        if cpu_load is None:
            raise ValueError("Invalid value for `cpu_load`, must not be `None`")  # noqa: E501

        self._cpu_load = cpu_load

    @property
    def mem_load(self):
        """Gets the mem_load of this StressResult.  # noqa: E501


        :return: The mem_load of this StressResult.  # noqa: E501
        :rtype: Metrics
        """
        return self._mem_load

    @mem_load.setter
    def mem_load(self, mem_load):
        """Sets the mem_load of this StressResult.


        :param mem_load: The mem_load of this StressResult.  # noqa: E501
        :type: Metrics
        """
        if mem_load is None:
            raise ValueError("Invalid value for `mem_load`, must not be `None`")  # noqa: E501

        self._mem_load = mem_load

    @property
    def disk_load(self):
        """Gets the disk_load of this StressResult.  # noqa: E501


        :return: The disk_load of this StressResult.  # noqa: E501
        :rtype: Metrics
        """
        return self._disk_load

    @disk_load.setter
    def disk_load(self, disk_load):
        """Sets the disk_load of this StressResult.


        :param disk_load: The disk_load of this StressResult.  # noqa: E501
        :type: Metrics
        """
        if disk_load is None:
            raise ValueError("Invalid value for `disk_load`, must not be `None`")  # noqa: E501

        self._disk_load = disk_load

    @property
    def approx_time_left(self):
        """Gets the approx_time_left of this StressResult.  # noqa: E501

        Approximate amount of time left in test  # noqa: E501

        :return: The approx_time_left of this StressResult.  # noqa: E501
        :rtype: str
        """
        return self._approx_time_left

    @approx_time_left.setter
    def approx_time_left(self, approx_time_left):
        """Sets the approx_time_left of this StressResult.

        Approximate amount of time left in test  # noqa: E501

        :param approx_time_left: The approx_time_left of this StressResult.  # noqa: E501
        :type: str
        """
        if approx_time_left is None:
            raise ValueError("Invalid value for `approx_time_left`, must not be `None`")  # noqa: E501

        self._approx_time_left = approx_time_left

    @property
    def time_started(self):
        """Gets the time_started of this StressResult.  # noqa: E501

        Time test started  # noqa: E501

        :return: The time_started of this StressResult.  # noqa: E501
        :rtype: str
        """
        return self._time_started

    @time_started.setter
    def time_started(self, time_started):
        """Sets the time_started of this StressResult.

        Time test started  # noqa: E501

        :param time_started: The time_started of this StressResult.  # noqa: E501
        :type: str
        """
        if time_started is None:
            raise ValueError("Invalid value for `time_started`, must not be `None`")  # noqa: E501

        self._time_started = time_started

    @property
    def time_ended(self):
        """Gets the time_ended of this StressResult.  # noqa: E501

        Time test ended  # noqa: E501

        :return: The time_ended of this StressResult.  # noqa: E501
        :rtype: str
        """
        return self._time_ended

    @time_ended.setter
    def time_ended(self, time_ended):
        """Sets the time_ended of this StressResult.

        Time test ended  # noqa: E501

        :param time_ended: The time_ended of this StressResult.  # noqa: E501
        :type: str
        """
        if time_ended is None:
            raise ValueError("Invalid value for `time_ended`, must not be `None`")  # noqa: E501

        self._time_ended = time_ended

    @property
    def alerts(self):
        """Gets the alerts of this StressResult.  # noqa: E501

        Number of alerts generated during test  # noqa: E501

        :return: The alerts of this StressResult.  # noqa: E501
        :rtype: str
        """
        return self._alerts

    @alerts.setter
    def alerts(self, alerts):
        """Sets the alerts of this StressResult.

        Number of alerts generated during test  # noqa: E501

        :param alerts: The alerts of this StressResult.  # noqa: E501
        :type: str
        """
        if alerts is None:
            raise ValueError("Invalid value for `alerts`, must not be `None`")  # noqa: E501

        self._alerts = alerts

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StressResult):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
