# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class SupportedLinkCapabilities(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'auto_speed_negotiation': 'bool',
        'capable_link_speed_mbps': 'list[int]',
        'link_network_technology': 'LinkNetworkTechnology',
        'link_speed_mbps': 'int'
    }

    attribute_map = {
        'auto_speed_negotiation': 'AutoSpeedNegotiation',
        'capable_link_speed_mbps': 'CapableLinkSpeedMbps',
        'link_network_technology': 'LinkNetworkTechnology',
        'link_speed_mbps': 'LinkSpeedMbps'
    }

    def __init__(self, auto_speed_negotiation=None, capable_link_speed_mbps=None, link_network_technology=None, link_speed_mbps=None):  # noqa: E501
        """SupportedLinkCapabilities - a model defined in OpenAPI"""  # noqa: E501

        self._auto_speed_negotiation = None
        self._capable_link_speed_mbps = None
        self._link_network_technology = None
        self._link_speed_mbps = None
        self.discriminator = None

        self.auto_speed_negotiation = auto_speed_negotiation
        if capable_link_speed_mbps is not None:
            self.capable_link_speed_mbps = capable_link_speed_mbps
        if link_network_technology is not None:
            self.link_network_technology = link_network_technology
        self.link_speed_mbps = link_speed_mbps

    @property
    def auto_speed_negotiation(self):
        """Gets the auto_speed_negotiation of this SupportedLinkCapabilities.  # noqa: E501

        Indicates whether the port has the capability to auto negotiate speed.  # noqa: E501

        :return: The auto_speed_negotiation of this SupportedLinkCapabilities.  # noqa: E501
        :rtype: bool
        """
        return self._auto_speed_negotiation

    @auto_speed_negotiation.setter
    def auto_speed_negotiation(self, auto_speed_negotiation):
        """Sets the auto_speed_negotiation of this SupportedLinkCapabilities.

        Indicates whether the port has the capability to auto negotiate speed.  # noqa: E501

        :param auto_speed_negotiation: The auto_speed_negotiation of this SupportedLinkCapabilities.  # noqa: E501
        :type: bool
        """

        self._auto_speed_negotiation = auto_speed_negotiation

    @property
    def capable_link_speed_mbps(self):
        """Gets the capable_link_speed_mbps of this SupportedLinkCapabilities.  # noqa: E501

        The self-described link network speed capabilities of this port. Note: Should this be a new enumerated type of link speeds?.  # noqa: E501

        :return: The capable_link_speed_mbps of this SupportedLinkCapabilities.  # noqa: E501
        :rtype: list[int]
        """
        return self._capable_link_speed_mbps

    @capable_link_speed_mbps.setter
    def capable_link_speed_mbps(self, capable_link_speed_mbps):
        """Sets the capable_link_speed_mbps of this SupportedLinkCapabilities.

        The self-described link network speed capabilities of this port. Note: Should this be a new enumerated type of link speeds?.  # noqa: E501

        :param capable_link_speed_mbps: The capable_link_speed_mbps of this SupportedLinkCapabilities.  # noqa: E501
        :type: list[int]
        """

        self._capable_link_speed_mbps = capable_link_speed_mbps

    @property
    def link_network_technology(self):
        """Gets the link_network_technology of this SupportedLinkCapabilities.  # noqa: E501


        :return: The link_network_technology of this SupportedLinkCapabilities.  # noqa: E501
        :rtype: LinkNetworkTechnology
        """
        return self._link_network_technology

    @link_network_technology.setter
    def link_network_technology(self, link_network_technology):
        """Sets the link_network_technology of this SupportedLinkCapabilities.


        :param link_network_technology: The link_network_technology of this SupportedLinkCapabilities.  # noqa: E501
        :type: LinkNetworkTechnology
        """

        self._link_network_technology = link_network_technology

    @property
    def link_speed_mbps(self):
        """Gets the link_speed_mbps of this SupportedLinkCapabilities.  # noqa: E501

        The speed of the link in Mbps when this link network technology is active.  # noqa: E501

        :return: The link_speed_mbps of this SupportedLinkCapabilities.  # noqa: E501
        :rtype: int
        """
        return self._link_speed_mbps

    @link_speed_mbps.setter
    def link_speed_mbps(self, link_speed_mbps):
        """Sets the link_speed_mbps of this SupportedLinkCapabilities.

        The speed of the link in Mbps when this link network technology is active.  # noqa: E501

        :param link_speed_mbps: The link_speed_mbps of this SupportedLinkCapabilities.  # noqa: E501
        :type: int
        """

        self._link_speed_mbps = link_speed_mbps

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SupportedLinkCapabilities):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
