# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class SupportedSpeed(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'for_mem_clock': 'str',
        'supported_graphics_clocks': 'list[str]'
    }

    attribute_map = {
        'for_mem_clock': 'ForMemClock',
        'supported_graphics_clocks': 'SupportedGraphicsClocks'
    }

    def __init__(self, for_mem_clock=None, supported_graphics_clocks=None):  # noqa: E501
        """SupportedSpeed - a model defined in OpenAPI"""  # noqa: E501

        self._for_mem_clock = None
        self._supported_graphics_clocks = None
        self.discriminator = None

        self.for_mem_clock = for_mem_clock
        self.supported_graphics_clocks = supported_graphics_clocks

    @property
    def for_mem_clock(self):
        """Gets the for_mem_clock of this SupportedSpeed.  # noqa: E501

        Frequency of memory clock.  # noqa: E501

        :return: The for_mem_clock of this SupportedSpeed.  # noqa: E501
        :rtype: str
        """
        return self._for_mem_clock

    @for_mem_clock.setter
    def for_mem_clock(self, for_mem_clock):
        """Sets the for_mem_clock of this SupportedSpeed.

        Frequency of memory clock.  # noqa: E501

        :param for_mem_clock: The for_mem_clock of this SupportedSpeed.  # noqa: E501
        :type: str
        """
        if for_mem_clock is None:
            raise ValueError("Invalid value for `for_mem_clock`, must not be `None`")  # noqa: E501

        self._for_mem_clock = for_mem_clock

    @property
    def supported_graphics_clocks(self):
        """Gets the supported_graphics_clocks of this SupportedSpeed.  # noqa: E501

        Frequency of graphics (shader) clock.  # noqa: E501

        :return: The supported_graphics_clocks of this SupportedSpeed.  # noqa: E501
        :rtype: list[str]
        """
        return self._supported_graphics_clocks

    @supported_graphics_clocks.setter
    def supported_graphics_clocks(self, supported_graphics_clocks):
        """Sets the supported_graphics_clocks of this SupportedSpeed.

        Frequency of graphics (shader) clock.  # noqa: E501

        :param supported_graphics_clocks: The supported_graphics_clocks of this SupportedSpeed.  # noqa: E501
        :type: list[str]
        """
        if supported_graphics_clocks is None:
            raise ValueError("Invalid value for `supported_graphics_clocks`, must not be `None`")  # noqa: E501

        self._supported_graphics_clocks = supported_graphics_clocks

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SupportedSpeed):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
