# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class SWFWVersions(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'info_rom_checksum': 'str',
        'info_rom_checksum_validation': 'str',
        'info_rom_ecc_object_version': 'str',
        'info_rom_image_version': 'str',
        'info_rom_power_object_version': 'str',
        'info_rom_version': 'str',
        'mcufw_version': 'str',
        'pc_ie_bridge_chip_fw': 'str',
        'vbios_version': 'str'
    }

    attribute_map = {
        'info_rom_checksum': 'InfoRomChecksum',
        'info_rom_checksum_validation': 'InfoRomChecksumValidation',
        'info_rom_ecc_object_version': 'InfoRomECCObjectVersion',
        'info_rom_image_version': 'InfoRomImageVersion',
        'info_rom_power_object_version': 'InfoRomPowerObjectVersion',
        'info_rom_version': 'InfoRomVersion',
        'mcufw_version': 'MCUFWVersion',
        'pc_ie_bridge_chip_fw': 'PCIeBridgeChipFW',
        'vbios_version': 'VBIOSVersion'
    }

    def __init__(self, info_rom_checksum=None, info_rom_checksum_validation=None, info_rom_ecc_object_version=None, info_rom_image_version=None, info_rom_power_object_version=None, info_rom_version=None, mcufw_version=None, pc_ie_bridge_chip_fw=None, vbios_version=None):  # noqa: E501
        """SWFWVersions - a model defined in OpenAPI"""  # noqa: E501

        self._info_rom_checksum = None
        self._info_rom_checksum_validation = None
        self._info_rom_ecc_object_version = None
        self._info_rom_image_version = None
        self._info_rom_power_object_version = None
        self._info_rom_version = None
        self._mcufw_version = None
        self._pc_ie_bridge_chip_fw = None
        self._vbios_version = None
        self.discriminator = None

        self.info_rom_checksum = info_rom_checksum
        self.info_rom_checksum_validation = info_rom_checksum_validation
        self.info_rom_ecc_object_version = info_rom_ecc_object_version
        self.info_rom_image_version = info_rom_image_version
        self.info_rom_power_object_version = info_rom_power_object_version
        self.info_rom_version = info_rom_version
        self.mcufw_version = mcufw_version
        self.pc_ie_bridge_chip_fw = pc_ie_bridge_chip_fw
        self.vbios_version = vbios_version

    @property
    def info_rom_checksum(self):
        """Gets the info_rom_checksum of this SWFWVersions.  # noqa: E501

        The checksum of the configuration stored in the device's infoROM.  # noqa: E501

        :return: The info_rom_checksum of this SWFWVersions.  # noqa: E501
        :rtype: str
        """
        return self._info_rom_checksum

    @info_rom_checksum.setter
    def info_rom_checksum(self, info_rom_checksum):
        """Sets the info_rom_checksum of this SWFWVersions.

        The checksum of the configuration stored in the device's infoROM.  # noqa: E501

        :param info_rom_checksum: The info_rom_checksum of this SWFWVersions.  # noqa: E501
        :type: str
        """
        if info_rom_checksum is None:
            raise ValueError("Invalid value for `info_rom_checksum`, must not be `None`")  # noqa: E501

        self._info_rom_checksum = info_rom_checksum

    @property
    def info_rom_checksum_validation(self):
        """Gets the info_rom_checksum_validation of this SWFWVersions.  # noqa: E501

        Result of a checksum validation on the infoROM.  # noqa: E501

        :return: The info_rom_checksum_validation of this SWFWVersions.  # noqa: E501
        :rtype: str
        """
        return self._info_rom_checksum_validation

    @info_rom_checksum_validation.setter
    def info_rom_checksum_validation(self, info_rom_checksum_validation):
        """Sets the info_rom_checksum_validation of this SWFWVersions.

        Result of a checksum validation on the infoROM.  # noqa: E501

        :param info_rom_checksum_validation: The info_rom_checksum_validation of this SWFWVersions.  # noqa: E501
        :type: str
        """
        if info_rom_checksum_validation is None:
            raise ValueError("Invalid value for `info_rom_checksum_validation`, must not be `None`")  # noqa: E501

        self._info_rom_checksum_validation = info_rom_checksum_validation

    @property
    def info_rom_ecc_object_version(self):
        """Gets the info_rom_ecc_object_version of this SWFWVersions.  # noqa: E501

        Version for the ECC recording data.  # noqa: E501

        :return: The info_rom_ecc_object_version of this SWFWVersions.  # noqa: E501
        :rtype: str
        """
        return self._info_rom_ecc_object_version

    @info_rom_ecc_object_version.setter
    def info_rom_ecc_object_version(self, info_rom_ecc_object_version):
        """Sets the info_rom_ecc_object_version of this SWFWVersions.

        Version for the ECC recording data.  # noqa: E501

        :param info_rom_ecc_object_version: The info_rom_ecc_object_version of this SWFWVersions.  # noqa: E501
        :type: str
        """
        if info_rom_ecc_object_version is None:
            raise ValueError("Invalid value for `info_rom_ecc_object_version`, must not be `None`")  # noqa: E501

        self._info_rom_ecc_object_version = info_rom_ecc_object_version

    @property
    def info_rom_image_version(self):
        """Gets the info_rom_image_version of this SWFWVersions.  # noqa: E501

        Global version of the infoROM image.  # noqa: E501

        :return: The info_rom_image_version of this SWFWVersions.  # noqa: E501
        :rtype: str
        """
        return self._info_rom_image_version

    @info_rom_image_version.setter
    def info_rom_image_version(self, info_rom_image_version):
        """Sets the info_rom_image_version of this SWFWVersions.

        Global version of the infoROM image.  # noqa: E501

        :param info_rom_image_version: The info_rom_image_version of this SWFWVersions.  # noqa: E501
        :type: str
        """
        if info_rom_image_version is None:
            raise ValueError("Invalid value for `info_rom_image_version`, must not be `None`")  # noqa: E501

        self._info_rom_image_version = info_rom_image_version

    @property
    def info_rom_power_object_version(self):
        """Gets the info_rom_power_object_version of this SWFWVersions.  # noqa: E501

        Version for the power management data.  # noqa: E501

        :return: The info_rom_power_object_version of this SWFWVersions.  # noqa: E501
        :rtype: str
        """
        return self._info_rom_power_object_version

    @info_rom_power_object_version.setter
    def info_rom_power_object_version(self, info_rom_power_object_version):
        """Sets the info_rom_power_object_version of this SWFWVersions.

        Version for the power management data.  # noqa: E501

        :param info_rom_power_object_version: The info_rom_power_object_version of this SWFWVersions.  # noqa: E501
        :type: str
        """
        if info_rom_power_object_version is None:
            raise ValueError("Invalid value for `info_rom_power_object_version`, must not be `None`")  # noqa: E501

        self._info_rom_power_object_version = info_rom_power_object_version

    @property
    def info_rom_version(self):
        """Gets the info_rom_version of this SWFWVersions.  # noqa: E501

        The version of the infoROM image.  # noqa: E501

        :return: The info_rom_version of this SWFWVersions.  # noqa: E501
        :rtype: str
        """
        return self._info_rom_version

    @info_rom_version.setter
    def info_rom_version(self, info_rom_version):
        """Sets the info_rom_version of this SWFWVersions.

        The version of the infoROM image.  # noqa: E501

        :param info_rom_version: The info_rom_version of this SWFWVersions.  # noqa: E501
        :type: str
        """
        if info_rom_version is None:
            raise ValueError("Invalid value for `info_rom_version`, must not be `None`")  # noqa: E501

        self._info_rom_version = info_rom_version

    @property
    def mcufw_version(self):
        """Gets the mcufw_version of this SWFWVersions.  # noqa: E501

        The version of Firmware running on the MCUs.  # noqa: E501

        :return: The mcufw_version of this SWFWVersions.  # noqa: E501
        :rtype: str
        """
        return self._mcufw_version

    @mcufw_version.setter
    def mcufw_version(self, mcufw_version):
        """Sets the mcufw_version of this SWFWVersions.

        The version of Firmware running on the MCUs.  # noqa: E501

        :param mcufw_version: The mcufw_version of this SWFWVersions.  # noqa: E501
        :type: str
        """
        if mcufw_version is None:
            raise ValueError("Invalid value for `mcufw_version`, must not be `None`")  # noqa: E501

        self._mcufw_version = mcufw_version

    @property
    def pc_ie_bridge_chip_fw(self):
        """Gets the pc_ie_bridge_chip_fw of this SWFWVersions.  # noqa: E501

        The firmware version of the bridge chip. Reported as N/A if doesn't exist.  # noqa: E501

        :return: The pc_ie_bridge_chip_fw of this SWFWVersions.  # noqa: E501
        :rtype: str
        """
        return self._pc_ie_bridge_chip_fw

    @pc_ie_bridge_chip_fw.setter
    def pc_ie_bridge_chip_fw(self, pc_ie_bridge_chip_fw):
        """Sets the pc_ie_bridge_chip_fw of this SWFWVersions.

        The firmware version of the bridge chip. Reported as N/A if doesn't exist.  # noqa: E501

        :param pc_ie_bridge_chip_fw: The pc_ie_bridge_chip_fw of this SWFWVersions.  # noqa: E501
        :type: str
        """
        if pc_ie_bridge_chip_fw is None:
            raise ValueError("Invalid value for `pc_ie_bridge_chip_fw`, must not be `None`")  # noqa: E501

        self._pc_ie_bridge_chip_fw = pc_ie_bridge_chip_fw

    @property
    def vbios_version(self):
        """Gets the vbios_version of this SWFWVersions.  # noqa: E501

        The version of BIOS on the GPU board.  # noqa: E501

        :return: The vbios_version of this SWFWVersions.  # noqa: E501
        :rtype: str
        """
        return self._vbios_version

    @vbios_version.setter
    def vbios_version(self, vbios_version):
        """Sets the vbios_version of this SWFWVersions.

        The version of BIOS on the GPU board.  # noqa: E501

        :param vbios_version: The vbios_version of this SWFWVersions.  # noqa: E501
        :type: str
        """
        if vbios_version is None:
            raise ValueError("Invalid value for `vbios_version`, must not be `None`")  # noqa: E501

        self._vbios_version = vbios_version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SWFWVersions):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
