# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class SystemInfo(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'product_name': 'str',
        'manufacturer': 'str',
        'serial_number': 'str',
        'uptime': 'str',
        'mother_board': 'MotherBoardInfo',
        'bmc': 'BMCInfo',
        'gpu': 'GPUInfo',
        'software': 'SoftwareInfo',
        'cec': 'CECInfo'
    }

    attribute_map = {
        'product_name': 'ProductName',
        'manufacturer': 'Manufacturer',
        'serial_number': 'SerialNumber',
        'uptime': 'Uptime',
        'mother_board': 'MotherBoard',
        'bmc': 'BMC',
        'gpu': 'GPU',
        'software': 'Software',
        'cec': 'CEC'
    }

    def __init__(self, product_name=None, manufacturer=None, serial_number=None, uptime=None, mother_board=None, bmc=None, gpu=None, software=None, cec=None):  # noqa: E501
        """SystemInfo - a model defined in OpenAPI"""  # noqa: E501

        self._product_name = None
        self._manufacturer = None
        self._serial_number = None
        self._uptime = None
        self._mother_board = None
        self._bmc = None
        self._gpu = None
        self._software = None
        self._cec = None
        self.discriminator = None

        self.product_name = product_name
        self.manufacturer = manufacturer
        self.serial_number = serial_number
        self.uptime = uptime
        self.mother_board = mother_board
        self.bmc = bmc
        if gpu is not None:
            self.gpu = gpu
        self.software = software
        if cec is not None:
            self.cec = cec

    @property
    def product_name(self):
        """Gets the product_name of this SystemInfo.  # noqa: E501


        :return: The product_name of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._product_name

    @product_name.setter
    def product_name(self, product_name):
        """Sets the product_name of this SystemInfo.


        :param product_name: The product_name of this SystemInfo.  # noqa: E501
        :type: str
        """
        if product_name is None:
            raise ValueError("Invalid value for `product_name`, must not be `None`")  # noqa: E501

        self._product_name = product_name

    @property
    def manufacturer(self):
        """Gets the manufacturer of this SystemInfo.  # noqa: E501


        :return: The manufacturer of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._manufacturer

    @manufacturer.setter
    def manufacturer(self, manufacturer):
        """Sets the manufacturer of this SystemInfo.


        :param manufacturer: The manufacturer of this SystemInfo.  # noqa: E501
        :type: str
        """
        if manufacturer is None:
            raise ValueError("Invalid value for `manufacturer`, must not be `None`")  # noqa: E501

        self._manufacturer = manufacturer

    @property
    def serial_number(self):
        """Gets the serial_number of this SystemInfo.  # noqa: E501


        :return: The serial_number of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._serial_number

    @serial_number.setter
    def serial_number(self, serial_number):
        """Sets the serial_number of this SystemInfo.


        :param serial_number: The serial_number of this SystemInfo.  # noqa: E501
        :type: str
        """
        if serial_number is None:
            raise ValueError("Invalid value for `serial_number`, must not be `None`")  # noqa: E501

        self._serial_number = serial_number

    @property
    def uptime(self):
        """Gets the uptime of this SystemInfo.  # noqa: E501


        :return: The uptime of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._uptime

    @uptime.setter
    def uptime(self, uptime):
        """Sets the uptime of this SystemInfo.


        :param uptime: The uptime of this SystemInfo.  # noqa: E501
        :type: str
        """
        if uptime is None:
            raise ValueError("Invalid value for `uptime`, must not be `None`")  # noqa: E501

        self._uptime = uptime

    @property
    def mother_board(self):
        """Gets the mother_board of this SystemInfo.  # noqa: E501


        :return: The mother_board of this SystemInfo.  # noqa: E501
        :rtype: MotherBoardInfo
        """
        return self._mother_board

    @mother_board.setter
    def mother_board(self, mother_board):
        """Sets the mother_board of this SystemInfo.


        :param mother_board: The mother_board of this SystemInfo.  # noqa: E501
        :type: MotherBoardInfo
        """
        if mother_board is None:
            raise ValueError("Invalid value for `mother_board`, must not be `None`")  # noqa: E501

        self._mother_board = mother_board

    @property
    def bmc(self):
        """Gets the bmc of this SystemInfo.  # noqa: E501


        :return: The bmc of this SystemInfo.  # noqa: E501
        :rtype: BMCInfo
        """
        return self._bmc

    @bmc.setter
    def bmc(self, bmc):
        """Sets the bmc of this SystemInfo.


        :param bmc: The bmc of this SystemInfo.  # noqa: E501
        :type: BMCInfo
        """
        if bmc is None:
            raise ValueError("Invalid value for `bmc`, must not be `None`")  # noqa: E501

        self._bmc = bmc

    @property
    def gpu(self):
        """Gets the gpu of this SystemInfo.  # noqa: E501


        :return: The gpu of this SystemInfo.  # noqa: E501
        :rtype: GPUInfo
        """
        return self._gpu

    @gpu.setter
    def gpu(self, gpu):
        """Sets the gpu of this SystemInfo.


        :param gpu: The gpu of this SystemInfo.  # noqa: E501
        :type: GPUInfo
        """

        self._gpu = gpu

    @property
    def software(self):
        """Gets the software of this SystemInfo.  # noqa: E501


        :return: The software of this SystemInfo.  # noqa: E501
        :rtype: SoftwareInfo
        """
        return self._software

    @software.setter
    def software(self, software):
        """Sets the software of this SystemInfo.


        :param software: The software of this SystemInfo.  # noqa: E501
        :type: SoftwareInfo
        """
        if software is None:
            raise ValueError("Invalid value for `software`, must not be `None`")  # noqa: E501

        self._software = software

    @property
    def cec(self):
        """Gets the cec of this SystemInfo.  # noqa: E501


        :return: The cec of this SystemInfo.  # noqa: E501
        :rtype: CECInfo
        """
        return self._cec

    @cec.setter
    def cec(self, cec):
        """Sets the cec of this SystemInfo.


        :param cec: The cec of this SystemInfo.  # noqa: E501
        :type: CECInfo
        """

        self._cec = cec

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SystemInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
