# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Task(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_context': 'str',
        'odata_etag': 'str',
        'odata_id': 'str',
        'odata_type': 'str',
        'actions': 'Actions2',
        'description': 'str',
        'end_time': 'datetime',
        'hide_payload': 'bool',
        'id': 'str',
        'messages': 'list[IdRef]',
        'name': 'str',
        'oem': 'dict(str, object)',
        'payload': 'Payload',
        'percent_complete': 'int',
        'start_time': 'datetime',
        'task_monitor': 'str',
        'task_state': 'TaskState',
        'task_status': 'Health'
    }

    attribute_map = {
        'odata_context': '@odata.context',
        'odata_etag': '@odata.etag',
        'odata_id': '@odata.id',
        'odata_type': '@odata.type',
        'actions': 'Actions',
        'description': 'Description',
        'end_time': 'EndTime',
        'hide_payload': 'HidePayload',
        'id': 'Id',
        'messages': 'Messages',
        'name': 'Name',
        'oem': 'Oem',
        'payload': 'Payload',
        'percent_complete': 'PercentComplete',
        'start_time': 'StartTime',
        'task_monitor': 'TaskMonitor',
        'task_state': 'TaskState',
        'task_status': 'TaskStatus'
    }

    def __init__(self, odata_context=None, odata_etag=None, odata_id=None, odata_type=None, actions=None, description=None, end_time=None, hide_payload=None, id=None, messages=None, name=None, oem=None, payload=None, percent_complete=None, start_time=None, task_monitor=None, task_state=None, task_status=None):  # noqa: E501
        """Task - a model defined in OpenAPI"""  # noqa: E501

        self._odata_context = None
        self._odata_etag = None
        self._odata_id = None
        self._odata_type = None
        self._actions = None
        self._description = None
        self._end_time = None
        self._hide_payload = None
        self._id = None
        self._messages = None
        self._name = None
        self._oem = None
        self._payload = None
        self._percent_complete = None
        self._start_time = None
        self._task_monitor = None
        self._task_state = None
        self._task_status = None
        self.discriminator = None

        if odata_context is not None:
            self.odata_context = odata_context
        if odata_etag is not None:
            self.odata_etag = odata_etag
        self.odata_id = odata_id
        self.odata_type = odata_type
        if actions is not None:
            self.actions = actions
        if description is not None:
            self.description = description
        if end_time is not None:
            self.end_time = end_time
        if hide_payload is not None:
            self.hide_payload = hide_payload
        self.id = id
        if messages is not None:
            self.messages = messages
        self.name = name
        if oem is not None:
            self.oem = oem
        if payload is not None:
            self.payload = payload
        self.percent_complete = percent_complete
        if start_time is not None:
            self.start_time = start_time
        if task_monitor is not None:
            self.task_monitor = task_monitor
        if task_state is not None:
            self.task_state = task_state
        if task_status is not None:
            self.task_status = task_status

    @property
    def odata_context(self):
        """Gets the odata_context of this Task.  # noqa: E501

        The OData description of a payload.  # noqa: E501

        :return: The odata_context of this Task.  # noqa: E501
        :rtype: str
        """
        return self._odata_context

    @odata_context.setter
    def odata_context(self, odata_context):
        """Sets the odata_context of this Task.

        The OData description of a payload.  # noqa: E501

        :param odata_context: The odata_context of this Task.  # noqa: E501
        :type: str
        """

        self._odata_context = odata_context

    @property
    def odata_etag(self):
        """Gets the odata_etag of this Task.  # noqa: E501

        The current ETag of the resource.  # noqa: E501

        :return: The odata_etag of this Task.  # noqa: E501
        :rtype: str
        """
        return self._odata_etag

    @odata_etag.setter
    def odata_etag(self, odata_etag):
        """Sets the odata_etag of this Task.

        The current ETag of the resource.  # noqa: E501

        :param odata_etag: The odata_etag of this Task.  # noqa: E501
        :type: str
        """

        self._odata_etag = odata_etag

    @property
    def odata_id(self):
        """Gets the odata_id of this Task.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this Task.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this Task.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this Task.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def odata_type(self):
        """Gets the odata_type of this Task.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this Task.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this Task.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this Task.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def actions(self):
        """Gets the actions of this Task.  # noqa: E501


        :return: The actions of this Task.  # noqa: E501
        :rtype: Actions2
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this Task.


        :param actions: The actions of this Task.  # noqa: E501
        :type: Actions2
        """

        self._actions = actions

    @property
    def description(self):
        """Gets the description of this Task.  # noqa: E501

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :return: The description of this Task.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Task.

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :param description: The description of this Task.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def end_time(self):
        """Gets the end_time of this Task.  # noqa: E501

        The date-time stamp that the task was last completed.  # noqa: E501

        :return: The end_time of this Task.  # noqa: E501
        :rtype: datetime
        """
        return self._end_time

    @end_time.setter
    def end_time(self, end_time):
        """Sets the end_time of this Task.

        The date-time stamp that the task was last completed.  # noqa: E501

        :param end_time: The end_time of this Task.  # noqa: E501
        :type: datetime
        """

        self._end_time = end_time

    @property
    def hide_payload(self):
        """Gets the hide_payload of this Task.  # noqa: E501

        Indicates that the contents of the Payload should be hidden from view after the Task has been created.  When set to True, the Payload object will not be returned on GET.  # noqa: E501

        :return: The hide_payload of this Task.  # noqa: E501
        :rtype: bool
        """
        return self._hide_payload

    @hide_payload.setter
    def hide_payload(self, hide_payload):
        """Sets the hide_payload of this Task.

        Indicates that the contents of the Payload should be hidden from view after the Task has been created.  When set to True, the Payload object will not be returned on GET.  # noqa: E501

        :param hide_payload: The hide_payload of this Task.  # noqa: E501
        :type: bool
        """

        self._hide_payload = hide_payload

    @property
    def id(self):
        """Gets the id of this Task.  # noqa: E501

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :return: The id of this Task.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Task.

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :param id: The id of this Task.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def messages(self):
        """Gets the messages of this Task.  # noqa: E501

        This is an array of messages associated with the task.  # noqa: E501

        :return: The messages of this Task.  # noqa: E501
        :rtype: list[IdRef]
        """
        return self._messages

    @messages.setter
    def messages(self, messages):
        """Sets the messages of this Task.

        This is an array of messages associated with the task.  # noqa: E501

        :param messages: The messages of this Task.  # noqa: E501
        :type: list[IdRef]
        """

        self._messages = messages

    @property
    def name(self):
        """Gets the name of this Task.  # noqa: E501

        The name of the resource or array member.  # noqa: E501

        :return: The name of this Task.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Task.

        The name of the resource or array member.  # noqa: E501

        :param name: The name of this Task.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def oem(self):
        """Gets the oem of this Task.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this Task.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this Task.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this Task.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def payload(self):
        """Gets the payload of this Task.  # noqa: E501


        :return: The payload of this Task.  # noqa: E501
        :rtype: Payload
        """
        return self._payload

    @payload.setter
    def payload(self, payload):
        """Sets the payload of this Task.


        :param payload: The payload of this Task.  # noqa: E501
        :type: Payload
        """

        self._payload = payload

    @property
    def percent_complete(self):
        """Gets the percent_complete of this Task.  # noqa: E501

        The completion percentage of this Task.  # noqa: E501

        :return: The percent_complete of this Task.  # noqa: E501
        :rtype: int
        """
        return self._percent_complete

    @percent_complete.setter
    def percent_complete(self, percent_complete):
        """Sets the percent_complete of this Task.

        The completion percentage of this Task.  # noqa: E501

        :param percent_complete: The percent_complete of this Task.  # noqa: E501
        :type: int
        """

        self._percent_complete = percent_complete

    @property
    def start_time(self):
        """Gets the start_time of this Task.  # noqa: E501

        The date-time stamp that the task was last started.  # noqa: E501

        :return: The start_time of this Task.  # noqa: E501
        :rtype: datetime
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this Task.

        The date-time stamp that the task was last started.  # noqa: E501

        :param start_time: The start_time of this Task.  # noqa: E501
        :type: datetime
        """

        self._start_time = start_time

    @property
    def task_monitor(self):
        """Gets the task_monitor of this Task.  # noqa: E501

        The URI of the Task Monitor for this task.  # noqa: E501

        :return: The task_monitor of this Task.  # noqa: E501
        :rtype: str
        """
        return self._task_monitor

    @task_monitor.setter
    def task_monitor(self, task_monitor):
        """Sets the task_monitor of this Task.

        The URI of the Task Monitor for this task.  # noqa: E501

        :param task_monitor: The task_monitor of this Task.  # noqa: E501
        :type: str
        """

        self._task_monitor = task_monitor

    @property
    def task_state(self):
        """Gets the task_state of this Task.  # noqa: E501


        :return: The task_state of this Task.  # noqa: E501
        :rtype: TaskState
        """
        return self._task_state

    @task_state.setter
    def task_state(self, task_state):
        """Sets the task_state of this Task.


        :param task_state: The task_state of this Task.  # noqa: E501
        :type: TaskState
        """

        self._task_state = task_state

    @property
    def task_status(self):
        """Gets the task_status of this Task.  # noqa: E501


        :return: The task_status of this Task.  # noqa: E501
        :rtype: Health
        """
        return self._task_status

    @task_status.setter
    def task_status(self, task_status):
        """Sets the task_status of this Task.


        :param task_status: The task_status of this Task.  # noqa: E501
        :type: Health
        """

        self._task_status = task_status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Task):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
