# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Temperature(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_id': 'str',
        'actions': 'TemperatureActions',
        'adjusted_max_allowable_operating_value': 'int',
        'adjusted_min_allowable_operating_value': 'int',
        'delta_physical_context': 'IdRef',
        'delta_reading_celsius': 'float',
        'lower_threshold_critical': 'float',
        'lower_threshold_fatal': 'float',
        'lower_threshold_non_critical': 'float',
        'max_allowable_operating_value': 'int',
        'max_reading_range_temp': 'float',
        'member_id': 'str',
        'min_allowable_operating_value': 'int',
        'min_reading_range_temp': 'float',
        'name': 'str',
        'oem': 'dict(str, object)',
        'physical_context': 'IdRef',
        'reading_celsius': 'float',
        'related_item': 'list[IdRef]',
        'related_itemodata_count': 'int',
        'sensor_number': 'int',
        'status': 'Status',
        'upper_threshold_critical': 'float',
        'upper_threshold_fatal': 'float',
        'upper_threshold_non_critical': 'float'
    }

    attribute_map = {
        'odata_id': '@odata.id',
        'actions': 'Actions',
        'adjusted_max_allowable_operating_value': 'AdjustedMaxAllowableOperatingValue',
        'adjusted_min_allowable_operating_value': 'AdjustedMinAllowableOperatingValue',
        'delta_physical_context': 'DeltaPhysicalContext',
        'delta_reading_celsius': 'DeltaReadingCelsius',
        'lower_threshold_critical': 'LowerThresholdCritical',
        'lower_threshold_fatal': 'LowerThresholdFatal',
        'lower_threshold_non_critical': 'LowerThresholdNonCritical',
        'max_allowable_operating_value': 'MaxAllowableOperatingValue',
        'max_reading_range_temp': 'MaxReadingRangeTemp',
        'member_id': 'MemberId',
        'min_allowable_operating_value': 'MinAllowableOperatingValue',
        'min_reading_range_temp': 'MinReadingRangeTemp',
        'name': 'Name',
        'oem': 'Oem',
        'physical_context': 'PhysicalContext',
        'reading_celsius': 'ReadingCelsius',
        'related_item': 'RelatedItem',
        'related_itemodata_count': 'RelatedItem@odata.count',
        'sensor_number': 'SensorNumber',
        'status': 'Status',
        'upper_threshold_critical': 'UpperThresholdCritical',
        'upper_threshold_fatal': 'UpperThresholdFatal',
        'upper_threshold_non_critical': 'UpperThresholdNonCritical'
    }

    def __init__(self, odata_id=None, actions=None, adjusted_max_allowable_operating_value=None, adjusted_min_allowable_operating_value=None, delta_physical_context=None, delta_reading_celsius=None, lower_threshold_critical=None, lower_threshold_fatal=None, lower_threshold_non_critical=None, max_allowable_operating_value=None, max_reading_range_temp=None, member_id=None, min_allowable_operating_value=None, min_reading_range_temp=None, name=None, oem=None, physical_context=None, reading_celsius=None, related_item=None, related_itemodata_count=None, sensor_number=None, status=None, upper_threshold_critical=None, upper_threshold_fatal=None, upper_threshold_non_critical=None):  # noqa: E501
        """Temperature - a model defined in OpenAPI"""  # noqa: E501

        self._odata_id = None
        self._actions = None
        self._adjusted_max_allowable_operating_value = None
        self._adjusted_min_allowable_operating_value = None
        self._delta_physical_context = None
        self._delta_reading_celsius = None
        self._lower_threshold_critical = None
        self._lower_threshold_fatal = None
        self._lower_threshold_non_critical = None
        self._max_allowable_operating_value = None
        self._max_reading_range_temp = None
        self._member_id = None
        self._min_allowable_operating_value = None
        self._min_reading_range_temp = None
        self._name = None
        self._oem = None
        self._physical_context = None
        self._reading_celsius = None
        self._related_item = None
        self._related_itemodata_count = None
        self._sensor_number = None
        self._status = None
        self._upper_threshold_critical = None
        self._upper_threshold_fatal = None
        self._upper_threshold_non_critical = None
        self.discriminator = None

        self.odata_id = odata_id
        if actions is not None:
            self.actions = actions
        self.adjusted_max_allowable_operating_value = adjusted_max_allowable_operating_value
        self.adjusted_min_allowable_operating_value = adjusted_min_allowable_operating_value
        if delta_physical_context is not None:
            self.delta_physical_context = delta_physical_context
        self.delta_reading_celsius = delta_reading_celsius
        self.lower_threshold_critical = lower_threshold_critical
        self.lower_threshold_fatal = lower_threshold_fatal
        self.lower_threshold_non_critical = lower_threshold_non_critical
        self.max_allowable_operating_value = max_allowable_operating_value
        self.max_reading_range_temp = max_reading_range_temp
        self.member_id = member_id
        self.min_allowable_operating_value = min_allowable_operating_value
        self.min_reading_range_temp = min_reading_range_temp
        self.name = name
        if oem is not None:
            self.oem = oem
        if physical_context is not None:
            self.physical_context = physical_context
        self.reading_celsius = reading_celsius
        if related_item is not None:
            self.related_item = related_item
        if related_itemodata_count is not None:
            self.related_itemodata_count = related_itemodata_count
        self.sensor_number = sensor_number
        if status is not None:
            self.status = status
        self.upper_threshold_critical = upper_threshold_critical
        self.upper_threshold_fatal = upper_threshold_fatal
        self.upper_threshold_non_critical = upper_threshold_non_critical

    @property
    def odata_id(self):
        """Gets the odata_id of this Temperature.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this Temperature.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this Temperature.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this Temperature.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def actions(self):
        """Gets the actions of this Temperature.  # noqa: E501


        :return: The actions of this Temperature.  # noqa: E501
        :rtype: TemperatureActions
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this Temperature.


        :param actions: The actions of this Temperature.  # noqa: E501
        :type: TemperatureActions
        """

        self._actions = actions

    @property
    def adjusted_max_allowable_operating_value(self):
        """Gets the adjusted_max_allowable_operating_value of this Temperature.  # noqa: E501

        Adjusted maximum allowable operating temperature for this equipment based on the current environmental conditions present.  # noqa: E501

        :return: The adjusted_max_allowable_operating_value of this Temperature.  # noqa: E501
        :rtype: int
        """
        return self._adjusted_max_allowable_operating_value

    @adjusted_max_allowable_operating_value.setter
    def adjusted_max_allowable_operating_value(self, adjusted_max_allowable_operating_value):
        """Sets the adjusted_max_allowable_operating_value of this Temperature.

        Adjusted maximum allowable operating temperature for this equipment based on the current environmental conditions present.  # noqa: E501

        :param adjusted_max_allowable_operating_value: The adjusted_max_allowable_operating_value of this Temperature.  # noqa: E501
        :type: int
        """

        self._adjusted_max_allowable_operating_value = adjusted_max_allowable_operating_value

    @property
    def adjusted_min_allowable_operating_value(self):
        """Gets the adjusted_min_allowable_operating_value of this Temperature.  # noqa: E501

        Adjusted minimum allowable operating temperature for this equipment based on the current environmental conditions present.  # noqa: E501

        :return: The adjusted_min_allowable_operating_value of this Temperature.  # noqa: E501
        :rtype: int
        """
        return self._adjusted_min_allowable_operating_value

    @adjusted_min_allowable_operating_value.setter
    def adjusted_min_allowable_operating_value(self, adjusted_min_allowable_operating_value):
        """Sets the adjusted_min_allowable_operating_value of this Temperature.

        Adjusted minimum allowable operating temperature for this equipment based on the current environmental conditions present.  # noqa: E501

        :param adjusted_min_allowable_operating_value: The adjusted_min_allowable_operating_value of this Temperature.  # noqa: E501
        :type: int
        """

        self._adjusted_min_allowable_operating_value = adjusted_min_allowable_operating_value

    @property
    def delta_physical_context(self):
        """Gets the delta_physical_context of this Temperature.  # noqa: E501


        :return: The delta_physical_context of this Temperature.  # noqa: E501
        :rtype: IdRef
        """
        return self._delta_physical_context

    @delta_physical_context.setter
    def delta_physical_context(self, delta_physical_context):
        """Sets the delta_physical_context of this Temperature.


        :param delta_physical_context: The delta_physical_context of this Temperature.  # noqa: E501
        :type: IdRef
        """

        self._delta_physical_context = delta_physical_context

    @property
    def delta_reading_celsius(self):
        """Gets the delta_reading_celsius of this Temperature.  # noqa: E501

        Delta Temperature reading.  # noqa: E501

        :return: The delta_reading_celsius of this Temperature.  # noqa: E501
        :rtype: float
        """
        return self._delta_reading_celsius

    @delta_reading_celsius.setter
    def delta_reading_celsius(self, delta_reading_celsius):
        """Sets the delta_reading_celsius of this Temperature.

        Delta Temperature reading.  # noqa: E501

        :param delta_reading_celsius: The delta_reading_celsius of this Temperature.  # noqa: E501
        :type: float
        """

        self._delta_reading_celsius = delta_reading_celsius

    @property
    def lower_threshold_critical(self):
        """Gets the lower_threshold_critical of this Temperature.  # noqa: E501

        Below normal range but not yet fatal.  # noqa: E501

        :return: The lower_threshold_critical of this Temperature.  # noqa: E501
        :rtype: float
        """
        return self._lower_threshold_critical

    @lower_threshold_critical.setter
    def lower_threshold_critical(self, lower_threshold_critical):
        """Sets the lower_threshold_critical of this Temperature.

        Below normal range but not yet fatal.  # noqa: E501

        :param lower_threshold_critical: The lower_threshold_critical of this Temperature.  # noqa: E501
        :type: float
        """

        self._lower_threshold_critical = lower_threshold_critical

    @property
    def lower_threshold_fatal(self):
        """Gets the lower_threshold_fatal of this Temperature.  # noqa: E501

        Below normal range and is fatal.  # noqa: E501

        :return: The lower_threshold_fatal of this Temperature.  # noqa: E501
        :rtype: float
        """
        return self._lower_threshold_fatal

    @lower_threshold_fatal.setter
    def lower_threshold_fatal(self, lower_threshold_fatal):
        """Sets the lower_threshold_fatal of this Temperature.

        Below normal range and is fatal.  # noqa: E501

        :param lower_threshold_fatal: The lower_threshold_fatal of this Temperature.  # noqa: E501
        :type: float
        """

        self._lower_threshold_fatal = lower_threshold_fatal

    @property
    def lower_threshold_non_critical(self):
        """Gets the lower_threshold_non_critical of this Temperature.  # noqa: E501

        Below normal range.  # noqa: E501

        :return: The lower_threshold_non_critical of this Temperature.  # noqa: E501
        :rtype: float
        """
        return self._lower_threshold_non_critical

    @lower_threshold_non_critical.setter
    def lower_threshold_non_critical(self, lower_threshold_non_critical):
        """Sets the lower_threshold_non_critical of this Temperature.

        Below normal range.  # noqa: E501

        :param lower_threshold_non_critical: The lower_threshold_non_critical of this Temperature.  # noqa: E501
        :type: float
        """

        self._lower_threshold_non_critical = lower_threshold_non_critical

    @property
    def max_allowable_operating_value(self):
        """Gets the max_allowable_operating_value of this Temperature.  # noqa: E501

        Maximum allowable operating temperature for this equipment.  # noqa: E501

        :return: The max_allowable_operating_value of this Temperature.  # noqa: E501
        :rtype: int
        """
        return self._max_allowable_operating_value

    @max_allowable_operating_value.setter
    def max_allowable_operating_value(self, max_allowable_operating_value):
        """Sets the max_allowable_operating_value of this Temperature.

        Maximum allowable operating temperature for this equipment.  # noqa: E501

        :param max_allowable_operating_value: The max_allowable_operating_value of this Temperature.  # noqa: E501
        :type: int
        """

        self._max_allowable_operating_value = max_allowable_operating_value

    @property
    def max_reading_range_temp(self):
        """Gets the max_reading_range_temp of this Temperature.  # noqa: E501

        Maximum value for ReadingCelsius.  # noqa: E501

        :return: The max_reading_range_temp of this Temperature.  # noqa: E501
        :rtype: float
        """
        return self._max_reading_range_temp

    @max_reading_range_temp.setter
    def max_reading_range_temp(self, max_reading_range_temp):
        """Sets the max_reading_range_temp of this Temperature.

        Maximum value for ReadingCelsius.  # noqa: E501

        :param max_reading_range_temp: The max_reading_range_temp of this Temperature.  # noqa: E501
        :type: float
        """

        self._max_reading_range_temp = max_reading_range_temp

    @property
    def member_id(self):
        """Gets the member_id of this Temperature.  # noqa: E501

        This is the identifier for the member within the collection.  # noqa: E501

        :return: The member_id of this Temperature.  # noqa: E501
        :rtype: str
        """
        return self._member_id

    @member_id.setter
    def member_id(self, member_id):
        """Sets the member_id of this Temperature.

        This is the identifier for the member within the collection.  # noqa: E501

        :param member_id: The member_id of this Temperature.  # noqa: E501
        :type: str
        """
        if member_id is None:
            raise ValueError("Invalid value for `member_id`, must not be `None`")  # noqa: E501

        self._member_id = member_id

    @property
    def min_allowable_operating_value(self):
        """Gets the min_allowable_operating_value of this Temperature.  # noqa: E501

        Minimum allowable operating temperature for this equipment.  # noqa: E501

        :return: The min_allowable_operating_value of this Temperature.  # noqa: E501
        :rtype: int
        """
        return self._min_allowable_operating_value

    @min_allowable_operating_value.setter
    def min_allowable_operating_value(self, min_allowable_operating_value):
        """Sets the min_allowable_operating_value of this Temperature.

        Minimum allowable operating temperature for this equipment.  # noqa: E501

        :param min_allowable_operating_value: The min_allowable_operating_value of this Temperature.  # noqa: E501
        :type: int
        """

        self._min_allowable_operating_value = min_allowable_operating_value

    @property
    def min_reading_range_temp(self):
        """Gets the min_reading_range_temp of this Temperature.  # noqa: E501

        Minimum value for ReadingCelsius.  # noqa: E501

        :return: The min_reading_range_temp of this Temperature.  # noqa: E501
        :rtype: float
        """
        return self._min_reading_range_temp

    @min_reading_range_temp.setter
    def min_reading_range_temp(self, min_reading_range_temp):
        """Sets the min_reading_range_temp of this Temperature.

        Minimum value for ReadingCelsius.  # noqa: E501

        :param min_reading_range_temp: The min_reading_range_temp of this Temperature.  # noqa: E501
        :type: float
        """

        self._min_reading_range_temp = min_reading_range_temp

    @property
    def name(self):
        """Gets the name of this Temperature.  # noqa: E501

        Temperature sensor name.  # noqa: E501

        :return: The name of this Temperature.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Temperature.

        Temperature sensor name.  # noqa: E501

        :param name: The name of this Temperature.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def oem(self):
        """Gets the oem of this Temperature.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this Temperature.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this Temperature.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this Temperature.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def physical_context(self):
        """Gets the physical_context of this Temperature.  # noqa: E501


        :return: The physical_context of this Temperature.  # noqa: E501
        :rtype: IdRef
        """
        return self._physical_context

    @physical_context.setter
    def physical_context(self, physical_context):
        """Sets the physical_context of this Temperature.


        :param physical_context: The physical_context of this Temperature.  # noqa: E501
        :type: IdRef
        """

        self._physical_context = physical_context

    @property
    def reading_celsius(self):
        """Gets the reading_celsius of this Temperature.  # noqa: E501

        Temperature.  # noqa: E501

        :return: The reading_celsius of this Temperature.  # noqa: E501
        :rtype: float
        """
        return self._reading_celsius

    @reading_celsius.setter
    def reading_celsius(self, reading_celsius):
        """Sets the reading_celsius of this Temperature.

        Temperature.  # noqa: E501

        :param reading_celsius: The reading_celsius of this Temperature.  # noqa: E501
        :type: float
        """

        self._reading_celsius = reading_celsius

    @property
    def related_item(self):
        """Gets the related_item of this Temperature.  # noqa: E501

        Describes the areas or devices to which this temperature measurement applies.  # noqa: E501

        :return: The related_item of this Temperature.  # noqa: E501
        :rtype: list[IdRef]
        """
        return self._related_item

    @related_item.setter
    def related_item(self, related_item):
        """Sets the related_item of this Temperature.

        Describes the areas or devices to which this temperature measurement applies.  # noqa: E501

        :param related_item: The related_item of this Temperature.  # noqa: E501
        :type: list[IdRef]
        """

        self._related_item = related_item

    @property
    def related_itemodata_count(self):
        """Gets the related_itemodata_count of this Temperature.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The related_itemodata_count of this Temperature.  # noqa: E501
        :rtype: int
        """
        return self._related_itemodata_count

    @related_itemodata_count.setter
    def related_itemodata_count(self, related_itemodata_count):
        """Sets the related_itemodata_count of this Temperature.

        The number of items in a collection.  # noqa: E501

        :param related_itemodata_count: The related_itemodata_count of this Temperature.  # noqa: E501
        :type: int
        """

        self._related_itemodata_count = related_itemodata_count

    @property
    def sensor_number(self):
        """Gets the sensor_number of this Temperature.  # noqa: E501

        A numerical identifier to represent the temperature sensor.  # noqa: E501

        :return: The sensor_number of this Temperature.  # noqa: E501
        :rtype: int
        """
        return self._sensor_number

    @sensor_number.setter
    def sensor_number(self, sensor_number):
        """Sets the sensor_number of this Temperature.

        A numerical identifier to represent the temperature sensor.  # noqa: E501

        :param sensor_number: The sensor_number of this Temperature.  # noqa: E501
        :type: int
        """

        self._sensor_number = sensor_number

    @property
    def status(self):
        """Gets the status of this Temperature.  # noqa: E501


        :return: The status of this Temperature.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this Temperature.


        :param status: The status of this Temperature.  # noqa: E501
        :type: Status
        """

        self._status = status

    @property
    def upper_threshold_critical(self):
        """Gets the upper_threshold_critical of this Temperature.  # noqa: E501

        Above normal range but not yet fatal.  # noqa: E501

        :return: The upper_threshold_critical of this Temperature.  # noqa: E501
        :rtype: float
        """
        return self._upper_threshold_critical

    @upper_threshold_critical.setter
    def upper_threshold_critical(self, upper_threshold_critical):
        """Sets the upper_threshold_critical of this Temperature.

        Above normal range but not yet fatal.  # noqa: E501

        :param upper_threshold_critical: The upper_threshold_critical of this Temperature.  # noqa: E501
        :type: float
        """

        self._upper_threshold_critical = upper_threshold_critical

    @property
    def upper_threshold_fatal(self):
        """Gets the upper_threshold_fatal of this Temperature.  # noqa: E501

        Above normal range and is fatal.  # noqa: E501

        :return: The upper_threshold_fatal of this Temperature.  # noqa: E501
        :rtype: float
        """
        return self._upper_threshold_fatal

    @upper_threshold_fatal.setter
    def upper_threshold_fatal(self, upper_threshold_fatal):
        """Sets the upper_threshold_fatal of this Temperature.

        Above normal range and is fatal.  # noqa: E501

        :param upper_threshold_fatal: The upper_threshold_fatal of this Temperature.  # noqa: E501
        :type: float
        """

        self._upper_threshold_fatal = upper_threshold_fatal

    @property
    def upper_threshold_non_critical(self):
        """Gets the upper_threshold_non_critical of this Temperature.  # noqa: E501

        Above normal range.  # noqa: E501

        :return: The upper_threshold_non_critical of this Temperature.  # noqa: E501
        :rtype: float
        """
        return self._upper_threshold_non_critical

    @upper_threshold_non_critical.setter
    def upper_threshold_non_critical(self, upper_threshold_non_critical):
        """Sets the upper_threshold_non_critical of this Temperature.

        Above normal range.  # noqa: E501

        :param upper_threshold_non_critical: The upper_threshold_non_critical of this Temperature.  # noqa: E501
        :type: float
        """

        self._upper_threshold_non_critical = upper_threshold_non_critical

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Temperature):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
