# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class TheaStruct(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_type': 'str',
        'health': 'GPUidRef',
        'host_name': 'str',
        'members': 'list[GPUidRef]',
        'membersodata_count': 'int',
        'status': 'GPUSummaryStatus',
        'time_stamp': 'float',
        'versions': 'GPUSystemVersions'
    }

    attribute_map = {
        'odata_type': '@odata.type',
        'health': 'Health',
        'host_name': 'HostName',
        'members': 'Members',
        'membersodata_count': 'Members@odata.count',
        'status': 'Status',
        'time_stamp': 'TimeStamp',
        'versions': 'Versions'
    }

    def __init__(self, odata_type=None, health=None, host_name=None, members=None, membersodata_count=None, status=None, time_stamp=None, versions=None):  # noqa: E501
        """TheaStruct - a model defined in OpenAPI"""  # noqa: E501

        self._odata_type = None
        self._health = None
        self._host_name = None
        self._members = None
        self._membersodata_count = None
        self._status = None
        self._time_stamp = None
        self._versions = None
        self.discriminator = None

        self.odata_type = odata_type
        self.health = health
        self.host_name = host_name
        self.members = members
        self.membersodata_count = membersodata_count
        self.status = status
        self.time_stamp = time_stamp
        self.versions = versions

    @property
    def odata_type(self):
        """Gets the odata_type of this TheaStruct.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this TheaStruct.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this TheaStruct.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this TheaStruct.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def health(self):
        """Gets the health of this TheaStruct.  # noqa: E501


        :return: The health of this TheaStruct.  # noqa: E501
        :rtype: GPUidRef
        """
        return self._health

    @health.setter
    def health(self, health):
        """Sets the health of this TheaStruct.


        :param health: The health of this TheaStruct.  # noqa: E501
        :type: GPUidRef
        """
        if health is None:
            raise ValueError("Invalid value for `health`, must not be `None`")  # noqa: E501

        self._health = health

    @property
    def host_name(self):
        """Gets the host_name of this TheaStruct.  # noqa: E501

        Name of the resource or array element.  # noqa: E501

        :return: The host_name of this TheaStruct.  # noqa: E501
        :rtype: str
        """
        return self._host_name

    @host_name.setter
    def host_name(self, host_name):
        """Sets the host_name of this TheaStruct.

        Name of the resource or array element.  # noqa: E501

        :param host_name: The host_name of this TheaStruct.  # noqa: E501
        :type: str
        """
        if host_name is None:
            raise ValueError("Invalid value for `host_name`, must not be `None`")  # noqa: E501

        self._host_name = host_name

    @property
    def members(self):
        """Gets the members of this TheaStruct.  # noqa: E501

        Collection of all information gathered for each GPU.  # noqa: E501

        :return: The members of this TheaStruct.  # noqa: E501
        :rtype: list[GPUidRef]
        """
        return self._members

    @members.setter
    def members(self, members):
        """Sets the members of this TheaStruct.

        Collection of all information gathered for each GPU.  # noqa: E501

        :param members: The members of this TheaStruct.  # noqa: E501
        :type: list[GPUidRef]
        """
        if members is None:
            raise ValueError("Invalid value for `members`, must not be `None`")  # noqa: E501

        self._members = members

    @property
    def membersodata_count(self):
        """Gets the membersodata_count of this TheaStruct.  # noqa: E501

        Number of GPUs detected on this host.  # noqa: E501

        :return: The membersodata_count of this TheaStruct.  # noqa: E501
        :rtype: int
        """
        return self._membersodata_count

    @membersodata_count.setter
    def membersodata_count(self, membersodata_count):
        """Sets the membersodata_count of this TheaStruct.

        Number of GPUs detected on this host.  # noqa: E501

        :param membersodata_count: The membersodata_count of this TheaStruct.  # noqa: E501
        :type: int
        """
        if membersodata_count is None:
            raise ValueError("Invalid value for `membersodata_count`, must not be `None`")  # noqa: E501

        self._membersodata_count = membersodata_count

    @property
    def status(self):
        """Gets the status of this TheaStruct.  # noqa: E501


        :return: The status of this TheaStruct.  # noqa: E501
        :rtype: GPUSummaryStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this TheaStruct.


        :param status: The status of this TheaStruct.  # noqa: E501
        :type: GPUSummaryStatus
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    @property
    def time_stamp(self):
        """Gets the time_stamp of this TheaStruct.  # noqa: E501

        Time when this XID error occured.  # noqa: E501

        :return: The time_stamp of this TheaStruct.  # noqa: E501
        :rtype: float
        """
        return self._time_stamp

    @time_stamp.setter
    def time_stamp(self, time_stamp):
        """Sets the time_stamp of this TheaStruct.

        Time when this XID error occured.  # noqa: E501

        :param time_stamp: The time_stamp of this TheaStruct.  # noqa: E501
        :type: float
        """
        if time_stamp is None:
            raise ValueError("Invalid value for `time_stamp`, must not be `None`")  # noqa: E501

        self._time_stamp = time_stamp

    @property
    def versions(self):
        """Gets the versions of this TheaStruct.  # noqa: E501


        :return: The versions of this TheaStruct.  # noqa: E501
        :rtype: GPUSystemVersions
        """
        return self._versions

    @versions.setter
    def versions(self, versions):
        """Sets the versions of this TheaStruct.


        :param versions: The versions of this TheaStruct.  # noqa: E501
        :type: GPUSystemVersions
        """
        if versions is None:
            raise ValueError("Invalid value for `versions`, must not be `None`")  # noqa: E501

        self._versions = versions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TheaStruct):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
