# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Thermal(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_context': 'str',
        'odata_etag': 'str',
        'odata_id': 'str',
        'odata_type': 'str',
        'actions': 'ThermalActions',
        'description': 'str',
        'fans': 'list[Fan]',
        'fansodata_count': 'int',
        'id': 'str',
        'name': 'str',
        'oem': 'dict(str, object)',
        'redundancy': 'list[IdRef]',
        'redundancyodata_count': 'int',
        'status': 'Status',
        'temperatures': 'list[Temperature]',
        'temperaturesodata_count': 'int'
    }

    attribute_map = {
        'odata_context': '@odata.context',
        'odata_etag': '@odata.etag',
        'odata_id': '@odata.id',
        'odata_type': '@odata.type',
        'actions': 'Actions',
        'description': 'Description',
        'fans': 'Fans',
        'fansodata_count': 'Fans@odata.count',
        'id': 'Id',
        'name': 'Name',
        'oem': 'Oem',
        'redundancy': 'Redundancy',
        'redundancyodata_count': 'Redundancy@odata.count',
        'status': 'Status',
        'temperatures': 'Temperatures',
        'temperaturesodata_count': 'Temperatures@odata.count'
    }

    def __init__(self, odata_context=None, odata_etag=None, odata_id=None, odata_type=None, actions=None, description=None, fans=None, fansodata_count=None, id=None, name=None, oem=None, redundancy=None, redundancyodata_count=None, status=None, temperatures=None, temperaturesodata_count=None):  # noqa: E501
        """Thermal - a model defined in OpenAPI"""  # noqa: E501

        self._odata_context = None
        self._odata_etag = None
        self._odata_id = None
        self._odata_type = None
        self._actions = None
        self._description = None
        self._fans = None
        self._fansodata_count = None
        self._id = None
        self._name = None
        self._oem = None
        self._redundancy = None
        self._redundancyodata_count = None
        self._status = None
        self._temperatures = None
        self._temperaturesodata_count = None
        self.discriminator = None

        if odata_context is not None:
            self.odata_context = odata_context
        if odata_etag is not None:
            self.odata_etag = odata_etag
        self.odata_id = odata_id
        self.odata_type = odata_type
        if actions is not None:
            self.actions = actions
        if description is not None:
            self.description = description
        if fans is not None:
            self.fans = fans
        if fansodata_count is not None:
            self.fansodata_count = fansodata_count
        self.id = id
        self.name = name
        if oem is not None:
            self.oem = oem
        if redundancy is not None:
            self.redundancy = redundancy
        if redundancyodata_count is not None:
            self.redundancyodata_count = redundancyodata_count
        if status is not None:
            self.status = status
        if temperatures is not None:
            self.temperatures = temperatures
        if temperaturesodata_count is not None:
            self.temperaturesodata_count = temperaturesodata_count

    @property
    def odata_context(self):
        """Gets the odata_context of this Thermal.  # noqa: E501

        The OData description of a payload.  # noqa: E501

        :return: The odata_context of this Thermal.  # noqa: E501
        :rtype: str
        """
        return self._odata_context

    @odata_context.setter
    def odata_context(self, odata_context):
        """Sets the odata_context of this Thermal.

        The OData description of a payload.  # noqa: E501

        :param odata_context: The odata_context of this Thermal.  # noqa: E501
        :type: str
        """

        self._odata_context = odata_context

    @property
    def odata_etag(self):
        """Gets the odata_etag of this Thermal.  # noqa: E501

        The current ETag of the resource.  # noqa: E501

        :return: The odata_etag of this Thermal.  # noqa: E501
        :rtype: str
        """
        return self._odata_etag

    @odata_etag.setter
    def odata_etag(self, odata_etag):
        """Sets the odata_etag of this Thermal.

        The current ETag of the resource.  # noqa: E501

        :param odata_etag: The odata_etag of this Thermal.  # noqa: E501
        :type: str
        """

        self._odata_etag = odata_etag

    @property
    def odata_id(self):
        """Gets the odata_id of this Thermal.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this Thermal.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this Thermal.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this Thermal.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def odata_type(self):
        """Gets the odata_type of this Thermal.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this Thermal.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this Thermal.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this Thermal.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def actions(self):
        """Gets the actions of this Thermal.  # noqa: E501


        :return: The actions of this Thermal.  # noqa: E501
        :rtype: ThermalActions
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this Thermal.


        :param actions: The actions of this Thermal.  # noqa: E501
        :type: ThermalActions
        """

        self._actions = actions

    @property
    def description(self):
        """Gets the description of this Thermal.  # noqa: E501

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :return: The description of this Thermal.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Thermal.

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :param description: The description of this Thermal.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def fans(self):
        """Gets the fans of this Thermal.  # noqa: E501

        This is the definition for fans.  # noqa: E501

        :return: The fans of this Thermal.  # noqa: E501
        :rtype: list[Fan]
        """
        return self._fans

    @fans.setter
    def fans(self, fans):
        """Sets the fans of this Thermal.

        This is the definition for fans.  # noqa: E501

        :param fans: The fans of this Thermal.  # noqa: E501
        :type: list[Fan]
        """

        self._fans = fans

    @property
    def fansodata_count(self):
        """Gets the fansodata_count of this Thermal.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The fansodata_count of this Thermal.  # noqa: E501
        :rtype: int
        """
        return self._fansodata_count

    @fansodata_count.setter
    def fansodata_count(self, fansodata_count):
        """Sets the fansodata_count of this Thermal.

        The number of items in a collection.  # noqa: E501

        :param fansodata_count: The fansodata_count of this Thermal.  # noqa: E501
        :type: int
        """

        self._fansodata_count = fansodata_count

    @property
    def id(self):
        """Gets the id of this Thermal.  # noqa: E501

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :return: The id of this Thermal.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Thermal.

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :param id: The id of this Thermal.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this Thermal.  # noqa: E501

        The name of the resource or array member.  # noqa: E501

        :return: The name of this Thermal.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Thermal.

        The name of the resource or array member.  # noqa: E501

        :param name: The name of this Thermal.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def oem(self):
        """Gets the oem of this Thermal.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this Thermal.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this Thermal.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this Thermal.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def redundancy(self):
        """Gets the redundancy of this Thermal.  # noqa: E501

        This structure is used to show redundancy for fans.  The Component ids will reference the members of the redundancy groups.  # noqa: E501

        :return: The redundancy of this Thermal.  # noqa: E501
        :rtype: list[IdRef]
        """
        return self._redundancy

    @redundancy.setter
    def redundancy(self, redundancy):
        """Sets the redundancy of this Thermal.

        This structure is used to show redundancy for fans.  The Component ids will reference the members of the redundancy groups.  # noqa: E501

        :param redundancy: The redundancy of this Thermal.  # noqa: E501
        :type: list[IdRef]
        """

        self._redundancy = redundancy

    @property
    def redundancyodata_count(self):
        """Gets the redundancyodata_count of this Thermal.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The redundancyodata_count of this Thermal.  # noqa: E501
        :rtype: int
        """
        return self._redundancyodata_count

    @redundancyodata_count.setter
    def redundancyodata_count(self, redundancyodata_count):
        """Sets the redundancyodata_count of this Thermal.

        The number of items in a collection.  # noqa: E501

        :param redundancyodata_count: The redundancyodata_count of this Thermal.  # noqa: E501
        :type: int
        """

        self._redundancyodata_count = redundancyodata_count

    @property
    def status(self):
        """Gets the status of this Thermal.  # noqa: E501


        :return: The status of this Thermal.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this Thermal.


        :param status: The status of this Thermal.  # noqa: E501
        :type: Status
        """

        self._status = status

    @property
    def temperatures(self):
        """Gets the temperatures of this Thermal.  # noqa: E501

        This is the definition for temperature sensors.  # noqa: E501

        :return: The temperatures of this Thermal.  # noqa: E501
        :rtype: list[Temperature]
        """
        return self._temperatures

    @temperatures.setter
    def temperatures(self, temperatures):
        """Sets the temperatures of this Thermal.

        This is the definition for temperature sensors.  # noqa: E501

        :param temperatures: The temperatures of this Thermal.  # noqa: E501
        :type: list[Temperature]
        """

        self._temperatures = temperatures

    @property
    def temperaturesodata_count(self):
        """Gets the temperaturesodata_count of this Thermal.  # noqa: E501

        The number of items in a collection.  # noqa: E501

        :return: The temperaturesodata_count of this Thermal.  # noqa: E501
        :rtype: int
        """
        return self._temperaturesodata_count

    @temperaturesodata_count.setter
    def temperaturesodata_count(self, temperaturesodata_count):
        """Sets the temperaturesodata_count of this Thermal.

        The number of items in a collection.  # noqa: E501

        :param temperaturesodata_count: The temperaturesodata_count of this Thermal.  # noqa: E501
        :type: int
        """

        self._temperaturesodata_count = temperaturesodata_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Thermal):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
