# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Thermals(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'fan_speed': 'str',
        'gpu_temperature_current': 'str',
        'gpu_temperature_threshold_max': 'str',
        'gpu_temperature_threshold_slow': 'str'
    }

    attribute_map = {
        'fan_speed': 'FanSpeed',
        'gpu_temperature_current': 'GPUTemperatureCurrent',
        'gpu_temperature_threshold_max': 'GPUTemperatureThresholdMax',
        'gpu_temperature_threshold_slow': 'GPUTemperatureThresholdSlow'
    }

    def __init__(self, fan_speed=None, gpu_temperature_current=None, gpu_temperature_threshold_max=None, gpu_temperature_threshold_slow=None):  # noqa: E501
        """Thermals - a model defined in OpenAPI"""  # noqa: E501

        self._fan_speed = None
        self._gpu_temperature_current = None
        self._gpu_temperature_threshold_max = None
        self._gpu_temperature_threshold_slow = None
        self.discriminator = None

        self.fan_speed = fan_speed
        self.gpu_temperature_current = gpu_temperature_current
        self.gpu_temperature_threshold_max = gpu_temperature_threshold_max
        self.gpu_temperature_threshold_slow = gpu_temperature_threshold_slow

    @property
    def fan_speed(self):
        """Gets the fan_speed of this Thermals.  # noqa: E501

        The fan speed value is the percent of maximum speed that the device's fan is currently intended to run at.  # noqa: E501

        :return: The fan_speed of this Thermals.  # noqa: E501
        :rtype: str
        """
        return self._fan_speed

    @fan_speed.setter
    def fan_speed(self, fan_speed):
        """Sets the fan_speed of this Thermals.

        The fan speed value is the percent of maximum speed that the device's fan is currently intended to run at.  # noqa: E501

        :param fan_speed: The fan_speed of this Thermals.  # noqa: E501
        :type: str
        """
        if fan_speed is None:
            raise ValueError("Invalid value for `fan_speed`, must not be `None`")  # noqa: E501

        self._fan_speed = fan_speed

    @property
    def gpu_temperature_current(self):
        """Gets the gpu_temperature_current of this Thermals.  # noqa: E501

        Core GPU temperature. For all discrete and S-class products.  # noqa: E501

        :return: The gpu_temperature_current of this Thermals.  # noqa: E501
        :rtype: str
        """
        return self._gpu_temperature_current

    @gpu_temperature_current.setter
    def gpu_temperature_current(self, gpu_temperature_current):
        """Sets the gpu_temperature_current of this Thermals.

        Core GPU temperature. For all discrete and S-class products.  # noqa: E501

        :param gpu_temperature_current: The gpu_temperature_current of this Thermals.  # noqa: E501
        :type: str
        """
        if gpu_temperature_current is None:
            raise ValueError("Invalid value for `gpu_temperature_current`, must not be `None`")  # noqa: E501

        self._gpu_temperature_current = gpu_temperature_current

    @property
    def gpu_temperature_threshold_max(self):
        """Gets the gpu_temperature_threshold_max of this Thermals.  # noqa: E501

        The temperature at which a GPU will shutdown.  # noqa: E501

        :return: The gpu_temperature_threshold_max of this Thermals.  # noqa: E501
        :rtype: str
        """
        return self._gpu_temperature_threshold_max

    @gpu_temperature_threshold_max.setter
    def gpu_temperature_threshold_max(self, gpu_temperature_threshold_max):
        """Sets the gpu_temperature_threshold_max of this Thermals.

        The temperature at which a GPU will shutdown.  # noqa: E501

        :param gpu_temperature_threshold_max: The gpu_temperature_threshold_max of this Thermals.  # noqa: E501
        :type: str
        """
        if gpu_temperature_threshold_max is None:
            raise ValueError("Invalid value for `gpu_temperature_threshold_max`, must not be `None`")  # noqa: E501

        self._gpu_temperature_threshold_max = gpu_temperature_threshold_max

    @property
    def gpu_temperature_threshold_slow(self):
        """Gets the gpu_temperature_threshold_slow of this Thermals.  # noqa: E501

        The temperature at which a GPU will begin slowing itself down in order to cool.  # noqa: E501

        :return: The gpu_temperature_threshold_slow of this Thermals.  # noqa: E501
        :rtype: str
        """
        return self._gpu_temperature_threshold_slow

    @gpu_temperature_threshold_slow.setter
    def gpu_temperature_threshold_slow(self, gpu_temperature_threshold_slow):
        """Sets the gpu_temperature_threshold_slow of this Thermals.

        The temperature at which a GPU will begin slowing itself down in order to cool.  # noqa: E501

        :param gpu_temperature_threshold_slow: The gpu_temperature_threshold_slow of this Thermals.  # noqa: E501
        :type: str
        """
        if gpu_temperature_threshold_slow is None:
            raise ValueError("Invalid value for `gpu_temperature_threshold_slow`, must not be `None`")  # noqa: E501

        self._gpu_temperature_threshold_slow = gpu_temperature_threshold_slow

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Thermals):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
