# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class TrustedModules(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'firmware_version': 'str',
        'firmware_version2': 'str',
        'interface_type': 'InterfaceType',
        'interface_type_selection': 'InterfaceTypeSelection',
        'oem': 'dict(str, object)',
        'status': 'Status'
    }

    attribute_map = {
        'firmware_version': 'FirmwareVersion',
        'firmware_version2': 'FirmwareVersion2',
        'interface_type': 'InterfaceType',
        'interface_type_selection': 'InterfaceTypeSelection',
        'oem': 'Oem',
        'status': 'Status'
    }

    def __init__(self, firmware_version=None, firmware_version2=None, interface_type=None, interface_type_selection=None, oem=None, status=None):  # noqa: E501
        """TrustedModules - a model defined in OpenAPI"""  # noqa: E501

        self._firmware_version = None
        self._firmware_version2 = None
        self._interface_type = None
        self._interface_type_selection = None
        self._oem = None
        self._status = None
        self.discriminator = None

        self.firmware_version = firmware_version
        self.firmware_version2 = firmware_version2
        if interface_type is not None:
            self.interface_type = interface_type
        if interface_type_selection is not None:
            self.interface_type_selection = interface_type_selection
        if oem is not None:
            self.oem = oem
        if status is not None:
            self.status = status

    @property
    def firmware_version(self):
        """Gets the firmware_version of this TrustedModules.  # noqa: E501

        The firmware version of this Trusted Module.  # noqa: E501

        :return: The firmware_version of this TrustedModules.  # noqa: E501
        :rtype: str
        """
        return self._firmware_version

    @firmware_version.setter
    def firmware_version(self, firmware_version):
        """Sets the firmware_version of this TrustedModules.

        The firmware version of this Trusted Module.  # noqa: E501

        :param firmware_version: The firmware_version of this TrustedModules.  # noqa: E501
        :type: str
        """

        self._firmware_version = firmware_version

    @property
    def firmware_version2(self):
        """Gets the firmware_version2 of this TrustedModules.  # noqa: E501

        The 2nd firmware version of this Trusted Module, if applicable.  # noqa: E501

        :return: The firmware_version2 of this TrustedModules.  # noqa: E501
        :rtype: str
        """
        return self._firmware_version2

    @firmware_version2.setter
    def firmware_version2(self, firmware_version2):
        """Sets the firmware_version2 of this TrustedModules.

        The 2nd firmware version of this Trusted Module, if applicable.  # noqa: E501

        :param firmware_version2: The firmware_version2 of this TrustedModules.  # noqa: E501
        :type: str
        """

        self._firmware_version2 = firmware_version2

    @property
    def interface_type(self):
        """Gets the interface_type of this TrustedModules.  # noqa: E501


        :return: The interface_type of this TrustedModules.  # noqa: E501
        :rtype: InterfaceType
        """
        return self._interface_type

    @interface_type.setter
    def interface_type(self, interface_type):
        """Sets the interface_type of this TrustedModules.


        :param interface_type: The interface_type of this TrustedModules.  # noqa: E501
        :type: InterfaceType
        """

        self._interface_type = interface_type

    @property
    def interface_type_selection(self):
        """Gets the interface_type_selection of this TrustedModules.  # noqa: E501


        :return: The interface_type_selection of this TrustedModules.  # noqa: E501
        :rtype: InterfaceTypeSelection
        """
        return self._interface_type_selection

    @interface_type_selection.setter
    def interface_type_selection(self, interface_type_selection):
        """Sets the interface_type_selection of this TrustedModules.


        :param interface_type_selection: The interface_type_selection of this TrustedModules.  # noqa: E501
        :type: InterfaceTypeSelection
        """

        self._interface_type_selection = interface_type_selection

    @property
    def oem(self):
        """Gets the oem of this TrustedModules.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this TrustedModules.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this TrustedModules.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this TrustedModules.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def status(self):
        """Gets the status of this TrustedModules.  # noqa: E501


        :return: The status of this TrustedModules.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this TrustedModules.


        :param status: The status of this TrustedModules.  # noqa: E501
        :type: Status
        """

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TrustedModules):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
