# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class VersionsCollection(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'dgx_release': 'str',
        'dcs_release': 'str',
        'nvidia_driver': 'str',
        'cuda_driver': 'str',
        'os_release': 'str',
        'kernel': 'str',
        'nvidia_container_runtime_docker': 'str',
        'docker_ce': 'str',
        'platform': 'str',
        'nvsm': 'str',
        'mlnx_ofed': 'str',
        'datacenter_gpu_manager': 'str',
        'datacenter_gpu_manager_fabricmanager': 'str',
        'odata_type': 'str'
    }

    attribute_map = {
        'dgx_release': 'dgx-release',
        'dcs_release': 'dcs-release',
        'nvidia_driver': 'nvidia-driver',
        'cuda_driver': 'cuda-driver',
        'os_release': 'os-release',
        'kernel': 'kernel',
        'nvidia_container_runtime_docker': 'nvidia-container-runtime-docker',
        'docker_ce': 'docker-ce',
        'platform': 'platform',
        'nvsm': 'nvsm',
        'mlnx_ofed': 'mlnx-ofed',
        'datacenter_gpu_manager': 'datacenter-gpu-manager',
        'datacenter_gpu_manager_fabricmanager': 'datacenter-gpu-manager-fabricmanager',
        'odata_type': '@odata.type'
    }

    def __init__(self, dgx_release=None, dcs_release=None, nvidia_driver=None, cuda_driver=None, os_release=None, kernel=None, nvidia_container_runtime_docker=None, docker_ce=None, platform=None, nvsm=None, mlnx_ofed=None, datacenter_gpu_manager=None, datacenter_gpu_manager_fabricmanager=None, odata_type=None):  # noqa: E501
        """VersionsCollection - a model defined in OpenAPI"""  # noqa: E501

        self._dgx_release = None
        self._dcs_release = None
        self._nvidia_driver = None
        self._cuda_driver = None
        self._os_release = None
        self._kernel = None
        self._nvidia_container_runtime_docker = None
        self._docker_ce = None
        self._platform = None
        self._nvsm = None
        self._mlnx_ofed = None
        self._datacenter_gpu_manager = None
        self._datacenter_gpu_manager_fabricmanager = None
        self._odata_type = None
        self.discriminator = None

        if dgx_release is not None:
            self.dgx_release = dgx_release
        if dcs_release is not None:
            self.dcs_release = dcs_release
        self.nvidia_driver = nvidia_driver
        self.cuda_driver = cuda_driver
        self.os_release = os_release
        self.kernel = kernel
        self.nvidia_container_runtime_docker = nvidia_container_runtime_docker
        self.docker_ce = docker_ce
        self.platform = platform
        self.nvsm = nvsm
        self.mlnx_ofed = mlnx_ofed
        self.datacenter_gpu_manager = datacenter_gpu_manager
        self.datacenter_gpu_manager_fabricmanager = datacenter_gpu_manager_fabricmanager
        self.odata_type = odata_type

    @property
    def dgx_release(self):
        """Gets the dgx_release of this VersionsCollection.  # noqa: E501

        DGX OS Version  # noqa: E501

        :return: The dgx_release of this VersionsCollection.  # noqa: E501
        :rtype: str
        """
        return self._dgx_release

    @dgx_release.setter
    def dgx_release(self, dgx_release):
        """Sets the dgx_release of this VersionsCollection.

        DGX OS Version  # noqa: E501

        :param dgx_release: The dgx_release of this VersionsCollection.  # noqa: E501
        :type: str
        """

        self._dgx_release = dgx_release

    @property
    def dcs_release(self):
        """Gets the dcs_release of this VersionsCollection.  # noqa: E501

        DCS OS Version  # noqa: E501

        :return: The dcs_release of this VersionsCollection.  # noqa: E501
        :rtype: str
        """
        return self._dcs_release

    @dcs_release.setter
    def dcs_release(self, dcs_release):
        """Sets the dcs_release of this VersionsCollection.

        DCS OS Version  # noqa: E501

        :param dcs_release: The dcs_release of this VersionsCollection.  # noqa: E501
        :type: str
        """

        self._dcs_release = dcs_release

    @property
    def nvidia_driver(self):
        """Gets the nvidia_driver of this VersionsCollection.  # noqa: E501

        GPU Driver version  # noqa: E501

        :return: The nvidia_driver of this VersionsCollection.  # noqa: E501
        :rtype: str
        """
        return self._nvidia_driver

    @nvidia_driver.setter
    def nvidia_driver(self, nvidia_driver):
        """Sets the nvidia_driver of this VersionsCollection.

        GPU Driver version  # noqa: E501

        :param nvidia_driver: The nvidia_driver of this VersionsCollection.  # noqa: E501
        :type: str
        """
        if nvidia_driver is None:
            raise ValueError("Invalid value for `nvidia_driver`, must not be `None`")  # noqa: E501

        self._nvidia_driver = nvidia_driver

    @property
    def cuda_driver(self):
        """Gets the cuda_driver of this VersionsCollection.  # noqa: E501

        CUDA Driver version  # noqa: E501

        :return: The cuda_driver of this VersionsCollection.  # noqa: E501
        :rtype: str
        """
        return self._cuda_driver

    @cuda_driver.setter
    def cuda_driver(self, cuda_driver):
        """Sets the cuda_driver of this VersionsCollection.

        CUDA Driver version  # noqa: E501

        :param cuda_driver: The cuda_driver of this VersionsCollection.  # noqa: E501
        :type: str
        """
        if cuda_driver is None:
            raise ValueError("Invalid value for `cuda_driver`, must not be `None`")  # noqa: E501

        self._cuda_driver = cuda_driver

    @property
    def os_release(self):
        """Gets the os_release of this VersionsCollection.  # noqa: E501

        Linux Distribution version  # noqa: E501

        :return: The os_release of this VersionsCollection.  # noqa: E501
        :rtype: str
        """
        return self._os_release

    @os_release.setter
    def os_release(self, os_release):
        """Sets the os_release of this VersionsCollection.

        Linux Distribution version  # noqa: E501

        :param os_release: The os_release of this VersionsCollection.  # noqa: E501
        :type: str
        """
        if os_release is None:
            raise ValueError("Invalid value for `os_release`, must not be `None`")  # noqa: E501

        self._os_release = os_release

    @property
    def kernel(self):
        """Gets the kernel of this VersionsCollection.  # noqa: E501

        Kernel version  # noqa: E501

        :return: The kernel of this VersionsCollection.  # noqa: E501
        :rtype: str
        """
        return self._kernel

    @kernel.setter
    def kernel(self, kernel):
        """Sets the kernel of this VersionsCollection.

        Kernel version  # noqa: E501

        :param kernel: The kernel of this VersionsCollection.  # noqa: E501
        :type: str
        """
        if kernel is None:
            raise ValueError("Invalid value for `kernel`, must not be `None`")  # noqa: E501

        self._kernel = kernel

    @property
    def nvidia_container_runtime_docker(self):
        """Gets the nvidia_container_runtime_docker of this VersionsCollection.  # noqa: E501

        Nvidia Container Runtime Docker version  # noqa: E501

        :return: The nvidia_container_runtime_docker of this VersionsCollection.  # noqa: E501
        :rtype: str
        """
        return self._nvidia_container_runtime_docker

    @nvidia_container_runtime_docker.setter
    def nvidia_container_runtime_docker(self, nvidia_container_runtime_docker):
        """Sets the nvidia_container_runtime_docker of this VersionsCollection.

        Nvidia Container Runtime Docker version  # noqa: E501

        :param nvidia_container_runtime_docker: The nvidia_container_runtime_docker of this VersionsCollection.  # noqa: E501
        :type: str
        """
        if nvidia_container_runtime_docker is None:
            raise ValueError("Invalid value for `nvidia_container_runtime_docker`, must not be `None`")  # noqa: E501

        self._nvidia_container_runtime_docker = nvidia_container_runtime_docker

    @property
    def docker_ce(self):
        """Gets the docker_ce of this VersionsCollection.  # noqa: E501

        Docker CE version  # noqa: E501

        :return: The docker_ce of this VersionsCollection.  # noqa: E501
        :rtype: str
        """
        return self._docker_ce

    @docker_ce.setter
    def docker_ce(self, docker_ce):
        """Sets the docker_ce of this VersionsCollection.

        Docker CE version  # noqa: E501

        :param docker_ce: The docker_ce of this VersionsCollection.  # noqa: E501
        :type: str
        """
        if docker_ce is None:
            raise ValueError("Invalid value for `docker_ce`, must not be `None`")  # noqa: E501

        self._docker_ce = docker_ce

    @property
    def platform(self):
        """Gets the platform of this VersionsCollection.  # noqa: E501

        Platform version  # noqa: E501

        :return: The platform of this VersionsCollection.  # noqa: E501
        :rtype: str
        """
        return self._platform

    @platform.setter
    def platform(self, platform):
        """Sets the platform of this VersionsCollection.

        Platform version  # noqa: E501

        :param platform: The platform of this VersionsCollection.  # noqa: E501
        :type: str
        """
        if platform is None:
            raise ValueError("Invalid value for `platform`, must not be `None`")  # noqa: E501

        self._platform = platform

    @property
    def nvsm(self):
        """Gets the nvsm of this VersionsCollection.  # noqa: E501

        NVSM version  # noqa: E501

        :return: The nvsm of this VersionsCollection.  # noqa: E501
        :rtype: str
        """
        return self._nvsm

    @nvsm.setter
    def nvsm(self, nvsm):
        """Sets the nvsm of this VersionsCollection.

        NVSM version  # noqa: E501

        :param nvsm: The nvsm of this VersionsCollection.  # noqa: E501
        :type: str
        """
        if nvsm is None:
            raise ValueError("Invalid value for `nvsm`, must not be `None`")  # noqa: E501

        self._nvsm = nvsm

    @property
    def mlnx_ofed(self):
        """Gets the mlnx_ofed of this VersionsCollection.  # noqa: E501

        MLNX OFED Driver version  # noqa: E501

        :return: The mlnx_ofed of this VersionsCollection.  # noqa: E501
        :rtype: str
        """
        return self._mlnx_ofed

    @mlnx_ofed.setter
    def mlnx_ofed(self, mlnx_ofed):
        """Sets the mlnx_ofed of this VersionsCollection.

        MLNX OFED Driver version  # noqa: E501

        :param mlnx_ofed: The mlnx_ofed of this VersionsCollection.  # noqa: E501
        :type: str
        """
        if mlnx_ofed is None:
            raise ValueError("Invalid value for `mlnx_ofed`, must not be `None`")  # noqa: E501

        self._mlnx_ofed = mlnx_ofed

    @property
    def datacenter_gpu_manager(self):
        """Gets the datacenter_gpu_manager of this VersionsCollection.  # noqa: E501

        Datacenter GPU Manangement version  # noqa: E501

        :return: The datacenter_gpu_manager of this VersionsCollection.  # noqa: E501
        :rtype: str
        """
        return self._datacenter_gpu_manager

    @datacenter_gpu_manager.setter
    def datacenter_gpu_manager(self, datacenter_gpu_manager):
        """Sets the datacenter_gpu_manager of this VersionsCollection.

        Datacenter GPU Manangement version  # noqa: E501

        :param datacenter_gpu_manager: The datacenter_gpu_manager of this VersionsCollection.  # noqa: E501
        :type: str
        """
        if datacenter_gpu_manager is None:
            raise ValueError("Invalid value for `datacenter_gpu_manager`, must not be `None`")  # noqa: E501

        self._datacenter_gpu_manager = datacenter_gpu_manager

    @property
    def datacenter_gpu_manager_fabricmanager(self):
        """Gets the datacenter_gpu_manager_fabricmanager of this VersionsCollection.  # noqa: E501

        Datacenter GPU Manangement FabricManager version  # noqa: E501

        :return: The datacenter_gpu_manager_fabricmanager of this VersionsCollection.  # noqa: E501
        :rtype: str
        """
        return self._datacenter_gpu_manager_fabricmanager

    @datacenter_gpu_manager_fabricmanager.setter
    def datacenter_gpu_manager_fabricmanager(self, datacenter_gpu_manager_fabricmanager):
        """Sets the datacenter_gpu_manager_fabricmanager of this VersionsCollection.

        Datacenter GPU Manangement FabricManager version  # noqa: E501

        :param datacenter_gpu_manager_fabricmanager: The datacenter_gpu_manager_fabricmanager of this VersionsCollection.  # noqa: E501
        :type: str
        """
        if datacenter_gpu_manager_fabricmanager is None:
            raise ValueError("Invalid value for `datacenter_gpu_manager_fabricmanager`, must not be `None`")  # noqa: E501

        self._datacenter_gpu_manager_fabricmanager = datacenter_gpu_manager_fabricmanager

    @property
    def odata_type(self):
        """Gets the odata_type of this VersionsCollection.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this VersionsCollection.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this VersionsCollection.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this VersionsCollection.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VersionsCollection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
