# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class VirtualFunction(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'device_max_count': 'int',
        'min_assignment_group_size': 'int',
        'network_port_max_count': 'int'
    }

    attribute_map = {
        'device_max_count': 'DeviceMaxCount',
        'min_assignment_group_size': 'MinAssignmentGroupSize',
        'network_port_max_count': 'NetworkPortMaxCount'
    }

    def __init__(self, device_max_count=None, min_assignment_group_size=None, network_port_max_count=None):  # noqa: E501
        """VirtualFunction - a model defined in OpenAPI"""  # noqa: E501

        self._device_max_count = None
        self._min_assignment_group_size = None
        self._network_port_max_count = None
        self.discriminator = None

        self.device_max_count = device_max_count
        self.min_assignment_group_size = min_assignment_group_size
        self.network_port_max_count = network_port_max_count

    @property
    def device_max_count(self):
        """Gets the device_max_count of this VirtualFunction.  # noqa: E501

        The maximum number of Virtual Functions (VFs) supported by this controller.  # noqa: E501

        :return: The device_max_count of this VirtualFunction.  # noqa: E501
        :rtype: int
        """
        return self._device_max_count

    @device_max_count.setter
    def device_max_count(self, device_max_count):
        """Sets the device_max_count of this VirtualFunction.

        The maximum number of Virtual Functions (VFs) supported by this controller.  # noqa: E501

        :param device_max_count: The device_max_count of this VirtualFunction.  # noqa: E501
        :type: int
        """

        self._device_max_count = device_max_count

    @property
    def min_assignment_group_size(self):
        """Gets the min_assignment_group_size of this VirtualFunction.  # noqa: E501

        The minimum number of Virtual Functions (VFs) that can be allocated or moved between physical functions for this controller.  # noqa: E501

        :return: The min_assignment_group_size of this VirtualFunction.  # noqa: E501
        :rtype: int
        """
        return self._min_assignment_group_size

    @min_assignment_group_size.setter
    def min_assignment_group_size(self, min_assignment_group_size):
        """Sets the min_assignment_group_size of this VirtualFunction.

        The minimum number of Virtual Functions (VFs) that can be allocated or moved between physical functions for this controller.  # noqa: E501

        :param min_assignment_group_size: The min_assignment_group_size of this VirtualFunction.  # noqa: E501
        :type: int
        """

        self._min_assignment_group_size = min_assignment_group_size

    @property
    def network_port_max_count(self):
        """Gets the network_port_max_count of this VirtualFunction.  # noqa: E501

        The maximum number of Virtual Functions (VFs) supported per network port for this controller.  # noqa: E501

        :return: The network_port_max_count of this VirtualFunction.  # noqa: E501
        :rtype: int
        """
        return self._network_port_max_count

    @network_port_max_count.setter
    def network_port_max_count(self, network_port_max_count):
        """Sets the network_port_max_count of this VirtualFunction.

        The maximum number of Virtual Functions (VFs) supported per network port for this controller.  # noqa: E501

        :param network_port_max_count: The network_port_max_count of this VirtualFunction.  # noqa: E501
        :type: int
        """

        self._network_port_max_count = network_port_max_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VirtualFunction):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
