# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class VLAN(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'vlan_enable': 'bool',
        'vlan_id': 'int'
    }

    attribute_map = {
        'vlan_enable': 'VLANEnable',
        'vlan_id': 'VLANId'
    }

    def __init__(self, vlan_enable=None, vlan_id=None):  # noqa: E501
        """VLAN - a model defined in OpenAPI"""  # noqa: E501

        self._vlan_enable = None
        self._vlan_id = None
        self.discriminator = None

        self.vlan_enable = vlan_enable
        if vlan_id is not None:
            self.vlan_id = vlan_id

    @property
    def vlan_enable(self):
        """Gets the vlan_enable of this VLAN.  # noqa: E501

        An indication of whether this VLAN is enabled for this VLAN network interface.  # noqa: E501

        :return: The vlan_enable of this VLAN.  # noqa: E501
        :rtype: bool
        """
        return self._vlan_enable

    @vlan_enable.setter
    def vlan_enable(self, vlan_enable):
        """Sets the vlan_enable of this VLAN.

        An indication of whether this VLAN is enabled for this VLAN network interface.  # noqa: E501

        :param vlan_enable: The vlan_enable of this VLAN.  # noqa: E501
        :type: bool
        """

        self._vlan_enable = vlan_enable

    @property
    def vlan_id(self):
        """Gets the vlan_id of this VLAN.  # noqa: E501


        :return: The vlan_id of this VLAN.  # noqa: E501
        :rtype: int
        """
        return self._vlan_id

    @vlan_id.setter
    def vlan_id(self, vlan_id):
        """Sets the vlan_id of this VLAN.


        :param vlan_id: The vlan_id of this VLAN.  # noqa: E501
        :type: int
        """
        if vlan_id is not None and vlan_id > 4094:  # noqa: E501
            raise ValueError("Invalid value for `vlan_id`, must be a value less than or equal to `4094`")  # noqa: E501
        if vlan_id is not None and vlan_id < 0:  # noqa: E501
            raise ValueError("Invalid value for `vlan_id`, must be a value greater than or equal to `0`")  # noqa: E501

        self._vlan_id = vlan_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VLAN):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
