# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Volume(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'odata_context': 'str',
        'odata_etag': 'str',
        'odata_id': 'str',
        'odata_type': 'str',
        'actions': 'Actions2',
        'block_size_bytes': 'int',
        'capacity_bytes': 'int',
        'description': 'str',
        'encrypted': 'bool',
        'encryption_types': 'list[EncryptionTypes]',
        'id': 'str',
        'identifiers': 'list[Identifier]',
        'links': 'Links2',
        'name': 'str',
        'oem': 'dict(str, object)',
        'operations': 'list[Operation]',
        'optimum_io_size_bytes': 'int',
        'status': 'Status',
        'volume_type': 'VolumeType'
    }

    attribute_map = {
        'odata_context': '@odata.context',
        'odata_etag': '@odata.etag',
        'odata_id': '@odata.id',
        'odata_type': '@odata.type',
        'actions': 'Actions',
        'block_size_bytes': 'BlockSizeBytes',
        'capacity_bytes': 'CapacityBytes',
        'description': 'Description',
        'encrypted': 'Encrypted',
        'encryption_types': 'EncryptionTypes',
        'id': 'Id',
        'identifiers': 'Identifiers',
        'links': 'Links',
        'name': 'Name',
        'oem': 'Oem',
        'operations': 'Operations',
        'optimum_io_size_bytes': 'OptimumIOSizeBytes',
        'status': 'Status',
        'volume_type': 'VolumeType'
    }

    def __init__(self, odata_context=None, odata_etag=None, odata_id=None, odata_type=None, actions=None, block_size_bytes=None, capacity_bytes=None, description=None, encrypted=None, encryption_types=None, id=None, identifiers=None, links=None, name=None, oem=None, operations=None, optimum_io_size_bytes=None, status=None, volume_type=None):  # noqa: E501
        """Volume - a model defined in OpenAPI"""  # noqa: E501

        self._odata_context = None
        self._odata_etag = None
        self._odata_id = None
        self._odata_type = None
        self._actions = None
        self._block_size_bytes = None
        self._capacity_bytes = None
        self._description = None
        self._encrypted = None
        self._encryption_types = None
        self._id = None
        self._identifiers = None
        self._links = None
        self._name = None
        self._oem = None
        self._operations = None
        self._optimum_io_size_bytes = None
        self._status = None
        self._volume_type = None
        self.discriminator = None

        if odata_context is not None:
            self.odata_context = odata_context
        if odata_etag is not None:
            self.odata_etag = odata_etag
        self.odata_id = odata_id
        self.odata_type = odata_type
        if actions is not None:
            self.actions = actions
        self.block_size_bytes = block_size_bytes
        self.capacity_bytes = capacity_bytes
        if description is not None:
            self.description = description
        self.encrypted = encrypted
        if encryption_types is not None:
            self.encryption_types = encryption_types
        self.id = id
        if identifiers is not None:
            self.identifiers = identifiers
        if links is not None:
            self.links = links
        self.name = name
        if oem is not None:
            self.oem = oem
        if operations is not None:
            self.operations = operations
        self.optimum_io_size_bytes = optimum_io_size_bytes
        if status is not None:
            self.status = status
        if volume_type is not None:
            self.volume_type = volume_type

    @property
    def odata_context(self):
        """Gets the odata_context of this Volume.  # noqa: E501

        The OData description of a payload.  # noqa: E501

        :return: The odata_context of this Volume.  # noqa: E501
        :rtype: str
        """
        return self._odata_context

    @odata_context.setter
    def odata_context(self, odata_context):
        """Sets the odata_context of this Volume.

        The OData description of a payload.  # noqa: E501

        :param odata_context: The odata_context of this Volume.  # noqa: E501
        :type: str
        """

        self._odata_context = odata_context

    @property
    def odata_etag(self):
        """Gets the odata_etag of this Volume.  # noqa: E501

        The current ETag of the resource.  # noqa: E501

        :return: The odata_etag of this Volume.  # noqa: E501
        :rtype: str
        """
        return self._odata_etag

    @odata_etag.setter
    def odata_etag(self, odata_etag):
        """Sets the odata_etag of this Volume.

        The current ETag of the resource.  # noqa: E501

        :param odata_etag: The odata_etag of this Volume.  # noqa: E501
        :type: str
        """

        self._odata_etag = odata_etag

    @property
    def odata_id(self):
        """Gets the odata_id of this Volume.  # noqa: E501

        The unique identifier for a resource.  # noqa: E501

        :return: The odata_id of this Volume.  # noqa: E501
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """Sets the odata_id of this Volume.

        The unique identifier for a resource.  # noqa: E501

        :param odata_id: The odata_id of this Volume.  # noqa: E501
        :type: str
        """
        if odata_id is None:
            raise ValueError("Invalid value for `odata_id`, must not be `None`")  # noqa: E501

        self._odata_id = odata_id

    @property
    def odata_type(self):
        """Gets the odata_type of this Volume.  # noqa: E501

        The type of a resource.  # noqa: E501

        :return: The odata_type of this Volume.  # noqa: E501
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """Sets the odata_type of this Volume.

        The type of a resource.  # noqa: E501

        :param odata_type: The odata_type of this Volume.  # noqa: E501
        :type: str
        """
        if odata_type is None:
            raise ValueError("Invalid value for `odata_type`, must not be `None`")  # noqa: E501

        self._odata_type = odata_type

    @property
    def actions(self):
        """Gets the actions of this Volume.  # noqa: E501


        :return: The actions of this Volume.  # noqa: E501
        :rtype: Actions2
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this Volume.


        :param actions: The actions of this Volume.  # noqa: E501
        :type: Actions2
        """

        self._actions = actions

    @property
    def block_size_bytes(self):
        """Gets the block_size_bytes of this Volume.  # noqa: E501

        The size of the smallest addressable unit (Block) of this volume in bytes.  # noqa: E501

        :return: The block_size_bytes of this Volume.  # noqa: E501
        :rtype: int
        """
        return self._block_size_bytes

    @block_size_bytes.setter
    def block_size_bytes(self, block_size_bytes):
        """Sets the block_size_bytes of this Volume.

        The size of the smallest addressable unit (Block) of this volume in bytes.  # noqa: E501

        :param block_size_bytes: The block_size_bytes of this Volume.  # noqa: E501
        :type: int
        """

        self._block_size_bytes = block_size_bytes

    @property
    def capacity_bytes(self):
        """Gets the capacity_bytes of this Volume.  # noqa: E501

        The size in bytes of this Volume.  # noqa: E501

        :return: The capacity_bytes of this Volume.  # noqa: E501
        :rtype: int
        """
        return self._capacity_bytes

    @capacity_bytes.setter
    def capacity_bytes(self, capacity_bytes):
        """Sets the capacity_bytes of this Volume.

        The size in bytes of this Volume.  # noqa: E501

        :param capacity_bytes: The capacity_bytes of this Volume.  # noqa: E501
        :type: int
        """

        self._capacity_bytes = capacity_bytes

    @property
    def description(self):
        """Gets the description of this Volume.  # noqa: E501

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :return: The description of this Volume.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Volume.

        The description of this resource.  Used for commonality in the schema definitions.  # noqa: E501

        :param description: The description of this Volume.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def encrypted(self):
        """Gets the encrypted of this Volume.  # noqa: E501

        Is this Volume encrypted.  # noqa: E501

        :return: The encrypted of this Volume.  # noqa: E501
        :rtype: bool
        """
        return self._encrypted

    @encrypted.setter
    def encrypted(self, encrypted):
        """Sets the encrypted of this Volume.

        Is this Volume encrypted.  # noqa: E501

        :param encrypted: The encrypted of this Volume.  # noqa: E501
        :type: bool
        """

        self._encrypted = encrypted

    @property
    def encryption_types(self):
        """Gets the encryption_types of this Volume.  # noqa: E501

        The types of encryption used by this Volume.  # noqa: E501

        :return: The encryption_types of this Volume.  # noqa: E501
        :rtype: list[EncryptionTypes]
        """
        return self._encryption_types

    @encryption_types.setter
    def encryption_types(self, encryption_types):
        """Sets the encryption_types of this Volume.

        The types of encryption used by this Volume.  # noqa: E501

        :param encryption_types: The encryption_types of this Volume.  # noqa: E501
        :type: list[EncryptionTypes]
        """

        self._encryption_types = encryption_types

    @property
    def id(self):
        """Gets the id of this Volume.  # noqa: E501

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :return: The id of this Volume.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Volume.

        The identifier that uniquely identifies the resource within the collection of similar resources.  # noqa: E501

        :param id: The id of this Volume.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def identifiers(self):
        """Gets the identifiers of this Volume.  # noqa: E501

        The Durable names for the volume.  # noqa: E501

        :return: The identifiers of this Volume.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._identifiers

    @identifiers.setter
    def identifiers(self, identifiers):
        """Sets the identifiers of this Volume.

        The Durable names for the volume.  # noqa: E501

        :param identifiers: The identifiers of this Volume.  # noqa: E501
        :type: list[Identifier]
        """

        self._identifiers = identifiers

    @property
    def links(self):
        """Gets the links of this Volume.  # noqa: E501


        :return: The links of this Volume.  # noqa: E501
        :rtype: Links2
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this Volume.


        :param links: The links of this Volume.  # noqa: E501
        :type: Links2
        """

        self._links = links

    @property
    def name(self):
        """Gets the name of this Volume.  # noqa: E501

        The name of the resource or array member.  # noqa: E501

        :return: The name of this Volume.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Volume.

        The name of the resource or array member.  # noqa: E501

        :param name: The name of this Volume.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def oem(self):
        """Gets the oem of this Volume.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this Volume.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this Volume.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this Volume.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def operations(self):
        """Gets the operations of this Volume.  # noqa: E501

        The operations currently running on the Volume.  # noqa: E501

        :return: The operations of this Volume.  # noqa: E501
        :rtype: list[Operation]
        """
        return self._operations

    @operations.setter
    def operations(self, operations):
        """Sets the operations of this Volume.

        The operations currently running on the Volume.  # noqa: E501

        :param operations: The operations of this Volume.  # noqa: E501
        :type: list[Operation]
        """

        self._operations = operations

    @property
    def optimum_io_size_bytes(self):
        """Gets the optimum_io_size_bytes of this Volume.  # noqa: E501

        The size in bytes of this Volume's optimum IO size.  # noqa: E501

        :return: The optimum_io_size_bytes of this Volume.  # noqa: E501
        :rtype: int
        """
        return self._optimum_io_size_bytes

    @optimum_io_size_bytes.setter
    def optimum_io_size_bytes(self, optimum_io_size_bytes):
        """Sets the optimum_io_size_bytes of this Volume.

        The size in bytes of this Volume's optimum IO size.  # noqa: E501

        :param optimum_io_size_bytes: The optimum_io_size_bytes of this Volume.  # noqa: E501
        :type: int
        """

        self._optimum_io_size_bytes = optimum_io_size_bytes

    @property
    def status(self):
        """Gets the status of this Volume.  # noqa: E501


        :return: The status of this Volume.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this Volume.


        :param status: The status of this Volume.  # noqa: E501
        :type: Status
        """

        self._status = status

    @property
    def volume_type(self):
        """Gets the volume_type of this Volume.  # noqa: E501


        :return: The volume_type of this Volume.  # noqa: E501
        :rtype: VolumeType
        """
        return self._volume_type

    @volume_type.setter
    def volume_type(self, volume_type):
        """Sets the volume_type of this Volume.


        :param volume_type: The volume_type of this Volume.  # noqa: E501
        :type: VolumeType
        """

        self._volume_type = volume_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Volume):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
