# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class WatchdogTimer(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'function_enabled': 'bool',
        'oem': 'dict(str, object)',
        'status': 'Status',
        'timeout_action': 'WatchdogTimeoutActions',
        'warning_action': 'WatchdogWarningActions'
    }

    attribute_map = {
        'function_enabled': 'FunctionEnabled',
        'oem': 'Oem',
        'status': 'Status',
        'timeout_action': 'TimeoutAction',
        'warning_action': 'WarningAction'
    }

    def __init__(self, function_enabled=None, oem=None, status=None, timeout_action=None, warning_action=None):  # noqa: E501
        """WatchdogTimer - a model defined in OpenAPI"""  # noqa: E501

        self._function_enabled = None
        self._oem = None
        self._status = None
        self._timeout_action = None
        self._warning_action = None
        self.discriminator = None

        self.function_enabled = function_enabled
        if oem is not None:
            self.oem = oem
        if status is not None:
            self.status = status
        self.timeout_action = timeout_action
        if warning_action is not None:
            self.warning_action = warning_action

    @property
    def function_enabled(self):
        """Gets the function_enabled of this WatchdogTimer.  # noqa: E501

        This indicates if the Host Watchdog Timer functionality has been enabled. Additional host-based software is necessary to activate the timer function.  # noqa: E501

        :return: The function_enabled of this WatchdogTimer.  # noqa: E501
        :rtype: bool
        """
        return self._function_enabled

    @function_enabled.setter
    def function_enabled(self, function_enabled):
        """Sets the function_enabled of this WatchdogTimer.

        This indicates if the Host Watchdog Timer functionality has been enabled. Additional host-based software is necessary to activate the timer function.  # noqa: E501

        :param function_enabled: The function_enabled of this WatchdogTimer.  # noqa: E501
        :type: bool
        """

        self._function_enabled = function_enabled

    @property
    def oem(self):
        """Gets the oem of this WatchdogTimer.  # noqa: E501

        The OEM extension.  # noqa: E501

        :return: The oem of this WatchdogTimer.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """Sets the oem of this WatchdogTimer.

        The OEM extension.  # noqa: E501

        :param oem: The oem of this WatchdogTimer.  # noqa: E501
        :type: dict(str, object)
        """

        self._oem = oem

    @property
    def status(self):
        """Gets the status of this WatchdogTimer.  # noqa: E501


        :return: The status of this WatchdogTimer.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this WatchdogTimer.


        :param status: The status of this WatchdogTimer.  # noqa: E501
        :type: Status
        """

        self._status = status

    @property
    def timeout_action(self):
        """Gets the timeout_action of this WatchdogTimer.  # noqa: E501


        :return: The timeout_action of this WatchdogTimer.  # noqa: E501
        :rtype: WatchdogTimeoutActions
        """
        return self._timeout_action

    @timeout_action.setter
    def timeout_action(self, timeout_action):
        """Sets the timeout_action of this WatchdogTimer.


        :param timeout_action: The timeout_action of this WatchdogTimer.  # noqa: E501
        :type: WatchdogTimeoutActions
        """
        if timeout_action is None:
            raise ValueError("Invalid value for `timeout_action`, must not be `None`")  # noqa: E501

        self._timeout_action = timeout_action

    @property
    def warning_action(self):
        """Gets the warning_action of this WatchdogTimer.  # noqa: E501


        :return: The warning_action of this WatchdogTimer.  # noqa: E501
        :rtype: WatchdogWarningActions
        """
        return self._warning_action

    @warning_action.setter
    def warning_action(self, warning_action):
        """Sets the warning_action of this WatchdogTimer.


        :param warning_action: The warning_action of this WatchdogTimer.  # noqa: E501
        :type: WatchdogWarningActions
        """

        self._warning_action = warning_action

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WatchdogTimer):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
