# Copyright (c) 2018, NVIDIA CORPORATION.  All rights reserved.
#
# NVIDIA CORPORATION and its licensors retain all intellectual property
# and proprietary rights in and to this software, related documentation
# and any modifications thereto.  Any use, reproduction, disclosure or
# distribution of this software and related documentation without an express
# license agreement from NVIDIA CORPORATION is strictly prohibited.

import os
from importlib import import_module

# Automatically import all Python modules in this package
modules = []
modules_dir = os.path.dirname(__file__)
with os.scandir(path=modules_dir) as i:
    for entry in i:
        if entry.name.startswith('_'):
            continue
        if entry.is_file() and entry.name.endswith('.py'):
            module_name = os.path.splitext(entry.name)[0]
        else:
            continue
        modules.append(import_module('.' + module_name, package=__name__))

# Automatically export any NVSM tasks defined in this package
__all__ = []
for m in modules:
    for x in m.__all__:
        globals()[x] = getattr(m, x)
        __all__.append(x)
