# Copyright (c) 2021, NVIDIA CORPORATION.  All rights reserved.
#
# NVIDIA CORPORATION and its licensors retain all intellectual property
# and proprietary rights in and to this software, related documentation
# and any modifications thereto.  Any use, reproduction, disclosure or
# distribution of this software and related documentation without an express
# license agreement from NVIDIA CORPORATION is strictly prohibited.

import os, sys, argparse, subprocess, re
from nvsmhealth import modules, tasks

class GdsLogs(tasks.ILogs):
    def __init__(self):
        super(GdsLogs, self).__init__()

    def run(self):
        pass

    def collect(self, context):
        json_paths = []
        json_paths.append("/etc/cufile.json")

        process_ids = subprocess.run(["nvidia-smi --query-compute-apps=pid --format=csv,noheader"], stdout=subprocess.PIPE, universal_newlines=True, shell=True)
        process_ids = process_ids.stdout
        #print(process_ids)
        process_ids = process_ids.split("\n")
        process_ids = list(filter(None, process_ids))
        #print(process_ids)

        for pid in process_ids:
            cmd = "xargs -0 -L1 -a /proc/{}/environ ".format(pid)
            output = subprocess.run([cmd], stdout=subprocess.PIPE, universal_newlines=True, shell=True)
            content = output.stdout
            #print(content)
            content = content.split("\n")
            content = list(filter(None, content))
            #print(content)

            for c in content:
                #print(c)
                line = re.search(r"CUFILE_ENV_PATH_JSON*", c)
                if line :
                    x = line.string.split("=")
                    json_path = x[1]
                    json_paths.append(json_path)
                    #print(json_path)

        for json_path in json_paths:
            #collect file path json_path
            collect_logs = tasks.CollectLogFiles(path=json_path)
            collect_logs.collect(context=context)


        pattern = "^\s+\"dir\":"
        for json_path in json_paths:
            file = open(json_path, "r")
            for line in file:
                if re.search(pattern,line):
                    x = line.split(":")
                    p = x[1].strip()
                    p = p.rstrip(",")
                    collect_logs = tasks.CollectLogFiles(path=p)
                    collect_logs.collect(context=context)
                    break
        

gds_collect = GdsLogs()