#!/usr/bin/env bash
# Copyright (c) 2018, NVIDIA CORPORATION.  All rights reserved.
#
# NVIDIA CORPORATION and its licensors retain all intellectual property
# and proprietary rights in and to this software, related documentation
# and any modifications thereto.  Any use, reproduction, disclosure or
# distribution of this software and related documentation without an express
# license agreement from NVIDIA CORPORATION is strictly prohibited.

ipmitool_raw() {
  COMMAND="ipmitool raw $@"
  echo "========> ${COMMAND} <========"
  ${COMMAND}
}

if grep -q 'DGX-2' /sys/devices/virtual/dmi/id/product_name ; then
  for hex in 0x0a 0x0c ; do
    ipmitool_raw 0x30 0x81 ${hex} 0x12 0x4d 0
  done
  for i in $(seq 0 5) ; do
    for j in $(seq 0 1) ; do
      ipmitool_raw 0x30 0x0e "0x0${i}" "0x0${j}"
    done
  done
  for i in $(seq 0 8) ; do
    ipmitool_raw 0x30 0x0f "0x0${i}"
  done
  ipmitool_raw 0x30 0x81 2 0x78 2 45
fi

