#!/usr/bin/env sh

# Copyright (c) 2018, NVIDIA CORPORATION.  All rights reserved.
#
# NVIDIA CORPORATION and its licensors retain all intellectual property
# and proprietary rights in and to this software, related documentation
# and any modifications thereto.  Any use, reproduction, disclosure or
# distribution of this software and related documentation without an express
# license agreement from NVIDIA CORPORATION is strictly prohibited.

export LC_ALL=POSIX

TEMP=$(mktemp --tmpdir)
for c in smart-log smart-log-add error-log fw-log id-ctrl list-ns id-ns show-regs ; do
    for f in $(find /dev -mindepth 1 -maxdepth 1 -type b -name 'nvme*'); do
        NVME_COMMAND="nvme $c $f"
        echo "====> $NVME_COMMAND <====" > "$TEMP"
        $NVME_COMMAND 2>/dev/null >> "$TEMP"
        if [ "$?" != "0" ]; then
            # Don't collect output of unsupported commands
            continue
        fi
        cat "$TEMP"
    done
done
rm "$TEMP"
