import re
import json
from nvsmhealth import modules, tasks, config

__all__ = [
    'run_dpkg_grep_kvm',
    'kvm_mode_on'
]

run_dpkg_grep_kvm = tasks.RunCommand(
    ['bash -c "dpkg -l | grep -c dgx-kvm-sw"'], shell=True) \
    .title('Run dpkg list and grep for kvm package')


class KvmModeOn(tasks.ITask):
    def __init__(self, cmd_task):
        super().__init__()
        self.__cmd_task = cmd_task
        self.depends(cmd_task)
        self.__result = None

    def getResult(self):
        return self.__result

    def run(self):
        self.__result = self.__cmd_task.getOutput().strip() != '0'


kvm_mode_on = KvmModeOn(run_dpkg_grep_kvm) \
    .title('Parse if KVM mode on')
