import re
import json
from nvsmhealth import modules, tasks, config

__all__ = [
    'parse_uname'
]

class ParseUname(tasks.ITask):
    def __init__(self):
        super().__init__()
        self.__result = None

    def getResult(self):
        return self.__result

    def run(self):
        cmds = [('kernel-name', ['uname', '-s']),
                ('kernel-release', ['uname', '-r']),
                ('kernel-version', ['uname', '-v']),
                ('kernel-nodename', ['uname', '-n']),
                ('kernel-machine', ['uname', '-m']),
                ('kernel-processor', ['uname', '-p']),
                ('kernel-hardware-platform', ['uname', '-i']),
                ('kernel-operating-system', ['uname', '-o'])]

        res = {}
        for key, c_args in cmds:
            t = tasks.RunCommand(args=c_args)
            t.run()
            res[key] = t.getOutput().strip()

        self.__result = res

parse_uname = ParseUname() \
        .title('Run and Parse uame tool')
