# Copyright (c) 2018, NVIDIA CORPORATION.  All rights reserved.
#
# NVIDIA CORPORATION and its licensors retain all intellectual property
# and proprietary rights in and to this software, related documentation
# and any modifications thereto.  Any use, reproduction, disclosure or
# distribution of this software and related documentation without an express
# license agreement from NVIDIA CORPORATION is strictly prohibited.

import logging
import os
import sys

# Automatically import all Python modules under this directory
__all__ = []
modules_dir = os.path.dirname(__file__)
with os.scandir(path=modules_dir) as i:
    for entry in i:
        if entry.name.startswith('.'):
            continue
        if entry.name.startswith('_'):
            continue
        if entry.is_dir():
            module_name = entry.name
        elif entry.is_file() and entry.name.endswith('.py'):
            module_name = os.path.splitext(entry.name)[0]
        __all__.append(module_name)

