from nvsmhealth.topic import Topic
from nvsmhealth import config

class HealthStream:
    def stream(self, message=None, progress=None):
        if message:
            self.stream_obj.message = message
        if progress:
            self.stream_obj.Health_task_progress = progress
        if self.pub_cb:
            self.stream_obj.timestamp = config.timestamp
            self.pub_cb(self.topic, self.stream_obj)
        elif self.stream_obj.message:
            print(self.stream_obj.message)


# Interface for health checks to implement stream results
class HealthSummaryStream(HealthStream):
    class StreamObj:
        def __init__(self):
            self.totalChecks = 0
            self.healthyChecks = 0
            self.unhealthyChecks = 0
            self.unknownChecks = 0
            self.informationalChecks = 0
            self.message = ''
            self.result = 'unknown'
            self.timestamp = ''
    def __init__(self,
                 i_pub_cb):
        self.topic      = Topic.TOPIC_HEALTH_DUMP_STREAM + "/Summary"
        self.pub_cb     = i_pub_cb
        self.stream_obj = HealthSummaryStream.StreamObj()

class HealthTaskStream(HealthStream):
    class StreamObj:
        def __init__(self,
                     i_Health_task_id,
                     i_Health_task_progress,
                     i_Message,
                     i_Timestamp):
            self.Health_task_id          = i_Health_task_id
            self.Health_task_progress    = i_Health_task_progress
            self.message                 = i_Message
            self.timestamp               = i_Timestamp
    def __init__(self,
                 i_Health_task_id,
                 i_pub_cb):
        self.topic      = Topic.TOPIC_HEALTH_DUMP_STREAM + "/" + i_Health_task_id
        self.pub_cb     = i_pub_cb
        self.stream_obj = HealthTaskStream.StreamObj(i_Health_task_id, 0, '', '')
