#!/usr/bin/python3

# Copyright (c) 2021, NVIDIA CORPORATION.  All rights reserved.
#
# NVIDIA CORPORATION and its licensors retain all intellectual property
# and proprietary rights in and to this software, related documentation
# and any modifications thereto.  Any use, reproduction, disclosure or
# distribution of this software and related documentation without an express
# license agreement from NVIDIA CORPORATION is strictly prohibited.

import os, shutil, subprocess, re


class GdsLogs:
    def __init__(self):
        pass

    def run(self):
        pass

    def collect(self):
        json_paths = []
        json_paths.append("/etc/cufile.json")

        process_ids = subprocess.run(["nvidia-smi --query-compute-apps=pid --format=csv,noheader"], stdout=subprocess.PIPE, universal_newlines=True, shell=True)
        process_ids = process_ids.stdout
        #print(process_ids)
        process_ids = process_ids.split("\n")
        process_ids = list(filter(None, process_ids))
        #print(process_ids)

        for pid in process_ids:
            cmd = "xargs -0 -L1 -a /proc/{}/environ ".format(pid)
            output = subprocess.run([cmd], stdout=subprocess.PIPE, universal_newlines=True, shell=True)
            content = output.stdout
            #print(content)
            content = content.split("\n")
            content = list(filter(None, content))
            #print(content)

            for c in content:
                #print(c)
                line = re.search(r"CUFILE_ENV_PATH_JSON*", c)
                if line :
                    x = line.string.split("=")
                    json_path = x[1]
                    json_paths.append(json_path)
                    #print(json_path)

        cwd = os.getcwd()

        for json_path in json_paths:
            #collect file path json_path
            destination = cwd + json_path

            dirname = os.path.dirname(destination)
            os.makedirs(dirname, exist_ok = True)

            try:
                shutil.copy(json_path, destination)
            except (shutil.Error, IOError) as err:
                print(err)
            except:
                print("Failed to copy file :" + json_path)

        pattern = r'^\s*\"dir\":\s*\"(.*)\"'

        for json_path in json_paths:
            if not os.path.exists(json_path):
                continue

            with open(json_path, "r") as file:
                for line in file:
                    match = re.search(pattern,line)
                    if match:
                        p = match.group(1)

                        destination = cwd + p

                        try:
                            shutil.copytree(p, destination)
                        except (shutil.Error, IOError) as err:
                            print(err)
                        except:
                            print("Failed to copy dir :" + p)

                        break


gds_collect = GdsLogs()

gds_collect.collect()
