#!/usr/bin/env sh

# Copyright (c) 2018, NVIDIA CORPORATION.  All rights reserved.
#
# NVIDIA CORPORATION and its licensors retain all intellectual property
# and proprietary rights in and to this software, related documentation
# and any modifications thereto.  Any use, reproduction, disclosure or
# distribution of this software and related documentation without an express
# license agreement from NVIDIA CORPORATION is strictly prohibited.

#Check if rshim is running
SERVICE="rshim"

fetch_boot_logs() {
        a=0
        while [ $a -lt 10 ]; do
                if [ -d "/dev/rshim$a" ]; then
                        echo "====> Rshim device log /dev/rshim$a <===="
                        echo "DISPLAY_LEVEL 2" >/dev/rshim$a/misc
                        cat /dev/rshim$a/misc
                        echo "DISPLAY_LEVEL 0" >/dev/rshim$a/misc
                        echo "\n"
                fi
                a=$(expr $a + 1)
        done
}

echo "=======> BF2 Boot Logs <======="
if pgrep -x "$SERVICE" >/dev/null; then
        fetch_boot_logs
else
        systemctl start $SERVICE
        sleep 5s
        if pgrep -x "$SERVICE" >/dev/null; then
                fetch_boot_logs
                systemctl stop $SERVICE
        else
                echo "Unable to collect BF2 Boot Logs"
        fi
fi
echo "\n"
