#!/usr/bin/env bash
# Copyright (c) 2019, NVIDIA CORPORATION.  All rights reserved.
#
# NVIDIA CORPORATION and its licensors retain all intellectual property
# and proprietary rights in and to this software, related documentation
# and any modifications thereto.  Any use, reproduction, disclosure or
# distribution of this software and related documentation without an express
# license agreement from NVIDIA CORPORATION is strictly prohibited.

ipmitool_raw() {
  COMMAND="ipmitool raw $@"
  ${COMMAND}
  echo "========> ${COMMAND} <========"
}


echo "PSU1..."
ipmitool_raw "0x30 0xd7 0x02 0x00"
ipmitool_raw "0x06 0x52 0x11 0xea 0x00 0x01"
echo -n "MFR ID: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x0d 0x99"
echo $? | xxd -r
echo " "
echo -n "FW VERSION: "
ipmitool_raw "0x06 0x52 0x11 0xb0 0x08 0xd5"
echo $? | xxd -r
echo " "
echo -n "READ PIN: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x5 0x97"
echo $?
echo -n "INPUT Status: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x5 0x7c"
echo $?
echo -n "MFR MODEL: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x0f 0x9a"
echo $? | xxd -r
echo " "
echo -n "MFR REVISION: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x04 0x9b"
echo $? | xxd -r
echo " "
echo -n "MFR LOCATION: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x06 0x9c"
echo $?
echo -n "MFR DATE: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x05 0x9d"
echo $? | xxd -r
echo " "
echo -n "MFR SERIAL: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x11 0x9e"
echo $? | xxd -r
echo " "
echo -n "MFR POUT MAX: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x3 0xa7"
echo $?
echo -n "CR OFFLINE MODE: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x02 0xe0"
echo $?
ipmitool_raw "0x30 0xd7 0x02 0x01"

sleep 1
echo "PSU2..."
ipmitool_raw "0x30 0xd7 0x02 0x00"
ipmitool_raw "0x06 0x52 0x11 0xea 0x00 0x02"
echo -n "MFR ID: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x0d 0x99"
echo $? | xxd -r
echo " "
echo -n "FW VERSION: "
ipmitool_raw "0x06 0x52 0x11 0xb0 0x08 0xd5"
echo $? | xxd -r
echo " "
echo -n "READ PIN: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x5 0x97"
echo $?
echo -n "INPUT Status: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x5 0x7c"
echo $?
echo -n "MFR MODEL: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x0f 0x9a"
echo $? | xxd -r
echo " "
echo -n "MFR REVISION: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x04 0x9b"
echo $? | xxd -r
echo " "
echo -n "MFR LOCATION: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x06 0x9c"
echo $?
echo -n "MFR DATE: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x05 0x9d"
echo $? | xxd -r
echo " "
echo -n "MFR SERIAL: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x11 0x9e"
echo $? | xxd -r
echo " "
echo -n "MFR POUT MAX: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x3 0xa7"
echo $?
echo -n "CR OFFLINE MODE: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x02 0xe0"
echo $?
ipmitool_raw "0x30 0xd7 0x02 0x01"

sleep 1


echo "PSU3..."
ipmitool_raw "0x30 0xd7 0x02 0x00"
ipmitool_raw "0x06 0x52 0x11 0xea 0x00 0x04"
echo -n "MFR ID: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x0d 0x99"
echo $? | xxd -r
echo " "
echo -n "FW VERSION: "
ipmitool_raw "0x06 0x52 0x11 0xb0 0x08 0xd5"
echo $? | xxd -r
echo " "
echo -n "READ PIN: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x5 0x97"
echo $?
echo -n "INPUT Status: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x5 0x7c"
echo $?
echo -n "MFR MODEL: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x0f 0x9a"
echo $? | xxd -r
echo " "
echo -n "MFR REVISION: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x04 0x9b"
echo $? | xxd -r
echo " "
echo -n "MFR LOCATION: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x06 0x9c"
echo $?
echo -n "MFR DATE: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x05 0x9d"
echo $? | xxd -r
echo " "
echo -n "MFR SERIAL: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x11 0x9e"
echo $? | xxd -r
echo " "
echo -n "MFR POUT MAX: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x3 0xa7"
echo $?
echo -n "CR OFFLINE MODE: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x02 0xe0"
echo $?
ipmitool_raw "0x30 0xd7 0x02 0x01"

sleep 1

echo "PSU4..."
ipmitool_raw "0x30 0xd7 0x02 0x00"
ipmitool_raw "0x06 0x52 0x11 0xea 0x00 0x08"
echo -n "MFR ID: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x0d 0x99"
echo $? | xxd -r
echo " "
echo -n "FW VERSION: "
ipmitool_raw "0x06 0x52 0x11 0xb0 0x08 0xd5"
echo $? | xxd -r
echo " "
echo -n "READ PIN: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x5 0x97"
echo $?
echo -n "INPUT Status: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x5 0x7c"
echo $?
echo -n "MFR MODEL: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x0f 0x9a"
echo $? | xxd -r
echo " "
echo -n "MFR REVISION: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x04 0x9b"
echo $? | xxd -r
echo " "
echo -n "MFR LOCATION: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x06 0x9c"
echo $?
echo -n "MFR DATE: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x05 0x9d"
echo $? | xxd -r
echo " "
echo -n "MFR SERIAL: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x11 0x9e"
echo $? | xxd -r
echo " "
echo -n "MFR POUT MAX: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x3 0xa7"
echo $?
echo -n "CR OFFLINE MODE: "
ipmitool_raw "0x6 0x52 0x11 0xb0 0x02 0xe0"
echo $?
ipmitool_raw "0x30 0xd7 0x02 0x01"

