# ComputerSystem

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**odata_context** | **str** | The OData description of a payload. | [optional] 
**odata_etag** | **str** | The current ETag of the resource. | [optional] 
**odata_id** | **str** | The unique identifier for a resource. | 
**odata_type** | **str** | The type of a resource. | 
**actions** | [**Actions**](Actions.md) |  | [optional] 
**asset_tag** | **str** | The user definable tag that can be used to track this computer system for inventory or other client purposes. | [optional] 
**bios** | [**IdRef**](IdRef.md) |  | [optional] 
**bios_version** | **str** | The version of the system BIOS or primary system firmware. | [optional] 
**boot** | [**Boot**](Boot.md) |  | [optional] 
**description** | **str** | The description of this resource.  Used for commonality in the schema definitions. | [optional] 
**ethernet_interfaces** | [**IdRef**](IdRef.md) |  | [optional] 
**host_name** | **str** | The DNS Host Name, without any domain information. | [optional] 
**host_watchdog_timer** | [**WatchdogTimer**](WatchdogTimer.md) |  | [optional] 
**hosted_services** | [**HostedServices**](HostedServices.md) |  | [optional] 
**hosting_roles** | [**list[HostingRole]**](HostingRole.md) | The hosing roles that this computer system supports. | [optional] 
**id** | **str** | The identifier that uniquely identifies the resource within the collection of similar resources. | 
**indicator_led** | [**IndicatorLED**](IndicatorLED.md) |  | [optional] 
**links** | [**Links**](Links.md) |  | [optional] 
**log_services** | [**IdRef**](IdRef.md) |  | [optional] 
**manufacturer** | **str** | The manufacturer or OEM of this system. | [optional] 
**memory** | [**IdRef**](IdRef.md) |  | [optional] 
**memory_domains** | [**IdRef**](IdRef.md) |  | [optional] 
**memory_summary** | [**MemorySummary**](MemorySummary.md) |  | [optional] 
**model** | **str** | The product name for this system, without the manufacturer name. | [optional] 
**name** | **str** | The name of the resource or array member. | 
**network_interfaces** | [**IdRef**](IdRef.md) |  | [optional] 
**oem** | **dict(str, object)** | The OEM extension. | [optional] 
**pc_ie_devices** | [**list[IdRef]**](IdRef.md) | A reference to a collection of PCIe Devices used by this computer system. | [optional] 
**pc_ie_devicesodata_count** | **int** | The number of items in a collection. | [optional] 
**pc_ie_functions** | [**list[IdRef]**](IdRef.md) | A reference to a collection of PCIe Functions used by this computer system. | [optional] 
**pc_ie_functionsodata_count** | **int** | The number of items in a collection. | [optional] 
**part_number** | **str** | The part number for this system. | [optional] 
**power_restore_policy** | [**PowerRestorePolicyTypes**](PowerRestorePolicyTypes.md) |  | [optional] 
**power_state** | [**PowerState**](PowerState.md) |  | [optional] 
**processor_summary** | [**ProcessorSummary**](ProcessorSummary.md) |  | [optional] 
**processors** | [**IdRef**](IdRef.md) |  | [optional] 
**redundancy** | [**list[IdRef]**](IdRef.md) | A reference to a collection of Redundancy entities that each name a set of computer systems that provide redundancy for this ComputerSystem. | [optional] 
**redundancyodata_count** | **int** | The number of items in a collection. | [optional] 
**sku** | **str** | The manufacturer SKU for this system. | [optional] 
**secure_boot** | [**IdRef**](IdRef.md) |  | [optional] 
**serial_number** | **str** | The serial number for this system. | [optional] 
**simple_storage** | [**IdRef**](IdRef.md) |  | [optional] 
**status** | [**Status**](Status.md) |  | [optional] 
**storage** | [**IdRef**](IdRef.md) |  | [optional] 
**sub_model** | **str** | The sub-model for this system. | [optional] 
**system_type** | [**SystemType**](SystemType.md) |  | [optional] 
**trusted_modules** | [**list[TrustedModules]**](TrustedModules.md) | This object describes the array of Trusted Modules in the system. | [optional] 
**uuid** | **str** |  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


