# nvsm_sdk.DefaultApi

All URIs are relative to *https://127.0.0.1:273*

Method | HTTP request | Description
------------- | ------------- | -------------
[**nvsm_v1_systems_computer_system_id_actions_computer_system_oem_collect_dump_health_post**](DefaultApi.md#nvsm_v1_systems_computer_system_id_actions_computer_system_oem_collect_dump_health_post) | **POST** /nvsm/v1/Systems/{ComputerSystemId}/Actions/ComputerSystem.Oem.CollectDumpHealth | 
[**nvsm_v1_systems_computer_system_id_actions_computer_system_oem_collect_dump_post**](DefaultApi.md#nvsm_v1_systems_computer_system_id_actions_computer_system_oem_collect_dump_post) | **POST** /nvsm/v1/Systems/{ComputerSystemId}/Actions/ComputerSystem.Oem.collectDump | 
[**redfish_v1_chassis_chassis_id_power_patch**](DefaultApi.md#redfish_v1_chassis_chassis_id_power_patch) | **PATCH** /redfish/v1/Chassis/{ChassisId}/Power | 
[**redfish_v1_task_service_get**](DefaultApi.md#redfish_v1_task_service_get) | **GET** /redfish/v1/TaskService | 
[**redfish_v1_task_service_patch**](DefaultApi.md#redfish_v1_task_service_patch) | **PATCH** /redfish/v1/TaskService | 
[**redfish_v1_task_service_put**](DefaultApi.md#redfish_v1_task_service_put) | **PUT** /redfish/v1/TaskService | 
[**redfish_v1_task_service_tasks_get**](DefaultApi.md#redfish_v1_task_service_tasks_get) | **GET** /redfish/v1/TaskService/Tasks | 
[**redfish_v1_task_service_tasks_task_id_delete**](DefaultApi.md#redfish_v1_task_service_tasks_task_id_delete) | **DELETE** /redfish/v1/TaskService/Tasks/{TaskId} | 
[**redfish_v1_task_service_tasks_task_id_get**](DefaultApi.md#redfish_v1_task_service_tasks_task_id_get) | **GET** /redfish/v1/TaskService/Tasks/{TaskId} | 


# **nvsm_v1_systems_computer_system_id_actions_computer_system_oem_collect_dump_health_post**
> Task nvsm_v1_systems_computer_system_id_actions_computer_system_oem_collect_dump_health_post(computer_system_id, dump_health_request_body)



### Example

* Api Key Authentication (bearerAuth): 

```python
from __future__ import print_function
import time
import nvsm_sdk
from nvsm_sdk.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerAuth
configuration = nvsm_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = nvsm_sdk.DefaultApi(nvsm_sdk.ApiClient(configuration))
computer_system_id = 'computer_system_id_example' # str | The value of the Id property of the ComputerSystem resource
dump_health_request_body = nvsm_sdk.DumpHealthRequestBody() # DumpHealthRequestBody | 

try:
    api_response = api_instance.nvsm_v1_systems_computer_system_id_actions_computer_system_oem_collect_dump_health_post(computer_system_id, dump_health_request_body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DefaultApi->nvsm_v1_systems_computer_system_id_actions_computer_system_oem_collect_dump_health_post: %s\n" % e)
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **computer_system_id** | **str**| The value of the Id property of the ComputerSystem resource | 
 **dump_health_request_body** | [**DumpHealthRequestBody**](DumpHealthRequestBody.md)|  | 

### Return type

[**Task**](Task.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **nvsm_v1_systems_computer_system_id_actions_computer_system_oem_collect_dump_post**
> Task nvsm_v1_systems_computer_system_id_actions_computer_system_oem_collect_dump_post(computer_system_id, dump_request_body)



### Example

* Api Key Authentication (bearerAuth): 

```python
from __future__ import print_function
import time
import nvsm_sdk
from nvsm_sdk.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerAuth
configuration = nvsm_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = nvsm_sdk.DefaultApi(nvsm_sdk.ApiClient(configuration))
computer_system_id = 'computer_system_id_example' # str | The value of the Id property of the ComputerSystem resource
dump_request_body = nvsm_sdk.DumpRequestBody() # DumpRequestBody | 

try:
    api_response = api_instance.nvsm_v1_systems_computer_system_id_actions_computer_system_oem_collect_dump_post(computer_system_id, dump_request_body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DefaultApi->nvsm_v1_systems_computer_system_id_actions_computer_system_oem_collect_dump_post: %s\n" % e)
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **computer_system_id** | **str**| The value of the Id property of the ComputerSystem resource | 
 **dump_request_body** | [**DumpRequestBody**](DumpRequestBody.md)|  | 

### Return type

[**Task**](Task.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **redfish_v1_chassis_chassis_id_power_patch**
> Power redfish_v1_chassis_chassis_id_power_patch(chassis_id, power)



### Example

* Api Key Authentication (bearerAuth): 

```python
from __future__ import print_function
import time
import nvsm_sdk
from nvsm_sdk.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerAuth
configuration = nvsm_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = nvsm_sdk.DefaultApi(nvsm_sdk.ApiClient(configuration))
chassis_id = 'chassis_id_example' # str | The value of the Id property of the Chassis resource
power = nvsm_sdk.Power() # Power | 

try:
    api_response = api_instance.redfish_v1_chassis_chassis_id_power_patch(chassis_id, power)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DefaultApi->redfish_v1_chassis_chassis_id_power_patch: %s\n" % e)
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **chassis_id** | **str**| The value of the Id property of the Chassis resource | 
 **power** | [**Power**](Power.md)|  | 

### Return type

[**Power**](Power.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **redfish_v1_task_service_get**
> TaskService redfish_v1_task_service_get()



### Example

* Api Key Authentication (bearerAuth): 

```python
from __future__ import print_function
import time
import nvsm_sdk
from nvsm_sdk.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerAuth
configuration = nvsm_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = nvsm_sdk.DefaultApi(nvsm_sdk.ApiClient(configuration))

try:
    api_response = api_instance.redfish_v1_task_service_get()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DefaultApi->redfish_v1_task_service_get: %s\n" % e)
```


### Parameters
This endpoint does not need any parameter.

### Return type

[**TaskService**](TaskService.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **redfish_v1_task_service_patch**
> TaskService redfish_v1_task_service_patch(task_service)



### Example

* Api Key Authentication (bearerAuth): 

```python
from __future__ import print_function
import time
import nvsm_sdk
from nvsm_sdk.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerAuth
configuration = nvsm_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = nvsm_sdk.DefaultApi(nvsm_sdk.ApiClient(configuration))
task_service = nvsm_sdk.TaskService() # TaskService | 

try:
    api_response = api_instance.redfish_v1_task_service_patch(task_service)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DefaultApi->redfish_v1_task_service_patch: %s\n" % e)
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **task_service** | [**TaskService**](TaskService.md)|  | 

### Return type

[**TaskService**](TaskService.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **redfish_v1_task_service_put**
> TaskService redfish_v1_task_service_put(task_service)



### Example

* Api Key Authentication (bearerAuth): 

```python
from __future__ import print_function
import time
import nvsm_sdk
from nvsm_sdk.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerAuth
configuration = nvsm_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = nvsm_sdk.DefaultApi(nvsm_sdk.ApiClient(configuration))
task_service = nvsm_sdk.TaskService() # TaskService | 

try:
    api_response = api_instance.redfish_v1_task_service_put(task_service)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DefaultApi->redfish_v1_task_service_put: %s\n" % e)
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **task_service** | [**TaskService**](TaskService.md)|  | 

### Return type

[**TaskService**](TaskService.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **redfish_v1_task_service_tasks_get**
> TaskCollection redfish_v1_task_service_tasks_get()



### Example

* Api Key Authentication (bearerAuth): 

```python
from __future__ import print_function
import time
import nvsm_sdk
from nvsm_sdk.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerAuth
configuration = nvsm_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = nvsm_sdk.DefaultApi(nvsm_sdk.ApiClient(configuration))

try:
    api_response = api_instance.redfish_v1_task_service_tasks_get()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DefaultApi->redfish_v1_task_service_tasks_get: %s\n" % e)
```


### Parameters
This endpoint does not need any parameter.

### Return type

[**TaskCollection**](TaskCollection.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **redfish_v1_task_service_tasks_task_id_delete**
> Task2 redfish_v1_task_service_tasks_task_id_delete(task_id)



### Example

* Api Key Authentication (bearerAuth): 

```python
from __future__ import print_function
import time
import nvsm_sdk
from nvsm_sdk.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerAuth
configuration = nvsm_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = nvsm_sdk.DefaultApi(nvsm_sdk.ApiClient(configuration))
task_id = 'task_id_example' # str | The value of the Id property of the Task resource

try:
    api_response = api_instance.redfish_v1_task_service_tasks_task_id_delete(task_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DefaultApi->redfish_v1_task_service_tasks_task_id_delete: %s\n" % e)
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **task_id** | **str**| The value of the Id property of the Task resource | 

### Return type

[**Task2**](Task2.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **redfish_v1_task_service_tasks_task_id_get**
> Task2 redfish_v1_task_service_tasks_task_id_get(task_id)



### Example

* Api Key Authentication (bearerAuth): 

```python
from __future__ import print_function
import time
import nvsm_sdk
from nvsm_sdk.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerAuth
configuration = nvsm_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = nvsm_sdk.DefaultApi(nvsm_sdk.ApiClient(configuration))
task_id = 'task_id_example' # str | The value of the Id property of the Task resource

try:
    api_response = api_instance.redfish_v1_task_service_tasks_task_id_get(task_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DefaultApi->redfish_v1_task_service_tasks_task_id_get: %s\n" % e)
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **task_id** | **str**| The value of the Id property of the Task resource | 

### Return type

[**Task2**](Task2.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

