# Drive

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**odata_context** | **str** | The OData description of a payload. | [optional] 
**odata_etag** | **str** | The current ETag of the resource. | [optional] 
**odata_id** | **str** | The unique identifier for a resource. | 
**odata_type** | **str** | The type of a resource. | 
**actions** | [**Actions2**](Actions2.md) |  | [optional] 
**assembly** | [**IdRef**](IdRef.md) |  | [optional] 
**asset_tag** | **str** | The user assigned asset tag for this drive. | [optional] 
**block_size_bytes** | **int** | The size of the smallest addressible unit (Block) of this drive in bytes. | [optional] 
**capable_speed_gbs** | **float** | The speed which this drive can communicate to a storage controller in ideal conditions in Gigabits per second. | [optional] 
**capacity_bytes** | **int** | The size in bytes of this Drive. | [optional] 
**description** | **str** | The description of this resource.  Used for commonality in the schema definitions. | [optional] 
**encryption_ability** | [**EncryptionAbility**](EncryptionAbility.md) |  | [optional] 
**encryption_status** | [**EncryptionStatus**](EncryptionStatus.md) |  | [optional] 
**failure_predicted** | **bool** | Is this drive currently predicting a failure in the near future. | [optional] 
**hotspare_replacement_mode** | [**HotspareReplacementModeType**](HotspareReplacementModeType.md) |  | [optional] 
**hotspare_type** | [**HotspareType**](HotspareType.md) |  | [optional] 
**id** | **str** | The identifier that uniquely identifies the resource within the collection of similar resources. | 
**identifiers** | [**list[Identifier]**](Identifier.md) | The Durable names for the drive. | [optional] 
**indicator_led** | [**IndicatorLED2**](IndicatorLED2.md) |  | [optional] 
**links** | [**Links2**](Links2.md) |  | [optional] 
**location** | [**list[Location]**](Location.md) | The Location of the drive. | [optional] 
**manufacturer** | **str** | This is the manufacturer of this drive. | [optional] 
**media_type** | [**MediaType**](MediaType.md) |  | [optional] 
**model** | **str** | This is the model number for the drive. | [optional] 
**name** | **str** | The name of the resource or array member. | 
**negotiated_speed_gbs** | **float** | The speed which this drive is currently communicating to the storage controller in Gigabits per second. | [optional] 
**oem** | **dict(str, object)** | The OEM extension. | [optional] 
**operations** | [**list[Operations]**](Operations.md) | The operations currently running on the Drive. | [optional] 
**part_number** | **str** | The part number for this drive. | [optional] 
**physical_location** | [**Location**](Location.md) |  | [optional] 
**predicted_media_life_left_percent** | **float** | The percentage of reads and writes that are predicted to still be available for the media. | [optional] 
**protocol** | [**IdRef**](IdRef.md) |  | [optional] 
**revision** | **str** | The revision of this Drive. This is typically the firmware/hardware version of the drive. | [optional] 
**rotation_speed_rpm** | **float** | The rotation speed of this Drive in Revolutions per Minute (RPM). | [optional] 
**sku** | **str** | This is the SKU for this drive. | [optional] 
**serial_number** | **str** | The serial number for this drive. | [optional] 
**status** | [**Status**](Status.md) |  | [optional] 
**status_indicator** | [**StatusIndicator**](StatusIndicator.md) |  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


