# EthernetInterface

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**odata_context** | **str** | The OData description of a payload. | [optional] 
**odata_etag** | **str** | The current ETag of the resource. | [optional] 
**odata_id** | **str** | The unique identifier for a resource. | 
**odata_type** | **str** | The type of a resource. | 
**actions** | [**Actions2**](Actions2.md) |  | [optional] 
**auto_neg** | **bool** | This indicates if the speed and duplex are automatically negotiated and configured on this interface. | [optional] 
**dhc_pv4** | [**DHCPv4Configuration**](DHCPv4Configuration.md) |  | [optional] 
**dhc_pv6** | [**DHCPv6Configuration**](DHCPv6Configuration.md) |  | [optional] 
**description** | **str** | The description of this resource.  Used for commonality in the schema definitions. | [optional] 
**fqdn** | **str** | This is the complete, fully qualified domain name obtained by DNS for this interface. | [optional] 
**full_duplex** | **bool** | This indicates if the interface is in Full Duplex mode or not. | [optional] 
**host_name** | **str** | The DNS Host Name, without any domain information. | [optional] 
**i_pv4_addresses** | [**list[IPv4Address]**](IPv4Address.md) | The IPv4 addresses currently assigned to this interface. | [optional] 
**i_pv4_static_addresses** | [**list[IPv4Address]**](IPv4Address.md) | The IPv4 static addresses assigned to this interface. | [optional] 
**i_pv6_address_policy_table** | [**list[IPv6AddressPolicyEntry]**](IPv6AddressPolicyEntry.md) | An array representing the RFC 6724 Address Selection Policy Table. | [optional] 
**i_pv6_addresses** | [**list[IPv6Address]**](IPv6Address.md) | Enumerates in an array all of the currently assigned IPv6 addresses on this interface. | [optional] 
**i_pv6_default_gateway** | **str** | This is the IPv6 default gateway address that is currently in use on this interface. | [optional] 
**i_pv6_static_addresses** | [**list[IPv6StaticAddress]**](IPv6StaticAddress.md) | Represents in an array all of the IPv6 static addresses to be assigned on this interface. | [optional] 
**i_pv6_static_default_gateways** | [**list[IPv6GatewayStaticAddress]**](IPv6GatewayStaticAddress.md) | The IPv6 static default gateways for this interface. | [optional] 
**id** | **str** | The identifier that uniquely identifies the resource within the collection of similar resources. | 
**interface_enabled** | **bool** | This indicates whether this interface is enabled. | [optional] 
**link_status** | [**LinkStatus2**](LinkStatus2.md) |  | [optional] 
**links** | [**Links2**](Links2.md) |  | [optional] 
**mac_address** | **str** |  | [optional] 
**mtu_size** | **int** | This is the currently configured Maximum Transmission Unit (MTU) in bytes on this interface. | [optional] 
**max_i_pv6_static_addresses** | **int** | This indicates the maximum number of Static IPv6 addresses that can be configured on this interface. | [optional] 
**name** | **str** | The name of the resource or array member. | 
**name_servers** | **list[str]** | This represents DNS name servers that are currently in use on this interface. | [optional] 
**oem** | **dict(str, object)** | The OEM extension. | [optional] 
**permanent_mac_address** | **str** |  | [optional] 
**speed_mbps** | **int** | This is the current speed in Mbps of this interface. | [optional] 
**stateless_address_auto_config** | [**StatelessAddressAutoConfiguration**](StatelessAddressAutoConfiguration.md) |  | [optional] 
**static_name_servers** | **list[str]** | A statically defined set of DNS server IP addresses (both IPv4 and IPv6). | [optional] 
**status** | [**Status**](Status.md) |  | [optional] 
**uefi_device_path** | **str** | The UEFI device path for this interface. | [optional] 
**vlan** | [**VLAN**](VLAN.md) |  | [optional] 
**vla_ns** | [**IdRef2**](IdRef2.md) |  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


