# ISCSIBoot

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**authentication_method** | [**AuthenticationMethod**](AuthenticationMethod.md) |  | [optional] 
**chap_secret** | **str** | The shared secret for CHAP authentication. | [optional] 
**chap_username** | **str** | The username for CHAP authentication. | [optional] 
**ip_address_type** | [**IPAddressType**](IPAddressType.md) |  | [optional] 
**ip_mask_dns_via_dhcp** | **bool** | Whether the iSCSI boot initiator uses DHCP to obtain the iniator name, IP address, and netmask. | [optional] 
**initiator_default_gateway** | **str** | The IPv6 or IPv4 iSCSI boot default gateway. | [optional] 
**initiator_ip_address** | **str** | The IPv6 or IPv4 address of the iSCSI initiator. | [optional] 
**initiator_name** | **str** | The iSCSI initiator name. | [optional] 
**initiator_netmask** | **str** | The IPv6 or IPv4 netmask of the iSCSI boot initiator. | [optional] 
**mutual_chap_secret** | **str** | The CHAP Secret for 2-way CHAP authentication. | [optional] 
**mutual_chap_username** | **str** | The CHAP Username for 2-way CHAP authentication. | [optional] 
**primary_dns** | **str** | The IPv6 or IPv4 address of the primary DNS server for the iSCSI boot initiator. | [optional] 
**primary_lun** | **int** | The logical unit number (LUN) for the primary iSCSI boot target. | [optional] 
**primary_target_ip_address** | **str** | The IP address (IPv6 or IPv4) for the primary iSCSI boot target. | [optional] 
**primary_target_name** | **str** | The name of the iSCSI primary boot target. | [optional] 
**primary_target_tcp_port** | **int** | The TCP port for the primary iSCSI boot target. | [optional] 
**primary_vlan_enable** | **bool** | This indicates if the primary VLAN is enabled. | [optional] 
**primary_vlan_id** | **int** | The 802.1q VLAN ID to use for iSCSI boot from the primary target. | [optional] 
**router_advertisement_enabled** | **bool** | Whether IPv6 router advertisement is enabled for the iSCSI boot target. | [optional] 
**secondary_dns** | **str** | The IPv6 or IPv4 address of the secondary DNS server for the iSCSI boot initiator. | [optional] 
**secondary_lun** | **int** | The logical unit number (LUN) for the secondary iSCSI boot target. | [optional] 
**secondary_target_ip_address** | **str** | The IP address (IPv6 or IPv4) for the secondary iSCSI boot target. | [optional] 
**secondary_target_name** | **str** | The name of the iSCSI secondary boot target. | [optional] 
**secondary_target_tcp_port** | **int** | The TCP port for the secondary iSCSI boot target. | [optional] 
**secondary_vlan_enable** | **bool** | This indicates if the secondary VLAN is enabled. | [optional] 
**secondary_vlan_id** | **int** | The 802.1q VLAN ID to use for iSCSI boot from the secondary target. | [optional] 
**target_info_via_dhcp** | **bool** | Whether the iSCSI boot target name, LUN, IP address, and netmask should be obtained from DHCP. | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


