# Manager

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**odata_context** | **str** | The OData description of a payload. | [optional] 
**odata_etag** | **str** | The current ETag of the resource. | [optional] 
**odata_id** | **str** | The unique identifier for a resource. | 
**odata_type** | **str** | The type of a resource. | 
**actions** | [**Actions2**](Actions2.md) |  | [optional] 
**auto_dst_enabled** | **bool** | Indicates whether the manager is configured for automatic DST adjustment. | [optional] 
**command_shell** | [**CommandShell**](CommandShell.md) |  | [optional] 
**date_time** | **datetime** | The current DateTime (with offset) for the manager, used to set or read time. | [optional] 
**date_time_local_offset** | **str** | The time offset from UTC that the DateTime property is set to in format: +06:00 . | [optional] 
**description** | **str** | The description of this resource.  Used for commonality in the schema definitions. | [optional] 
**ethernet_interfaces** | [**IdRef2**](IdRef2.md) |  | [optional] 
**firmware_version** | **str** | The firmware version of this Manager. | [optional] 
**graphical_console** | [**GraphicalConsole**](GraphicalConsole.md) |  | [optional] 
**host_interfaces** | [**IdRef2**](IdRef2.md) |  | [optional] 
**id** | **str** | The identifier that uniquely identifies the resource within the collection of similar resources. | 
**links** | [**Links2**](Links2.md) |  | [optional] 
**log_services** | [**IdRef2**](IdRef2.md) |  | [optional] 
**manager_type** | [**ManagerType**](ManagerType.md) |  | [optional] 
**model** | **str** | The model information of this Manager as defined by the manufacturer. | [optional] 
**name** | **str** | The name of the resource or array member. | 
**network_protocol** | [**IdRef2**](IdRef2.md) |  | [optional] 
**oem** | **dict(str, object)** | The OEM extension. | [optional] 
**power_state** | [**PowerState2**](PowerState2.md) |  | [optional] 
**redundancy** | [**list[IdRef2]**](IdRef2.md) | Redundancy information for the managers of this system. | [optional] 
**redundancyodata_count** | **int** | The number of items in a collection. | [optional] 
**remote_account_service** | [**IdRef2**](IdRef2.md) |  | [optional] 
**remote_redfish_service_uri** | **str** | This property contains the URI of the Redfish Service Root for the remote Manager represented by this resource. | [optional] 
**serial_console** | [**SerialConsole**](SerialConsole.md) |  | [optional] 
**serial_interfaces** | [**IdRef2**](IdRef2.md) |  | [optional] 
**service_entry_point_uuid** | **str** |  | [optional] 
**status** | [**Status**](Status.md) |  | [optional] 
**uuid** | **str** |  | [optional] 
**virtual_media** | [**IdRef2**](IdRef2.md) |  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


