# Memory

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**odata_context** | **str** | The OData description of a payload. | [optional] 
**odata_etag** | **str** | The current ETag of the resource. | [optional] 
**odata_id** | **str** | The unique identifier for a resource. | 
**odata_type** | **str** | The type of a resource. | 
**actions** | [**Actions2**](Actions2.md) |  | [optional] 
**allocation_alignment_mi_b** | **int** | The boundary which memory regions are allocated on, measured in mebibytes (MiB). | [optional] 
**allocation_increment_mi_b** | **int** | The size of the smallest unit of allocation for a memory region in mebibytes (MiB). | [optional] 
**allowed_speeds_m_hz** | **list[int]** | Speed bins supported by this Memory. | [optional] 
**assembly** | [**IdRef**](IdRef.md) |  | [optional] 
**base_module_type** | [**BaseModuleType**](BaseModuleType.md) |  | [optional] 
**bus_width_bits** | **int** | Bus Width in bits. | [optional] 
**cache_size_mi_b** | **int** | Total size of the cache portion memory in MiB. | [optional] 
**capacity_mi_b** | **int** | Memory Capacity in mebibytes (MiB). | [optional] 
**configuration_locked** | **bool** | Indicates that the configuration of this memory has been locked. | [optional] 
**data_width_bits** | **int** | Data Width in bits. | [optional] 
**description** | **str** | The description of this resource.  Used for commonality in the schema definitions. | [optional] 
**device_id** | **str** | Device ID. | [optional] 
**device_locator** | **str** | Location of the Memory in the platform. | [optional] 
**error_correction** | [**ErrorCorrection**](ErrorCorrection.md) |  | [optional] 
**firmware_api_version** | **str** | Version of API supported by the firmware. | [optional] 
**firmware_revision** | **str** | Revision of firmware on the Memory controller. | [optional] 
**function_classes** | **list[str]** | Function Classes by the Memory. | [optional] 
**id** | **str** | The identifier that uniquely identifies the resource within the collection of similar resources. | 
**is_rank_spare_enabled** | **bool** | Rank spare enabled status. | [optional] 
**is_spare_device_enabled** | **bool** | Spare device enabled status. | [optional] 
**links** | [**Links2**](Links2.md) |  | [optional] 
**location** | [**Location**](Location.md) |  | [optional] 
**logical_size_mi_b** | **int** | Total size of the logical memory in MiB. | [optional] 
**manufacturer** | **str** | The Memory manufacturer. | [optional] 
**max_tdp_milli_watts** | **list[int]** | Maximum TDPs in milli Watts. | [optional] 
**memory_device_type** | [**MemoryDeviceType**](MemoryDeviceType.md) |  | [optional] 
**memory_location** | [**MemoryLocation**](MemoryLocation.md) |  | [optional] 
**memory_media** | [**list[MemoryMedia]**](MemoryMedia.md) | Media of this Memory. | [optional] 
**memory_subsystem_controller_manufacturer_id** | **str** | The manufacturer ID of the memory subsystem controller of this memory module. | [optional] 
**memory_subsystem_controller_product_id** | **str** | The product ID of the memory subsystem controller of this memory module. | [optional] 
**memory_type** | [**MemoryType**](MemoryType.md) |  | [optional] 
**metrics** | [**IdRef**](IdRef.md) |  | [optional] 
**module_manufacturer_id** | **str** | The manufacturer ID of this memory module. | [optional] 
**module_product_id** | **str** | The product ID of this memory module. | [optional] 
**name** | **str** | The name of the resource or array member. | 
**non_volatile_size_mi_b** | **int** | Total size of the non-volatile portion memory in MiB. | [optional] 
**oem** | **dict(str, object)** | The OEM extension. | [optional] 
**operating_memory_modes** | [**list[OperatingMemoryModes]**](OperatingMemoryModes.md) | Memory modes supported by the Memory. | [optional] 
**operating_speed_mhz** | **int** | Operating speed of Memory in MHz or MT/s as appropriate. | [optional] 
**part_number** | **str** | The product part number of this device. | [optional] 
**persistent_region_number_limit** | **int** | Total number of persistent regions this Memory can support. | [optional] 
**persistent_region_size_limit_mi_b** | **int** | Total size of persistent regions in mebibytes (MiB). | [optional] 
**persistent_region_size_max_mi_b** | **int** | Maximum size of a single persistent region in mebibytes (MiB). | [optional] 
**power_management_policy** | [**PowerManagementPolicy**](PowerManagementPolicy.md) |  | [optional] 
**rank_count** | **int** | Number of ranks available in the Memory. | [optional] 
**regions** | [**list[RegionSet]**](RegionSet.md) | Memory regions information within the Memory. | [optional] 
**security_capabilities** | [**SecurityCapabilities**](SecurityCapabilities.md) |  | [optional] 
**security_state** | [**SecurityStates**](SecurityStates.md) |  | [optional] 
**serial_number** | **str** | The product serial number of this device. | [optional] 
**spare_device_count** | **int** | Number of unused spare devices available in the Memory. | [optional] 
**status** | [**Status**](Status.md) |  | [optional] 
**subsystem_device_id** | **str** | Subsystem Device ID. | [optional] 
**subsystem_vendor_id** | **str** | SubSystem Vendor ID. | [optional] 
**vendor_id** | **str** | Vendor ID. | [optional] 
**volatile_region_number_limit** | **int** | Total number of volatile regions this Memory can support. | [optional] 
**volatile_region_size_limit_mi_b** | **int** | Total size of volatile regions in mebibytes (MiB). | [optional] 
**volatile_region_size_max_mi_b** | **int** | Maximum size of a single volatile region in mebibytes (MiB). | [optional] 
**volatile_size_mi_b** | **int** | Total size of the volitile portion memory in MiB. | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


