# NetworkPort

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**odata_context** | **str** | The OData description of a payload. | [optional] 
**odata_etag** | **str** | The current ETag of the resource. | [optional] 
**odata_id** | **str** | The unique identifier for a resource. | 
**odata_type** | **str** | The type of a resource. | 
**actions** | [**Actions2**](Actions2.md) |  | [optional] 
**active_link_technology** | [**LinkNetworkTechnology**](LinkNetworkTechnology.md) |  | [optional] 
**associated_network_addresses** | **list[str]** | The array of configured network addresses (MAC or WWN) that are associated with this Network Port, including the programmed address of the lowest numbered Network Device Function, the configured but not active address if applicable, the address for hardware port teaming, or other network addresses. | [optional] 
**current_link_speed_mbps** | **int** | Network Port Current Link Speed. | [optional] 
**description** | **str** | The description of this resource.  Used for commonality in the schema definitions. | [optional] 
**eee_enabled** | **bool** | Whether IEEE 802.3az Energy Efficient Ethernet (EEE) is enabled for this network port. | [optional] 
**fc_fabric_name** | **str** | The FC Fabric Name provided by the switch. | [optional] 
**fc_port_connection_type** | [**PortConnectionType**](PortConnectionType.md) |  | [optional] 
**flow_control_configuration** | [**FlowControl**](FlowControl.md) |  | [optional] 
**flow_control_status** | [**FlowControl**](FlowControl.md) |  | [optional] 
**id** | **str** | The identifier that uniquely identifies the resource within the collection of similar resources. | 
**link_status** | [**LinkStatus**](LinkStatus.md) |  | [optional] 
**max_frame_size** | **int** | The maximum frame size supported by the port. | [optional] 
**name** | **str** | The name of the resource or array member. | 
**net_dev_func_max_bw_alloc** | [**list[NetDevFuncMaxBWAlloc]**](NetDevFuncMaxBWAlloc.md) | The array of maximum bandwidth allocation percentages for the Network Device Functions associated with this port. | [optional] 
**net_dev_func_min_bw_alloc** | [**list[NetDevFuncMinBWAlloc]**](NetDevFuncMinBWAlloc.md) | The array of minimum bandwidth allocation percentages for the Network Device Functions associated with this port. | [optional] 
**number_discovered_remote_ports** | **int** | The number of ports not on this adapter that this port has discovered. | [optional] 
**oem** | **dict(str, object)** | The OEM extension. | [optional] 
**physical_port_number** | **str** | The physical port number label for this port. | [optional] 
**port_maximum_mtu** | **int** | The largest maximum transmission unit (MTU) that can be configured for this network port. | [optional] 
**signal_detected** | **bool** | Whether or not the port has detected enough signal on enough lanes to establish link. | [optional] 
**status** | [**Status**](Status.md) |  | [optional] 
**supported_ethernet_capabilities** | [**list[SupportedEthernetCapabilities]**](SupportedEthernetCapabilities.md) | The set of Ethernet capabilities that this port supports. | [optional] 
**supported_link_capabilities** | [**list[SupportedLinkCapabilities]**](SupportedLinkCapabilities.md) | The self-described link capabilities of this port. | [optional] 
**vendor_id** | **str** | The Vendor Identification for this port. | [optional] 
**wake_on_lan_enabled** | **bool** | Whether Wake on LAN (WoL) is enabled for this network port. | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


