# PowerControl

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**odata_id** | **str** | The unique identifier for a resource. | 
**actions** | [**PowerControlActions**](PowerControlActions.md) |  | [optional] 
**member_id** | **str** | This is the identifier for the member within the collection. | 
**name** | **str** | Power Control Function name. | [optional] 
**oem** | **dict(str, object)** | The OEM extension. | [optional] 
**physical_context** | [**IdRef**](IdRef.md) |  | [optional] 
**power_allocated_watts** | **float** | The total amount of power that has been allocated (or budegeted)to  chassis resources. | [optional] 
**power_available_watts** | **float** | The amount of power not already budgeted and therefore available for additional allocation. (powerCapacity - powerAllocated).  This indicates how much reserve power capacity is left. | [optional] 
**power_capacity_watts** | **float** | The total amount of power available to the chassis for allocation. This may the power supply capacity, or power budget assigned to the chassis from an up-stream chassis. | [optional] 
**power_consumed_watts** | **float** | The actual power being consumed by the chassis. | [optional] 
**power_limit** | [**PowerLimit**](PowerLimit.md) |  | [optional] 
**power_metrics** | [**PowerMetric**](PowerMetric.md) |  | [optional] 
**power_requested_watts** | **float** | The potential power that the chassis resources are requesting which may be higher than the current level being consumed since requested power includes budget that the chassis resource wants for future use. | [optional] 
**related_item** | [**list[IdRef]**](IdRef.md) | The ID(s) of the resources associated with this Power Limit. | [optional] 
**related_itemodata_count** | **int** | The number of items in a collection. | [optional] 
**status** | [**Status**](Status.md) |  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


