# PowerSupply

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**odata_id** | **str** | The unique identifier for a resource. | 
**actions** | [**PowerSupplyActions**](PowerSupplyActions.md) |  | [optional] 
**assembly** | [**IdRef**](IdRef.md) |  | [optional] 
**efficiency_percent** | **float** | The measured efficiency of this Power Supply as a percentage. | [optional] 
**firmware_version** | **str** | The firmware version for this Power Supply. | [optional] 
**hot_pluggable** | **bool** | Indicates if this device can be inserted or removed while the equipment is in operation. | [optional] 
**indicator_led** | [**IndicatorLED2**](IndicatorLED2.md) |  | [optional] 
**input_ranges** | [**list[InputRange]**](InputRange.md) | This is the input ranges that the power supply can use. | [optional] 
**last_power_output_watts** | **float** | The average power output of this Power Supply. | [optional] 
**line_input_voltage** | **float** | The line input voltage at which the Power Supply is operating. | [optional] 
**line_input_voltage_type** | [**LineInputVoltageType**](LineInputVoltageType.md) |  | [optional] 
**location** | [**Location**](Location.md) |  | [optional] 
**manufacturer** | **str** | This is the manufacturer of this power supply. | [optional] 
**member_id** | **str** | This is the identifier for the member within the collection. | 
**model** | **str** | The model number for this Power Supply. | [optional] 
**name** | **str** | The name of the Power Supply. | [optional] 
**oem** | **dict(str, object)** | The OEM extension. | [optional] 
**part_number** | **str** | The part number for this Power Supply. | [optional] 
**power_capacity_watts** | **float** | The maximum capacity of this Power Supply. | [optional] 
**power_input_watts** | **float** | The measured input power of this Power Supply. | [optional] 
**power_output_watts** | **float** | The measured output power of this Power Supply. | [optional] 
**power_supply_type** | [**PowerSupplyType**](PowerSupplyType.md) |  | [optional] 
**redundancy** | [**list[IdRef]**](IdRef.md) | This structure is used to show redundancy for power supplies.  The Component ids will reference the members of the redundancy groups. | [optional] 
**redundancyodata_count** | **int** | The number of items in a collection. | [optional] 
**related_item** | [**list[IdRef]**](IdRef.md) | The ID(s) of the resources associated with this Power Limit. | [optional] 
**related_itemodata_count** | **int** | The number of items in a collection. | [optional] 
**serial_number** | **str** | The serial number for this Power Supply. | [optional] 
**spare_part_number** | **str** | The spare part number for this Power Supply. | [optional] 
**status** | [**Status**](Status.md) |  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


