# Processor

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**odata_context** | **str** | The OData description of a payload. | [optional] 
**odata_etag** | **str** | The current ETag of the resource. | [optional] 
**odata_id** | **str** | The unique identifier for a resource. | 
**odata_type** | **str** | The type of a resource. | 
**acceleration_functions** | [**IdRef**](IdRef.md) |  | [optional] 
**actions** | [**Actions2**](Actions2.md) |  | [optional] 
**assembly** | [**IdRef**](IdRef.md) |  | [optional] 
**description** | **str** | The description of this resource.  Used for commonality in the schema definitions. | [optional] 
**fpga** | [**FPGA**](FPGA.md) |  | [optional] 
**id** | **str** | The identifier that uniquely identifies the resource within the collection of similar resources. | 
**instruction_set** | [**InstructionSet**](InstructionSet.md) |  | [optional] 
**links** | [**Links2**](Links2.md) |  | [optional] 
**location** | [**Location**](Location.md) |  | [optional] 
**manufacturer** | **str** | The processor manufacturer. | [optional] 
**max_speed_m_hz** | **int** | The maximum clock speed of the processor. | [optional] 
**max_tdp_watts** | **int** | The maximum Thermal Design Power (TDP) in watts. | [optional] 
**metrics** | [**IdRef**](IdRef.md) |  | [optional] 
**model** | **str** | The product model number of this device. | [optional] 
**name** | **str** | The name of the resource or array member. | 
**oem** | **dict(str, object)** | The OEM extension. | [optional] 
**processor_architecture** | [**ProcessorArchitecture**](ProcessorArchitecture.md) |  | [optional] 
**processor_id** | [**ProcessorId**](ProcessorId.md) |  | [optional] 
**processor_memory** | [**list[ProcessorMemory]**](ProcessorMemory.md) | The memory directly attached or integrated witin this Procesor. | [optional] 
**processor_type** | [**ProcessorType**](ProcessorType.md) |  | [optional] 
**socket** | **str** | The socket or location of the processor. | [optional] 
**status** | [**Status**](Status.md) |  | [optional] 
**sub_processors** | [**IdRef**](IdRef.md) |  | [optional] 
**tdp_watts** | **int** | The nominal Thermal Design Power (TDP) in watts. | [optional] 
**total_cores** | **int** | The total number of cores contained in this processor. | [optional] 
**total_threads** | **int** | The total number of execution threads supported by this processor. | [optional] 
**uuid** | **str** |  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


