# Stats

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**bar1_memory_usage** | [**ResourceUsage**](ResourceUsage.md) |  | 
**error_stats** | [**ErrorStat**](ErrorStat.md) |  | 
**frame_buffer_memory_usage** | [**ResourceUsage**](ResourceUsage.md) |  | 
**nvlink_counters_per_link** | [**list[NvlinkCounters]**](NvlinkCounters.md) | NVLink related metrics for this GPU. | 
**pc_ie_replay_counter** | **int** | This is the internal counter that records various errors on the PCIe bus. | 
**pc_ie_rx_throughput** | **str** | The GPU-centric receive throughput across the PCIe bus in MB/s over the past 20ms. Only supported on Maxwell architectures and newer. | 
**pc_ie_tx_throughput** | **str** | The GPU-centric transmission throughput across the PCIe bus in MB/s over the past 20ms. Only supported on Maxwell architectures and newer. | 
**performance_state** | **str** | The current performance state for the GPU. States range from P0 (maximum performance) to P12 (minimum performance). | 
**gpu_throttle_reasons** | [**GPUThrottleReasons**](GPUThrottleReasons.md) |  | 
**usage_memory_fb** | **str** | Usage Memory Frame Buffer. | 
**user_processes** | [**list[GPUProcess]**](GPUProcess.md) | List of processes having Compute or Graphics Context on the device. | 
**util_decoder** | **str** | Percent of time over the past sample period during which the GPU\\xe2\\x80\\x99s video decoder was being used. | 
**util_encoder** | **str** | Percent of time over the past sample period during which the GPU video encoder was being used. | 
**util_gpu** | **str** | Percent of time over the past sample period during which one or more kernels was executing on the GPU. The sample period may be between 1 second and 1/6 second depending on the product. | 
**util_memory** | **str** | Percent of time over the past sample period during which global (device) memory was being read or written. The sample period may be between 1 second and 1/6 second depending on the product. | 
**violations** | [**Violations**](Violations.md) |  | 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


