# Temperature

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**odata_id** | **str** | The unique identifier for a resource. | 
**actions** | [**TemperatureActions**](TemperatureActions.md) |  | [optional] 
**adjusted_max_allowable_operating_value** | **int** | Adjusted maximum allowable operating temperature for this equipment based on the current environmental conditions present. | [optional] 
**adjusted_min_allowable_operating_value** | **int** | Adjusted minimum allowable operating temperature for this equipment based on the current environmental conditions present. | [optional] 
**delta_physical_context** | [**IdRef**](IdRef.md) |  | [optional] 
**delta_reading_celsius** | **float** | Delta Temperature reading. | [optional] 
**lower_threshold_critical** | **float** | Below normal range but not yet fatal. | [optional] 
**lower_threshold_fatal** | **float** | Below normal range and is fatal. | [optional] 
**lower_threshold_non_critical** | **float** | Below normal range. | [optional] 
**max_allowable_operating_value** | **int** | Maximum allowable operating temperature for this equipment. | [optional] 
**max_reading_range_temp** | **float** | Maximum value for ReadingCelsius. | [optional] 
**member_id** | **str** | This is the identifier for the member within the collection. | 
**min_allowable_operating_value** | **int** | Minimum allowable operating temperature for this equipment. | [optional] 
**min_reading_range_temp** | **float** | Minimum value for ReadingCelsius. | [optional] 
**name** | **str** | Temperature sensor name. | [optional] 
**oem** | **dict(str, object)** | The OEM extension. | [optional] 
**physical_context** | [**IdRef**](IdRef.md) |  | [optional] 
**reading_celsius** | **float** | Temperature. | [optional] 
**related_item** | [**list[IdRef]**](IdRef.md) | Describes the areas or devices to which this temperature measurement applies. | [optional] 
**related_itemodata_count** | **int** | The number of items in a collection. | [optional] 
**sensor_number** | **int** | A numerical identifier to represent the temperature sensor. | [optional] 
**status** | [**Status**](Status.md) |  | [optional] 
**upper_threshold_critical** | **float** | Above normal range but not yet fatal. | [optional] 
**upper_threshold_fatal** | **float** | Above normal range and is fatal. | [optional] 
**upper_threshold_non_critical** | **float** | Above normal range. | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


