# coding: utf-8

"""
    NVSM

    System Management APIs for NVIDIA Enterprise Servers  # noqa: E501

    OpenAPI spec version: 21.05.11
    Contact: dgx-sw-support@nvidia.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from nvsm_sdk.api_client import ApiClient


class RedfishApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def nvsm_v1_jobs_job_id_get(self, job_id, **kwargs):  # noqa: E501
        """nvsm_v1_jobs_job_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.nvsm_v1_jobs_job_id_get(job_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str job_id: ID of the job whose details are expected (required)
        :return: JobStatus
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.nvsm_v1_jobs_job_id_get_with_http_info(job_id, **kwargs)  # noqa: E501
        else:
            (data) = self.nvsm_v1_jobs_job_id_get_with_http_info(job_id, **kwargs)  # noqa: E501
            return data

    def nvsm_v1_jobs_job_id_get_with_http_info(self, job_id, **kwargs):  # noqa: E501
        """nvsm_v1_jobs_job_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.nvsm_v1_jobs_job_id_get_with_http_info(job_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str job_id: ID of the job whose details are expected (required)
        :return: JobStatus
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['job_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method nvsm_v1_jobs_job_id_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'job_id' is set
        if ('job_id' not in local_var_params or
                local_var_params['job_id'] is None):
            raise ValueError("Missing the required parameter `job_id` when calling `nvsm_v1_jobs_job_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'job_id' in local_var_params:
            path_params['JobId'] = local_var_params['job_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/nvsm/v1/Jobs/{JobId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='JobStatus',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_chassis_chassis_id_actions_chassis_reset_post(self, chassis_id, reset_request_body, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_actions_chassis_reset_post  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_actions_chassis_reset_post(chassis_id, reset_request_body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param ResetRequestBody reset_request_body: (required)
        :return: RedfishError
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_chassis_chassis_id_actions_chassis_reset_post_with_http_info(chassis_id, reset_request_body, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_chassis_chassis_id_actions_chassis_reset_post_with_http_info(chassis_id, reset_request_body, **kwargs)  # noqa: E501
            return data

    def redfish_v1_chassis_chassis_id_actions_chassis_reset_post_with_http_info(self, chassis_id, reset_request_body, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_actions_chassis_reset_post  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_actions_chassis_reset_post_with_http_info(chassis_id, reset_request_body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param ResetRequestBody reset_request_body: (required)
        :return: RedfishError
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['chassis_id', 'reset_request_body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_chassis_chassis_id_actions_chassis_reset_post" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'chassis_id' is set
        if ('chassis_id' not in local_var_params or
                local_var_params['chassis_id'] is None):
            raise ValueError("Missing the required parameter `chassis_id` when calling `redfish_v1_chassis_chassis_id_actions_chassis_reset_post`")  # noqa: E501
        # verify the required parameter 'reset_request_body' is set
        if ('reset_request_body' not in local_var_params or
                local_var_params['reset_request_body'] is None):
            raise ValueError("Missing the required parameter `reset_request_body` when calling `redfish_v1_chassis_chassis_id_actions_chassis_reset_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'chassis_id' in local_var_params:
            path_params['ChassisId'] = local_var_params['chassis_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'reset_request_body' in local_var_params:
            body_params = local_var_params['reset_request_body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Chassis/{ChassisId}/Actions/Chassis.Reset', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='RedfishError',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_chassis_chassis_id_get(self, chassis_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_get(chassis_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param bool force_refresh: Force refresh
        :return: Chassis
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_chassis_chassis_id_get_with_http_info(chassis_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_chassis_chassis_id_get_with_http_info(chassis_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_chassis_chassis_id_get_with_http_info(self, chassis_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_get_with_http_info(chassis_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param bool force_refresh: Force refresh
        :return: Chassis
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['chassis_id', 'force_refresh']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_chassis_chassis_id_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'chassis_id' is set
        if ('chassis_id' not in local_var_params or
                local_var_params['chassis_id'] is None):
            raise ValueError("Missing the required parameter `chassis_id` when calling `redfish_v1_chassis_chassis_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'chassis_id' in local_var_params:
            path_params['ChassisId'] = local_var_params['chassis_id']  # noqa: E501

        query_params = []
        if 'force_refresh' in local_var_params:
            query_params.append(('ForceRefresh', local_var_params['force_refresh']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Chassis/{ChassisId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Chassis',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_chassis_chassis_id_network_adapters_get(self, chassis_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_get(chassis_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :return: NetworkAdapterCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_chassis_chassis_id_network_adapters_get_with_http_info(chassis_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_chassis_chassis_id_network_adapters_get_with_http_info(chassis_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_chassis_chassis_id_network_adapters_get_with_http_info(self, chassis_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_get_with_http_info(chassis_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :return: NetworkAdapterCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['chassis_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_chassis_chassis_id_network_adapters_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'chassis_id' is set
        if ('chassis_id' not in local_var_params or
                local_var_params['chassis_id'] is None):
            raise ValueError("Missing the required parameter `chassis_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'chassis_id' in local_var_params:
            path_params['ChassisId'] = local_var_params['chassis_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Chassis/{ChassisId}/NetworkAdapters', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkAdapterCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_get(self, chassis_id, network_adapter_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_get(chassis_id, network_adapter_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :return: NetworkAdapter
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_get_with_http_info(chassis_id, network_adapter_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_get_with_http_info(chassis_id, network_adapter_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_get_with_http_info(self, chassis_id, network_adapter_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_get_with_http_info(chassis_id, network_adapter_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :return: NetworkAdapter
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['chassis_id', 'network_adapter_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'chassis_id' is set
        if ('chassis_id' not in local_var_params or
                local_var_params['chassis_id'] is None):
            raise ValueError("Missing the required parameter `chassis_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_get`")  # noqa: E501
        # verify the required parameter 'network_adapter_id' is set
        if ('network_adapter_id' not in local_var_params or
                local_var_params['network_adapter_id'] is None):
            raise ValueError("Missing the required parameter `network_adapter_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'chassis_id' in local_var_params:
            path_params['ChassisId'] = local_var_params['chassis_id']  # noqa: E501
        if 'network_adapter_id' in local_var_params:
            path_params['NetworkAdapterId'] = local_var_params['network_adapter_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Chassis/{ChassisId}/NetworkAdapters/{NetworkAdapterId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkAdapter',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_get(self, chassis_id, network_adapter_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_get(chassis_id, network_adapter_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :return: NetworkDeviceFunctionCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_get_with_http_info(chassis_id, network_adapter_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_get_with_http_info(chassis_id, network_adapter_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_get_with_http_info(self, chassis_id, network_adapter_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_get_with_http_info(chassis_id, network_adapter_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :return: NetworkDeviceFunctionCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['chassis_id', 'network_adapter_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'chassis_id' is set
        if ('chassis_id' not in local_var_params or
                local_var_params['chassis_id'] is None):
            raise ValueError("Missing the required parameter `chassis_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_get`")  # noqa: E501
        # verify the required parameter 'network_adapter_id' is set
        if ('network_adapter_id' not in local_var_params or
                local_var_params['network_adapter_id'] is None):
            raise ValueError("Missing the required parameter `network_adapter_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'chassis_id' in local_var_params:
            path_params['ChassisId'] = local_var_params['chassis_id']  # noqa: E501
        if 'network_adapter_id' in local_var_params:
            path_params['NetworkAdapterId'] = local_var_params['network_adapter_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Chassis/{ChassisId}/NetworkAdapters/{NetworkAdapterId}/NetworkDeviceFunctions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkDeviceFunctionCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_get(self, chassis_id, network_adapter_id, net_dev_func_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_get(chassis_id, network_adapter_id, net_dev_func_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :param str net_dev_func_id: The value of the Id property of the NetworkDeviceFunction resource (required)
        :return: NetworkDeviceFunction
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_get_with_http_info(chassis_id, network_adapter_id, net_dev_func_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_get_with_http_info(chassis_id, network_adapter_id, net_dev_func_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_get_with_http_info(self, chassis_id, network_adapter_id, net_dev_func_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_get_with_http_info(chassis_id, network_adapter_id, net_dev_func_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :param str net_dev_func_id: The value of the Id property of the NetworkDeviceFunction resource (required)
        :return: NetworkDeviceFunction
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['chassis_id', 'network_adapter_id', 'net_dev_func_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'chassis_id' is set
        if ('chassis_id' not in local_var_params or
                local_var_params['chassis_id'] is None):
            raise ValueError("Missing the required parameter `chassis_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_get`")  # noqa: E501
        # verify the required parameter 'network_adapter_id' is set
        if ('network_adapter_id' not in local_var_params or
                local_var_params['network_adapter_id'] is None):
            raise ValueError("Missing the required parameter `network_adapter_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_get`")  # noqa: E501
        # verify the required parameter 'net_dev_func_id' is set
        if ('net_dev_func_id' not in local_var_params or
                local_var_params['net_dev_func_id'] is None):
            raise ValueError("Missing the required parameter `net_dev_func_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'chassis_id' in local_var_params:
            path_params['ChassisId'] = local_var_params['chassis_id']  # noqa: E501
        if 'network_adapter_id' in local_var_params:
            path_params['NetworkAdapterId'] = local_var_params['network_adapter_id']  # noqa: E501
        if 'net_dev_func_id' in local_var_params:
            path_params['NetDevFuncId'] = local_var_params['net_dev_func_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Chassis/{ChassisId}/NetworkAdapters/{NetworkAdapterId}/NetworkDeviceFunctions/{NetDevFuncId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkDeviceFunction',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_patch(self, chassis_id, network_adapter_id, net_dev_func_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_patch  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_patch(chassis_id, network_adapter_id, net_dev_func_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :param str net_dev_func_id: The value of the Id property of the NetworkDeviceFunction resource (required)
        :return: NetworkDeviceFunction
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_patch_with_http_info(chassis_id, network_adapter_id, net_dev_func_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_patch_with_http_info(chassis_id, network_adapter_id, net_dev_func_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_patch_with_http_info(self, chassis_id, network_adapter_id, net_dev_func_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_patch  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_patch_with_http_info(chassis_id, network_adapter_id, net_dev_func_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :param str net_dev_func_id: The value of the Id property of the NetworkDeviceFunction resource (required)
        :return: NetworkDeviceFunction
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['chassis_id', 'network_adapter_id', 'net_dev_func_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_patch" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'chassis_id' is set
        if ('chassis_id' not in local_var_params or
                local_var_params['chassis_id'] is None):
            raise ValueError("Missing the required parameter `chassis_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_patch`")  # noqa: E501
        # verify the required parameter 'network_adapter_id' is set
        if ('network_adapter_id' not in local_var_params or
                local_var_params['network_adapter_id'] is None):
            raise ValueError("Missing the required parameter `network_adapter_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_patch`")  # noqa: E501
        # verify the required parameter 'net_dev_func_id' is set
        if ('net_dev_func_id' not in local_var_params or
                local_var_params['net_dev_func_id'] is None):
            raise ValueError("Missing the required parameter `net_dev_func_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_patch`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'chassis_id' in local_var_params:
            path_params['ChassisId'] = local_var_params['chassis_id']  # noqa: E501
        if 'network_adapter_id' in local_var_params:
            path_params['NetworkAdapterId'] = local_var_params['network_adapter_id']  # noqa: E501
        if 'net_dev_func_id' in local_var_params:
            path_params['NetDevFuncId'] = local_var_params['net_dev_func_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Chassis/{ChassisId}/NetworkAdapters/{NetworkAdapterId}/NetworkDeviceFunctions/{NetDevFuncId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkDeviceFunction',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_put(self, chassis_id, network_adapter_id, net_dev_func_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_put  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_put(chassis_id, network_adapter_id, net_dev_func_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :param str net_dev_func_id: The value of the Id property of the NetworkDeviceFunction resource (required)
        :return: NetworkDeviceFunction
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_put_with_http_info(chassis_id, network_adapter_id, net_dev_func_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_put_with_http_info(chassis_id, network_adapter_id, net_dev_func_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_put_with_http_info(self, chassis_id, network_adapter_id, net_dev_func_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_put  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_put_with_http_info(chassis_id, network_adapter_id, net_dev_func_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :param str net_dev_func_id: The value of the Id property of the NetworkDeviceFunction resource (required)
        :return: NetworkDeviceFunction
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['chassis_id', 'network_adapter_id', 'net_dev_func_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_put" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'chassis_id' is set
        if ('chassis_id' not in local_var_params or
                local_var_params['chassis_id'] is None):
            raise ValueError("Missing the required parameter `chassis_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_put`")  # noqa: E501
        # verify the required parameter 'network_adapter_id' is set
        if ('network_adapter_id' not in local_var_params or
                local_var_params['network_adapter_id'] is None):
            raise ValueError("Missing the required parameter `network_adapter_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_put`")  # noqa: E501
        # verify the required parameter 'net_dev_func_id' is set
        if ('net_dev_func_id' not in local_var_params or
                local_var_params['net_dev_func_id'] is None):
            raise ValueError("Missing the required parameter `net_dev_func_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_device_functions_net_dev_func_id_put`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'chassis_id' in local_var_params:
            path_params['ChassisId'] = local_var_params['chassis_id']  # noqa: E501
        if 'network_adapter_id' in local_var_params:
            path_params['NetworkAdapterId'] = local_var_params['network_adapter_id']  # noqa: E501
        if 'net_dev_func_id' in local_var_params:
            path_params['NetDevFuncId'] = local_var_params['net_dev_func_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Chassis/{ChassisId}/NetworkAdapters/{NetworkAdapterId}/NetworkDeviceFunctions/{NetDevFuncId}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkDeviceFunction',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_get(self, chassis_id, network_adapter_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_get(chassis_id, network_adapter_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :return: NetworkPortCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_get_with_http_info(chassis_id, network_adapter_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_get_with_http_info(chassis_id, network_adapter_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_get_with_http_info(self, chassis_id, network_adapter_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_get_with_http_info(chassis_id, network_adapter_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :return: NetworkPortCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['chassis_id', 'network_adapter_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'chassis_id' is set
        if ('chassis_id' not in local_var_params or
                local_var_params['chassis_id'] is None):
            raise ValueError("Missing the required parameter `chassis_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_get`")  # noqa: E501
        # verify the required parameter 'network_adapter_id' is set
        if ('network_adapter_id' not in local_var_params or
                local_var_params['network_adapter_id'] is None):
            raise ValueError("Missing the required parameter `network_adapter_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'chassis_id' in local_var_params:
            path_params['ChassisId'] = local_var_params['chassis_id']  # noqa: E501
        if 'network_adapter_id' in local_var_params:
            path_params['NetworkAdapterId'] = local_var_params['network_adapter_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Chassis/{ChassisId}/NetworkAdapters/{NetworkAdapterId}/NetworkPorts', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkPortCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_get(self, chassis_id, network_adapter_id, network_port_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_get(chassis_id, network_adapter_id, network_port_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :param str network_port_id: The value of the Id property of the NetworkPort resource (required)
        :return: NetworkPort
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_get_with_http_info(chassis_id, network_adapter_id, network_port_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_get_with_http_info(chassis_id, network_adapter_id, network_port_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_get_with_http_info(self, chassis_id, network_adapter_id, network_port_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_get_with_http_info(chassis_id, network_adapter_id, network_port_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :param str network_port_id: The value of the Id property of the NetworkPort resource (required)
        :return: NetworkPort
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['chassis_id', 'network_adapter_id', 'network_port_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'chassis_id' is set
        if ('chassis_id' not in local_var_params or
                local_var_params['chassis_id'] is None):
            raise ValueError("Missing the required parameter `chassis_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_get`")  # noqa: E501
        # verify the required parameter 'network_adapter_id' is set
        if ('network_adapter_id' not in local_var_params or
                local_var_params['network_adapter_id'] is None):
            raise ValueError("Missing the required parameter `network_adapter_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_get`")  # noqa: E501
        # verify the required parameter 'network_port_id' is set
        if ('network_port_id' not in local_var_params or
                local_var_params['network_port_id'] is None):
            raise ValueError("Missing the required parameter `network_port_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'chassis_id' in local_var_params:
            path_params['ChassisId'] = local_var_params['chassis_id']  # noqa: E501
        if 'network_adapter_id' in local_var_params:
            path_params['NetworkAdapterId'] = local_var_params['network_adapter_id']  # noqa: E501
        if 'network_port_id' in local_var_params:
            path_params['NetworkPortId'] = local_var_params['network_port_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Chassis/{ChassisId}/NetworkAdapters/{NetworkAdapterId}/NetworkPorts/{NetworkPortId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkPort',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_patch(self, chassis_id, network_adapter_id, network_port_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_patch  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_patch(chassis_id, network_adapter_id, network_port_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :param str network_port_id: The value of the Id property of the NetworkPort resource (required)
        :return: NetworkPort
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_patch_with_http_info(chassis_id, network_adapter_id, network_port_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_patch_with_http_info(chassis_id, network_adapter_id, network_port_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_patch_with_http_info(self, chassis_id, network_adapter_id, network_port_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_patch  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_patch_with_http_info(chassis_id, network_adapter_id, network_port_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :param str network_port_id: The value of the Id property of the NetworkPort resource (required)
        :return: NetworkPort
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['chassis_id', 'network_adapter_id', 'network_port_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_patch" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'chassis_id' is set
        if ('chassis_id' not in local_var_params or
                local_var_params['chassis_id'] is None):
            raise ValueError("Missing the required parameter `chassis_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_patch`")  # noqa: E501
        # verify the required parameter 'network_adapter_id' is set
        if ('network_adapter_id' not in local_var_params or
                local_var_params['network_adapter_id'] is None):
            raise ValueError("Missing the required parameter `network_adapter_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_patch`")  # noqa: E501
        # verify the required parameter 'network_port_id' is set
        if ('network_port_id' not in local_var_params or
                local_var_params['network_port_id'] is None):
            raise ValueError("Missing the required parameter `network_port_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_patch`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'chassis_id' in local_var_params:
            path_params['ChassisId'] = local_var_params['chassis_id']  # noqa: E501
        if 'network_adapter_id' in local_var_params:
            path_params['NetworkAdapterId'] = local_var_params['network_adapter_id']  # noqa: E501
        if 'network_port_id' in local_var_params:
            path_params['NetworkPortId'] = local_var_params['network_port_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Chassis/{ChassisId}/NetworkAdapters/{NetworkAdapterId}/NetworkPorts/{NetworkPortId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkPort',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_put(self, chassis_id, network_adapter_id, network_port_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_put  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_put(chassis_id, network_adapter_id, network_port_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :param str network_port_id: The value of the Id property of the NetworkPort resource (required)
        :return: NetworkPort
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_put_with_http_info(chassis_id, network_adapter_id, network_port_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_put_with_http_info(chassis_id, network_adapter_id, network_port_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_put_with_http_info(self, chassis_id, network_adapter_id, network_port_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_put  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_put_with_http_info(chassis_id, network_adapter_id, network_port_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param str network_adapter_id: The value of the Id property of the NetworkAdapter resource (required)
        :param str network_port_id: The value of the Id property of the NetworkPort resource (required)
        :return: NetworkPort
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['chassis_id', 'network_adapter_id', 'network_port_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_put" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'chassis_id' is set
        if ('chassis_id' not in local_var_params or
                local_var_params['chassis_id'] is None):
            raise ValueError("Missing the required parameter `chassis_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_put`")  # noqa: E501
        # verify the required parameter 'network_adapter_id' is set
        if ('network_adapter_id' not in local_var_params or
                local_var_params['network_adapter_id'] is None):
            raise ValueError("Missing the required parameter `network_adapter_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_put`")  # noqa: E501
        # verify the required parameter 'network_port_id' is set
        if ('network_port_id' not in local_var_params or
                local_var_params['network_port_id'] is None):
            raise ValueError("Missing the required parameter `network_port_id` when calling `redfish_v1_chassis_chassis_id_network_adapters_network_adapter_id_network_ports_network_port_id_put`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'chassis_id' in local_var_params:
            path_params['ChassisId'] = local_var_params['chassis_id']  # noqa: E501
        if 'network_adapter_id' in local_var_params:
            path_params['NetworkAdapterId'] = local_var_params['network_adapter_id']  # noqa: E501
        if 'network_port_id' in local_var_params:
            path_params['NetworkPortId'] = local_var_params['network_port_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Chassis/{ChassisId}/NetworkAdapters/{NetworkAdapterId}/NetworkPorts/{NetworkPortId}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkPort',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_chassis_chassis_id_patch(self, chassis_id, chassis, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_patch  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_patch(chassis_id, chassis, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param Chassis chassis: (required)
        :return: Chassis
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_chassis_chassis_id_patch_with_http_info(chassis_id, chassis, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_chassis_chassis_id_patch_with_http_info(chassis_id, chassis, **kwargs)  # noqa: E501
            return data

    def redfish_v1_chassis_chassis_id_patch_with_http_info(self, chassis_id, chassis, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_patch  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_patch_with_http_info(chassis_id, chassis, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param Chassis chassis: (required)
        :return: Chassis
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['chassis_id', 'chassis']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_chassis_chassis_id_patch" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'chassis_id' is set
        if ('chassis_id' not in local_var_params or
                local_var_params['chassis_id'] is None):
            raise ValueError("Missing the required parameter `chassis_id` when calling `redfish_v1_chassis_chassis_id_patch`")  # noqa: E501
        # verify the required parameter 'chassis' is set
        if ('chassis' not in local_var_params or
                local_var_params['chassis'] is None):
            raise ValueError("Missing the required parameter `chassis` when calling `redfish_v1_chassis_chassis_id_patch`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'chassis_id' in local_var_params:
            path_params['ChassisId'] = local_var_params['chassis_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'chassis' in local_var_params:
            body_params = local_var_params['chassis']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Chassis/{ChassisId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Chassis',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_chassis_chassis_id_post(self, chassis_id, power_mode_request_body, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_post  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_post(chassis_id, power_mode_request_body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param PowerModeRequestBody power_mode_request_body: (required)
        :return: Chassis
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_chassis_chassis_id_post_with_http_info(chassis_id, power_mode_request_body, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_chassis_chassis_id_post_with_http_info(chassis_id, power_mode_request_body, **kwargs)  # noqa: E501
            return data

    def redfish_v1_chassis_chassis_id_post_with_http_info(self, chassis_id, power_mode_request_body, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_post  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_post_with_http_info(chassis_id, power_mode_request_body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param PowerModeRequestBody power_mode_request_body: (required)
        :return: Chassis
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['chassis_id', 'power_mode_request_body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_chassis_chassis_id_post" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'chassis_id' is set
        if ('chassis_id' not in local_var_params or
                local_var_params['chassis_id'] is None):
            raise ValueError("Missing the required parameter `chassis_id` when calling `redfish_v1_chassis_chassis_id_post`")  # noqa: E501
        # verify the required parameter 'power_mode_request_body' is set
        if ('power_mode_request_body' not in local_var_params or
                local_var_params['power_mode_request_body'] is None):
            raise ValueError("Missing the required parameter `power_mode_request_body` when calling `redfish_v1_chassis_chassis_id_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'chassis_id' in local_var_params:
            path_params['ChassisId'] = local_var_params['chassis_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'power_mode_request_body' in local_var_params:
            body_params = local_var_params['power_mode_request_body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Chassis/{ChassisId}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Chassis',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_chassis_chassis_id_power_get(self, chassis_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_power_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_power_get(chassis_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param bool force_refresh: Force refresh
        :return: Power
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_chassis_chassis_id_power_get_with_http_info(chassis_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_chassis_chassis_id_power_get_with_http_info(chassis_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_chassis_chassis_id_power_get_with_http_info(self, chassis_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_power_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_power_get_with_http_info(chassis_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :param bool force_refresh: Force refresh
        :return: Power
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['chassis_id', 'force_refresh']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_chassis_chassis_id_power_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'chassis_id' is set
        if ('chassis_id' not in local_var_params or
                local_var_params['chassis_id'] is None):
            raise ValueError("Missing the required parameter `chassis_id` when calling `redfish_v1_chassis_chassis_id_power_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'chassis_id' in local_var_params:
            path_params['ChassisId'] = local_var_params['chassis_id']  # noqa: E501

        query_params = []
        if 'force_refresh' in local_var_params:
            query_params.append(('ForceRefresh', local_var_params['force_refresh']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Chassis/{ChassisId}/Power', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Power',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_chassis_chassis_id_thermal_get(self, chassis_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_thermal_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_thermal_get(chassis_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :return: Thermal
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_chassis_chassis_id_thermal_get_with_http_info(chassis_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_chassis_chassis_id_thermal_get_with_http_info(chassis_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_chassis_chassis_id_thermal_get_with_http_info(self, chassis_id, **kwargs):  # noqa: E501
        """redfish_v1_chassis_chassis_id_thermal_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_chassis_id_thermal_get_with_http_info(chassis_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str chassis_id: The value of the Id property of the Chassis resource (required)
        :return: Thermal
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['chassis_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_chassis_chassis_id_thermal_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'chassis_id' is set
        if ('chassis_id' not in local_var_params or
                local_var_params['chassis_id'] is None):
            raise ValueError("Missing the required parameter `chassis_id` when calling `redfish_v1_chassis_chassis_id_thermal_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'chassis_id' in local_var_params:
            path_params['ChassisId'] = local_var_params['chassis_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Chassis/{ChassisId}/Thermal', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Thermal',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_chassis_get(self, **kwargs):  # noqa: E501
        """redfish_v1_chassis_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_get(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: ChassisCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_chassis_get_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_chassis_get_with_http_info(**kwargs)  # noqa: E501
            return data

    def redfish_v1_chassis_get_with_http_info(self, **kwargs):  # noqa: E501
        """redfish_v1_chassis_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_chassis_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: ChassisCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_chassis_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Chassis', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ChassisCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_get(self, **kwargs):  # noqa: E501
        """redfish_v1_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_get(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: ServiceRoot
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_get_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_get_with_http_info(**kwargs)  # noqa: E501
            return data

    def redfish_v1_get_with_http_info(self, **kwargs):  # noqa: E501
        """redfish_v1_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: ServiceRoot
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ServiceRoot',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_managers_get(self, **kwargs):  # noqa: E501
        """redfish_v1_managers_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_managers_get(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: ManagerCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_managers_get_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_managers_get_with_http_info(**kwargs)  # noqa: E501
            return data

    def redfish_v1_managers_get_with_http_info(self, **kwargs):  # noqa: E501
        """redfish_v1_managers_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_managers_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: ManagerCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_managers_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Managers', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ManagerCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_get(self, manager_id, ethernet_interface_id, **kwargs):  # noqa: E501
        """redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_get(manager_id, ethernet_interface_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str manager_id: The value of the Id property of the Manager resource (required)
        :param str ethernet_interface_id: The value of the Id property of the EthernetInterface resource (required)
        :return: EthernetInterface
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_get_with_http_info(manager_id, ethernet_interface_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_get_with_http_info(manager_id, ethernet_interface_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_get_with_http_info(self, manager_id, ethernet_interface_id, **kwargs):  # noqa: E501
        """redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_get_with_http_info(manager_id, ethernet_interface_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str manager_id: The value of the Id property of the Manager resource (required)
        :param str ethernet_interface_id: The value of the Id property of the EthernetInterface resource (required)
        :return: EthernetInterface
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['manager_id', 'ethernet_interface_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'manager_id' is set
        if ('manager_id' not in local_var_params or
                local_var_params['manager_id'] is None):
            raise ValueError("Missing the required parameter `manager_id` when calling `redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_get`")  # noqa: E501
        # verify the required parameter 'ethernet_interface_id' is set
        if ('ethernet_interface_id' not in local_var_params or
                local_var_params['ethernet_interface_id'] is None):
            raise ValueError("Missing the required parameter `ethernet_interface_id` when calling `redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'manager_id' in local_var_params:
            path_params['ManagerId'] = local_var_params['manager_id']  # noqa: E501
        if 'ethernet_interface_id' in local_var_params:
            path_params['EthernetInterfaceId'] = local_var_params['ethernet_interface_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Managers/{ManagerId}/EthernetInterfaces/{EthernetInterfaceId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='EthernetInterface',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_patch(self, manager_id, ethernet_interface_id, ethernet_interface, **kwargs):  # noqa: E501
        """redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_patch  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_patch(manager_id, ethernet_interface_id, ethernet_interface, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str manager_id: The value of the Id property of the Manager resource (required)
        :param str ethernet_interface_id: The value of the Id property of the EthernetInterface resource (required)
        :param EthernetInterface ethernet_interface: (required)
        :return: EthernetInterface
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_patch_with_http_info(manager_id, ethernet_interface_id, ethernet_interface, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_patch_with_http_info(manager_id, ethernet_interface_id, ethernet_interface, **kwargs)  # noqa: E501
            return data

    def redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_patch_with_http_info(self, manager_id, ethernet_interface_id, ethernet_interface, **kwargs):  # noqa: E501
        """redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_patch  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_patch_with_http_info(manager_id, ethernet_interface_id, ethernet_interface, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str manager_id: The value of the Id property of the Manager resource (required)
        :param str ethernet_interface_id: The value of the Id property of the EthernetInterface resource (required)
        :param EthernetInterface ethernet_interface: (required)
        :return: EthernetInterface
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['manager_id', 'ethernet_interface_id', 'ethernet_interface']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_patch" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'manager_id' is set
        if ('manager_id' not in local_var_params or
                local_var_params['manager_id'] is None):
            raise ValueError("Missing the required parameter `manager_id` when calling `redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_patch`")  # noqa: E501
        # verify the required parameter 'ethernet_interface_id' is set
        if ('ethernet_interface_id' not in local_var_params or
                local_var_params['ethernet_interface_id'] is None):
            raise ValueError("Missing the required parameter `ethernet_interface_id` when calling `redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_patch`")  # noqa: E501
        # verify the required parameter 'ethernet_interface' is set
        if ('ethernet_interface' not in local_var_params or
                local_var_params['ethernet_interface'] is None):
            raise ValueError("Missing the required parameter `ethernet_interface` when calling `redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_patch`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'manager_id' in local_var_params:
            path_params['ManagerId'] = local_var_params['manager_id']  # noqa: E501
        if 'ethernet_interface_id' in local_var_params:
            path_params['EthernetInterfaceId'] = local_var_params['ethernet_interface_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'ethernet_interface' in local_var_params:
            body_params = local_var_params['ethernet_interface']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Managers/{ManagerId}/EthernetInterfaces/{EthernetInterfaceId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='EthernetInterface',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_put(self, manager_id, ethernet_interface_id, ethernet_interface, **kwargs):  # noqa: E501
        """redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_put  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_put(manager_id, ethernet_interface_id, ethernet_interface, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str manager_id: The value of the Id property of the Manager resource (required)
        :param str ethernet_interface_id: The value of the Id property of the EthernetInterface resource (required)
        :param EthernetInterface ethernet_interface: (required)
        :return: EthernetInterface
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_put_with_http_info(manager_id, ethernet_interface_id, ethernet_interface, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_put_with_http_info(manager_id, ethernet_interface_id, ethernet_interface, **kwargs)  # noqa: E501
            return data

    def redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_put_with_http_info(self, manager_id, ethernet_interface_id, ethernet_interface, **kwargs):  # noqa: E501
        """redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_put  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_put_with_http_info(manager_id, ethernet_interface_id, ethernet_interface, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str manager_id: The value of the Id property of the Manager resource (required)
        :param str ethernet_interface_id: The value of the Id property of the EthernetInterface resource (required)
        :param EthernetInterface ethernet_interface: (required)
        :return: EthernetInterface
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['manager_id', 'ethernet_interface_id', 'ethernet_interface']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_put" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'manager_id' is set
        if ('manager_id' not in local_var_params or
                local_var_params['manager_id'] is None):
            raise ValueError("Missing the required parameter `manager_id` when calling `redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_put`")  # noqa: E501
        # verify the required parameter 'ethernet_interface_id' is set
        if ('ethernet_interface_id' not in local_var_params or
                local_var_params['ethernet_interface_id'] is None):
            raise ValueError("Missing the required parameter `ethernet_interface_id` when calling `redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_put`")  # noqa: E501
        # verify the required parameter 'ethernet_interface' is set
        if ('ethernet_interface' not in local_var_params or
                local_var_params['ethernet_interface'] is None):
            raise ValueError("Missing the required parameter `ethernet_interface` when calling `redfish_v1_managers_manager_id_ethernet_interfaces_ethernet_interface_id_put`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'manager_id' in local_var_params:
            path_params['ManagerId'] = local_var_params['manager_id']  # noqa: E501
        if 'ethernet_interface_id' in local_var_params:
            path_params['EthernetInterfaceId'] = local_var_params['ethernet_interface_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'ethernet_interface' in local_var_params:
            body_params = local_var_params['ethernet_interface']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Managers/{ManagerId}/EthernetInterfaces/{EthernetInterfaceId}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='EthernetInterface',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_managers_manager_id_ethernet_interfaces_get(self, manager_id, **kwargs):  # noqa: E501
        """redfish_v1_managers_manager_id_ethernet_interfaces_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_managers_manager_id_ethernet_interfaces_get(manager_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str manager_id: The value of the Id property of the Manager resource (required)
        :return: EthernetInterfaceCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_managers_manager_id_ethernet_interfaces_get_with_http_info(manager_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_managers_manager_id_ethernet_interfaces_get_with_http_info(manager_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_managers_manager_id_ethernet_interfaces_get_with_http_info(self, manager_id, **kwargs):  # noqa: E501
        """redfish_v1_managers_manager_id_ethernet_interfaces_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_managers_manager_id_ethernet_interfaces_get_with_http_info(manager_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str manager_id: The value of the Id property of the Manager resource (required)
        :return: EthernetInterfaceCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['manager_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_managers_manager_id_ethernet_interfaces_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'manager_id' is set
        if ('manager_id' not in local_var_params or
                local_var_params['manager_id'] is None):
            raise ValueError("Missing the required parameter `manager_id` when calling `redfish_v1_managers_manager_id_ethernet_interfaces_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'manager_id' in local_var_params:
            path_params['ManagerId'] = local_var_params['manager_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Managers/{ManagerId}/EthernetInterfaces', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='EthernetInterfaceCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_managers_manager_id_get(self, manager_id, **kwargs):  # noqa: E501
        """redfish_v1_managers_manager_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_managers_manager_id_get(manager_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str manager_id: The value of the Id property of the Manager resource (required)
        :return: Manager
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_managers_manager_id_get_with_http_info(manager_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_managers_manager_id_get_with_http_info(manager_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_managers_manager_id_get_with_http_info(self, manager_id, **kwargs):  # noqa: E501
        """redfish_v1_managers_manager_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_managers_manager_id_get_with_http_info(manager_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str manager_id: The value of the Id property of the Manager resource (required)
        :return: Manager
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['manager_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_managers_manager_id_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'manager_id' is set
        if ('manager_id' not in local_var_params or
                local_var_params['manager_id'] is None):
            raise ValueError("Missing the required parameter `manager_id` when calling `redfish_v1_managers_manager_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'manager_id' in local_var_params:
            path_params['ManagerId'] = local_var_params['manager_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Managers/{ManagerId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Manager',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_managers_manager_id_patch(self, manager_id, manager, **kwargs):  # noqa: E501
        """redfish_v1_managers_manager_id_patch  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_managers_manager_id_patch(manager_id, manager, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str manager_id: The value of the Id property of the Manager resource (required)
        :param Manager manager: (required)
        :return: Manager
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_managers_manager_id_patch_with_http_info(manager_id, manager, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_managers_manager_id_patch_with_http_info(manager_id, manager, **kwargs)  # noqa: E501
            return data

    def redfish_v1_managers_manager_id_patch_with_http_info(self, manager_id, manager, **kwargs):  # noqa: E501
        """redfish_v1_managers_manager_id_patch  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_managers_manager_id_patch_with_http_info(manager_id, manager, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str manager_id: The value of the Id property of the Manager resource (required)
        :param Manager manager: (required)
        :return: Manager
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['manager_id', 'manager']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_managers_manager_id_patch" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'manager_id' is set
        if ('manager_id' not in local_var_params or
                local_var_params['manager_id'] is None):
            raise ValueError("Missing the required parameter `manager_id` when calling `redfish_v1_managers_manager_id_patch`")  # noqa: E501
        # verify the required parameter 'manager' is set
        if ('manager' not in local_var_params or
                local_var_params['manager'] is None):
            raise ValueError("Missing the required parameter `manager` when calling `redfish_v1_managers_manager_id_patch`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'manager_id' in local_var_params:
            path_params['ManagerId'] = local_var_params['manager_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'manager' in local_var_params:
            body_params = local_var_params['manager']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Managers/{ManagerId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Manager',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_managers_manager_id_put(self, manager_id, manager, **kwargs):  # noqa: E501
        """redfish_v1_managers_manager_id_put  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_managers_manager_id_put(manager_id, manager, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str manager_id: The value of the Id property of the Manager resource (required)
        :param Manager manager: (required)
        :return: Manager
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_managers_manager_id_put_with_http_info(manager_id, manager, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_managers_manager_id_put_with_http_info(manager_id, manager, **kwargs)  # noqa: E501
            return data

    def redfish_v1_managers_manager_id_put_with_http_info(self, manager_id, manager, **kwargs):  # noqa: E501
        """redfish_v1_managers_manager_id_put  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_managers_manager_id_put_with_http_info(manager_id, manager, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str manager_id: The value of the Id property of the Manager resource (required)
        :param Manager manager: (required)
        :return: Manager
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['manager_id', 'manager']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_managers_manager_id_put" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'manager_id' is set
        if ('manager_id' not in local_var_params or
                local_var_params['manager_id'] is None):
            raise ValueError("Missing the required parameter `manager_id` when calling `redfish_v1_managers_manager_id_put`")  # noqa: E501
        # verify the required parameter 'manager' is set
        if ('manager' not in local_var_params or
                local_var_params['manager'] is None):
            raise ValueError("Missing the required parameter `manager` when calling `redfish_v1_managers_manager_id_put`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'manager_id' in local_var_params:
            path_params['ManagerId'] = local_var_params['manager_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'manager' in local_var_params:
            body_params = local_var_params['manager']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Managers/{ManagerId}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Manager',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_get(self, computer_system_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_get(computer_system_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :return: ComputerSystem
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_get_with_http_info(computer_system_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_get_with_http_info(computer_system_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_get_with_http_info(self, computer_system_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_get_with_http_info(computer_system_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :return: ComputerSystem
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ComputerSystem',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_memory_get(self, computer_system_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_memory_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_memory_get(computer_system_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param bool force_refresh: Force refresh
        :return: MemoryCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_memory_get_with_http_info(computer_system_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_memory_get_with_http_info(computer_system_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_memory_get_with_http_info(self, computer_system_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_memory_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_memory_get_with_http_info(computer_system_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param bool force_refresh: Force refresh
        :return: MemoryCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id', 'force_refresh']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_memory_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_memory_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501

        query_params = []
        if 'force_refresh' in local_var_params:
            query_params.append(('ForceRefresh', local_var_params['force_refresh']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/Memory', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='MemoryCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_memory_memory_id_get(self, computer_system_id, memory_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_memory_memory_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_memory_memory_id_get(computer_system_id, memory_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str memory_id: The value of the Id property of the Memory resource (required)
        :param bool force_refresh: Force refresh
        :return: Memory
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_memory_memory_id_get_with_http_info(computer_system_id, memory_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_memory_memory_id_get_with_http_info(computer_system_id, memory_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_memory_memory_id_get_with_http_info(self, computer_system_id, memory_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_memory_memory_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_memory_memory_id_get_with_http_info(computer_system_id, memory_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str memory_id: The value of the Id property of the Memory resource (required)
        :param bool force_refresh: Force refresh
        :return: Memory
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id', 'memory_id', 'force_refresh']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_memory_memory_id_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_memory_memory_id_get`")  # noqa: E501
        # verify the required parameter 'memory_id' is set
        if ('memory_id' not in local_var_params or
                local_var_params['memory_id'] is None):
            raise ValueError("Missing the required parameter `memory_id` when calling `redfish_v1_systems_computer_system_id_memory_memory_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501
        if 'memory_id' in local_var_params:
            path_params['MemoryId'] = local_var_params['memory_id']  # noqa: E501

        query_params = []
        if 'force_refresh' in local_var_params:
            query_params.append(('ForceRefresh', local_var_params['force_refresh']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/Memory/{MemoryId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Memory',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_network_interfaces_get(self, computer_system_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_get(computer_system_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param bool force_refresh: Force refresh
        :return: NetworkInterfaceCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_network_interfaces_get_with_http_info(computer_system_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_network_interfaces_get_with_http_info(computer_system_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_network_interfaces_get_with_http_info(self, computer_system_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_get_with_http_info(computer_system_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param bool force_refresh: Force refresh
        :return: NetworkInterfaceCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id', 'force_refresh']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_network_interfaces_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501

        query_params = []
        if 'force_refresh' in local_var_params:
            query_params.append(('ForceRefresh', local_var_params['force_refresh']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/NetworkInterfaces', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkInterfaceCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_get(self, computer_system_id, network_interface_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_get(computer_system_id, network_interface_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param bool force_refresh: Force refresh
        :return: NetworkInterface
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_get_with_http_info(computer_system_id, network_interface_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_get_with_http_info(computer_system_id, network_interface_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_get_with_http_info(self, computer_system_id, network_interface_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_get_with_http_info(computer_system_id, network_interface_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param bool force_refresh: Force refresh
        :return: NetworkInterface
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id', 'network_interface_id', 'force_refresh']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_get`")  # noqa: E501
        # verify the required parameter 'network_interface_id' is set
        if ('network_interface_id' not in local_var_params or
                local_var_params['network_interface_id'] is None):
            raise ValueError("Missing the required parameter `network_interface_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501
        if 'network_interface_id' in local_var_params:
            path_params['NetworkInterfaceId'] = local_var_params['network_interface_id']  # noqa: E501

        query_params = []
        if 'force_refresh' in local_var_params:
            query_params.append(('ForceRefresh', local_var_params['force_refresh']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/NetworkInterfaces/{NetworkInterfaceId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkInterface',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_get(self, computer_system_id, network_interface_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_get(computer_system_id, network_interface_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param bool force_refresh: Force refresh
        :return: NetworkDeviceFunctionCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_get_with_http_info(computer_system_id, network_interface_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_get_with_http_info(computer_system_id, network_interface_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_get_with_http_info(self, computer_system_id, network_interface_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_get_with_http_info(computer_system_id, network_interface_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param bool force_refresh: Force refresh
        :return: NetworkDeviceFunctionCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id', 'network_interface_id', 'force_refresh']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_get`")  # noqa: E501
        # verify the required parameter 'network_interface_id' is set
        if ('network_interface_id' not in local_var_params or
                local_var_params['network_interface_id'] is None):
            raise ValueError("Missing the required parameter `network_interface_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501
        if 'network_interface_id' in local_var_params:
            path_params['NetworkInterfaceId'] = local_var_params['network_interface_id']  # noqa: E501

        query_params = []
        if 'force_refresh' in local_var_params:
            query_params.append(('ForceRefresh', local_var_params['force_refresh']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/NetworkInterfaces/{NetworkInterfaceId}/NetworkDeviceFunctions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkDeviceFunctionCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_get(self, computer_system_id, network_interface_id, net_dev_func_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_get(computer_system_id, network_interface_id, net_dev_func_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param str net_dev_func_id: The value of the Id property of the NetworkDeviceFunction resource (required)
        :return: NetworkDeviceFunction
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_get_with_http_info(computer_system_id, network_interface_id, net_dev_func_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_get_with_http_info(computer_system_id, network_interface_id, net_dev_func_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_get_with_http_info(self, computer_system_id, network_interface_id, net_dev_func_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_get_with_http_info(computer_system_id, network_interface_id, net_dev_func_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param str net_dev_func_id: The value of the Id property of the NetworkDeviceFunction resource (required)
        :return: NetworkDeviceFunction
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id', 'network_interface_id', 'net_dev_func_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_get`")  # noqa: E501
        # verify the required parameter 'network_interface_id' is set
        if ('network_interface_id' not in local_var_params or
                local_var_params['network_interface_id'] is None):
            raise ValueError("Missing the required parameter `network_interface_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_get`")  # noqa: E501
        # verify the required parameter 'net_dev_func_id' is set
        if ('net_dev_func_id' not in local_var_params or
                local_var_params['net_dev_func_id'] is None):
            raise ValueError("Missing the required parameter `net_dev_func_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501
        if 'network_interface_id' in local_var_params:
            path_params['NetworkInterfaceId'] = local_var_params['network_interface_id']  # noqa: E501
        if 'net_dev_func_id' in local_var_params:
            path_params['NetDevFuncId'] = local_var_params['net_dev_func_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/NetworkInterfaces/{NetworkInterfaceId}/NetworkDeviceFunctions/{NetDevFuncId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkDeviceFunction',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_patch(self, computer_system_id, network_interface_id, net_dev_func_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_patch  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_patch(computer_system_id, network_interface_id, net_dev_func_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param str net_dev_func_id: The value of the Id property of the NetworkDeviceFunction resource (required)
        :return: NetworkDeviceFunction
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_patch_with_http_info(computer_system_id, network_interface_id, net_dev_func_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_patch_with_http_info(computer_system_id, network_interface_id, net_dev_func_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_patch_with_http_info(self, computer_system_id, network_interface_id, net_dev_func_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_patch  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_patch_with_http_info(computer_system_id, network_interface_id, net_dev_func_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param str net_dev_func_id: The value of the Id property of the NetworkDeviceFunction resource (required)
        :return: NetworkDeviceFunction
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id', 'network_interface_id', 'net_dev_func_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_patch" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_patch`")  # noqa: E501
        # verify the required parameter 'network_interface_id' is set
        if ('network_interface_id' not in local_var_params or
                local_var_params['network_interface_id'] is None):
            raise ValueError("Missing the required parameter `network_interface_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_patch`")  # noqa: E501
        # verify the required parameter 'net_dev_func_id' is set
        if ('net_dev_func_id' not in local_var_params or
                local_var_params['net_dev_func_id'] is None):
            raise ValueError("Missing the required parameter `net_dev_func_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_patch`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501
        if 'network_interface_id' in local_var_params:
            path_params['NetworkInterfaceId'] = local_var_params['network_interface_id']  # noqa: E501
        if 'net_dev_func_id' in local_var_params:
            path_params['NetDevFuncId'] = local_var_params['net_dev_func_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/NetworkInterfaces/{NetworkInterfaceId}/NetworkDeviceFunctions/{NetDevFuncId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkDeviceFunction',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_put(self, computer_system_id, network_interface_id, net_dev_func_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_put  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_put(computer_system_id, network_interface_id, net_dev_func_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param str net_dev_func_id: The value of the Id property of the NetworkDeviceFunction resource (required)
        :return: NetworkDeviceFunction
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_put_with_http_info(computer_system_id, network_interface_id, net_dev_func_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_put_with_http_info(computer_system_id, network_interface_id, net_dev_func_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_put_with_http_info(self, computer_system_id, network_interface_id, net_dev_func_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_put  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_put_with_http_info(computer_system_id, network_interface_id, net_dev_func_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param str net_dev_func_id: The value of the Id property of the NetworkDeviceFunction resource (required)
        :return: NetworkDeviceFunction
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id', 'network_interface_id', 'net_dev_func_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_put" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_put`")  # noqa: E501
        # verify the required parameter 'network_interface_id' is set
        if ('network_interface_id' not in local_var_params or
                local_var_params['network_interface_id'] is None):
            raise ValueError("Missing the required parameter `network_interface_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_put`")  # noqa: E501
        # verify the required parameter 'net_dev_func_id' is set
        if ('net_dev_func_id' not in local_var_params or
                local_var_params['net_dev_func_id'] is None):
            raise ValueError("Missing the required parameter `net_dev_func_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_device_functions_net_dev_func_id_put`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501
        if 'network_interface_id' in local_var_params:
            path_params['NetworkInterfaceId'] = local_var_params['network_interface_id']  # noqa: E501
        if 'net_dev_func_id' in local_var_params:
            path_params['NetDevFuncId'] = local_var_params['net_dev_func_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/NetworkInterfaces/{NetworkInterfaceId}/NetworkDeviceFunctions/{NetDevFuncId}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkDeviceFunction',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_get(self, computer_system_id, network_interface_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_get(computer_system_id, network_interface_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param bool force_refresh: Force refresh
        :return: NetworkPortCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_get_with_http_info(computer_system_id, network_interface_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_get_with_http_info(computer_system_id, network_interface_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_get_with_http_info(self, computer_system_id, network_interface_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_get_with_http_info(computer_system_id, network_interface_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param bool force_refresh: Force refresh
        :return: NetworkPortCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id', 'network_interface_id', 'force_refresh']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_get`")  # noqa: E501
        # verify the required parameter 'network_interface_id' is set
        if ('network_interface_id' not in local_var_params or
                local_var_params['network_interface_id'] is None):
            raise ValueError("Missing the required parameter `network_interface_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501
        if 'network_interface_id' in local_var_params:
            path_params['NetworkInterfaceId'] = local_var_params['network_interface_id']  # noqa: E501

        query_params = []
        if 'force_refresh' in local_var_params:
            query_params.append(('ForceRefresh', local_var_params['force_refresh']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/NetworkInterfaces/{NetworkInterfaceId}/NetworkPorts', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkPortCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_get(self, computer_system_id, network_interface_id, network_port_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_get(computer_system_id, network_interface_id, network_port_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param str network_port_id: The value of the Id property of the NetworkPort resource (required)
        :return: NetworkPort
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_get_with_http_info(computer_system_id, network_interface_id, network_port_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_get_with_http_info(computer_system_id, network_interface_id, network_port_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_get_with_http_info(self, computer_system_id, network_interface_id, network_port_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_get_with_http_info(computer_system_id, network_interface_id, network_port_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param str network_port_id: The value of the Id property of the NetworkPort resource (required)
        :return: NetworkPort
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id', 'network_interface_id', 'network_port_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_get`")  # noqa: E501
        # verify the required parameter 'network_interface_id' is set
        if ('network_interface_id' not in local_var_params or
                local_var_params['network_interface_id'] is None):
            raise ValueError("Missing the required parameter `network_interface_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_get`")  # noqa: E501
        # verify the required parameter 'network_port_id' is set
        if ('network_port_id' not in local_var_params or
                local_var_params['network_port_id'] is None):
            raise ValueError("Missing the required parameter `network_port_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501
        if 'network_interface_id' in local_var_params:
            path_params['NetworkInterfaceId'] = local_var_params['network_interface_id']  # noqa: E501
        if 'network_port_id' in local_var_params:
            path_params['NetworkPortId'] = local_var_params['network_port_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/NetworkInterfaces/{NetworkInterfaceId}/NetworkPorts/{NetworkPortId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkPort',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_patch(self, computer_system_id, network_interface_id, network_port_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_patch  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_patch(computer_system_id, network_interface_id, network_port_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param str network_port_id: The value of the Id property of the NetworkPort resource (required)
        :return: NetworkPort
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_patch_with_http_info(computer_system_id, network_interface_id, network_port_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_patch_with_http_info(computer_system_id, network_interface_id, network_port_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_patch_with_http_info(self, computer_system_id, network_interface_id, network_port_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_patch  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_patch_with_http_info(computer_system_id, network_interface_id, network_port_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param str network_port_id: The value of the Id property of the NetworkPort resource (required)
        :return: NetworkPort
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id', 'network_interface_id', 'network_port_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_patch" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_patch`")  # noqa: E501
        # verify the required parameter 'network_interface_id' is set
        if ('network_interface_id' not in local_var_params or
                local_var_params['network_interface_id'] is None):
            raise ValueError("Missing the required parameter `network_interface_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_patch`")  # noqa: E501
        # verify the required parameter 'network_port_id' is set
        if ('network_port_id' not in local_var_params or
                local_var_params['network_port_id'] is None):
            raise ValueError("Missing the required parameter `network_port_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_patch`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501
        if 'network_interface_id' in local_var_params:
            path_params['NetworkInterfaceId'] = local_var_params['network_interface_id']  # noqa: E501
        if 'network_port_id' in local_var_params:
            path_params['NetworkPortId'] = local_var_params['network_port_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/NetworkInterfaces/{NetworkInterfaceId}/NetworkPorts/{NetworkPortId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkPort',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_put(self, computer_system_id, network_interface_id, network_port_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_put  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_put(computer_system_id, network_interface_id, network_port_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param str network_port_id: The value of the Id property of the NetworkPort resource (required)
        :return: NetworkPort
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_put_with_http_info(computer_system_id, network_interface_id, network_port_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_put_with_http_info(computer_system_id, network_interface_id, network_port_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_put_with_http_info(self, computer_system_id, network_interface_id, network_port_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_put  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_put_with_http_info(computer_system_id, network_interface_id, network_port_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str network_interface_id: The value of the Id property of the Network interface resource (required)
        :param str network_port_id: The value of the Id property of the NetworkPort resource (required)
        :return: NetworkPort
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id', 'network_interface_id', 'network_port_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_put" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_put`")  # noqa: E501
        # verify the required parameter 'network_interface_id' is set
        if ('network_interface_id' not in local_var_params or
                local_var_params['network_interface_id'] is None):
            raise ValueError("Missing the required parameter `network_interface_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_put`")  # noqa: E501
        # verify the required parameter 'network_port_id' is set
        if ('network_port_id' not in local_var_params or
                local_var_params['network_port_id'] is None):
            raise ValueError("Missing the required parameter `network_port_id` when calling `redfish_v1_systems_computer_system_id_network_interfaces_network_interface_id_network_ports_network_port_id_put`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501
        if 'network_interface_id' in local_var_params:
            path_params['NetworkInterfaceId'] = local_var_params['network_interface_id']  # noqa: E501
        if 'network_port_id' in local_var_params:
            path_params['NetworkPortId'] = local_var_params['network_port_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/NetworkInterfaces/{NetworkInterfaceId}/NetworkPorts/{NetworkPortId}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkPort',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_processors_get(self, computer_system_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_processors_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_processors_get(computer_system_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :return: ProcessorCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_processors_get_with_http_info(computer_system_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_processors_get_with_http_info(computer_system_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_processors_get_with_http_info(self, computer_system_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_processors_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_processors_get_with_http_info(computer_system_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :return: ProcessorCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_processors_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_processors_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/Processors', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ProcessorCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_processors_processor_id_get(self, computer_system_id, processor_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_processors_processor_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_processors_processor_id_get(computer_system_id, processor_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str processor_id: The value of the Id property of the Processor resource (required)
        :return: Processor
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_processors_processor_id_get_with_http_info(computer_system_id, processor_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_processors_processor_id_get_with_http_info(computer_system_id, processor_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_processors_processor_id_get_with_http_info(self, computer_system_id, processor_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_processors_processor_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_processors_processor_id_get_with_http_info(computer_system_id, processor_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str processor_id: The value of the Id property of the Processor resource (required)
        :return: Processor
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id', 'processor_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_processors_processor_id_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_processors_processor_id_get`")  # noqa: E501
        # verify the required parameter 'processor_id' is set
        if ('processor_id' not in local_var_params or
                local_var_params['processor_id'] is None):
            raise ValueError("Missing the required parameter `processor_id` when calling `redfish_v1_systems_computer_system_id_processors_processor_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501
        if 'processor_id' in local_var_params:
            path_params['ProcessorId'] = local_var_params['processor_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/Processors/{ProcessorId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Processor',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_storage_get(self, computer_system_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_storage_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_storage_get(computer_system_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :return: StorageCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_storage_get_with_http_info(computer_system_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_storage_get_with_http_info(computer_system_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_storage_get_with_http_info(self, computer_system_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_storage_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_storage_get_with_http_info(computer_system_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :return: StorageCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_storage_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_storage_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/Storage', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='StorageCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_storage_storage_id_drives_drive_id_get(self, computer_system_id, storage_id, drive_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_storage_storage_id_drives_drive_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_storage_storage_id_drives_drive_id_get(computer_system_id, storage_id, drive_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str storage_id: The value of the Id property of the Storage resource (required)
        :param str drive_id: The value of the Id property of the Drive resource (required)
        :param bool force_refresh: Force refresh
        :return: Drive
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_storage_storage_id_drives_drive_id_get_with_http_info(computer_system_id, storage_id, drive_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_storage_storage_id_drives_drive_id_get_with_http_info(computer_system_id, storage_id, drive_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_storage_storage_id_drives_drive_id_get_with_http_info(self, computer_system_id, storage_id, drive_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_storage_storage_id_drives_drive_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_storage_storage_id_drives_drive_id_get_with_http_info(computer_system_id, storage_id, drive_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str storage_id: The value of the Id property of the Storage resource (required)
        :param str drive_id: The value of the Id property of the Drive resource (required)
        :param bool force_refresh: Force refresh
        :return: Drive
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id', 'storage_id', 'drive_id', 'force_refresh']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_storage_storage_id_drives_drive_id_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_storage_storage_id_drives_drive_id_get`")  # noqa: E501
        # verify the required parameter 'storage_id' is set
        if ('storage_id' not in local_var_params or
                local_var_params['storage_id'] is None):
            raise ValueError("Missing the required parameter `storage_id` when calling `redfish_v1_systems_computer_system_id_storage_storage_id_drives_drive_id_get`")  # noqa: E501
        # verify the required parameter 'drive_id' is set
        if ('drive_id' not in local_var_params or
                local_var_params['drive_id'] is None):
            raise ValueError("Missing the required parameter `drive_id` when calling `redfish_v1_systems_computer_system_id_storage_storage_id_drives_drive_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501
        if 'storage_id' in local_var_params:
            path_params['StorageId'] = local_var_params['storage_id']  # noqa: E501
        if 'drive_id' in local_var_params:
            path_params['DriveId'] = local_var_params['drive_id']  # noqa: E501

        query_params = []
        if 'force_refresh' in local_var_params:
            query_params.append(('ForceRefresh', local_var_params['force_refresh']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/Storage/{StorageId}/Drives/{DriveId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Drive',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_storage_storage_id_get(self, computer_system_id, storage_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_storage_storage_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_storage_storage_id_get(computer_system_id, storage_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str storage_id: The value of the Id property of the Storage resource (required)
        :return: Storage
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_storage_storage_id_get_with_http_info(computer_system_id, storage_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_storage_storage_id_get_with_http_info(computer_system_id, storage_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_storage_storage_id_get_with_http_info(self, computer_system_id, storage_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_storage_storage_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_storage_storage_id_get_with_http_info(computer_system_id, storage_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str storage_id: The value of the Id property of the Storage resource (required)
        :return: Storage
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id', 'storage_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_storage_storage_id_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_storage_storage_id_get`")  # noqa: E501
        # verify the required parameter 'storage_id' is set
        if ('storage_id' not in local_var_params or
                local_var_params['storage_id'] is None):
            raise ValueError("Missing the required parameter `storage_id` when calling `redfish_v1_systems_computer_system_id_storage_storage_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501
        if 'storage_id' in local_var_params:
            path_params['StorageId'] = local_var_params['storage_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/Storage/{StorageId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Storage',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_storage_storage_id_volumes_get(self, computer_system_id, storage_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_storage_storage_id_volumes_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_storage_storage_id_volumes_get(computer_system_id, storage_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str storage_id: The value of the Id property of the Storage resource (required)
        :return: VolumeCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_storage_storage_id_volumes_get_with_http_info(computer_system_id, storage_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_storage_storage_id_volumes_get_with_http_info(computer_system_id, storage_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_storage_storage_id_volumes_get_with_http_info(self, computer_system_id, storage_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_storage_storage_id_volumes_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_storage_storage_id_volumes_get_with_http_info(computer_system_id, storage_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str storage_id: The value of the Id property of the Storage resource (required)
        :return: VolumeCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id', 'storage_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_storage_storage_id_volumes_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_storage_storage_id_volumes_get`")  # noqa: E501
        # verify the required parameter 'storage_id' is set
        if ('storage_id' not in local_var_params or
                local_var_params['storage_id'] is None):
            raise ValueError("Missing the required parameter `storage_id` when calling `redfish_v1_systems_computer_system_id_storage_storage_id_volumes_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501
        if 'storage_id' in local_var_params:
            path_params['StorageId'] = local_var_params['storage_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/Storage/{StorageId}/Volumes', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='VolumeCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_computer_system_id_storage_storage_id_volumes_volume_id_get(self, computer_system_id, storage_id, volume_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_storage_storage_id_volumes_volume_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_storage_storage_id_volumes_volume_id_get(computer_system_id, storage_id, volume_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str storage_id: The value of the Id property of the Storage resource (required)
        :param str volume_id: The value of the Id property of the Volume resource (required)
        :return: Volume
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_computer_system_id_storage_storage_id_volumes_volume_id_get_with_http_info(computer_system_id, storage_id, volume_id, **kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_computer_system_id_storage_storage_id_volumes_volume_id_get_with_http_info(computer_system_id, storage_id, volume_id, **kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_computer_system_id_storage_storage_id_volumes_volume_id_get_with_http_info(self, computer_system_id, storage_id, volume_id, **kwargs):  # noqa: E501
        """redfish_v1_systems_computer_system_id_storage_storage_id_volumes_volume_id_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_computer_system_id_storage_storage_id_volumes_volume_id_get_with_http_info(computer_system_id, storage_id, volume_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str computer_system_id: The value of the Id property of the ComputerSystem resource (required)
        :param str storage_id: The value of the Id property of the Storage resource (required)
        :param str volume_id: The value of the Id property of the Volume resource (required)
        :return: Volume
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['computer_system_id', 'storage_id', 'volume_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_computer_system_id_storage_storage_id_volumes_volume_id_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'computer_system_id' is set
        if ('computer_system_id' not in local_var_params or
                local_var_params['computer_system_id'] is None):
            raise ValueError("Missing the required parameter `computer_system_id` when calling `redfish_v1_systems_computer_system_id_storage_storage_id_volumes_volume_id_get`")  # noqa: E501
        # verify the required parameter 'storage_id' is set
        if ('storage_id' not in local_var_params or
                local_var_params['storage_id'] is None):
            raise ValueError("Missing the required parameter `storage_id` when calling `redfish_v1_systems_computer_system_id_storage_storage_id_volumes_volume_id_get`")  # noqa: E501
        # verify the required parameter 'volume_id' is set
        if ('volume_id' not in local_var_params or
                local_var_params['volume_id'] is None):
            raise ValueError("Missing the required parameter `volume_id` when calling `redfish_v1_systems_computer_system_id_storage_storage_id_volumes_volume_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'computer_system_id' in local_var_params:
            path_params['ComputerSystemId'] = local_var_params['computer_system_id']  # noqa: E501
        if 'storage_id' in local_var_params:
            path_params['StorageId'] = local_var_params['storage_id']  # noqa: E501
        if 'volume_id' in local_var_params:
            path_params['VolumeId'] = local_var_params['volume_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems/{ComputerSystemId}/Storage/{StorageId}/Volumes/{VolumeId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Volume',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def redfish_v1_systems_get(self, **kwargs):  # noqa: E501
        """redfish_v1_systems_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_get(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: ComputerSystemCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.redfish_v1_systems_get_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.redfish_v1_systems_get_with_http_info(**kwargs)  # noqa: E501
            return data

    def redfish_v1_systems_get_with_http_info(self, **kwargs):  # noqa: E501
        """redfish_v1_systems_get  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.redfish_v1_systems_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: ComputerSystemCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method redfish_v1_systems_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/redfish/v1/Systems', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ComputerSystemCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)
